#ifndef DCUCHANNELDUMMY_H
#define DCUCHANNELDUMMY_H
#include <time.h>
#include "fecdescription.h"
#include "ccudescription.h"
#include "dcudescription.h"
#include "dcuchannelinterface.h"
/**
   \class DcuChannelDummy
    \author W. Beaumont University Antwerpen
    \date 12/ 2001
    \version 1.0
    \briefc Dummy Dcu

 
 */
class DcuChannelDummy : public DcuChannelInterface
{
private:
  bool fInitialized;
  MuxDescription* fDcuDescription;
  FecDescription* fFecDescription;
   unsigned short  count;
  short fAddress;
  int AttachChannel();
  unsigned char fActiveChannel;
public:
  /**
     Constructor. Correct initialisation should be checked with isInitialized()
     @param tdname  Name of the TDeviceControl, controlling the Daq
     @param board   Board id as registered in TDeviceControl
     @param channel Channel number as registered in TDeviceControl
  */
  
  DcuChannelDummy(char *tdname,int board,int channel);
  virtual ~DcuChannelDummy();
  /** True if the channel was found in the Daq*/
  bool isInitialized() { return fInitialized;}
  /** MuxDescription callbacks */

  virtual void setAddress(short i) {fAddress=i;}
  virtual short getAddress() { return fAddress;}
  virtual void setActiveChannel(unsigned char ch) {fActiveChannel= ch;}
  virtual unsigned char getActiveChannel(){return fActiveChannel;}
  virtual time_t getTime(){return 0;}
  virtual unsigned short getDcuADC(unsigned char ch);
  /** Share memory lock */
  virtual void  lock() {;}
  /** Share memory unlock */
  virtual void  unlock() {;}
  /** Share memory and Daq release */
  virtual void  release();
  /** DaqAction callback to requestAction + signal of server */
  virtual void  justDoIt();
  virtual int wait(){return 0;}

};
#endif
