#ifndef DCUCONVERSION
#define DCUCONVERSION
#include "dcuinfo.h"
/** \class  DcuConverion
    
    \brief conversion from ADC value to physical values    
*/


class DcuConversion :public DcuInfo  {
  /** assignmet of the dcu channels on the hybrid */
 public:
   enum dcuassignment { SITEMP,  V250,V125,IBIAS,EXTTEMP,NC1,NC2 ,INTTEMP}; 
  //DcuConversion(){}
// conversion functions 

  private:
     unsigned short  fAdcOffset;
    float fK2_5;
    float fK1_25;
    float fSiNtcBeta;
    float fSiR0;
    float fHybR0;
    float fHybNtcBeta;
    float fIBias0;
    float fIBias4;
    float fBiasRes;
    float fTempGain;
// all these values  have to be checked 
    void initValues(){
      fAdcOffset=0;
      fK2_5=.75;
      fK1_25=1;
      fSiNtcBeta= 3380.0;
      fHybNtcBeta= 3380.0;
      fIBias0=20e-6;
      fIBias4=10e-6;
      fSiR0=5E3;  fHybR0=10E3;
      fBiasRes=2e3; 
      fTempGain=9.22;
      
      
    }
  public:
    DcuConversion() { initValues(); }
    DcuConversion(unsigned int id, float gain=0,
		  unsigned int tempoffset=0,float reftemp=-300)
      : DcuInfo(id,gain,tempoffset,reftemp) {
      initValues();
    }
      
    ~DcuConversion(){}
    // conversion calls , input is the dcu readout 
    float Dcu125Voltage( unsigned short value) ;
    float DcuExternTemperature ( unsigned short dcuvalue  );
    float DcuHybridTemperature ( unsigned short dcuvalue  );
    float Dcu250Voltage( unsigned short value) ;
    float  Dcu2Voltage( unsigned short dcuvalue );
    float DcuLeakageCurrent( unsigned short dcuvalue );
    float DcuTsTemperature( unsigned short dcuvalue );
    void setDcuAdcOffset(unsigned short offs) {fAdcOffset=offs;}
    void set1_25Vdefaults(float k) {fK1_25=k;}
    void set1_5Vdefaults(float k) {fK2_5=k;}
    void setSiNtcDefaults(float ro=-1,float beta=-1,float bias=-1) {
      if( ro >0) {fSiR0=ro;}
      if( beta>0) { fSiNtcBeta= beta;}
      if( bias >0) {fIBias0=0;}
    }
    void setHbNtcDefaults(float ro=-1,float beta=-1,float bias=-1) {
      if( ro >0) {fHybR0=ro;}
      if( beta>0) { fHybNtcBeta= beta;}
      if( bias >0) {fIBias4=0;}
    }
    void setBiasDefaults( float sensro) {fBiasRes=sensro;}
    void setTsTempDefaults( float TempGain=-1,
			     unsigned short TempRefValue=-1){
      if( fTempGain>0){ fTempGain=TempGain;}
      if(TempRefValue>0){fTempRefValue=TempRefValue;}
    }
    
    float NtcResistor2temperature ( float R , float R0 , float T0, float beta);
    float DcuConversion::Temperature2NtcResitor( float T , float R0 , float T0, float beta);
};
#endif 


