#ifndef FECCTRLDEVINTERFACE
#define FECCTRLDEVINTERFACE 

#include "plli2cchannelinterface.h"

/**
   \class FecCtrlDevInterface
   \author W.Beaumont
   \date December  2002
   \version 1.0

   \brief Abstract all functionnalities of a  FeCDevCtrl
   This class is an 
*/
   

class FecCtrlDevInterface {

public:
  enum FecCtrlDevTypes{ DUMMY,DIMFECCTRL,SHAREDMEM,DIRECT};

 public:
  
  
  virtual ~FecCtrlDevInterface (){}

  /** FEC generates an hard reset to the hybrids 
   */
  virtual void hardReset()=0;

   /**    
    this function is needed for the shared memory implementation
    because there is no direct fec access for that implementation
    for others it is not necessary to implement this function
   */
       
   virtual void setI2CChannel(PllI2cChannelInterface* i2c){;}

   virtual void plxReset()=0;

   virtual void fecReset()=0;

   virtual void initTTCRX()=0;

   virtual bool isInitialized(){ return fInitialized;} 
   
   protected :
   bool  fInitialized;

};
#endif 

