#ifndef __FedDeviceDim
#define  __FedDeviceDim
#include <map>
#include <vector>
#include "dimfeddevicechannel.h"

/** 
    \class FedDeviceDim
    \author W.Beaumont
    \date December  2002
    \version 1.0

    \brief class to intract with the (dim)feddevice 
    initilaze the fed device and is used a class for 
    the fedchanneldd to attach fedchannels for the lt.
    When constructucted with the variable fedsrn and host 
     will create the the channel for the requested 
    fed serial nr if not exist only the use count will be increased
    If the dimfeddevicechannel is ceated correctly the 
    isPresent(fedserialnr) give true else it gives false
    in case the  dimfeddevicechannel is not created correctly
    the created  dimfeddevicechannel will be deleted 
    if the constructor is given olnly with the fedsrnnr 
    map will be consulted to see if the  dimfeddevicechannel with 
    the give fed srn is constructred.
    If this is not the case isPresent() gives false .
    Always use is isPresent() to check if the initialization is
    done correctly 
*/

class FedDeviceDim{
 public:
  typedef struct { 
    DimFedDeviceChannel* channel;
    int usecount;
    string host;
    int feddelay;
    int highthreshold;
    int lowthreshold;
    vector<int> forbidden;
  } DimFedDevAdm;
 private:  
  static map<int,DimFedDevAdm*> fDimFedAdm;
  //pointer to the used device fed set it to 0 if not exist
  map<int,DimFedDevAdm*>::iterator fDFD;
  //shortcut to the fedadm info
  DimFedDevAdm* fDevAdm;
  int fFedSrnr; //should set only once by the constructor
  string fHost;//should set only once by the constructor

 protected:
 // shortcut the the conntected dimfeddevicechannel 
  DimFedDeviceChannel* fDimFedDev;
  /** set the threshod for the header finding 
      if low and high are both 0 the threshold finding algorithm is activated
      otherwise the thresholds are set to the given values
      @param low the low threshold for the fed 
      @param high the high threshold for the the fed
      @return always true
  */
  bool setThresholds(int& low , int&  high);
 /** set the threshod for the header finding
     calls the threshold finding algorithm 
     same as setThreshold(0,0);
     @return always true
 */
  bool setThresholds();
  

  bool setFedDelay( int & delay );

 public:
  /** create the dimfeddevicechannel for the requested fed
      located in the host if it not exist in the map table
      otherwise it will the 
      if create is true else it only reate this object
      @param fedsrn the fed id that is requested     
      @param the host where the dimfeddeviceserver is running
      @param fbd a vector of fed delays that doesn't work in theis setup 
  */
  FedDeviceDim(int fedsrn, string host,vector<int> fbd );
  /** this use of this constructer assumes the existing of the 
      dimfeddevicechannel for the requested fedsrnr.
      After the call of the constructor the function 
      isPresent() should be used to check if the functionalllity
      can be used. If this gives false this object should be 
      destructed
  */
  FedDeviceDim(int fedsrnr);

  /** checks if the DimFedDeviceChannel for the fed with  serialnr
      is created 
      @param fedsrnr the fedserial nr 
      @return true if the  DimFedDeviceChannel for the fedsrn exist
  */
  bool isPresent(int fedsrnr);
  bool isPresent();
  void getThresholds( int &low, int&high){
    low=fDevAdm->lowthreshold;
    high=fDevAdm->highthreshold;
  }

  int getFedSerialNr(){ return fFedSrnr;}
  int  getFedDelay(){ return fDevAdm->feddelay;}
  void setScopeMode(int j) ;
  protected :
// crtrl  functions as is choosen for a prottected 
    // fDimFedDev these are not needed 
  void   enableTrigger(){fDimFedDev->enableTrigger();}
  void disableTrigger() {fDimFedDev->disableTrigger();}
  unsigned short getApvEventData(int event,int ch,int apv, int nr_sample);
  void init() {fDimFedDev->init();}
  void cleanStart() {fDimFedDev->cleanStart();}
  void cleanStop(){fDimFedDev-> cleanStop();}
  void loop() {fDimFedDev->loop();}
  void exitLoop() {fDimFedDev->exitLoop();}
  void restart() {fDimFedDev->restart();}
 
   

};
#endif 
