#ifndef __FedProcessCtrlDummy
#define  __FedProcessCtrlDummy
#include "fedprocessctrlinterface.h"

/** 
    \class FedProcessCtrlDummy
    \author W.Beaumont
    \date September  2001
    \version 1.0

    \brief Dummy realization fort h  FedProcessCtrl
*/

class FedProcessCtrlDummy : public FedProcessCtrlInterface
{ int fSpill;

  // functions 
protected: 
  /** Connect to the Daq and check if channel is available,
      it turns isInitialized() to true if Ok
  */
  virtual int  AttachFEDChannel( int serial_nr, int channelnr){return 0;}
  /** Unused */
 
public:
       /** Constructor
      
  */   
  FedProcessCtrlDummy  (   ); 

  virtual ~FedProcessCtrlDummy();

 
  /** Get Number of event in Spill (buffer) */
  virtual int getNumberOfEvents(); 
  /** Get Spill number (buffer counts) */
  virtual int getSpillNumber() {return fSpill++ ;}  
/** check for new spill return true if spill is DIFFERENT in respect to the last request
    will lock the buffer if there is a new spill */ 
  virtual bool NewSpill();

  /** check for new spill and wait for skip spills 
     @param skip the number of spills that should be skipped 
     */
  virtual bool NewSpill(int skip );

  virtual unsigned short 
    getApvEventData(int event,int ch,int apv, int nr_sample,int fednr=0);



  /** return the board Id of the FED device in use if not implemented returns -1*/
  virtual int getFedId(){ return 0;}

  /** Lock access */
  virtual void  lockDataBuffer(){;}
  /** UnLock access */
  virtual void  unlockDataBuffer(){;}
  /** Release access */
  virtual void  release(); 
 
  /** if the buffer is locked it will unlock the buffer */
  virtual void NextSpill();
 
};

#endif 
	

