/*****************************************************************************/
/*                     The Karlsruhe CMS readout project                     */
/*                                                                           */
/* Copyright (C) 2000/2001  by Guido Dirkes, Manuel Fahrer,                  */
/*			       Stefan Heier, Wolfgang Scherdtfeger,          */
/*			       Thomas Weiler and Siegfried Weseler           */
/* All rights reserved.                                                      */
/*                                                                           */
/* This file is part of the ANALYSIS tool.                                   */
/* Corresponding file are:                                                   */
/*   motherboard.h  definition of Motherboard class                          */
/*   motherboard.cc declaration of motherboard methodes                      */
/*   testmb.cc      simple test programm for motherbaord hardware            */
/*   Makefile                                                                */
/*                                                                           */
/* First release  19/07/2000 by Stefan Heier                                 */
/* Second release 15/08/2001 by Guido Dirkes make shared libraries           */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   This program is free software; you can redistribute it and/or modify    */
/*   it under the terms of the GNU General Public License as published by    */
/*   the Free Software Foundation; either version 2 of the License, or       */
/*   (at your option) any later version.                                     */
/*                                                                           */
/*   This program is distributed in the hope that it will be useful,         */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*   GNU General Public License for more details.                            */
/*                                                                           */
/*   You should have received a copy of the GNU General Public License       */
/*   along with this program; if not, write to the Free Software             */
/*   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               */
/*                                                                           */
/*****************************************************************************/
#ifndef __MBBASE_H
#define __MBBASE_H

#define TIMEOUT 100
class Motherboard
{
 private:
    int ctrl;

 public:
    Motherboard();
    virtual int getSlot(int s, int board = 0) = 0;
    virtual int releaseSlot() = 0;
    virtual int sendData(unsigned char *data, int len = 1) = 0;
    virtual int readData(unsigned char *data, int len = 1) = 0;
    virtual int testbyte(int s) = 0;
};



#endif




