/*****************************************************************************/
/*                     The Karlsruhe CMS readout project                     */
/*                                                                           */
/* Copyright (C) 2000/2001  by Guido Dirkes, Manuel Fahrer,                  */
/*			       Stefan Heier, Wolfgang Scherdtfeger,          */
/*			       Thomas Weiler and Siegfried Weseler           */
/* All rights reserved.                                                      */
/*                                                                           */
/* This file is part of the ANALYSIS tool.                                   */
/* Corresponding file are:                                                   */
/*   motherboard.h  definition of Motherboard class                          */
/*   motherboard.cc declaration of motherboard methodes                      */
/*   testmb.cc      simple test programm for motherbaord hardware            */
/*   Makefile                                                                */
/*                                                                           */
/* First release  19/07/2000 by Stefan Heier                                 */
/* Second release 15/08/2001 by Guido Dirkes make shared libraries           */
/* Modified version to be compatible with the normi2c class used for         */
/* basic daq control                                                         */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   This program is free software; you can redistribute it and/or modify    */
/*   it under the terms of the GNU General Public License as published by    */
/*   the Free Software Foundation; either version 2 of the License, or       */
/*   (at your option) any later version.                                     */
/*                                                                           */
/*   This program is distributed in the hope that it will be useful,         */
/*   but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*   GNU General Public License for more details.                            */
/*                                                                           */
/*   You should have received a copy of the GNU General Public License       */
/*   along with this program; if not, write to the Free Software             */
/*   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               */
/*                                                                           */
/*****************************************************************************/
#ifndef __MOTHERBOARDI2C_H
#define __MOTHERBOARDI2C_H

#include <fcntl.h>
#include <sys/ioctl.h>
#include <asm/ioctl.h>
#include <asm/types.h>
#include <unistd.h>
#include <iostream>
#include <mbbase.h>

class NormI2c;

class MotherboardI2C : public Motherboard
{ ushort DATAADDR ; 
  ushort CTRLADDR ;
  ushort ACKADDR  ;
 private:
    NormI2c  *i2c;
    unsigned char ctrl;
 public:
    /** constructor 
	@param ni2c an implementation of the standard normI2c interface
	@param basseaddr the i2c base address , should be 0x70 
    */       
    MotherboardI2C(NormI2c *ni2c, int baseaddr=0x70);
    int testbyte(int s); // not used
    int getSlot(int s, int board = 0);
    int releaseSlot();
    int sendData(unsigned char *data, int len = 1);
    int readData(unsigned char *, int) { return 0; }
};

#endif



