#ifndef __MULTIPLEXER_H
#define __MULTIPLEXER_H

#include <motherboardi2c.h>

class Multiplexer
{
   private:
     Motherboard *mbptr;
     
     int slot;
     // each motherboard has a ID, which will be 0 for all mux devices
     int mboard;
     // not used for CMS
     int board_id;

   public:
     /*! constructor takes pointer to motherboard and information about 
       slot (0-7) and board (default 0 | not used for CMS)*/
     Multiplexer( Motherboard *mptr, int nslot=0, int nmboard=0 );
     /*! channel selects which input channel (0-9) is connected 
       to output line, board_id is unused for CMS */
     int selectChannel(int channel, int board_id=0);
     /*! turn off all input lines */
     int disableSwitch(int board_id=0);
};

#endif
