#ifndef MUXCHANNELINTERFACE
#define MUXCHANNELINTERFACE
/** 
    \class  MuxChannelInterface 
    \author W. Beaumont
    \date October  2002
    \version 1.0


    \brief interface class to control the fed input multiplexer.
    The multiplexer should set the channel to the correct active group
    the active group depends on the definition in the connection file. 
*/


class MuxChannelInterface {
 protected: 
int   fActiveGroup;
 public:

 MuxChannelInterface(){;}
 virtual ~MuxChannelInterface(){;}
  /** set the active group for a multiplexer 
      @param group the groupnr to which the multiplexer hast to be set
      @return 0 if everything is ok
  */
  virtual int  setActiveGroup(int group) {return fActiveGroup=group;}
  virtual int  getActiveGroup() {return fActiveGroup;}
  

};


#endif
