#ifndef __MUXEXCHANGE
#define __MUXEXCHANGE


#include "calexchange.h"
#include "muxexchangedef.h"
class TscI2cDevice;

/** 
    \class  MuxExchange 
    \author W. Beaumont
    \date May  2001
    \version 1.0


    \brief exchange connection information of the multiplexer
  class to hold the parameters for the parameters for the mux device control
     and to access the mux card info
 */
class MuxExchange :public  CalExchange <MuxExchangeDef::MuxValues> {
 private: 
  MuxExchangeDef::MuxValues* fMuxVal ;
  
 public: 
 /**there is no i2cinterface class.
    to avoid to many settters, getters this is made public
     each supported device needs its own member 
  */ 
  TscI2cDevice* fTsc; 
 
 public:
 MuxExchange( CalExchange <MuxExchangeDef::MuxValues> ce):
   CalExchange <MuxExchangeDef::MuxValues>(ce){ 
    fMuxVal= getCalValues();
 }
  int getFedNr(int muxcrd){ 
    return MuxExchangeDef::getfedserialnr(*fMuxVal,muxcrd) ;}
  int getFedCh(int muxcrd){
    return MuxExchangeDef::getfedchannel(*fMuxVal,muxcrd) ;}
  int getI2cAddr(int muxcrd) { 
    return MuxExchangeDef::getI2cAddr(*fMuxVal,muxcrd) ;}
  int getNrCards() { return fMuxVal->size();} 
  /** returns the group number to which the mux channel of the muxcard
      is attached to 
  */
  int getGroupNr( int muxcrd, int muxchannel){
    return MuxExchangeDef::getGroupNr(*fMuxVal, muxcrd,muxchannel);
  }
};

#endif 
