#ifndef __MUXEXCHANGEDEF
#define __MUXEXCHANGEDEF

#include <map>



//#include "tsci2cdevice.h"

/** the name space for the HV bias channel class and HV conversion class
    namespace HvConversionDef
    defintion not covered by the code  groupnr:
    -2 invalid active group 
    -1 direct FED connection (so always active) 
    The active group is the group that is at that moment connected
    to the FED. Most natural the group is the same number as the 
    mux channel but this is not necessary.
 */
namespace MuxExchangeDef { 
  enum FedMuxTypes {DUMMY,  KARLS };   
  typedef std::map<int,int> GCR ; // GroupChannelRelation
  // first enty is the group,second is the channel
  typedef struct{
    int devicenr;
    int fedsrnr;
    int fedchnr;
    int i2c_addr;
    GCR  grp_ch;
  } FedMuxInfo ;

  typedef  std::map<int,FedMuxInfo> MuxValues ; // first nr is the card id 

  typedef MuxValues::const_iterator  CI;
  /** returns the group number to which the mux channel of the muxcard
      is attached to 
  */
  int getGroupNr( MuxValues ce,int cardnr, int muxchannel);

  int getfedchannel( MuxValues ce, int cardnr); 
  int getfedserialnr(MuxValues ce, int cardnr); 
  int getI2cAddr(MuxValues ce, int cardnr) ;
      
  void setfedchannel(MuxValues& ce,int channel, int cardnr);

  void  setfedsernr(MuxValues& ce,int serienr, int cardnr);
  
  
  void  seti2caddr(MuxValues& ce,int i2c_addr, int cardnr);

  // code cardnr and dev in one otherwise to much programing work
  int   cardId(int devnr, int cardnr);
  int getDevNr( int cardid); 
  int getCardNr( int cardid); 


	
};


#endif 
