#ifndef MUXI2CCHANNELDUMMY_H
#define MUXI2CCHANNELDUMMY_H
#include "fecdescription.h"
#include "ccudescription.h"
#include "muxdescription.h"
#include "muxi2cchannelinterface.h"
/**
   \class MuxI2cChannelDummy
    \author V.Z
    \date 10/ 2001
    \version 1.0
    \briefc Dummy MuxI2c

 
 */
class MuxI2cChannelDummy : public MuxI2cChannelInterface
{
private:
  bool fInitialized;
  MuxDescription* fMuxDescription;
  FecDescription* fFecDescription;
  int AttachChannel();

public:
  /**
     Constructor. Correct initialisation should be checked with isInitialized()
     @param tdname  Name of the TDeviceControl, controlling the Daq
     @param board   Board id as registered in TDeviceControl
     @param channel Channel number as registered in TDeviceControl
  */
  
  MuxI2cChannelDummy(char *tdname,int board,int channel);
  virtual ~MuxI2cChannelDummy();
  /** True if the channel was found in the Daq*/
  bool isInitialized() { return fInitialized;}
  /** MuxDescription callbacks */
  virtual void setResistor(short i) {;}
  virtual void setAddress(short i) {;}
  virtual short getAddress() { return 1;}
  virtual short getResistor() { return 1;}
  /** Share memory lock */
  virtual void  lock() {;}
  /** Share memory unlock */
  virtual void  unlock() {;}
  /** Share memory and Daq release */
  virtual void  release();
  /** DaqAction callback to requestAction + signal of server */
  virtual void  justDoIt();
  virtual int wait(){return 0;}

};
#endif
