#ifndef MUXI2CCHANNELLT
#define MUXI2CCHANNELLT

#include "muxi2cchannelinterface.h"
/**
   \class MuxI2cChannelLt
    \authorW. Beaumont V.Z
    \date 10/ 2001
    \version 1.0
    \brief Lt  implementation of MuxI2cChannelInterface

    <h2> Usage </h2>
    It implements MuxI2cChannelInterface class for the lt application. 
    It takes care about the correct instantiation
    of the muxi2channel (ccu address, Fec board, Ccu channel ) according the connection
    to the bench position as described in the lt.xml file
    
    

 */
class MuxI2cChannelLt : public MuxI2cChannelInterface
{
private:
 

   MuxI2cChannelInterface* fMci;
 
  bool fInitialized;
  int fChannel;
  int fBoard;
  
  int AttachChannel();

public:
  /**
     Constructor. Correct initialisation should be checked with isInitialized()
     @param  benchposition   the benchposition where the module is .
     
  */
  
  MuxI2cChannelLt(int benchposition );
  virtual ~MuxI2cChannelLt();
  /** True if the channel was found in the Daq*/
  bool isInitialized() { return fInitialized;}

  /** MuxDescription callbacks */

  virtual void setResistor(short i) {fMci->setResistor(i);}
  virtual void setAddress(short i) {fMci->setAddress(i);}
  virtual short getAddress() { return fMci->getAddress();}
  virtual short getResistor() { return fMci->getResistor();}
  /** Share memory lock */
  virtual void  lock() {fMci->lock();}
  /** Share memory unlock */
  virtual void  unlock() {fMci->unlock();}
  /** Share memory and Daq release */
  virtual void  release(){ fMci->release();}
  /** DaqAction callback to requestAction + signal of server */
  virtual void  justDoIt() {fMci->justDoIt();};
 /** poll routine */
  virtual int wait(){return fMci->wait();}
  
  
};
#endif
