#ifndef OPTOI2CCHANNELDUMMY
#define OPTOI2CCHANNELDUMMY

#include "optoi2cchannelinterface.h"
/** \class OptoI2cChannelDummy
    \author W. Beaumont
    \date December 2002
    \version 1.0

    \brief dummy implementation of the OptoI2cChannelInterface class
*/
class OptoI2cChannelDummy : public OptoI2cChannelInterface 
{ 
  short fLevel;
  short  fAddress;
  unsigned char fGain[3];
  short fBias[3];
  unsigned char  fActiveChannel;
public:
  /** Constructor, implements ChannelId 
      @param b Board Id
      @param c Channel number 
  */
  OptoI2cChannelDummy(char *tdname,int b,int c) ;
  virtual ~OptoI2cChannelDummy();
  /** CallBacks to OPTO setting, see OptoDescription for definition */
  virtual void setLevel(int i) {fLevel=(short) i;}
  virtual void setAddress(short i) {fAddress=i;}
  virtual short getAddress(){return fAddress;}
  virtual short getLevel(){return fLevel;}
  virtual void setOptoGain(unsigned char ch, unsigned char f);
  virtual void setOptoBias(unsigned char ch, char f);
  virtual void setActiveChannel(unsigned char ch){fActiveChannel=ch ;}
  virtual unsigned char getOptoGain(unsigned char ch);
  virtual char getOptoBias(unsigned char ch);
  virtual unsigned char getActiveChannel(){return fActiveChannel;}



  /** Access Lock to parameters */
  virtual void  lock() {;}
  /** Access UnLock to parameters */
  virtual void  unlock() {;}
  /** Release of channel to the DAQ */
  virtual void  release() ;
  /** Request DAQ to change parameter */
  virtual void  justDoIt() ;
  /**  polling routine */
  virtual int wait();

};
#endif
