#ifndef OPTOI2CCHANNELLT_H
#define OPTOI2CCHANNELLT_H

#include "optoi2cchannelinterface.h"
/**
   \class Optoi2cChannel
   \author W. Beaumont V.Z
   \date 10/  2001
   \version 1.0
   \brief Lt  implementation of PllChannelInterface

    <h2> Usage </h2>
    It implements PllChannelInterface class for the lt application. 
    It takes care about the correct instantiation
    of the PllChannel (ccu address, Fec board, Ccu channel ) according the connection
    to the bench position as described in the lt.xml file
    
   
    \

 */

class OptoI2cChannelLt : public OptoI2cChannelInterface
{
private:
   OptoI2cChannelInterface* fCd;
   bool fInitialized; 
   int fChannel;
   int fBoard;
public:
  /**
     Constructor. Correct initialisation should be checked with isInitialized()
     @param  benchposition   the benchposition where the module is .
  */  
  OptoI2cChannelLt(int benchpostion);
 virtual ~OptoI2cChannelLt();
  /** True if the channel was found in the Daq*/
  inline bool isInitialized() { return fInitialized;}
  /** PllDescription callbacks */
  virtual void setAddress(short i) {fCd->setAddress(i);}

 virtual void setLevel(int i) { fCd->setLevel(i);}
 virtual short getLevel(){return  fCd->getLevel();}
  virtual void setOptoGain(unsigned char ch, unsigned char f){
    fCd->setOptoGain( ch,  f);}
  virtual void setOptoBias(unsigned char ch, char f){
    fCd->setOptoBias( ch,  f);}
  virtual void setActiveChannel(unsigned char ch) {
    fCd->setActiveChannel( ch);}
  virtual unsigned char getOptoGain(unsigned char ch){
    return fCd->getOptoGain( ch) ;}
  virtual char getOptoBias(unsigned char ch){
    return fCd->getOptoBias( ch) ;}
  virtual unsigned char getActiveChannel(){
    return fCd->getActiveChannel();
    ;}
  
  virtual short getAddress() {return fCd->getAddress();}
  
 /** Share memory lock */
  virtual void  lock() {fCd->lock();}
  /** Share memory unlock */
  virtual void  unlock() {fCd->unlock();}
  /** Share memory detach, Daq release of the channel */
  virtual void  release(){fCd->release();}
  /** DaqAction callback to requestAction + signal of server */
  virtual void  justDoIt(){fCd->justDoIt();}
 
 /** poll routine */ 
  virtual int wait(){return fCd->wait();}

};
#endif
