#ifndef PLLI2CCHANNELDUMMY_H
#define PLLI2CCHANNELDUMMY_H
#include "fecdescription.h"
#include "ccudescription.h"
#include "plldescription.h"
#include "plli2cchannelinterface.h"
/**
   \class PllI2cChannelDummy
    \author V.Z
    \date 10/2001
    \version 1.0
    \brief Dummy channel


 */

class PllI2cChannelDummy : public PllI2cChannelInterface
{
private:
  bool fInitialized;
  PllDescription* fPllDescription;
  FecDescription* fFecDescription;
  short fClockDelay;
  short fFineDelay;
  short fAddres;
  int AttachChannel();
public:
  /**
     Constructor. Correct initialisation should be checked with isInitialized()
     @param tdname  Name of the TDeviceControl, controlling the Daq
     @param board   Board id as registered in TDeviceControl
     @param channel Channel number as registered in TDeviceControl
  */  
  PllI2cChannelDummy(char *tdname,int board,int channel);
  virtual ~PllI2cChannelDummy();
  /** True if the channel was found in the Daq*/
  inline bool isInitialized() { return fInitialized;}
  /** PllDescription callbacks */
  virtual void setAddress(short i) { fAddres=i;;}
  virtual void setLatency(short i) {fFineDelay=i;}
  virtual void setInit(short i) {;}
  virtual short getAddress() {return  fAddres;}
  virtual short getLatency() {return fFineDelay;}
  virtual short getClock(){return fClockDelay;};
  virtual void  setClock(short i){fClockDelay=i;};
  virtual  bool initRequested() { return 1;}
  /** Share memory lock */
  virtual void  lock() {;}
  /** Share memory unlock */
  virtual void  unlock() {;}
  /** Share memory and Daq release */
  virtual void  release();
  /** DaqAction callback to requestAction + signal of server */
  virtual void  justDoIt();
virtual int wait(){return 0;};

};
#endif
