#include "apv25i2cchannellt.h"
#include "apv25i2cchanneldummy.h"
#include "benchposconnection.h"
#include "apv25i2cchannel.h"
#include "dimapvaccesschannel.h"
#include "ltparser.h"
#include "daqerrormsg.h"
extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice

   
Apv25I2cChannelLt::Apv25I2cChannelLt(int slotpos  ) :
  Apv25I2cChannelInterface(-1,-1){  
  BenchPosConnection* BenchP =
    new BenchPosConnection(*ltparser->getBenchPosConnections(slotpos));
  if ( BenchP->getId() == -1) {  
    DAQEXIT( "Benchpos" << slotpos <<" doesn't exist \n");  
  }
  //BenchP->info();
  int fedcard=0;
  fChannel=BenchP->getCcuChannel();
  fBoard=  10000*fedcard +BenchP->getCcuAddress();
  this->setBoardId(fBoard);
  this->setChannelId(fChannel);
  BenchPosConnection::I2cDevType type=BenchP->getApvType(); 
  if( BenchP->getFecSimulation())   {  type=BenchPosConnection::DUMMYI2C;}
  switch (type) {
    case BenchPosConnection::DUMMYI2C: {
      Apv25I2cChannelDummy* fA = 
	new Apv25I2cChannelDummy ("ControlePrincipal",fBoard,fChannel); 
      fInitialised= fA->isInitialized();
      fCd=fA;
    }
    break;
    case BenchPosConnection::APV25DIM: {
      DT_DEBUG_LTC("DIM connect");
      DimApvaccessChannel* fA =
	new DimApvaccessChannel(BenchP->getDimHostName(),0,0,fBoard,fChannel);
      DT_DEBUG_LTC("DIM connect to "<<BenchP->getDimHostName() <<
				    " b :"<< fBoard << " ch " << fChannel);
       fInitialised= true;
	fCd=fA;
    }    
    break;
    case BenchPosConnection::APV25: {
      Apv25I2cChannel* fA = 
	new Apv25I2cChannel("ControlePrincipal",fBoard,fChannel);
	fInitialised= fA->isInitialized();
      fCd=fA;
    }    
    default: { 
      DT_ERROR("Not existing type for apvi2c :"<<(int)type);
     }
  }    
  delete BenchP;
}

Apv25I2cChannelLt::~Apv25I2cChannelLt(){
  delete fCd;
} 



