#include "dcuconversion.h"
#include "dcuchannellt.h"
#include "dcuchanneldummy.h"
#include "benchposconnection.h"
#include "dcuchannel.h"
#include "dimdcuaccesschannel.h"
#include "ltparser.h"
#include "daqerrormsg.h"
#include "CalibrationValues.h"     
extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice

   
DcuChannelLt::DcuChannelLt(int slotpos  ) : DcuChannelInterface(-1,-1){
  BenchPosConnection* BenchP =
    new BenchPosConnection(*ltparser->getBenchPosConnections(slotpos));
  if ( BenchP->getId() == -1 ) 
    { DAQEXIT("Benchpos" << slotpos <<" doesn't exist \n");}
  //BenchP->info();
  fChannel=BenchP->getCcuChannel();
  fBoard=  BenchP->getCcuAddress();
  this->setBoardId(fBoard);
  this->setChannelId(fChannel);
  BenchPosConnection::I2cDevType type=BenchP->getDcuType();
  if( BenchP->getFecSimulation()){ type=BenchPosConnection::DUMMYI2C;}
  switch (type) {
    case BenchPosConnection::DUMMYI2C: {
      DcuChannelDummy* fA = 
	new DcuChannelDummy ("ControlePrincipal",fBoard,fChannel); 
      fInitialized= fA->isInitialized();
      fMci=fA;  
    }
    break;
    case BenchPosConnection::DCU2DIM: {
      DimDcuaccessChannel*  fA =
	new DimDcuaccessChannel(BenchP->getDimHostName(),0,0,fBoard,fChannel);
	 fInitialized= true ;
	 fMci=fA;
    }
    break;
     case BenchPosConnection::DCU2: {
       DcuChannel* fA = new DcuChannel("ControlePrincipal",fBoard,fChannel);
	if ( ! fA->isInitialized())
	  {DT_ERROR("dcu channel not initialized");
	  }
	 fInitialized= fA->isInitialized();
	 fMci=fA;
     }
     break;
    default: { 
       DT_ERROR("Not existing type for DCU :"<<(int)type);
     }
  }
  delete BenchP;
}

DcuChannelLt::~DcuChannelLt(){ 
  release();
  delete fMci;
} 

float  DcuChannelLt::getDcuV125( )
    { float value;
      lock();
      value= (float) getDcuADC(DcuConversion::V125);
      unlock();
      return value;
    }


float  DcuChannelLt::getDcuV250() 
 { float value;
      lock();
      value= (float) getDcuADC( DcuConversion::V250);
      unlock();
      return value;    
    }

  float  DcuChannelLt::getDcuTempInt() 
{ float value;
      lock();
      value= (float) getDcuADC( DcuConversion::INTTEMP);
      unlock();
      return value;    
    }



  float  DcuChannelLt::getDcuTempHyb() 
{ float value;
      lock();
      value= (float) getDcuADC( DcuConversion::EXTTEMP);
      unlock();
      return value;    
    }



  float  DcuChannelLt::getDcuTempSi() 

{ float value;
      lock();
      value= (float) getDcuADC(DcuConversion::SITEMP);
      unlock();
      return value;    
    }

  float  DcuChannelLt::getDcuBiasCurrent()
{ float value;
      lock();
      value= (float) getDcuADC(DcuConversion::IBIAS );
      unlock();
      return value;    
    }




//  void DcuChannelLt::justDoIt()
//  {
//    if (fInitialized && fApvDescription!=0 && fCd!=0)
//    { 
//      fDcuDescription->requestAction(getpid());
//      kill(fCd->fPidServer,SIGCONT);
//    }
//  }



//  int DcuChannelLt::wait()
//  {
//   int r=0;
//    do {
//      r++;
//      usleep(30);
//    } while (!DcuDescription->isDone());
//    return r;
//  }


