#include "daqerrormsg.h"
#include "fbcardwrapper.h"
#include "fbcardio.h"
#include "fbcarddummy.h"
#include "fbcardinterface.h"
#include "fbcarddef.h"
#include "ltparser.h"

FBCardWrapper::FBCardWrapper( int devicenr,LtParser* ltparser) {
 
  fInitialized=false;
  fDeviceId = devicenr; 
  CalExchange <int>* c=
    ltparser->getFBCardInfo(devicenr);
  if ( c){
    DT_DEBUG_LTC(c->printIdValues(std::cout));
    fType= c->getType();
    
    switch(fType){
      case FBCardDef::IOCARD :{
	fFBCard= new FBCardIo( c);
	fInitialized=true;	
      }
      break;
      case FBCardDef::DUMMY :{
	fFBCard = new FBCardDummy(c);
	fInitialized=true;
      }
      break;
      default:{
	DT_WARN("ForwardBias Card "<<devicenr<< " type " 
		<<fType <<" not defined");
      }
    }
  }
  if( ! fInitialized){
    DT_WARN("ForwardBias Card "<<devicenr<< " type "
	    << fType<<" not correctly initialized ");
  }
}

