#include "fecctrldevwrapper.h"
#include "fecctrldevshm.h"
#include "fecctrldevdummy.h"
#include "fecctrldevdim.h"


FecCtrlDevWrapper::FecCtrlDevWrapper(   int device ,  LtParser* ltparser  ) { 
  fInitialized=false;
  fDeviceId = device; 
  CalExchange <int>* c=0 ; 
                            
  int n =ltparser->getNumberFecCtrlDev();
  DT_DEBUG_LTC("Probes " << n  ) ;
  c = ltparser-> getFecCtrlDevInfo(fDeviceId);
        
  if ( c)  {	
    DT_DEBUG_LTC(c->printIdValues(cout));
    DT_DEBUG_LTC("requested shmname: " << c->getTDeviceControlName( ));
    DT_DEBUG_LTC("name: " << c->getName( ));
    fType= c->getType();
  }
  else {fType =FecCtrlDevInterface::SHAREDMEM;}  
  // !!! if not fedctrl is defined take the default one 
  switch ( fType ){ 
    case FecCtrlDevInterface::DUMMY:{  
      FecCtrlDevDummy* fTChanneld  = new FecCtrlDevDummy();
      if ( !( fInitialized=fTChanneld->isInitialized()) ) 
	{ delete fTChanneld ;  fT=0;}
      else { fT=fTChanneld;DT_DEBUG_LTC("Dummy created");}
      
    }
      break; 
    case FecCtrlDevInterface::SHAREDMEM: { 
	FecCtrlDevShm* fTChannel  = new FecCtrlDevShm();
	if ( !( fInitialized=fTChannel->isInitialized()) ) 
	  { delete fTChannel ;  fT=0;}
	else { fT=fTChannel;DT_DEBUG_LTC("Sharedmem created");}
      }
      break;
      case FecCtrlDevInterface::DIMFECCTRL: {
	string host(c->getShmName());
	FecCtrlDevDim * fTChanneldd=  new 
	  FecCtrlDevDim(c->getBoardNr(), host);
	if ( !( fInitialized=fTChanneldd->isInitialized()) ) 
	  { delete fTChanneldd ;  fT=0;}
	else { fT=fTChanneldd;DT_DEBUG_LTC("DimDev created");} 
      }
      break;
      default: fT=0;
	DT_DEBUG_LTC( "FecCtrldev type" << fType << "not supported"<< endl) ;
	
	break;
    }
}

FecCtrlDevWrapper::~ FecCtrlDevWrapper()
{ ;
// nothing to do 

} 





