
#include "fedchanneldimdev.h"
 
FedChannelDimDev::FedChannelDimDev(long fed_ser_nr, long channel_arg, PROCESS_MODE process_mode_arg, 
				   long  mux_channel_arg , long  time_channel_arg)
    : FedDeviceDim(fed_ser_nr) ,
      FedChannelInterface(fed_ser_nr,channel_arg,process_mode_arg,mux_channel_arg,time_channel_arg) { 
  fChannel=channel_arg;
  fFrameSize=0;
  fInitialized=false ; 
  if (isPresent()) {fInitialized=true;}
  fProcessMode = process_mode_arg;
  fSkip=1;
  switch (fProcessMode){
    case FRAME_FIRST_SAMPLE:{ fFrameSize=140;fOdd=0; fSkip=2; 
    }
    break;
    case FRAME_SECOND_SAMPLE:{ fFrameSize=140;fOdd=1;fSkip=2;    
    }
    break;
    default : fInitialized=false ;
      DT_WARN(" ONLY APV Header recognizion with mux is supported");
      
  } 
  sizeNeeded=fFrameSize* sizeof(short);
  //printf(" pointer to dimfeddev %p/n", fDimFedDev);
}

int  FedChannelDimDev::getApvEventData(int event_nr,short *out_buf, int size_of_buf ) { 
  short *i = out_buf; if (size_of_buf < sizeNeeded) return -1;
  
  for(int  lc=0;lc <fFrameSize ;lc++){
    *i= (short)fDimFedDev->getApvEventData(event_nr,fChannel,fOdd,lc);
    i++;
  }  
  return fFrameSize ;
}

  
short  FedChannelDimDev::getApvEventSample(int i,int  event_nr){
  return (short) fDimFedDev->getApvEventData(event_nr,fChannel,fOdd,i);
}



short  FedChannelDimDev::getSampleFromBuffer(int i){
  DT_WARN("Implementation pending !!");
  return -1;

}

 
FedChannelDimDev::~FedChannelDimDev(){ ;}





