#include "feddevicedim.h"


FedDeviceDim::FedDeviceDim(int fedsrnr, 
			   string host,vector<int> fbd){
 fFedSrnr=fedsrnr;
 fDFD=fDimFedAdm.find(fFedSrnr);
 if( fDFD != fDimFedAdm.end()){
   fDimFedDev= fDFD->second->channel;
   fDFD->second->usecount++;
   fDevAdm=fDFD->second;
 }
 else {    
   fDimFedDev =new DimFedDeviceChannel(fFedSrnr,host);
   // if init not  ok. delete set fDimFedDev=0;fDevAdm=0;
   // fHost="undefined";
   // else
   fDevAdm = new DimFedDevAdm;
   
   fDevAdm->channel=fDimFedDev ;
   fDevAdm->usecount=1;
   fDevAdm->host=host;
   fHost=host;
   fDimFedAdm[fFedSrnr]=fDevAdm;
 }
}
FedDeviceDim::FedDeviceDim(int fedsrnr){
  fFedSrnr=fedsrnr;
  fDFD=fDimFedAdm.find(fFedSrnr);
  if( fDFD != fDimFedAdm.end()){
    fDimFedDev= fDFD->second->channel;    
    fDFD->second->usecount++;
    fHost= fDFD->second->host;
    fDevAdm=fDFD->second;
  }
  else {
    fDFD=0;
    fDevAdm=0;
    fHost="undefined";
  }    
}


bool FedDeviceDim::setFedDelay(int & delayin ){
  int delay =0;
  bool delaynotaccepted=false; int maxdelays=10;
  int checkeddelays=0;
  if (delayin < 0) {
    delay=fDimFedDev->findDelay() -1;
    if (delay < 0) {delay=9;}
   
    //check if the calculated delay is not forbidden
    // if it set the delay one less and check again 
    // up to the maximum delay if all delays 
    // are forbidden  then .... the system can not work
    while ( delaynotaccepted &&  checkeddelays< maxdelays){
      delaynotaccepted=false;// in case no match is found
      for (unsigned int lc=0;lc< fDevAdm->forbidden.size();lc++){
	if( delay == fDevAdm->forbidden[lc]){
	  delay--; if (delay < 0) {delay=9;}
	  delaynotaccepted=true;
	  break;
	}
      }
      checkeddelays++;
    }
    fDevAdm->feddelay=delay;
  }
  else (delay = delayin % 10);
  delayin=delay;
  fDimFedDev->setDelay(delay);
  return (  checkeddelays != (maxdelays -1));
}


bool FedDeviceDim::setThresholds(){
  int low=0, high=0;
  return setThresholds(low,high);
}

bool FedDeviceDim::setThresholds(int& low , int& high){
  fDimFedDev->exitLoop();
  if ( low ==0  && high == 0 ){
    fDimFedDev->findThreshold(low,high);
  }
  fDimFedDev->setLowThreshold(low);
  fDimFedDev->setHighThreshold(high);
  fDevAdm->lowthreshold=low;
  fDevAdm->highthreshold=high;
  return true; 
}
void FedDeviceDim::setScopeMode(int j)
{ 
  if(j ==0) {
    // to overcome a bug 
    fDimFedDev->setLowThreshold(0);
  }
  else {
     fDimFedDev->setLowThreshold(1);
  }
  fDimFedDev->setScopeMode(j);
  fDimFedDev->setLowThreshold(fDevAdm->lowthreshold);
}





bool FedDeviceDim::isPresent(){
  return isPresent(fFedSrnr);
}

bool FedDeviceDim::isPresent(int fedsrnr){
  return ( fDimFedAdm.find(fedsrnr) != fDimFedAdm.end());
}

unsigned short FedDeviceDim::getApvEventData(
  int event,int ch,int apv, int nr_sample){
  return fDimFedDev->getApvEventData(event,ch,apv, nr_sample);
}

map<int,FedDeviceDim::DimFedDevAdm*> FedDeviceDim::fDimFedAdm;
