#include "TDeviceControl.h"
#include "TShare.h"
#include "fedprocessctrl.h"
#include <stdio.h>
#include <signal.h>
#include <iostream.h> 
#include <daqerrormsg.h>
static TDeviceControl* fControl =0;

FedProcessCtrl::FedProcessCtrl() : FedProcessCtrlInterface() 
{ fLocked=false;
  fInitialized=false;
  // Attach to Main control share memory
  if (fControl== 0)
    fControl =new TDeviceControl("ControlePrincipal",TShare_OPEN);
  DeviceControlDescription* d= (DeviceControlDescription*) fControl->Attach(); 
  int i=1;bool found=false;
  while ( i  && !found ) 
    {
      // start with i = 1 !
     
      if( PMCFED == d->Channel[i].fType)
	{  found=true; 
	int dc=0; //device counter
	while( dc <8 && d->Channel[i].fChannelNumber != -5)
	  { dc++;i++;}
	
	if( dc <8)
	  { int cc=i+1 ; //channel counter
	  fBoardnr=d->Channel[cc].fBoardId;
	  fShmSize= d->Channel[cc].fShareSize; 
	}
	else {fBoardnr = -1;}
	}
      i++;
	if( i > d->NumberOfChannels){ i=0;}
      
    }
  if( !found)
    {  DT_ERROR( "no PMCFED found ");
    }
  strcpy(fShmName,d->Channel[i].fShareName);
//  delete d;
  fPid = getpid();
  fCd = 0;
  if (AttachFEDDevice(fShmName,fPid)<0)
    {
      DT_DEBUG_LTC("Cannot get device for shmname" <<fShmName );
      if (fCd!=0)
        fControl->ReleaseDevice(fCd->fPidServer,fPid,-1);
      return;
    }
  fInitialized=true;
}

FedProcessCtrl::~FedProcessCtrl()
{
  //  printf("Destructeur  init %d  desc %d \n",fInitialized, fCd);
  this->release();
  //delete-> fMemoryClient;
  
   delete fControl;
}
void FedProcessCtrl::release()
{
  if (fInitialized && fCd!=0)
    fControl->ReleaseDevice(fCd->fPidServer,fPid,-1);

}

int FedProcessCtrl::AttachFEDDevice(char* shname, pid_t cp )
{
 
  fCd = fControl->RequestDevice(shname, cp);
  
  kill(fCd->fPidServer,SIGCONT);
  cout << "je signal" << fCd->fPidServer << endl;
  cout << "call shm with parameters name" <<   fCd->fShareName <<" size"<< fShmSize<< endl;
  fMemoryClient = new TShare(fCd->fShareName,TShare_OPEN,fShmSize);
  fFed= (FedDescription*) fMemoryClient->Attach();
 


  return 0;
}
bool FedProcessCtrl::NewSpill(int skip)
{
  fMemoryClient->Lock(); 
  fLocked=true;
  fSpillnr=(unsigned int)fFed->getSpill();
  fSpillnr+=(unsigned int)(skip);
  fMemoryClient->Unlock();fLocked=false;
 return NewSpill();
} 


bool FedProcessCtrl::NewSpill()
{ bool returnvalue=false;
  fMemoryClient->Lock();			    
  fLocked=true;
  if ( fSpillnr >= (unsigned int)fFed->getSpill())
    {fMemoryClient->Unlock();fLocked=false;	 returnvalue= false; }
  else
    { returnvalue =true;
    fNrEvents= fFed->getNinSpill();
    fSpillnr=(unsigned int)fFed->getSpill();
    }
 
  return returnvalue;
}


void  FedProcessCtrl::NextSpill()
{ if(fLocked)
  {  fMemoryClient->Unlock();fLocked=false; }
}
