#include "TDeviceControl.h"
#include "TShare.h"
#include "fedprocessctrldimdev.h"
#include <stdio.h>
#include <signal.h>
#include <iostream.h> 
#include "daqerrormsg.h"

FedProcessCtrlDimDev::FedProcessCtrlDimDev(int fedsrn, string host,vector<int> fbd ) : FedDeviceDim( fedsrn,  host,fbd ){
  // these commands are to be compatible with the 
  // shared memory and have to become individual commonds
  // for the fedProcessCtrl
  
  
  fInitialized=false;
  if( isPresent()) {
    fInitialized=true;
    fDimFedDev->init();
    fSpill=fDimFedDev->getNinSpill();
    // fDimFedDev->restart(); 
  }
}

bool FedProcessCtrlDimDev::AdjustThresholds(){
  int low=0, high=0;
  return  setThresholds(low,high);
} 

bool FedProcessCtrlDimDev::AdjustThresholds(int& low, int& high){
  bool retval =setThresholds(low ,high);
  // cout <<"low " << low<<" high " << high <<endl;
  return  retval;
} 

bool FedProcessCtrlDimDev::NewSpill(){
 bool returnvalue=false;
 // fSpillSize inherited from interface 
 int n;
  if(fSpillSize >= (n=fDimFedDev->getNinSpill())){
    DT_DEBUG_LTC("actspillsize: "<<n <<" requested "<< fSpillSize);
    returnvalue= false;
  }
  else {
    
    returnvalue=true;
    // fDimFedDev->disableTrigger();
    fSpill=fDimFedDev->getSpillNumber();
    fActSpillSize=fDimFedDev->getNinSpill();
    DT_DEBUG_LTC("actspillsize: "<<fActSpillSize );
  }
 
  return returnvalue;  
}

bool FedProcessCtrlDimDev::NewSpill(int skip){ 
  clearFed();
  return NewSpill();
}

bool  FedProcessCtrlDimDev::stopFedDaqLoop(){
  fDimFedDev->exitLoop();
  return true;
}


bool  FedProcessCtrlDimDev::clearFed(){  
  int waits=0;int tries=0;
  while(tries++ <3){
    fDimFedDev->exitLoop();
    while (fDimFedDev->isRunning() && (waits++ < 5))  {
      sleep(1);
      printf("FED is still running wait %d of 5\n",waits);
    }
  }
  fDimFedDev->cleanStop();//added 01082003 
//  fDimFedDev->disableTrigger();
    fDimFedDev->clearBuffer(); 
//  fDimFedDev->purgeBuffer(); // done by clean start
    fDimFedDev->enableTrigger();//done by clean start?
    //DimFedDev->cleanStart();
    DT_DEBUG_LTC("request restart fed");
    fDimFedDev->restart();
  
  //normally the TSC should be stopped before
  return true; 
}

void FedProcessCtrlDimDev::setSpillSize(int spillsize){
  // has to be checked for maximum 
  if (spillsize > MAXBUFFEREVENT ) {spillsize=MAXBUFFEREVENT;}
  else {fSpillSize=spillsize;}
} 


void  FedProcessCtrlDimDev::NextSpill(){ 
  
  fDimFedDev->clearBuffer();
//  fDimFedDev->enableTrigger();
}

unsigned short 
    FedProcessCtrlDimDev::getApvEventData(int event,int ch,int apv, int nr_sample,int fednr){
  return FedDeviceDim::getApvEventData(event,ch,apv, nr_sample);
}

void  FedProcessCtrlDimDev::setScopeMode(int j){
  DT_DEBUG_LTC("set fed mode to "<< j);
  FedDeviceDim::setScopeMode(j);
}
