#include "fedprocessctrlwrapper.h"
#include "fedprocessctrl.h"
#include "fedprocessctrldummy.h"
#include "fedprocessctrldimdev.h"


FedProcessCtrlWrapper::FedProcessCtrlWrapper(   int device ,  LtParser* ltparser,bool ordernr  ) 
{ fInitialized=false;
   fDeviceId = device; 
   CalExchange <int>* c=0 ; 
                            
   int n =ltparser->getNumberFedProcessCtrl();
   DT_DEBUG_LTC("Probes " << n  ) ;
   c = ltparser-> getFedProcessCtrlInfo(fDeviceId,ordernr);
        
   if ( c)  {	
     DT_DEBUG_LTC(c->printIdValues(cout));
     DT_DEBUG_LTC("requested shmname: " << c->getTDeviceControlName( ));
     DT_DEBUG_LTC("name: " << c->getName( ));
     fType= c->getType();
   }
   else {fType =FedProcessCtrlInterface::SHAREDMEM;}  
   // !!! if not fedctrl is defined take the default one 
   switch ( fType ){ 
     case FedProcessCtrlInterface::DUMMY:{  
       FedProcessCtrlDummy* fTChanneld  = new FedProcessCtrlDummy();
       if ( !( fInitialized=fTChanneld->isInitialized()) ) 
	 { delete fTChanneld ;  fT=0;}
       else { fT=fTChanneld;DT_DEBUG_LTC("Dummy created");}
	
     }
     break; 
     case FedProcessCtrlInterface::SHAREDMEM: { 
       FedProcessCtrl* fTChannel  = new FedProcessCtrl();
       if ( !( fInitialized=fTChannel->isInitialized()) ) 
	 { delete fTChannel ;  fT=0;}
       else { fT=fTChannel;DT_DEBUG_LTC("Sharedmem created");}
     }
     break;
     case FedProcessCtrlInterface::DIMFEDDEV: {
       vector<int> dummy;
       string host(c->getShmName());
       FedProcessCtrlDimDev * fTChanneldd=  new 
	 FedProcessCtrlDimDev(c->getBoardNr(), host, dummy);
       if ( !( fInitialized=fTChanneldd->isInitialized()) ) 
	 { delete fTChanneldd ;  fT=0;}
       else { fT=fTChanneldd;DT_DEBUG_LTC("DimDev created");} 
     }
     break;
     default: fT=0;
       DT_DEBUG_LTC( "FedProcessCtrl type" << fType << "not supported"<< endl) ;
       
       break;
   }    
}

FedProcessCtrlWrapper::~ FedProcessCtrlWrapper()
{ ;
// nothing to do 

} 





