using namespace std;
#include <i2c_ledcontroller.h>
#include <iostream>
#include <unistd.h>



I2CLedController::I2CLedController(NormI2c *i,int baseaddr ){
  CTRLADDR=baseaddr;
  DATAADDR=baseaddr+2;
    ushort_led dummy = 0;
    
    i2cnorm = i;
    i2c=new I2cNormTransl(i2cnorm);
    // set DS = 1 and RESET = 0;
    dummy = 0x01;
    i2c->write(CTRLADDR, &dummy, 1);

    // set RESET = 1 and leave DS = 1;
    dummy = 0x03;
    i2c->write(CTRLADDR, &dummy, 1);

    ctrl = 0;

}

int I2CLedController::setVoltage(float voltage)
{
  int intvoltage;
  
  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  voltage /= 2;
  intvoltage = (int)((voltage+.001)*100.);

  // calculate the values of the two data packages to be sent
  return setVoltage(intvoltage);
}


int I2CLedController::setVoltage(int voltage){
  return setVoltage(voltage,14);
}


int I2CLedController::setVoltage(int voltage,int selectDAC )
{ int lowbit,highbit;
  ushort_led addr[3];
  ushort_led dummy;

  if ( voltage > 255 ) {
    cerr << "LedArray::setVoltage(int voltage) invalid voltage of "
         << voltage << " (0..255 allowed)" << endl;
    return -1;
  }

  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  // calculate the values of the two data packages to be sent
  cout << " LedArray::setVoltage(int voltage = " << voltage << ")" <<
endl;
  lowbit = (voltage & 0x0f) << 4;
  addr[0] = (ushort_led ) (lowbit | 0x7);
  highbit = (voltage & 0xf0);
  addr[1] = (ushort_led ) (highbit | 0xf);
  addr[2] =  (ushort_led )selectDAC;

  for (int i=0; i < 3; i++)
    {
      i2c->write(DATAADDR, &addr[i], 1);

      // generate data strobe
      dummy = 0x02;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);

    }

  return 0;

}

int I2CLedController::constIluminationSensor1(float voltage)
{

  // constant ilumantion for sensor 1

  int intvoltage;
  
  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  voltage /= 2;
  intvoltage = (int)((voltage+.001)*100.);

  // calculate the values of the two data packages to be sent
  return constIluminationSensor1( intvoltage);
 
}

int I2CLedController::constIluminationSensor1(int voltage)
{
  // constant ilumantion for sensor 1
  //

  if ( voltage > 255 ) {
    cerr << "LedArray::setVoltage(int voltage) invalid voltage of "
         << voltage << " (0..255 allowed)" << endl;
    return -1;
  }


  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  // calculate the values of the two data packages to be sent
  cout << " LedArray::setVoltage(int voltage = " << voltage << ")" <<
endl;
  return setVoltage( voltage,22);
  
}

int I2CLedController::constIluminationSensor2(float voltage)
{
  // constant ilumantion for sensor 2

  int intvoltage;
 
  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  voltage /= 2;
  intvoltage = (int)((voltage+.001)*100.);
  return constIluminationSensor2( intvoltage);
  

}

int I2CLedController::constIluminationSensor2(int voltage)
{

  // constant ilumantion for sensor 2
  if ( voltage > 255 ) {
    cerr << "LedArray::setVoltage(int voltage) invalid voltage of "
         << voltage << " (0..255 allowed)" << endl;
    return -1;
  }


  // the voltage can be set between 0 ... 255 which is equivalent
  // to 0V ... 2.55V
  // with an opamp you gain a factor of 2 in the voltage :0..5.1V
  // see datasheet for output voltage limitations !!

  // calculate the values of the two data packages to be sent
  cout << " LedArray::setVoltage(int voltage = " << voltage << ")" <<
endl;
  return setVoltage(voltage,30);
  
}

int I2CLedController::singleShot( int arraynumber,
                                  int lednumber, int switchnumber)
{
  ushort_led addr[2];
  ushort_led dummy;

  // calculate data to be sent

  addr[0] = arraynumber | 8 | (lednumber << 5);
  addr[1] = arraynumber | 16 | (switchnumber << 5);

  // sent data to the motherboard

  for (int i=0; i < 2; i++)
    {
      i2c->write(DATAADDR, &addr[i], 1);

      // generate data strobe
      dummy = 0x02;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);

    }

  return 0;

}

int I2CLedController::lvdsDisable( int arraynumber)
{
  ushort_led dummy;

  // disable LVDS on previous used LED-Array
  // just sent 00000xxx with xxx binary array ID

  i2c->write(DATAADDR, (ushort_led*)&arraynumber, 1);

      // generate data strobe
      dummy = 0x02;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);

  return 0;

}

int I2CLedController::arrayReset()
{

  //  sent reset to controll card and array
  //  resets all arrays connected to the same wire.

  ushort_led dummy;

      // !Reset = 0 and !DS = 1
      dummy = 0x01;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      // !Reset = 1 and !DS = 1
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);

  return 0;

}

int I2CLedController::powerSwitch(int power)
{
  ushort_led power_on = 38;
  ushort_led power_off = 6;
  ushort_led dummy;
  //power on

  if(power == 1)
    {
      i2c->write(DATAADDR, &power_on, 1);

      usleep(1000);
      // generate data strobe
      dummy = 0x02;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);

    }

  // power off

  if(power == 0)
     {
       i2c->write(DATAADDR, &power_off, 1);

      // generate data strobe
      dummy = 0x02;
      i2c->write(CTRLADDR, &dummy, 1);
      usleep(1000);
      dummy = 0x03;
      i2c->write(CTRLADDR, &dummy, 1);

    }
    return 0;

}

