#include "normi2ctsc.h"
#include "daqerrormsg.h"
#include "ledcardkarls.h"
#include "muxchannelkarls.h"
#include "i2c_ledcontroller.h"
#include "i2cid.h"


LedCardKarls::LedCardKarls(CalExchange <int>* ce){
  fCe=ce;
  fLedCard=0;
  fInitialized=false;
  int boardnr=fCe->getBoardNr();
  int adcnr;int devI2cchannel;int subdev ;int devicenr;
  I2cId::i2cdevicetypes type; 
  I2cId::decodeI2cBoardNr(boardnr,adcnr,devI2cchannel,
			  subdev,devicenr,type);    
  //fDevReg = new SharedDeviceRegistration(boardnr);
  //fI2c=fDevReg->getNormI2c( );  
  fI2cAddr=adcnr;
  char devicename[100];
  switch (type){
    case I2cId::TSCI2CCHANNEL :{
      sprintf(devicename,"tsci2c%02d",devicenr);
      fTsc= new  TscI2cDevice(devicename);
       fI2c= new NormI2cTsc(fTsc,devicenr);
    }
    break;
    case I2cId::PMCI2CCHANNEL:
    case I2cId::INVALID:
    default: {DAQEXIT("only TSCI2C  supported  requested is "<<type);} 
  }
  fLedCard= new I2CLedController(fI2c,fI2cAddr);
  if(fLedCard) {fInitialized = true ;}
}


LedCardKarls::~LedCardKarls(){
  if ( fLedCard) delete fLedCard;
  if ( fI2c) delete fI2c;
  if (fTsc) delete fTsc;
}

float  LedCardKarls::setLightLevel(float level){
  float setlevel0,setlevel1;
  setlevel0=setLightLevel(level,0);
  setlevel1=setLightLevel(level,1);
  if (setlevel0 < 0  || setlevel1 < 0) {
    return -1;
  }
  else {
    return (setlevel0 +setlevel1) /2;
  }
}


float  LedCardKarls::setLightLevel(float level, int channel){
  float setlevel;
  switch  (channel) {
    case 0 :{
      setlevel=fLedCard->constIluminationSensor1(level);
    } 
    break;
    case 1 : {
      setlevel=fLedCard->constIluminationSensor1(level);
    }
    break;
    default :  setlevel=-1;
  }
  return setlevel;
}
  









