#include "daqerrormsg.h"
#include "ledcardwrapper.h"
#include "ledcardkarls.h"
#include "ledcardio.h"
#include "ledcarddummy.h"
#include "ledcardinterface.h"
#include "ledcarddef.h"
#include "ltparser.h"

LedCardWrapper::LedCardWrapper( int devicenr,LtParser* ltparser) {
 
  fInitialized=false;
  fDeviceId = devicenr; 
  CalExchange <int>* c=
    ltparser->getLedCardInfo(devicenr);
  if ( c){
    DT_DEBUG_LTC(c->printIdValues(std::cout));
    fType= c->getType();
    
    switch(fType){
      case LedCardDef::KARLS :{
	fLedCard= new LedCardKarls( c);
	fInitialized=true;	
      }
      break;
      case LedCardDef::IOCARD :{
	fLedCard= new LedCardIo( c);
	fInitialized=true;	
      }
      break;
      case LedCardDef::DUMMY :{
	fLedCard = new LedCardDummy(c);
	fInitialized=true;
      }
      break;
      default:{
	DT_WARN("Led Card "<<devicenr<< " type " 
		<<fType <<" not defined");
      }
    }
  }
  if( ! fInitialized){
    DT_WARN("LedCard "<<devicenr<< " type "
	    << fType<<" not correctly initialized ");
  }
}

