#include "muxchannelkarls.h"
#include "daqerrormsg.h"
using namespace std;
MuxChannelKarls::MuxChannelKarls(int cardnr,MuxExchangeDef::FedMuxInfo mi,
				 MotherboardI2C* mb ){
  fCardnr= cardnr;
  fMuxInfo= mi;
  fMB=mb;
  fMux= new Multiplexer(mb,cardnr);
  fActiveGroup =-2 ; //invalid 
}

int   MuxChannelKarls::setActiveGroup ( int groupnr){
  int  seterror=0;
  if ( fActiveGroup == groupnr) { return 0;}
  map <int,int>::const_iterator ci=
     fMuxInfo.grp_ch.find(groupnr);
  if(ci != fMuxInfo.grp_ch.end()){
    fActiveGroup=groupnr;
    fActiveChannel=ci->second;
    DT_DEBUG_ND3("set muxcard "<< fCardnr <<" to channel " <<  fActiveChannel);
    seterror= fMux->selectChannel(fActiveChannel); 
  }
  return seterror;
}
       
MuxChannelKarls::~MuxChannelKarls(){
  if(fMux) delete fMux;
}
