#include "normi2ctsc.h"
#include "daqerrormsg.h"
#include "muxdevkarls.h"
#include "muxchannelkarls.h"
#include "i2cid.h"
#include "motherboardi2c.h"

using namespace std;
MuxDevKarls::MuxDevKarls( CalExchange <MuxExchangeDef::MuxValues>* ce){
  fCe = ce;
  int boardnr=fCe->getBoardNr();
  int adcnr;int devI2cchannel;int subdev ;int devicenr;
  I2cId::i2cdevicetypes type; 
  I2cId::decodeI2cBoardNr(boardnr,adcnr,devI2cchannel,
			  subdev,devicenr,type);    
  char devicename[100];
  switch (type){
    case I2cId::TSCI2CCHANNEL :{
      sprintf(devicename,"tsci2c%02d",devicenr);
      fTsc= new  TscI2cDevice(devicename);
       fI2c= new NormI2cTsc(fTsc,devicenr);
    }
    break;
    case I2cId::PMCI2CCHANNEL:
    case I2cId::INVALID:
    default: {DAQEXIT("only TSCI2C  supported  requested is "<<type);} 
  }

  fMB= new MotherboardI2C(fI2c);
  MuxExchangeDef::MuxValues* muxval = fCe->getCalValues();  
  for (MuxExchangeDef::CI  lc1=muxval->begin();
       lc1 !=muxval->end();lc1++){
    // card id is the device nr and the card nr in the device
    fCards[ MuxExchangeDef::cardId(boardnr,(*lc1).first) ]=
      new MuxChannelKarls((*lc1).first, (*lc1).second,fMB);
  }        
}

MuxDevKarls::~MuxDevKarls(){
  fCards.clearpointermap();
  if (fI2c) {delete fI2c;}
  if (fMB) {delete fMB;}
    // type id is needed to delete the correct device 
    // as there is no device interface class defined 
    int boardnr = fCe->getBoardNr();
    int adcnr;int devI2cchannel;int subdev ;int devicenr;
    I2cId::i2cdevicetypes type; 
    I2cId::decodeI2cBoardNr(boardnr,adcnr,devI2cchannel,
			    subdev,devicenr,type);
    
    switch (type){
      case I2cId::TSCI2CCHANNEL :{	 
	if(fTsc) { delete fTsc;}
      }
      break;
      case I2cId::PMCI2CCHANNEL:
      case I2cId::INVALID:
      default: { 
	DT_WARN("only TSCI2C  supported  requested is " <<type);
      } 
    }
    
  }


