#include "daqerrormsg.h"
#include "muxdevwrapper.h"
#include "muxdevkarls.h"
#include "muxdevdummy.h"
#include "muxexchange.h"
#include "muxdevinterface.h"
#include "ltparser.h"

MuxDevInterface* lttest::getMuxDev( int devicenr,LtParser* ltp){
 
   bool  fInitialized=false;
   CalExchange <MuxExchangeDef::MuxValues>* c=
     ltp->getMuxDevInfo(devicenr);
   MuxDevInterface* fMuxDev=0;
   int fType=0;
   if ( c){
     DT_DEBUG_LTC(c->printIdValues(std::cout));
     fType= c->getType();
     
     switch(fType){
       case MuxExchangeDef::KARLS :{
	 fMuxDev= new MuxDevKarls( c);
	 fInitialized=true;
	 
       }
       break;
       case MuxExchangeDef::DUMMY :{
	 fMuxDev = new MuxDevDummy(c);
	 fInitialized=true;
       }
       break;
       default:{
	 DT_WARN("Mux Device type " <<fType <<" not defined");
       }
     }
   }
   if( ! fInitialized){
     DT_WARN("mux" <<devicenr<<" of type "<< fType<<
	     " not correctly initialized ");
   }
   return fMuxDev;
}

