
#include "muxi2cchannellt.h"
#include "muxi2cchanneldummy.h"
#include "benchposconnection.h"
#include "muxi2cchannel.h"
#include "dimmuxaccesschannel.h"
#include "ltparser.h"
#include "daqerrormsg.h"
extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice

   
MuxI2cChannelLt::MuxI2cChannelLt(int slotpos  ) :MuxI2cChannelInterface(-1,-1){
  BenchPosConnection* BenchP =
    new BenchPosConnection(*ltparser->getBenchPosConnections(slotpos));
  if ( BenchP->getId() == -1 ) { 
    DAQEXIT("Benchpos" << slotpos <<" doesn't exist \n");
  }
     //BenchP->info();
  fChannel=BenchP->getCcuChannel();
  fBoard=  BenchP->getCcuAddress();
  this->setBoardId(fBoard);
  this->setChannelId(fChannel);
  BenchPosConnection::I2cDevType type=BenchP->getMuxType(); 
  if( BenchP->getFecSimulation())    {   
    type=BenchPosConnection::DUMMYI2C;
  }
  fMci=0;
  switch (type) {
    case BenchPosConnection::DUMMYI2C: {
      MuxI2cChannelDummy* fA = 
	new MuxI2cChannelDummy ("ControlePrincipal",fBoard,fChannel); 
      fInitialized= fA->isInitialized();
      fMci=fA;
    }
    break;
    case BenchPosConnection::MUX25DIM:   { 
      
      DimMuxaccessChannel* fA=
	new DimMuxaccessChannel(BenchP->getDimHostName(),0,0,fBoard,fChannel);
      fMci=fA;
      fInitialized=true; 
    }
    break;
    case BenchPosConnection::MUX25:   { 
      MuxI2cChannel* fA = 
	new MuxI2cChannel("ControlePrincipal",fBoard,fChannel);
      fInitialized= fA->isInitialized();
      fMci=fA;
    }
    break;
    default: { 
      DT_ERROR("Not existing type for MUX :"<<(int)type);
    }
  }
  if(fMci ==0) { fInitialized=false;}
  delete BenchP;
}

MuxI2cChannelLt::~MuxI2cChannelLt(){
  delete fMci;
} 



