#include "optoi2cchannellt.h"
#include "optoi2cchanneldummy.h"
#include "benchposconnection.h"
#include "dimoptoaccesschannel.h"
#include "optoi2cchannel.h"
#include "ltparser.h"
#include "daqerrormsg.h"
extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice

   
OptoI2cChannelLt::OptoI2cChannelLt(int slotpos  )   : 
  OptoI2cChannelInterface(-1,-1){  
 BenchPosConnection* BenchP =   
   new BenchPosConnection(*ltparser->getBenchPosConnections(slotpos));
 if ( BenchP->getId()== -1 ) { 
   DAQEXIT("Benchpos" << slotpos <<" doesn't exist \n");
 }
 //BenchP->info();
 
    fChannel=BenchP->getCcuChannel();
    fBoard=  BenchP->getCcuAddress() + 1000 * BenchP->getFecNr();

     this->setBoardId(fBoard);
     this->setChannelId(fChannel);
     BenchPosConnection::I2cDevType type=BenchP->getOptoType(); 
     if( BenchP->getFecSimulation()) {
       type=BenchPosConnection::DUMMYI2C;
     }
     switch (type) {
       case BenchPosConnection::DUMMYI2C: {
	 OptoI2cChannelDummy* fA = 
	   new OptoI2cChannelDummy ("ControlePrincipal",
				    fBoard,fChannel); 
	 fInitialized=true ;
	 fCd=fA;
       }
       break;
       case BenchPosConnection::OPTODIM: {
	 DimOptoaccessChannel* fA = 
	   new DimOptoaccessChannel(BenchP->getDimHostName(),
				    0,0,fBoard,fChannel);
	 DT_DEBUG_LTC("board" <<fBoard << "Channel" <<fChannel);
         fInitialized= true ;
	 fCd=fA;
       }
       break;
       case BenchPosConnection::OPTO: {
	  OptoI2cChannel* fA = 
	  new OptoI2cChannel("ControlePrincipal",fBoard,fChannel);
	 DT_DEBUG_LTC("board" <<fBoard << "Channel" <<fChannel);
         fInitialized= fA->isInitialized();
	 fCd=fA;
       }
       break;
       default: { 
	 DT_ERROR("Not existing type for opto :"<<(int)type);
       }
     }
    
    delete BenchP;

}

OptoI2cChannelLt::~OptoI2cChannelLt(){
  delete fCd;
} 



