#include "plli2cchannellt.h"
#include "plli2cchanneldummy.h"
#include "benchposconnection.h"
#include "dimpllaccesschannel.h"
#include "plli2cchannel.h"
#include "ltparser.h"
#include "daqerrormsg.h"
extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice

   
PllI2cChannelLt::PllI2cChannelLt(int slotpos  ) : PllI2cChannelInterface(-1,-1){  
  BenchPosConnection* BenchP=
    new BenchPosConnection(*ltparser->getBenchPosConnections(slotpos));
  if ( BenchP->getId()== -1 ) { DAQEXIT("Benchpos" << slotpos <<" doesn't exist \n");}
  //BenchP->info();
  fChannel=BenchP->getCcuChannel();
  fBoard=  BenchP->getCcuAddress() + 1000 * BenchP->getFecNr();
  this->setBoardId(fBoard);
  this->setChannelId(fChannel);
  fLatencyOffset= BenchP->getLatencyOffset();
  BenchPosConnection::I2cDevType type=BenchP->getPllType(); 
  if( BenchP->getFecSimulation())    {   
    type=BenchPosConnection::DUMMYI2C;
  }
  switch (type) {
    case BenchPosConnection::DUMMYI2C: {
	PllI2cChannelDummy* fA = 
	  new PllI2cChannelDummy ("ControlePrincipal",fBoard,fChannel); 
	fInitialized= true ;
	fCd=fA;
    }
    break;
    case BenchPosConnection::PLLDIM: {
      DimPllaccessChannel* fA = 
	new DimPllaccessChannel(BenchP->getDimHostName(),0,0,fBoard,fChannel);
      DT_DEBUG_LTC("DIM connect to "<<BenchP->getDimHostName() <<
				    " b :"<< fBoard << " ch " << fChannel);
      fInitialized= fA->isInitialized();
      fCd=fA;
    }
    break;
     case BenchPosConnection::PLL: {
      PllI2cChannel* fA = 
	new PllI2cChannel("ControlePrincipal",fBoard,fChannel);
       fInitialized= fA->isInitialized();
       fCd=fA;
     }
     break;
    default: { 
       DT_ERROR("Not existing type for pll :"<<(int)type);
     }
  }    
  delete BenchP;
 }

PllI2cChannelLt::~PllI2cChannelLt(){
  delete fCd;
} 



