#include "simulationexchange.h"
SimulationExchange::SimulationExchange() {
  fTriggerDelay=96;
}

Apv25Description SimulationExchange::Ad; 


bool SimulationExchange::CheckCalMode() {
 if( Ad.getMode()  &0x04) return false;
else return true;
}


bool SimulationExchange::StripCalActive( int stripnr){
  // int group = strip%8;
  unsigned char bitset= 1 << (stripnr % 8) ;
  return (bool)  (bitset & ~(unsigned char ) Ad.getCdrv());
}


int SimulationExchange::getTriggerDelay(){
  // for the moment fixed. 
  return fTriggerDelay; 
}

int SimulationExchange::getCalPulseHeight(int stripnr){
  int starttime =4;
  int stoptime =3;
  int steps=8;
  float ampl=0;
 if (StripCalActive( stripnr)){
   int latency=Ad.getLatency();
   unsigned short     delta= Ad.getCsel();
   ampl= 1.8*(float)Ad.getIcal() + (stripnr % 10);
   int dt= fTriggerDelay -latency ;
   if ( dt <= starttime  && dt >= -stoptime )  {
     if (dt < 0) { 
       dt =stoptime+dt+1 ;
       delta =steps*dt-delta-1 ;
       ampl=  ampl *  delta/ (stoptime *steps);
     }
     else{
       dt=starttime-dt;
       delta += steps* dt;
       ampl=ampl * delta/ (starttime * steps);
     } 
   }
   else { ampl=0;}
 }
 else {ampl=0;}


 return (int)ampl;
}

