#include <stdlib.h>

#include <TROOT.h>
#include <TApplication.h>
#include <TVirtualX.h>

#include <TGListBox.h>
#include <TGClient.h>
#include <TGFrame.h>
#include <TGIcon.h>
#include <TGLabel.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGMsgBox.h>
#include <TGMenu.h>
#include <TGCanvas.h>
#include <TGComboBox.h>
#include <TGTab.h>
#include <TGSlider.h>
#include <TGDoubleSlider.h>
#include <TGFileDialog.h>
#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>
#include <TH1.h>
#include <TH2.h>
#include <TRandom.h>
#include <TSystem.h>
#include <TEnv.h>
#include "I2CDialog_25t.h"


Int_t mb_button_id[9] = { kMBYes, kMBNo, kMBOk, kMBApply,
                          kMBRetry, kMBIgnore, kMBCancel,
                          kMBClose, kMBDismiss };




I2CDialog::I2CDialog(const TGWindow *main, UInt_t w,
                       UInt_t h)
    : TGMainFrame(main, w, h)    
{
   // Create a dialog window. A dialog window pops up with respect to its
   // "main" window.

   fL1 = new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX,
                           2, 2, 2, 2);
   fL2 = new TGLayoutHints(kLHintsBottom | kLHintsRight, 2, 2, 5, 1);

   fFrame = new TGVerticalFrame(this, 380, 420, kFixedWidth);

   fFrame0 = new TGCompositeFrame(this, 80, 220, kVerticalFrame);
   fFrame0->AddFrame( new TGLabel(fFrame0, "I2C Control"), fL1);


   fF01 = new TGCompositeFrame(fFrame0, 60, 20, kHorizontalFrame);
   fF01->AddFrame(new TGLabel(fF01, "FEC Device"), fL1);
   fF01->AddFrame(fTxtDevice = new TGTextEntry(fF01, new TGTextBuffer(100)), fL1);

   fFrame0->AddFrame(fF01,fL1);


  
   fFrame2 = new TGCompositeFrame(this, 160, 120, kHorizontalFrame);

   fOkButton = new TGTextButton(fFrame2, "&Ok", 1);
   fOkButton->Associate(this);
   fCancelButton = new TGTextButton(fFrame2, "&Cancel", 2);
   fCancelButton->Associate(this);

   fFrame2->AddFrame(fOkButton,fL1);
   fFrame2->AddFrame(fCancelButton,fL1);


   fFrame1 = new TGCompositeFrame(this, 80, 220, kVerticalFrame);

   fF1a = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF1a->AddFrame( new TGLabel(fF1a, "CCU address "), fL1);
   fF1a->AddFrame(fTxtCcuAddress= new TGTextEntry(fF1a, new TGTextBuffer(100)), fL1);


   fF1b = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF1b->AddFrame( new TGLabel(fF1b, "CCU channel "), fL1);
   fF1b->AddFrame(fTxtCcuChannel = new TGTextEntry(fF1b, new TGTextBuffer(100)), fL1);

   fF1 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF1->AddFrame( new TGLabel(fF1, "I2C Address"), fL1);
   fF1->AddFrame(fTxtAddress = new TGTextEntry(fF1, new TGTextBuffer(100)), fL1);
   
   fF2 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF2->AddFrame( new TGLabel(fF2, "Mode"), fL1);
   fF2->AddFrame(fTxtMode = new TGTextEntry(fF2, new TGTextBuffer(100)), fL1);

   fF3 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF3->AddFrame( new TGLabel(fF3, "Latency"), fL1);
   fF3->AddFrame(fTxtLatency = new TGTextEntry(fF3, new TGTextBuffer(100)), fL1);

   fF4 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF4->AddFrame( new TGLabel(fF4, "Ipre"), fL1);
   fF4->AddFrame(fTxtIpre = new TGTextEntry(fF4, new TGTextBuffer(100)), fL1);

   fF5 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF5->AddFrame( new TGLabel(fF5, "Isha"), fL1);
   fF5->AddFrame(fTxtIsha = new TGTextEntry(fF5, new TGTextBuffer(100)), fL1);

   fF6 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF6->AddFrame( new TGLabel(fF6, "Ipsp"), fL1);
   fF6->AddFrame(fTxtIpsp = new TGTextEntry(fF6, new TGTextBuffer(100)), fL1);

   fF7 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF7->AddFrame( new TGLabel(fF7, "Ipcasc"), fL1);
   fF7->AddFrame(fTxtIpcasc = new TGTextEntry(fF7, new TGTextBuffer(100)), fL1);

   fF8 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF8->AddFrame( new TGLabel(fF8, "Issf"), fL1);
   fF8->AddFrame(fTxtIssf = new TGTextEntry(fF8, new TGTextBuffer(100)), fL1);

   fF9 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF9->AddFrame( new TGLabel(fF9, "Ipsf"), fL1);
   fF9->AddFrame(fTxtIpsf = new TGTextEntry(fF9, new TGTextBuffer(100)), fL1);

   fF10 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF10->AddFrame( new TGLabel(fF10, "Vfp"), fL1);
   fF10->AddFrame(fTxtVfp = new TGTextEntry(fF10, new TGTextBuffer(100)), fL1);


   fF11 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF11->AddFrame( new TGLabel(fF11, "Vfs"), fL1);
   fF11->AddFrame(fTxtVfs = new TGTextEntry(fF11, new TGTextBuffer(100)), fL1);

   fF12 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF12->AddFrame( new TGLabel(fF12, "Vpsp"), fL1);
   fF12->AddFrame(fTxtVpsp = new TGTextEntry(fF12, new TGTextBuffer(100)), fL1);

   fF13 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF13->AddFrame( new TGLabel(fF13, "Imuxin"), fL1);
   fF13->AddFrame(fTxtImuxin = new TGTextEntry(fF13, new TGTextBuffer(100)), fL1);

   fF14 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF14->AddFrame( new TGLabel(fF14, "Ical"), fL1);
   fF14->AddFrame(fTxtIcal = new TGTextEntry(fF14, new TGTextBuffer(100)), fL1);

   fF15 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF15->AddFrame( new TGLabel(fF15, "Csel"), fL1);
   fF15->AddFrame(fTxtCsel = new TGTextEntry(fF15, new TGTextBuffer(100)), fL1);

   fF16 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF16->AddFrame( new TGLabel(fF16, "Cdrv"), fL1);
   fF16->AddFrame(fTxtCdrv = new TGTextEntry(fF16, new TGTextBuffer(100)), fL1);

   fF17 = new TGCompositeFrame(fFrame1, 60, 20, kHorizontalFrame);
   fF17->AddFrame( new TGLabel(fF17, "muxgain"), fL1);
   fF17->AddFrame(fTxtmuxgain = new TGTextEntry(fF17, new TGTextBuffer(100)), fL1);
   
   fFrame1->AddFrame(fF1a, fL1);
   fFrame1->AddFrame(fF1b, fL1);
   fFrame1->AddFrame(fF1, fL1);  
   fFrame1->AddFrame(fF2, fL1);
   fFrame1->AddFrame(fF3, fL1);
   fFrame1->AddFrame(fF4, fL1);
   fFrame1->AddFrame(fF5, fL1);
   fFrame1->AddFrame(fF6, fL1);
   fFrame1->AddFrame(fF7, fL1);
   fFrame1->AddFrame(fF8, fL1);
   fFrame1->AddFrame(fF9, fL1);
   fFrame1->AddFrame(fF10, fL1);
   fFrame1->AddFrame(fF11, fL1);
   fFrame1->AddFrame(fF12, fL1);
   fFrame1->AddFrame(fF13, fL1);
   fFrame1->AddFrame(fF14, fL1);
   fFrame1->AddFrame(fF15, fL1); 
   fFrame1->AddFrame(fF16, fL1);
   fFrame1->AddFrame(fF17, fL1);

   fTxtDevice->Resize(150, fTxtDevice->GetDefaultHeight());
   fTxtCcuAddress->Resize(150, fTxtAddress->GetDefaultHeight());
   fTxtCcuChannel->Resize(150, fTxtAddress->GetDefaultHeight());
   fTxtAddress->Resize(150, fTxtAddress->GetDefaultHeight());
   fTxtMode->Resize(150, fTxtMode->GetDefaultHeight());
   fTxtLatency->Resize(150, fTxtLatency->GetDefaultHeight());
   fTxtIpre->Resize(150, fTxtIpre->GetDefaultHeight());
   fTxtIsha->Resize(150, fTxtIsha->GetDefaultHeight());
   fTxtIpsp->Resize(150, fTxtIpsp->GetDefaultHeight()); 
   fTxtIpcasc->Resize(150, fTxtIpcasc->GetDefaultHeight());
   fTxtIssf->Resize(150, fTxtIssf->GetDefaultHeight());
   fTxtIpsf->Resize(150, fTxtIpsf->GetDefaultHeight());
   fTxtVfp->Resize(150, fTxtVfp->GetDefaultHeight());
   fTxtVfs->Resize(150, fTxtVfs->GetDefaultHeight());
   fTxtVpsp->Resize(150, fTxtVpsp->GetDefaultHeight());
   fTxtImuxin->Resize(150, fTxtImuxin->GetDefaultHeight());
   fTxtIcal->Resize(150, fTxtIcal->GetDefaultHeight());
   fTxtCsel->Resize(150, fTxtCsel->GetDefaultHeight());
   fTxtCdrv->Resize(150, fTxtCdrv->GetDefaultHeight());
   fTxtmuxgain->Resize(150, fTxtmuxgain->GetDefaultHeight());


   fTxtDevice->SetText("0");
   fTxtCcuAddress->SetText("4"); 
   fTxtCcuChannel->SetText("6");
   fTxtAddress->SetText("66");
   fTxtMode->SetText("15");
   fTxtLatency->SetText("94");
   fTxtIpre->SetText("115");
   fTxtIsha->SetText("50");
   fTxtIpsp->SetText("80");
   fTxtIpcasc->SetText("60");
   fTxtIssf->SetText("50");
   fTxtIpsf->SetText("50");
   fTxtVfp->SetText("67");
   fTxtVfs->SetText("67");
   fTxtVpsp->SetText("40");
   fTxtImuxin->SetText("50");
   fTxtIcal->SetText("200");
   fTxtCsel->SetText("0");
   fTxtCdrv->SetText("0");
   fTxtmuxgain->SetText("40");

   fFrame0->Resize(250, 250);
   fFrame1->Resize(250, 250);
   fFrame2->Resize(250, fOkButton->GetDefaultHeight());


   fFrame->AddFrame(fFrame0, fL1);
   fFrame->AddFrame(fFrame1, fL1);
   fFrame->AddFrame(fFrame2, fL1);


   AddFrame(fFrame,fL1);
   MapSubwindows();
   Resize(GetDefaultSize());

   // position relative to the parent's window
   Window_t wdum;
   int ax, ay;
   gVirtualX->TranslateCoordinates(main->GetId(), GetParent()->GetId(),
                          (((TGFrame *) main)->GetWidth() - fWidth) >> 1,
                          (((TGFrame *) main)->GetHeight() - fHeight) >> 1,
                          ax, ay, wdum);
   Move(ax, ay);

   SetWindowName("Dialog");

   MapWindow();
   //fClient->WaitFor(this);    // otherwise canvas contextmenu does not work
}

I2CDialog::~I2CDialog()
{
   // Delete test dialog widgets.


   delete fOkButton;
   delete fCancelButton;



  delete fTxtDevice;
  delete fTxtCcuChannel ;
  delete fTxtCcuAddress;
  delete fTxtAddress;
  delete fTxtMode;
  delete fTxtLatency;
  delete fTxtIpre;
  delete fTxtIsha;
  delete fTxtIpsp;
  delete fTxtIpcasc;
  delete fTxtIssf;
  delete fTxtIpsf;
  delete fTxtVfp;
  delete fTxtVfs;
  delete fTxtVpsp;
  delete fTxtImuxin;
  delete fTxtIcal;
  delete fTxtCsel;
  delete fTxtCdrv;
  delete fTxtmuxgain;

 delete fF1; 
 delete fF1a;
 delete fF1b;
 delete fF2; 
 delete fF3;
 delete fF4;
 delete fF5;
 delete fF6;
 delete fF7;
 delete fF8;
 delete fF9;
 delete fF10;
 delete fF11;
 delete fF12;
 delete fF13;
 delete fF14;
 delete fF15;
 delete fF16;
 delete fF17;
 delete fFrame1;
 delete fFrame2;
 delete fF01;
 delete fFrame0;
 delete fFrame;
 delete fL1; 
 delete fL2;

   
}

void I2CDialog::CloseWindow()
{
   // Called when window is closed via the window manager.

  //  delete this;
  UnmapWindow();
}

Bool_t I2CDialog::ProcessMessage(Long_t msg, Long_t parm1, Long_t)
{
   // Process messages coming from widgets associated with the dialog.



   switch (GET_MSG(msg)) {
      case kC_COMMAND:

         switch (GET_SUBMSG(msg)) {
            case kCM_BUTTON:
              printf("%ld \n",parm1);
               switch(parm1) {
                  case 1:
		  {   short  fecnb=0;  int  addrccu=4;  int i2cchannel=6;
		    short value;
		     sscanf(fTxtCcuChannel->GetText(),"%d",&i2cchannel);
		      sscanf(fTxtDevice->GetText(),"%d",&fecnb);
		      sscanf(fTxtCcuAddress->GetText(),"%d",&addrccu);
		      Apv25I2cChannel* apvi2c =  
			     new Apv25I2cChannel("ControlePrincipal",fecnb*10000+addrccu,i2cchannel);
		      if (!apvi2c->isInitialized()) exit(0);
		      fI2C=apvi2c;
                      //
#ifndef NOREALI2C
		    
                     fI2C->lock();
                      
                      sscanf(fTxtAddress->GetText(),"%hd",&value);
		      fI2C->setAddress(value);
                      sscanf(fTxtMode->GetText(),"%hd",&value);
		      fI2C->setMode(value);
                      sscanf(fTxtLatency->GetText(),"%hd",&value);
		       fI2C->setLatency(value);
                      sscanf(fTxtIpre->GetText(),"%hd",&value);
		       fI2C->setIpre(value);
                      sscanf(fTxtIsha->GetText(),"%hd",&value);
		       fI2C->setIsha(value);
                      sscanf(fTxtIpsp->GetText(),"%hd",&value);
		       fI2C->setIpsp(value);
                      sscanf(fTxtIpcasc->GetText(),"%hd",&value);
		       fI2C->setIpcasc(value);
                      sscanf(fTxtIssf->GetText(),"%hd",&value);
		       fI2C->setIssf(value);
                      sscanf(fTxtIpsf->GetText(),"%hd",&value);
		       fI2C->setIpsf(value);
                      sscanf(fTxtVfp->GetText(),"%hd",&value);
		       fI2C->setVfp(value);
                      sscanf(fTxtVfs->GetText(),"%hd",&value); 
		       fI2C->setVfs(value);
                      sscanf(fTxtVpsp->GetText(),"%hd",&value);
		      fI2C->setVpsp(value);
                      sscanf(fTxtImuxin->GetText(),"%hd",&value);
		      fI2C->setImuxin(value);
                      sscanf(fTxtIcal->GetText(),"%hd",&value);   
		       fI2C->setIcal(value);
                      sscanf(fTxtCsel->GetText(),"%hd",&value);   
		       fI2C->setCsel(value);
                      sscanf(fTxtCdrv->GetText(),"%hd",&value);   
		       fI2C->setCdrv(value);
                      sscanf(fTxtmuxgain->GetText(),"%hd",&value);   
		       fI2C->setMuxgain(value);
		       fI2C->justDoIt();
                      fI2C->unlock();
#else
		      printf(" No check or read to I2C channel \n");
#endif 
#ifndef NOREALI2C 
		      fI2C->release();
#endif 
                    
                    
                    delete fI2C;
                            
                    }
                    break;
                  case 2:
                    printf("\nTerminating dialog:%ld, %s pressed\n",parm1,
                            (parm1 == 1) ? "OK" : "Cancel");
                     CloseWindow();
                     break;
                  default:
                     break;
               }
               break;
            case kCM_RADIOBUTTON:
               switch (parm1) {
               default:
                     break;
               }
               break;
            case kCM_CHECKBUTTON:
               switch (parm1) {
                  default:
                     break;
               }
               break;
            default:
               break;
         }
         break;

      default:
         break;
   }
   return kTRUE;
}

