//#define I2CPMC
#ifdef I2CPMC
#include "i2cpmcdevice.h"
#include "normi2cpmc.h"
#else 
#include "tsci2cdevice.h"
#include "normi2ctsc.h"
#endif
#include "motherboardi2c.h"
#include "multiplexer.h"
#include <string.h>
#include <stdio.h>

int main()
{
#ifdef I2CPMC 
  I2cPmcDevice i2cpmc(0);
  NormI2cPmc  i2c(&i2cpmc);
#else
  TscI2cDevice tsc("tsci2c06");
  NormI2cTsc  i2c(&tsc,6); 
#endif 
  Motherboard *mbd = new MotherboardI2C(&i2c);
  int channel,board_id,nmux=3,selmux;
  Multiplexer *multi[nmux];
  
  for (int k=0; k<nmux;k++) {
    //    Multiplexer multi[k] (mbd, k);
    multi[k] = new Multiplexer(mbd, k);
  }   
  char in;

       cout << endl;
       cout << " Testprogramm for Multiplexer  " << endl;
       cout << "-------------------------------" << endl;
       cout << "S selects channel to multiplex " << endl;
       cout << "D disables all relais  " << endl;
       cout << "E exits  the programm. " << endl;
       cout << "C cycles the full MUX. " << endl;
       cout << endl;
   do  
     {
       cin >> in;
       switch (in)
         {
         case 'S':
         case 's':
           
	   cout << " Which Multiplexer should be used (0.." << nmux 
	        << ") :" ;
	   cin >> selmux;
           cout << " Select Channel (0 ...9): " ;
           cin >> channel;
	   board_id = 0; 

           multi[selmux]->selectChannel( channel, board_id);
	   cout << "   done...  " << endl; 

           break;
	 
	 case 'D':
	 case 'd':

	   cout << " Which Multiplexer should be used (0.." << nmux 
	        << ") :" ;
	   cin >> selmux;
	   cout << " Disable all relais on Board_ID ? ";
	   cin >> board_id;

	   multi[selmux]->disableSwitch(board_id);
	   cout << "   done...  " << endl; 

	   break;

         case 'C':
         case 'c':
	   
	   cout << " Which Multiplexer should be used (0.." << nmux 
	        << ") :" ;
	   cin >> selmux;
	   cout << endl << endl;
           cout << " Now we cycle the full Multiplexer " << endl;
           cout << "-----------------------------------" << endl;
	   board_id = 0;

	   for (int k=0; k<=9; k++) {

             multi[selmux]->selectChannel( k, board_id);
	     cout << " " << k;
             sleep(1);

           }

           multi[selmux]->disableSwitch(board_id);
           cout << "   done...  " << endl;

           break;
	 }
     }
   while( (in !='e') && (in != 'E'));

  return 0;
}


















