#include <sys/wait.h>
#include <signal.h>
#include <unistd.h>
#include "ltparser.h"
#include "daqerrormsg.h"
#include <apv25i2cchannelinterface.h>
#include "apv25i2cchannellt.h"
#include "benchposconnection.h"
#include "cmdlinedecode.h"
 
#define MAXPOS 2 
LtParser* ltparser;


bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}

 
void usage (){
  cout << "set  query all APV in defined benchpositons unless -benchpos is given"<<endl;
  cout <<" stop with Ctrl-C , program will first finsh the loop before exiting"<<endl;
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tTestLtI2cChannels  -benchpos 3  -ltconfig lttemp.xml " <<endl;
  cout <<"options:"<<endl;
  cout <<"\t-ltconfig :the configuration file (default is lt.xml)"<<endl;  
  cout <<"\t-benchpos : check apv for only this bench pos"<<endl;
  cout <<"\t-h : this message"<<endl;
  cout <<endl;
  std::exit(-1);
}

int   main (int argc ,  char **argv){   
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  int benchpos=-1;
  string cmdresult;
  string cmderr;
  
  if( "found"== CmdLineDecode(argc,argv,"h",cmdresult,false)){
    usage();
  }   
  if( "found"== CmdLineDecode(argc,argv,"benchpos",cmdresult,true)){
    benchpos= atoi(cmdresult.c_str());
    DT_DEBUG_LTAPPL("Check only for "<< cmdresult.c_str());
  }
  ltparser = new LtParser();
  if( "found"== CmdLineDecode(argc,argv,"ltconfig",cmdresult,true)){
    // cout<< "use "<< result <<" as config " <<endl;
    ltparser->setParseFileName( cmdresult);
    DT_DEBUG_LTAPPL("Procedure: parse "<< cmdresult.c_str());
  }
  ltparser->parseFile();
  int nrPB=0;
  BenchPosConnection* BenchP[MAXPOS];
  if( benchpos<0 || benchpos > 10) {
    nrPB= ltparser->getNumberBenchPositions() ;
    for (int lc =0 ; lc < nrPB ; lc++) { 
      BenchP[lc]=new BenchPosConnection(*ltparser->getBenchPosConnections(lc));
      BenchP[lc]->info();
    }
  }
  else {
    nrPB=1;
    BenchP[0]=new BenchPosConnection(benchpos);
    if (!BenchP[0] ) {
      DAQEXIT("no info for bencpos "<<benchpos);
    }
  }

  Apv25I2cChannelInterface* apv[20];  
  if  (nrPB > 20 ) exit(-1);
  for (int lc =0 ; lc < nrPB ; lc++) {      
    Apv25I2cChannelLt*  apvreal=  new Apv25I2cChannelLt(lc);
    if (!apvreal->isInitialized()) exit(0);
    //else 
    apv[lc]   = apvreal;     
  }

     // Use it 
 int count=0;
 int mode, readmode,address;
 while(! HasToExit)
   {  if (! (nrPB %2) ) count++ ;   
      for (int lc =0 ; lc < nrPB ; lc++) 
	{ apv[lc]->lock();
	switch( count%5)
	  {
	    case 1: address= 32 ; break;
	     case 2: address= 33 ; break;  
	    case 3: address= 36; break;  
	    case 4: address= 37; break;  

	    default :    address= 63; break;
	  }
	    apv[lc]->setAddress(address);

	  if(!( (count++) %2) )  mode=11 ;
	  else mode=15 ; 
	  apv[lc]->setMode(mode);
	  apv[lc]->setLatency(24+lc);
	  apv[lc]->setMuxgain(8);
	  apv[lc]->setCdrv(34);
	  
	
	 
	  apv[lc]->unlock(); 
	  apv[lc]->justDoIt();
	 apv[lc]->wait(); 

	 apv[lc]->justDoIt();
	 apv[lc]->wait(); 

	  apv[lc]->lock();
	  //apv[lc]->justDoIt();
	  //  apv[lc]->wait();
	  cout << "pos "<< lc<< "ccu ch" << BenchP[lc]-> getCcuChannel()  <<" address " << apv[lc]->getAddress(); 
	  readmode= apv[lc]->getMode();
	  cout <<" setmode "<< mode <<" read  mode " << readmode;
	  if ( readmode != mode ) cout << "ERROR" ;
	  cout << "cnt: "<< count;
//     apv[lc]->setLatency(24);
	  cout <<" muxgain " <<      apv[lc]->getMuxgain();
	  //     apv[lc]->setCdrv(34);

	  cout << endl;
	  apv[lc]->unlock();  
	  
	  sleep(3);
	}
   }
 // Release
 for (int lc =0 ; lc < nrPB ; lc++) delete  apv[lc] ;
 
     return 0;
}
