using namespace std;

//#include <ios_base>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "ltparser.h"
#include "dcuchannellt.h"
#include "daqerrormsg.h" 
#include "cmdlinedecode.h"
LtParser* ltparser;
#include "dcuconversion.h"
using namespace DcuConversionDef;
bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}

 

void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tTestLtDcuChannel   -benchid  100  -ltconfig lttemp.xml " <<endl;
  cout <<"-benchnr  nr of the bench "<<endl;
  cout <<"-ltconfig  filename :  name of the configuration file  optional"<<endl;
  cout <<"-h  this message "<<endl<<endl;
  std::exit(-1);
}



int   main (int argc, char** argv)
{ char adcdes[8][10]={"SINTC","V2.50","V1.25","BIAS ",
		      "HYBT ","NC   ","NC   ","DCUT "};
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  
  int benchnr=0;
  DaqToolsErrorMessage dte;
 cout <<   dte.getPrintingLevel() << endl;
 string result;
   string cmdresult;
   if( "found"==CmdLineDecode(argc,argv,"h",result,false)) {
     usage();
   }
   if( "found"==( cmdresult=CmdLineDecode(argc,argv,"benchnr",result,true))){
     benchnr = (int)  strtod(result.c_str(),NULL);
   }
   ltparser = new LtParser();
   if( "found"==CmdLineDecode(argc,argv,"ltconfig",result,true)){
     cout<< "use "<< result <<" as config " <<endl;
     ltparser->setParseFileName( result);
   }
   if(ltparser->parseFile( )) {
     DAQEXIT("error in lt configuration file look at error output");} 
   
   cout << "use dcu of benchpos "<<benchnr<<endl; 
  DcuChannelLt* dcu = 
     new DcuChannelLt(benchnr);
  DcuConversion conv(0);
  // if (!dcu->isInitialized()) exit(0);
  dcu->lock();
   dcu->setAddress(0x0);
   dcu->unlock();
//   ios_base::fmtflags mycoutflags=ios_base::left|ios_base::hex;
//   ios_base::fmtflags old_coutflags=cout.flags(mycoutflags);
   
     // Use it

   short unsigned int dcuvalue=0; 
  while ( ! HasToExit)    { 
    dcu->update();
    cout<< V250<<" "  << adcdes[V250]
	<<" V250 "<< dcu->getDcuV250()<<"\t";
    cout<<V125 <<" "  <<adcdes[V125]
	<<" V125 "<< dcu->getDcuV125()<<endl ;
    dcuvalue= (short unsigned int)dcu->getDcuTempSi();
    cout<<SITEMP<<" " <<adcdes[SITEMP]
	<<" TSi  "<<dcuvalue<<"=="
	<< conv.DcuExternTemperature(dcuvalue)
	<<" C== "<< conv.Dcu2Voltage(dcuvalue)<<"V \t";
    dcuvalue=(short unsigned int)dcu->getDcuTempHyb(); 
    cout<<EXTTEMP<<" "<<adcdes[EXTTEMP]
	<<" THyb "<<dcuvalue<<"=="
	<< conv.DcuHybridTemperature(dcuvalue)
	<<" C== "<< conv.Dcu2Voltage(dcuvalue) <<endl;
    cout<<INTTEMP<<" "<<adcdes[INTTEMP]
	<<" TDcu "<<dcu->getDcuTempInt()<<"\t";
    cout<<IBIAS<<" "<<adcdes[IBIAS]
	<<" Bias " <<dcu->getDcuBiasCurrent()<<endl<<endl;
    if (HasToExit) break;
    usleep(2000000);
  }
//  cout.flags(old_coutflags);
    
     dcu->release();
     delete dcu;
     return 0;
}
