#ifndef __HUMIDITYCHANNEL
#define __HUMIDITYCHANNEL
#include "CalibrationValues.h"
#include <humiditychannelinterface.h>
#include <adcchannelinterface.h>

/** \brief humidity  channel interface 
     
     
     The HumidityChannel will be the interface class
     The Adc Channel indicates which humidity  probe is used. The type is looked up in 
     the config file what is hardcoded at the moment in CalibrationValues.h
     
     For an example how to use it look at ScMonitor
   
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 03 24 

 
*/


                               
class HumidityChannel : public HumidityChannelInterface
{ 
private:
   AdcChannelInterface  *fHAdc, *fRefAdc;
   float fActualAdcValue;
   float fRefAdcValue;
 
 public:
  HumidityChannel( AdcChannelInterface  *HAdcCh,AdcChannelInterface *RAdcCh ,
		   CalExchange <HumidityConversionDef::HumidityCalValues>* c );
    
 

   virtual float getHumidity();
   virtual float getInputValue(){return fActualAdcValue;} 
   virtual float getRefVolt(){return fRefAdcValue;}
   AdcChannelInterface* getAdcChannelPointer(){return fHAdc;}


//  float getLastHumidityAdcValue()
//    { 
//    return fActualAdcValue; 
//   }


  virtual void info()
    { float RefAdcValue ;
     while (! fRefAdc->getAdcData(RefAdcValue)) {};
     printf("___________________________________________\n");
     printf(" Actual Vref value %f \n", RefAdcValue);
     fHAdc->getAdcData(fActualAdcValue); 
      printHCvalues( fActualAdcValue);
      printf (" actualhumidity  %f %% \n", getHumidity());
    }

  
};

//ostream& operator<<(ostream& s, HumidityChannel HC  );

//ofstream& operator<<(ofstream& s, HumidityChannel HC  );


#endif
