#ifndef HUMIDITYCHANNELDIM
#define HUMIDITYCHANNELDIM
#include <dic.hxx>
#include "humiditychannelinterface.h"
#include "CalibrationValues.h"
#include "daqerrormsg.h"
#include "dimchannelnames.h"
#include <stdlib.h>

class HumidityChannelDim : public HumidityChannelInterface ,			     
			      public DimChannelNames,
			      public  DimClient

{ private:
  bool fIsIntialized;
  float fActualHumidity;
  public:
  HumidityChannelDim(CalExchange <HumidityConversionDef::HumidityCalValues>* c);
/// get the actual humidity
   virtual float getHumidity();
   virtual float getInputValue(){return fActualHumidity;}

   /** \brief  send inforation about the humidity channel to cout ,use only for debug reasons
       it is allowed to implement a empty function here */
   virtual void info(){;}
   virtual bool isInitialized(){ return fIsInitialized;}   
   virtual ~HumidityChannelDim() {};
   int wait();
  void infoHandler();

private:
  DimInfo* fHumidityinfo;
 char fCmd[80];
  float  fSent[256];
  float  fRecBuf[256];
 int fNsent;
  int fNreceived;
  bool fIsInitialized;
};



#endif
