#ifndef __HUMIDITYCHANNELINTERFACE
#define __HUMIDITYCHANNELINTERFACE

#include <iostream>
#include <fstream>
#include "CalibrationValues.h"
#include <adcchannelinterface.h>

/** \brief humidity  channel interface 
     
     
     The HumidityChannel will be the interface class
   
     For an example how to use it look at
   
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 05 23 

 
*/



class HumidityChannelInterface  : public HumidityConversion 
{
 public:
 HumidityChannelInterface(){ }
 HumidityChannelInterface(  CalExchange <HumidityConversionDef::HumidityCalValues>* c ):
   HumidityConversion(*c) {}

 virtual float getHumidity()=0;
 /** return the raw input value like an adc input */
 virtual float getInputValue()=0;
 ///this function should not be used for standard application 
 virtual float getRefVolt(){return-1;}



// float getLastHumidityAdcValue()=0;
 virtual void info()=0;
 virtual ~HumidityChannelInterface(){};
 virtual bool isInitialized(){return false;}
 
};
std::ostream& operator<<(std::ostream& s, HumidityChannelInterface& HC  );

std::ofstream& operator<<(std::ofstream& s, HumidityChannelInterface& HC  );


#endif
