#ifndef __HUMIDITYCTRLDUMMY 
#define __HUMIDITYCTRLDUMMY

#include "humidityctrlinterface.h"
class PowerChannelInterface;
/**  \class Humidityctrldummy
  

 \brief class  implementation of the HumitityCtrlInterface
     reads the humidity from a humidity probe and set the gas flow output
     The class can also be used as a humiditychannel
     version 0.10 is a minimum implementation. No  control only 
     switch on in control 
     \author W. Beaumont
     \date 20021122
     \version 0.10
     
*/ 


class HumidityCtrlDummy: public HumidityCtrlInterface
{  public :
    /** the HumidityCtrlDummy initialization using the configuration file 
        @param c the id and calibration information 
    */
    HumidityCtrlDummy( CalExchange <HumidityCtrlDef::HumidityCtrlValues>* c );
    virtual ~HumidityCtrlDummy();
 
  /**   \brief this call updates the steering value 
	to achieve the required temperature
	should be called on regulair base. 
	returns 0 if o.k
	-1 if temperture read is not updated
	-5 unknow error 
  */
  virtual int control();
  
  
  /** set the power to inactive   
   */
  virtual void setZeroGasFlow(); 
  virtual void setMaxGasFlow();
  virtual void setTargetHumidity (float target); 
  virtual  float getTargetHumidity (); 
   
  /** for cold box with synchrone control set direct the power  */
   virtual void    setGasFlow(float flow ) ;
 /** return the value to which the gasflow is set  */
   virtual float getGasFlow(); 
   virtual int  getType();
 
  virtual float getHumidity();
 /** return the raw input value like an adc input */
 virtual float getInputValue();
 ///this function should not be used for standard application 
 virtual float getRefVolt();
  virtual void info(){ printHumidityCtrlDummy();}  

 protected: 
   
  
  private:
  int fGasFlowChannelId; 
  CalExchange <HumidityCtrlDef::HumidityCtrlValues>* fCH;
  float fTargetHumidity; //< the request temperature for the system
  float fActualGasFlow;//< the actual power 
  //CtrlStatus fCtrlStatus ;
 
  void cleanup();
  void   printHumidityCtrlDummy();
 

};

#endif
