#ifndef __HUMIDITYCTRLPROBE 
#define __HUMIDITYCTRLPROBE

#include "humidityctrlinterface.h"
;
/**  \class HumidityCtrlPRoble
  

 \brief class  implementation of the HumitityCtrlInterface
     reads the humidity from a humidity probe 
     and is used to exchange parameters  with the  tempctrl 
    
     \author W. Beaumont
     \date 200310724
     \version 1.00
     
*/ 


class HumidityCtrlProbe: public HumidityCtrlInterface
{  public :
    /** the HumidityCtrl initialization using the configuration file 
        @param c the id and calibration information 
    */
    HumidityCtrlProbe( 
      CalExchange <HumidityCtrlDef::HumidityCtrlValues>* c );
    virtual ~HumidityCtrlProbe();
 
  /**   \brief this call updates the steering value 
	to achieve the required temperature
	should be called on regulair base. 
	returns 0 if o.k
	-1 if temperture read is not updated
	-5 unknow error 
  */
  virtual int control();
  
  
  /** set the power to inactive   
   */
  virtual void setZeroGasFlow(); 
  virtual void setMaxGasFlow();
  virtual void setTargetHumidity (float target); 
  virtual  float getTargetHumidity () { return -1 ;}
  /** if maximum allowed humidity is reached it returns true
      this checks the actual humidity against the maximum humidity
  */
  bool maxHumidityReached();
   
  /** for cold box with synchrone control set direct the power  */
   virtual void    setGasFlow(float flow ) ;
 /** return the value to which the gasflow is set  */
   virtual float getGasFlow(); 
   virtual int  getType();
 
  virtual float getHumidity();
 /** return the raw input value like an adc input */
 virtual float getInputValue();
 ///this function should not be used for standard application 
 virtual float getRefVolt();
  virtual void info(){ printHumidityCtrl();}  


     
  private:
  HumidityChannelInterface* fHumidity;
 
  //CtrlStatus fCtrlStatus ;
 
  void cleanup();
  void   printHumidityCtrl();
 

};

#endif
