#ifndef __INTERLOCK
#define __INTERLOCK 

class DioChannelInterface ;
#include <CalibrationValues.h>

/**
   \class InterLock 
   \author W. Beaumont  
   \date  March 2002
   \version 1.00

   \brief class interface to the interlock system
   This class gives the methodes to access interlock information and 
   to interact with the inter lock system.
   The interaction to the inter lock can be 
   - activate interlock , this will activate an I/O channel that activates the interlock
     system. This can be used in case of emergency 
   - restart watch dog. 
   Interlock system  can not be reenabled by software by definition.
   The class  get informatation of witch IO channels are connected to this class by the LtParser class. 
   
 */




class InterLock : public CalExchange< int[3] >
{ private:
  int fDeviceId;
  int fInitialized;
  DioChannelInterface*  fInterlockOut ;
  DioChannelInterface*  fWatchDog;
   DioChannelInterface* fStatusline;
   // DioChannelInterface* fActiveLine;
 public:
    enum INTERLOCKLINE{ WATCHDOG=0 ,STATUS=1,EMERGENCY=2}; 
    enum INTERLOCKTYPE {DUMMY,ACTIVE};

  InterLock(int device=0);
  ~InterLock();
  
  void Restart_Watchdog(){;}
  int GetInterlockLineStatus();
  void ActivateInterlock();
   
    
};

#endif
