#ifndef __POWERCHANNELINTERFACE
#define __POWERCHANNELINTERFACE
//#include  <unistd.h>
#include <iostream>
#include <fstream>
//#include "CalibrationValues.h"
//#include <adcchannelinterface.h>

/** \brief power channel interface class
     
     The  PowerChannelInterface  is a minium interface definition
     implementations are assumed to take care about calibration issues and 
     attachment to real power channel, mostly DAC connected to voltage controlled power supply
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 10 04
   
 
*/

class PowerChannelInterface  
{  public:
  /// get the actual power
  virtual float getPower() =0;
  /// set the actual power 
  virtual unsigned short  setPower(float setpower)=0; 
  /// get the device ID
  virtual int getId()=0;
  /** \brief  send inforation about the power channel to cout ,use only for debug reasons
      it is allowed to implement a empty function here */
  virtual void info()=0;
  /** returns true if the power channel can also heat beside cooling */
  virtual bool heater(){return false;} 
  virtual ~PowerChannelInterface() {;};


};

std::ostream& operator<<(std::ostream& s, PowerChannelInterface& TC  );
 
std::ofstream& operator<<(std::ofstream& s, PowerChannelInterface& TC  );


#endif 
