#ifndef __POWERCHANNELLT
#define __POWERCHANNELLT
#include  <unistd.h>
#include <iostream>
#include <fstream>

#include "powerchannelinterface.h"
#include "powerchannel.h" //needed can not be only be in src file  
#include "powerchannelpol.h" 
#include "powerchannelpolcom.h" 
/** \brief power channel lt class def file
  
     
     The PowerChannelLt  chose the correct connections based on the lt.xml file

     \author W. Beaumont University Antwerpen 
     \version 0.1 
     \date 20011004 
     
 
*/


class PowerChannelLt :  public PowerChannelInterface  
{ private:
   PowerChannelInterface*  fPC;
    bool fInitialized;
    int fDeviceId ;
    int fType;
  public:
  /** \brief constructor 
      The powerchannel needs a pointer to a DacChannel. The PowerChannelLt chose the correct DacChannel 
      instantiation based on the device ID and the description in the lt.xml file 
      @param DeviceID  the device ID in the lt.xml file 
      @param polstatus the status of the common pollarity switch for tempctl (like Wien box)    
  */
   PowerChannelLt( int DeviceId , int*  polstatus = 0  ) ;
    /// returns the device ID of the power channel
    virtual int  getId()  { return fPC->getId();}
    /// set the ouptut device to deliver the actual power  returns the new DAC setting (in Volts)
    virtual unsigned short  setPower(float power) { return fPC->setPower(power);}
    
    /// read back the set power 
    /** depends from DAC if this is the last set value (software read back)
	or a read back from the (hardware) device setting
    */ 
    virtual float getPower(){return fPC->getPower() ;}
    virtual bool heater() {return  fPC->heater();}
    /// print some information about the power channel object only for debug reasons
   virtual void info() { fPC->info();}
   
   ~PowerChannelLt();
};

#endif 
