#ifndef __TEMPCTRLREG 
#define __TEMPCTRLREG

#include <map>
#include <unistd.h>
#include <iostream>

#include "CalibrationValues.h"
#include <adcchannelinterface.h>
#include "powerchannelinterface.h"
#include "temperaturechannelinterface.h"
#define MAX_HISTORY_ENTRIES 10

class ColdBox;

class TempCtrlInterface;
TempCtrlInterface* getTempCtrlMapInfo(int deviceid);

/** 
  
 \brief register tempctrl objects
    
     \author W. Beaumont
     \date 20030718
     \version 1.00
     
*/ 


class TempCtrlReg
{ 
  // definitions 
  int fDeviceId;
  protected :
  static std::map <int,TempCtrlInterface*> fRegTempCtrls ;
  std::map <int,TempCtrlInterface*>* getTempCtrlRegMap(){ return &fRegTempCtrls;}
  friend TempCtrlInterface* getTempCtrlMapInfo(int deviceid);
  friend class ColdBox;
  /** remove the temperature contrl from the map 
      @return true if succesful
   */
  unsigned int fNrReference;
  
  /** register the device id to the tempctrl map 
      assumed is that it is already tested that the tempctrl device id
      is not already registered 
  */
  
  public :
    TempCtrlReg(){fNrReference=0;} 
  
  
   ~TempCtrlReg(){;}
   bool  unRegisterTempCtrl();
  bool  registerTempCtrl(int id, TempCtrlInterface *tci);
  void increaseReference(){fNrReference++;}
  void decreaseReference(){fNrReference--;}
};

#endif
