#ifndef __TEMPCTRLTCPIP
#define __TEMPCTRLTCPIP
#include <map>
#include <unistd.h>
#include <stdiostream.h>
#include <string>
#include "CalibrationValues.h"
#include <adcchannelinterface.h>
#include "powerchannelinterface.h"
#include "tempctrlinterface.h"
#include "viproxy.h"
#define MAX_HISTORY_ENTRIES 10

class TempCtrlTCPIP:public TempCtrlInterface
{ 
  public :

  TempCtrlTCPIP(ViProxy* prx, string identity, int b,int c):proxy(prx)
  {
     setBoardNr(b);
     setChannelNr(c);
     char board[5] = {0};
     char channel[5] = {0};
     sprintf(board,"%i",b);
     sprintf(channel,"%i",c);
     id = identity + " " + string(board) + " " + string(channel);
  }
  virtual ~TempCtrlTCPIP() {}
 
  virtual int control() {return 0;}
  virtual void setZeroPower() {}
  virtual void setTargetTemperature(float target) { ftargettemptcpip = target;
  						    proxy->setValue(id,target);
  						  }
  virtual float getTargetTemperature() {return ftargettemptcpip; }
  virtual float getActualTemperature() { return float(proxy->getValue(id)); }
  virtual float getTemperature()  { return float(proxy->getValue(id)); }
  virtual float getInputValue()  { return 0.; }

  virtual void  setPower(float power ) {}
  virtual float getActualPower() {return 0;}
  virtual int   getType() {return 0;}
  virtual void info() {}
  virtual bool isInitialized() {return true;}

  private:
  ViProxy* proxy;
  string id;
  float ftargettemptcpip;
};

#endif
