#ifndef TEMPERATURECHANNELDIM
#define TEMPERATURECHANNELDIM
#include <dic.hxx>
#include "temperaturechannelinterface.h"
#include "CalibrationValues.h"
#include "daqerrormsg.h"
#include "dimchannelnames.h"
#include <stdlib.h>

class TemperatureChannelDim : public TemperatureChannelInterface ,			     
			      public DimChannelNames,
			      public  DimClient

{ private:
  bool fIsIntialized;
  float fActualTemperature;
  public:
  TemperatureChannelDim(CalExchange <TempConverDef::TempCalValues>* c);
/// get the actual temperature
   virtual float getTemperature();
   virtual float getInputValue(){ return fActualTemperature;}

   /** \brief  send inforation about the temperature channel to cout ,use only for debug reasons
       it is allowed to implement a empty function here */
   virtual void info(){;}
   virtual bool isInitialized(){ return fIsInitialized;}   
   virtual ~TemperatureChannelDim() {};
   int wait();
  void infoHandler();

private:
  DimInfo* fTempinfo;
 char fCmd[80];
  float fSent[256];
  float  fRecBuf[256];
 int fNsent;
  int fNreceived;
  bool fIsInitialized;
};



#endif
