#ifndef __TEMPERATURECHANNELTCPIP
#define __TEMPERATURECHANNELTCPIP
#include  <unistd.h>
#include <iostream.h>
#include <string>
#include <fstream.h>
#include "CalibrationValues.h"
#include "viproxy.h"
#include "temperaturechannelinterface.h"

class TemperatureChannelTCPIP : public TemperatureChannelInterface

{ 
 public:
  TemperatureChannelTCPIP(ViProxy* prx, string identity, int b,int c):proxy(prx)
  {
       setBoardNr(b);
       setChannelNr(c);
       char board[5] = {0};
       char channel[5] = {0};
       sprintf(board,"%i",b);
       sprintf(channel,"%i",c);
       id = identity + " " + string(board) + " " + string(channel);
  }
  virtual ~TemperatureChannelTCPIP() {}
  virtual float getTemperature() {return float(proxy->getValue(id)); }
  virtual float getInputValue() {return 0.; }
  virtual void info() {};
  virtual bool isInitialized() {return true;}   
 private: 
  ViProxy* proxy;
  string id;
};

#endif 
