#ifndef __TEMPERATURECHANNELTEMPCTRL
#define __TEMPERATURECHANNELTEMPCTRL
#include  <unistd.h>
#include <iostream>
#include <fstream>
#include "CalibrationValues.h"
#include "temperaturechannelinterface.h"
/** \brief temperature probes reads temp from tempctrl
  
    r
   
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2003 07  24 
      \version 1.1
   
 
*/

class TempCtrlInterface;

class TemperatureChannelTempCtrl :  public TemperatureChannelInterface 


{ private:
  TempCtrlInterface* fTc;
   bool fInitialized;
   float fLastReadTemperature;
   /** which temperature probe should readout 
       (given in the Boardnr of the calibration values)
       0, 1 : box temperature
       2:  Water temperature
       3:  hotside temperature
   */
   int fProbe ; 
   int fDeviceId;
 public:
  /** \brief constructor 
      
      @param AdcCh pointer to a real adc channel 
       CalExchange <TempConverDef::TempCalValues> for initialization
       the channel defines the temperature probe that will be selected
       0 1 : box  temperature 
       2 : water temperature 
       3 : hotside temperature 
  */
   TemperatureChannelTempCtrl( CalExchange <TempConverDef::TempCalValues>* c  ) ;
   ~TemperatureChannelTempCtrl();
     /// true if the temperature channel is sucessfull intialized 
    virtual bool isInitialized() { return fInitialized;}

    /// returns the actual temperature 
    virtual float getTemperature() ;
    /// return the last readed adc value what is used to calculate the current
    virtual float getInputValue(){ return fLastReadTemperature;}
    /// print some information about the temperature channel object only for debug reasons
    virtual void info();
   
};

#endif 
