#include "humiditychannelinterface.h"
#include "humiditychannel.h"
#include "humiditychanneltrhxsense.h"
#include "humiditychanneldim.h"
#include "humiditychannellt.h"
#include "humidityparser.h"
#include <adcchanneldummy.h> 
#include <adcchannel.h>
#include "ltparser.h"
#include "daqerrormsg.h" 
//extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice


HumidityChannelLt::HumidityChannelLt( int device) : HumidityChannelInterface()
{  
  
    CalExchange <HumidityConversionDef::HumidityCalValues>* c=0 ;
   HumidityParser hp;                        
    int nProbes =hp.getCards();
    DT_DEBUG_LTC( "Probes " << nProbes);
     c = hp.getInfo(device );
     
    if ( c) 
    { DT_DEBUG_LTC(c->printIdValues(cout));
      fType= c->getType();
    
      switch (fType)
	{ case HumidityConversionDef::TRHXSENS :
	  fT= new HumidityChannelTrhxSens(c->getBoardNr(),c);     
	  break;
	  case HumidityConversionDef::HUMSPECIAL:
	      {  fT=new HumidityChannelDim(c);
		      if( !fT->isInitialized())
			{   DAQEXIT("error in getting dim  channel for device "<< device << endl) ;}        
	      }
	  break;
	  case  HumidityConversionDef::HUMIRELADC:
	  { AdcChannelInterface* fADC= new AdcChannel(c->getBoardNr(),c->getChannelNr());
	   fADCref = new AdcChannel(0,14);  		
  	   fT= new HumidityChannel( fADC , fADCref, c );
	   //fT->info();
	  }
	
	  break;
	  case  HumidityConversionDef::DUMMY:
	  { AdcChannelInterface* fADC= new AdcChannelDummy(c->getBoardNr(),c->getChannelNr());
	    fADCref = new AdcChannelDummy(0,15);  		
	    fT= new HumidityChannel( fADC , fADCref, c );
	    //fT->info();
	  }
	  break;
	  default:  DAQEXIT("Humidiyt  probe type "<<fType << " not supported "  );
	  break;
	}
					
      DT_DEBUG_LTC(getName()<<" "<< *fT); 
    }
    else
      {   DAQEXIT("requested probe ID:" << device << " not found");
      }
    // fInitialized=true;
    setCalibrationId(fT->getCalibrationId());

    //delete parser;
    
    
  }

HumidityChannelLt::~HumidityChannelLt()
{
  	switch (fType)
      { 
       case  HumidityConversionDef::HUMIRELADC :	  
	     { HumidityChannel* fTC = (HumidityChannel*) fT; 
	      delete fTC->getAdcChannelPointer();
	      delete fADCref;
	     }
	      break;
	default:
	  break;
      }
 delete fT;

} 





