//FILE not in use and not correct.
#include <cstdio>
#include <cerrno>
#include "humidityctrl.h"
#include "daqerrormsg.h"
#include "powerchannellt.h"
#include "humiditychannellt.h"

HumidityCtrl::HumidityCtrl( CalExchange <HumidityCtrlDef::HumidityCtrlValues>* c):HumidityCtrlInterface(c)
{ 
  DT_DEBUG_LTC( fCV);
  if(fCV->getCalValues()->fGasFlowId >= 0) {
    fGasFlow = new PowerChannelLt(fCV->getCalValues()->fGasFlowId);
  }
  else {
    fGasFlow=0;
  }
  fHumidity  = new HumidityChannelLt(fCV->getCalValues()->fHumidityId);
  
 
  // stores the id's in the hummidity channel interface 
  setCalibrationId(fCV->getCalibrationId());
  // default settings:

  fTargetHumidity=  fHumidity->getHumidity() ;
  setZeroGasFlow();    
  DT_DEBUG_LTC( "tempctrl init done");
  //delete ltparser;
  fInitialized=true;
}

HumidityCtrl::~HumidityCtrl(){
  cleanup();
}

void HumidityCtrl::cleanup(){
  // is in principle the destructor but can be called in case of exit 
  // should disapear if I know how to handle exceptions 
  setZeroGasFlow();
  delete fHumidity; fHumidity=0;   
  delete fGasFlow; fGasFlow=0;
  
}

void HumidityCtrl::setTargetHumidity (float target)  { 
  fTargetHumidity =target;
}

int  HumidityCtrl::getType(){
  return  fCV->getType() ;
}
  

int HumidityCtrl::control(){    
  fActualHumidity=  fHumidity->getHumidity() ;
  // in the future here could come a control procedure ;
  //(void)fGasFlow->setPower(0);
  int  exit_value=0;
  return exit_value;
}

float HumidityCtrl::getGasFlow() {  return fActualGasFlow;}

void HumidityCtrl::setGasFlow(float flow){
  if(fGasFlow){
    (void)fGasFlow->setPower(flow);
    fActualGasFlow=flow;
  }
} 

void HumidityCtrl::setZeroGasFlow(){
  if(fGasFlow) {
    (void)fGasFlow->setPower(0);
  }
 fActualGasFlow=0;
} 

void HumidityCtrl::setMaxGasFlow(){
  float maxflow=fCV->getCalValues()->fMaxGasFlow;
  if(fGasFlow){
    (void)fGasFlow->setPower(0*maxflow);
  }
  fActualGasFlow=0;
} 


void  HumidityCtrl::printHumidityCtrl (){    
  cout <<" HumidityCtrl "<<  getName()<<" Id:"<< getId()<<endl;
  cout << "T " << getActualHumidity()<<" [\%] Target:  ";
  cout << getTargetHumidity() ;
  cout  << " [\%]  Power "  << getGasFlow() << " [W] " ;
//  	    switch ( fCtrlStatus)
//  	      {
//  		case  UNKNOWN :  cout << "unknown" ;
//  		  break;
//  		case NOTSTARTED: cout << "not started" ;
//  		  break;
//  		  case NORMAL :  cout << "normal" ;
//  		    break;
//  		    case UNDERHUMIDITY : cout << "temerature to low";
//  		      break;
//  		case  OVERHUMIDITY : cout << "high temperature" ;
//  		  break;
//  		default:  cout << "invalid status" ;
// }
cout << "\n";
}



float HumidityCtrl::getHumidity() {return  fHumidity->getHumidity();}

float HumidityCtrl::getInputValue(){ return fHumidity->getInputValue();}

float HumidityCtrl::getRefVolt(){return fHumidity->getRefVolt();}




