#include <cstdio>
#include <cerrno>
#include "humidityctrlprobe.h"
#include "daqerrormsg.h"
#include "humiditychannellt.h"

HumidityCtrlProbe::HumidityCtrlProbe( CalExchange <HumidityCtrlDef::HumidityCtrlValues>* c) 
  : HumidityCtrlInterface(c) { 
  DT_DEBUG_LTC( fCV);       
  fHumidity  = new HumidityChannelLt(fCV->getCalValues()->fHumidityId);
  
 
  // stores the id's in the hummidity channel interface 
  setCalibrationId(fCV->getCalibrationId());
  // default settings:
  DT_DEBUG_LTC( "init done");
  //delete ltparser;
  fInitialized=true;
}

HumidityCtrlProbe::~HumidityCtrlProbe(){
  cleanup();
}

void HumidityCtrlProbe::cleanup(){
  // is in principle the destructor but can be called in case of exit 
  delete fHumidity;    

}

void HumidityCtrlProbe::setTargetHumidity (float target)  {
}

int  HumidityCtrlProbe::getType(){
  return  fCV->getType() ;
}
  

int HumidityCtrlProbe::control(){  
  fActualHumidity=  fHumidity->getHumidity() ;  
  int  exit_value=0;
  return exit_value;
}

float HumidityCtrlProbe::getGasFlow() {  return -1;}

void HumidityCtrlProbe::setGasFlow(float flow){

} 

void HumidityCtrlProbe::setZeroGasFlow(){

} 

void HumidityCtrlProbe::setMaxGasFlow(){

} 


void  HumidityCtrlProbe::printHumidityCtrl (){    
  cout <<" HumidityCtrl "<<  getName()<<" Id:"<< getId()<<endl;
  cout << "T " << getActualHumidity()<<" [\%] Target:  ";
  cout << getTargetHumidity() ;
  cout  << " [\%]  Power "  << getGasFlow() << " [W] " ;
//  	    switch ( fCtrlStatus)
//  	      {
//  		case  UNKNOWN :  cout << "unknown" ;
//  		  break;
//  		case NOTSTARTED: cout << "not started" ;
//  		  break;
//  		  case NORMAL :  cout << "normal" ;
//  		    break;
//  		    case UNDERHUMIDITY : cout << "temerature to low";
//  		      break;
//  		case  OVERHUMIDITY : cout << "high temperature" ;
//  		  break;
//  		default:  cout << "invalid status" ;
// }
cout << "\n";
}



float HumidityCtrlProbe::getHumidity() {return  fHumidity->getHumidity();}

float HumidityCtrlProbe::getInputValue(){ return fHumidity->getInputValue();}

float HumidityCtrlProbe::getRefVolt(){return fHumidity->getRefVolt();}




