#include "humidityctrlwrapper.h"
#include "humidityctrl.h"
#include "humidityctrldummy.h"
#include "humidityctrlprobe.h"
#include "daqerrormsg.h"
#include "ltparser.h"
#include "humidityctrlparser.h"


HumidityCtrlInterface* lttest:: getHumidityCtrl(int device ) 
{ bool fInitialized=false;
 HumidityCtrlInterface* fH; 
   DT_NOTE(""); 
   CalExchange <HumidityCtrlDef::HumidityCtrlValues>* c=0 ;
   HumidityCtrlParser hcp;
   int n =hcp.getNrCards();                         
   //int n =ltparser->getNumberHumidiyCtrls();
   DT_DEBUG_LTC("Probes " << n  ) ;
   //c = ltparser-> getHumidityCtrlInfo(fDeviceId);
   c = hcp.getInfo(device );   
    if ( c) 
      {	DT_DEBUG_LTC(c->printIdValues(cout));
      DT_DEBUG_LTC("requested shmname: " << c->getTDeviceControlName( ));
	DT_DEBUG_LTC("name: " << c->getName( ));
      int fType= c->getType();
	switch ( fType )
	  { 
	    case HumidityCtrlDef::DUMMY:{  
	      HumidityCtrlDummy* fHChanneld  = new HumidityCtrlDummy(c);
	      if ( !( fInitialized=fHChanneld->isInitialized()) ) 
		{ delete fHChanneld ;  fH=0;}
	      else { fH=fHChanneld;}
	    }
	    break; 
	    case HumidityCtrlDef::STANDARD : { 
	      string host(c->getShmName());
	      HumidityCtrl* fHChannel = new HumidityCtrl(c);
	      if ( !( fInitialized=fHChannel->isInitialized()) ) 
		{ delete fHChannel ;  fH=0;}
	      else { fH=fHChannel;}
	    }
	    break;
	    case HumidityCtrlDef::PROBEONLY : { 
	      string host(c->getShmName());
	      HumidityCtrlProbe* fHChannel = new HumidityCtrlProbe(c);
	      if ( !( fInitialized=fHChannel->isInitialized()) ) 
		{ delete fHChannel ;  fH=0;}
	      else { fH=fHChannel;}
	    }
	    break;
	    default: { fH=0;
	      DT_DEBUG_LTC( "Humidity ctrl   type" << fType 
			    << "not supported"<< endl) ;
	    }
	    break;
	  }      
      }
    else
      {   DAQEXIT( "requested Humidityctrl  ID not found "<<device << endl);
      }
    return fH;
  }

//  HumidityCtrlWrapper::~ HumidityCtrlWrapper()
//  { ;

//  } 





