#include "interlock.h"
#include <diochannelinterface.h>
#include <ltparser.h> 
#include "daqerrormsg.h"

extern LtParser* ltparser;


InterLock::InterLock( int deviceId)

{  fInitialized=false ;
 fDeviceId=deviceId;
 fInterlockOut=0;
 fStatusline=0;fWatchDog=0;
 CalExchange<int[3]>*  info= ltparser->getInterlockInfo(fDeviceId) ;
 if( info) {
   int* c=0;
   c=(int*)info->getCalValues();
   CalExchange<int>*a= ltparser->getDioLineInfo(c[EMERGENCY] );
   if(a) {fInterlockOut = ltparser->getDioChannel(a);}
   a= ltparser->getDioLineInfo(c[1] );
   if(a) {
     fStatusline= ltparser->getDioChannel(a);
   }
 }
 else {
   DT_WARN("No interlock with device ID "<<fDeviceId<<" defined");
 }

}

InterLock::~InterLock(){
  delete fStatusline;
}


int InterLock::GetInterlockLineStatus(){
  if(fStatusline){ 
    // should be zero in case status is o.k.
    return fStatusline->getBit();}
  // if status line is not defined return 0
  else {return 0;}
}
