#include "powerchannel.h"
#include "daqerrormsg.h"

  PowerChannel::PowerChannel( DacChannelInterface  *DacCh, 
					   CalExchange <PowerConversionDef::PowerCalValues>* c )
                        :PowerChannelInterface() , PowerConversion( *c )
                         
  {fDacCh=DacCh;  
    
   }

unsigned short  PowerChannel:: setPower(float power)   {   
	fActualDacValue=Power2Dacconversion(power);
	DT_DEBUG_LTC("send to Dac "<< getChannelNr() <<" power  "
		     <<power<<" = " 
	       << fActualDacValue<<" counts");
        fDacCh->lock();
	fDacCh->setOutputVoltage( fActualDacValue);
	fDacCh->unlock();
	fDacCh->justDoIt();  int resttime;
	// check if sigal arives  for dummy to overcome pause 
	if( !(resttime=sleep(3))) {
	  //DT_DEBUG_LTC("sleep restime  "<< resttime);
	}
	return fActualDacValue;
}

 float   PowerChannel::getPower()
    {  float power ; 
    // while ( checkspill()) {usleep(400000);}
	fDacCh->lock();
	fDacCh->getOutputVoltage();
	fDacCh->unlock();  
	
	power= Dac2Powerconversion(fActualDacValue);
	
	return power;
    }

std::ostream& operator<<(std::ostream& s, PowerChannelInterface& TC  )
{ 
  s << "T" <<TC.getId()  << ":  \0x1B[31m"<< TC.getPower()  <<"\0x1B[30m"<< "C"  ;


  return s;
}

std::ofstream& operator<<(std::ofstream& s, PowerChannelInterface& TC  )
{ 
  s << "T" <<TC.getId()<<": "<< TC.getPower()    ;

  return s;
}
