
#include "daqerrormsg.h"
#include "powerchannellt.h"
#include <dacchannel.h>
#include "dacchanneldummy.h"
#include "dacchanneltrhx.h"
#include "ltparser.h"
extern LtParser* ltparser; 

  PowerChannelLt::PowerChannelLt(int device , int*  PolStatus )
    :PowerChannelInterface()
{ 
  fDeviceId = device; 
  fInitialized=false;
  
  CalExchange <PowerConversionDef::PowerCalValues>* c=0;
    c = ltparser-> getPowerChannelCalibration(fDeviceId);
   if ( c) 
      {	DacChannelInterface* Dac=0;
	fType= c->getType();
	int dactype= fType;
	 DT_DEBUG_LTC(fType);
	   if ( fType >= PowerConversionDef::POL) 
	     { dactype=		 fType % PowerConversionDef::POL;}
	switch ( dactype ) //initialize the correct type of DAC channel
	  {  case PowerConversionDef::DAC :
	         {  DacChannel* Daclc= 
		       new DacChannel(c->getTDeviceControlName( ) ,
				      c->getBoardNr(),c->getChannelNr());
		    // make local pointer becasue isInisitialized is not 
		   // defined for interface 
		    Dac= Daclc;
		   if ( ! Daclc->isInitialized()) 
		     { DAQEXIT( "error in getting DAC  channel for device "<< fDeviceId << endl);
		     }
		 }
	    break;
	    case PowerConversionDef::SERIAL : 
	         { DacChannelTrhx* Daclc= 
		                 new DacChannelTrhx(c->getBoardNr(),c->getChannelNr());
		   Dac=Daclc;
		   if ( ! Daclc->isInitialized()) 
		     {  DAQEXIT("error in getting DAC  channel for device "<< fDeviceId << endl);
		     }
		 }
	    break;
	    case PowerConversionDef::DUMMY :
	         {  Dac= 
		      new DacChannelDummy(c->getTDeviceControlName( ),c->getBoardNr(),c->getChannelNr());
		   // this device will not fail 
		 }
	    break;
	     
	    default : DAQEXIT("PowerChannel type " << fType  << " not supported");
	    break;
	  }
        if( fType >= PowerConversionDef::POL)   { 
	  int dioId=  c->getCalValues()->DioChannelId;
          CalExchange<int>*  c_dio =ltparser->getDioLineInfo(dioId);
	  if(!c_dio) {DAQEXIT("Dio channel "<< dioId <<" not in file ");}
	  else { 
	    DioChannelInterface* Dio = ltparser->getDioChannel (c_dio);
	    if (! Dio){DAQEXIT("Dio channel "<< dioId <<" not found");} 
	    else {
	      if(  fType >= PowerConversionDef::POLCOM) {
		if( PolStatus == 0 ){ DAQEXIT("Common PolStatus not set");}
		fPC = new PowerChannelPolCom(PolStatus  ,  Dac ,Dio, c );
	      }
	      else{
		fPC = new PowerChannelPol( Dac ,Dio, c );
	      }	      
	    }
	  }
	}
	else {
	  fPC = new PowerChannel( Dac , c );
	}
       //fPC ->info();
       fInitialized=true;
      }
    else
      {  DAQEXIT("requested powerchannel  not found "<<fDeviceId << endl) ;
      }

    //delete parser;
    
    
  }

PowerChannelLt::~PowerChannelLt()
{ DT_DEBUG_LTC("DeviceNr"<< fDeviceId);
  int dactype= fType;
  if ( fType >= PowerConversionDef::POL) 
    { dactype= fType%PowerConversionDef::POL;}
   switch ( dactype ) 
     {case PowerConversionDef::DAC :
      case PowerConversionDef::DUMMY :
      case PowerConversionDef::SERIAL :
	   		  
	      {PowerChannel* pc  = (PowerChannel*) fPC;  
	      // use PowerDacChannel pointer because PowerChannel interfase hasn't  getDacChannelPointer
	        delete pc->getDacChannelPointer();		
	        
	      }		
  					 
					  break;
	    default :                 
	   break;
	  }
 if( fType > PowerConversionDef::POL)
   { PowerChannelPol* pc  = (PowerChannelPol*) fPC; 
   if(pc)  delete pc->getDioChannelPointer();
   }
 delete fPC;
 

 
} 





