#include "powerchannelpol.h"
#include "daqerrormsg.h"

  PowerChannelPol::PowerChannelPol( DacChannelInterface  *DacCh, 
				    DioChannelInterface  *DioCh,
					   CalExchange <PowerConversionDef::PowerCalValues>* c )
    :PowerChannel( DacCh, c)
                         
{  
   fNegativeValue=c->getCalValues()->NegOutput ;
    fPositiveValue=c->getCalValues()->PosOutput ;
    fDioCh=DioCh; 
    fDioCh->setBit( fPositiveValue);
    fDioCh->wait();
    fPositive=true;
 
   }

unsigned short  PowerChannelPol:: setPower(float power) 
{ // only operate the switch under 0 power and if there is a polartity switch
  if ( power <0 )
    {  if( fPositive)  
      {  DT_DEBUG_LTC("power "<<power<<" set Dio  "<<getId() << " to "<< fNegativeValue);
        PowerChannel::setPower(0);
	fDioCh->setBit( fNegativeValue);
	fDioCh->wait();
	fPositive=false;
      }
    power=-power;
    }
  else // power is positive  
  if ( !fPositive)  
    { DT_DEBUG_LTC("power "<<power<<" set Dio  "<<getId() << " to "<< fPositiveValue);  
      PowerChannel::setPower(0);
      fDioCh->setBit( fPositiveValue);
      fDioCh->wait();
      fPositive=true;
    }
  return PowerChannel::setPower(power);

}


 PowerChannelPol::~PowerChannelPol() 
{
}
