#include "powerchannelpolcom.h"
#include "daqerrormsg.h"




PowerChannelPolCom::PowerChannelPolCom(
                    int*  PolStatus,
		    DacChannelInterface  *DacCh, 
		    DioChannelInterface  *DioCh,
		    CalExchange <PowerConversionDef::PowerCalValues>* c )
  :PowerChannel( DacCh, c)
{                        
  fPolStatus = PolStatus;
  fNegativeValue=c->getCalValues()->NegOutput ;
  fPositiveValue=c->getCalValues()->PosOutput ;
  fDioCh=DioCh; 
  fDioCh->setBit( fPositiveValue);
  fDioCh->wait();
  fPositive=true;
}



unsigned short  PowerChannelPolCom:: setPower(float power) 
{ // only operate the switch under 0 power and if there is a polarity switch


  float ActualPow = PowerChannel::getPower();
	
// LD+GF (Torino 3/6/2)
//     variable fPolStatus introduced. This allows to sincronize 
//     the behaviour of the 2 peltier w.r.t. polarity. Power set to zero
//     if change in polarity is needed, then change of polarity, power to 
//     5V or less and then to the requested power.
     
// fPolStatus =  1     positive polarity, no request to change;
//            =  2     negative polarity, no request to change;
//            =  10    request to change to positive polarity !
//            =  20    request to change to negative polarity !

//  cout << " Pasked ="<<power<<"Apow="<< ActualPow << " fPolStatus= "<<*fPolStatus<<"fPositive="<<fPositive;

  if ( power <0 ) // -------------------- power is negative -------------- //
  {
        if      ( (!fPositive) && (*fPolStatus==2) ) {power=-power;}          
	else if ( (!fPositive) && (*fPolStatus==1) ) {power=0; *fPolStatus=20;} 
	else if ( (!fPositive) && (*fPolStatus==10) ){power=0; *fPolStatus=20;}	
	else if ( (!fPositive) && (*fPolStatus==20) )
	 { if (ActualPow==0) {
	      fDioCh->setBit( fNegativeValue );fDioCh->wait();
	      fPositive=false; *fPolStatus=2;
	      power=1;}
	    else { power=0; *fPolStatus=20;}
	  }	
        else if ( (fPositive) && (*fPolStatus==1) ) { power=0; *fPolStatus=20;}
	else if ( ( fPositive) && (*fPolStatus==2) )
	 { if (ActualPow==0) {
	       fDioCh->setBit( fNegativeValue ); fDioCh->wait();
	       fPositive=false; *fPolStatus=2;
	       power=1;}
	    else { power=0; *fPolStatus=20;}
	 }
	else if ( ( fPositive) && (*fPolStatus==10 )) {power=0; *fPolStatus=20;}
	else if ( ( fPositive) && (*fPolStatus==20 ))
         {  if (ActualPow==0) {
	       fDioCh->setBit( fNegativeValue ); fDioCh->wait();
	       fPositive=false; *fPolStatus=2;
	       power=1;}
	    else { power=0; *fPolStatus=20;}		
	}					     
    }  

   else // ---------------- power is positive  ------------------//
   {
        if ((!fPositive) && (*fPolStatus==1) )
	{   if (ActualPow==0) {
	       fDioCh->setBit( fPositiveValue ); fDioCh->wait();
	       fPositive=true ; *fPolStatus=1;
	       power=1;
	       }
	    else { power=0; *fPolStatus=10; }		
	}
	else if ( (!fPositive) && (*fPolStatus==2) ){power=0;*fPolStatus=10;}
	else if ( (!fPositive) && (*fPolStatus==10 ))		
	{  if (ActualPow==0) {
	       fDioCh->setBit( fPositiveValue ); fDioCh->wait();
	       fPositive=true ; *fPolStatus=1;
	       power=1;}
	    else { power=0; *fPolStatus=10;}							        	        
	}
	else if ( (!fPositive) && (*fPolStatus==20 )) {power=0;*fPolStatus=10;}
        else if ( (fPositive) && (*fPolStatus==1) )   {*fPolStatus=1;}
	else if ( ( fPositive) && (*fPolStatus==2) )  {power=0;*fPolStatus=10;}
	else if ( ( fPositive) && (*fPolStatus==10 ))		
	{ if (ActualPow==0) {
	       fDioCh->setBit( fPositiveValue ); fDioCh->wait();
	       fPositive=true ; *fPolStatus=1;
	       power=1;}
	    else { power=0; *fPolStatus=10;}				             
	}
	else if ( ( fPositive) && (*fPolStatus==20 )){power=0;*fPolStatus=10;}
   }

//  cout << " Power set ="<<power<<" fPolStatus="<<*fPolStatus<<"fPositive=" <<fPositive << endl;

    return PowerChannel::setPower(power);

}


 PowerChannelPolCom::~PowerChannelPolCom() 
{
}
