/** \brief temperature channel interface source code 
     
    
     The Adc Channel indicates which temperature probe is used. The type is looked up in 
     the config file what is hardcoded at the moment in CalibrationValues.h
     
     For an example how to use it look in ScMonitor
   
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 03 24 
      \version 1.1
     \date 2001 05 11 
  \version 1.2
     \date 2001 05 22 
 
*/
#include "temperaturechannel.h"


  TemperatureChannel::TemperatureChannel( AdcChannelInterface  *AdcCh, 
					   CalExchange <TempConverDef::TempCalValues>* c )
                        :TemperatureChannelInterface(c) 
                         
  {fAdcCh=AdcCh;  
    
   }

float TemperatureChannel::getTemperature() 
    {  float temperature ; 
    // while ( checkspill()) {usleep(400000);}

	
	fAdcCh->lock();
	fAdcCh->getAdcData(fActualAdcValue);
	fAdcCh->unlock();  
	//    cout<<" fact "<<fActualAdcValue<<endl;
	temperature= Adc2Tconversion(fActualAdcValue);
	//    cout<<temperature<<endl;
	return temperature;
    }

 bool TemperatureChannel::checkspill()
    {   fAdcCh->lock();
       int actualspill= fAdcCh->getSpillNumber() ;
       fAdcCh->unlock();
    if ( fLastSpill != actualspill ) // don't check for order
	{  fLastSpill = actualspill ; 
	return false ;
	}
    else
      { return true ;}
    }

