
#include <cstdio>
#include <strstream>
#include <string>

#include "viproxy.h"


ViProxy::ViProxy(string host,int port) {
	serverip.SetHostName(host.c_str(),false);
	try {
		mysock=new TCPClientSocket(serverip,port);
	}
	catch (SocketException &excep) {
		cout << "Socket Exception: " << (const char*) excep << endl;
		mysock=0; // socket creation what not successfull we shoudl not delete the not completly created object
	}
	catch (...) {
		cout << "Other Error" << endl;
	}
}

ViProxy::~ViProxy() {
	if(mysock!=0) delete mysock; // close the connection
}

bool ViProxy::Reset() { 
	// to implement to reconnect if disconnected
	return true;
}

double ViProxy::getValue(string command) {
	if (mysock!=0) {
		command="R"+command+"\r\n";
		while(command.size()<20) command.insert(0,"*"); 
		char* sdata=const_cast<char*>(command.c_str());
		char  rdata[65535];
		int bytesend=0;
		int byterecv=0;
		cout << "ViProxy::getValue Sended data=" << sdata; 
		try {
			bytesend=mysock->SendData(sdata,strlen(sdata));
			byterecv=mysock->RecvData(rdata,65535);
			rdata[byterecv]=0; // string delimiter 
			cout << "ViProxy::getValue Received data=" << rdata << endl;
			cout << "ViProxy::getValue ParsedResult=" << ParseResult(string(rdata)).second << endl;
			return ParseResult(string(rdata)).second;		
		} 
		catch (SocketException &excep) {
			cout << "Erreur de socket: " << (const char*) excep << endl;
			return -999999;	// this is bad, should throw specific exception
		}
	}
	return -999999;
}


bool ViProxy::setValue(string command,int value) {
	if (mysock!=0) {
		cout << "ViProxy::setValue value to set=" << value << endl;
		char ssdata[200];
		char sdata[200];
		char rdata[65535];
		sprintf(ssdata,"S%s %d\r\n",command.c_str(),value);
		string ccommand(ssdata);
		while (ccommand.length() < 20) ccommand.insert(0,"*");
		sprintf(sdata,"%s",ccommand.c_str());
		//cout << sdata;	
		//cout << strlen(sdata) << endl;
		int bytesend=0;
		int byterecv=0;
		cout << "ViProxy::setValue setted data=" << sdata << endl; 
		try {
			bytesend=mysock->SendData(sdata,strlen(sdata));
			byterecv=mysock->RecvData(rdata,65535);
			rdata[byterecv]=0;
			cout << "ViProxy::setValue get data=" << rdata << endl;
		}
		catch (SocketException &excep) {
			cout << "Erreur de socket: " << (const char*) excep << endl;
			return false;	// this is bad, should throw specific exception
		}
		//cout << rdata << endl;
		if (bytesend!=byterecv || string(rdata)!=string(sdata)) return false;
		else return true;
	}
	return false;
}

pair<int,double> ViProxy::ParseResult(string result) {
//	const string delimiters=" ";
//	vector<string> tokens;
//   	string::size_type lastPos = result.find_first_not_of(delimiters, 0);
//    	string::size_type pos     = result.find_first_of(delimiters, lastPos);
//    	while (string::npos != pos || string::npos != lastPos) {
//	        tokens.push_back(result.substr(lastPos, pos - lastPos));
//	        lastPos = result.find_first_not_of(delimiters, pos);
//	        pos = result.find_first_of(delimiters, lastPos);
//    	}
	char   req[200];
	pair<int,double> retval;	
	int dummy;
	strstream rcvstream;
	rcvstream << result;
	rcvstream >> req >> dummy >>retval.first >> retval.second;	
	//cout << retval.second << endl;
	return retval; 
}


