


#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
//#include <sys/wait.h>
#include <signal.h>

#include <fstream.h>
#include <time.h>
//#include <cstdlib.h>

#include "temperaturechannelinterface.h"
#include "temperaturechannellt.h" 
#include "currentchannelinterface.h"
#include "humiditychannelinterface.h"
#include "humiditychannellt.h"
#include "currentchannellt.h"

#include <adcchannel.h>

#include "ltparser.h"

#define MAXPOS 2 
LtParser* ltparser;

bool HasToExit=false;

void  Ictrlc(int s)
{

 if (s == SIGCONT) { printf("%d sigcont received\n ",getpid()); 
		     return ;
		    }
 // all other signals 
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
 
   HasToExit=true;

}

#define MAXTEMPCH 1
#define MAXHUMIDITYCH 1
int main()
{
    ltparser = new LtParser();
   ltparser->parseFile( "../../../Config/sc.xml");

   signal(SIGINT,Ictrlc); // Arm interrupt handler
   signal(SIGCONT,Ictrlc); // Arm interrupt handler
   std::ofstream datout( "../data/scout.dat");
   const time_t starttime = time(NULL);
   if ( ! datout) 
     { cerr << "can not open scout.dat\n" ;
       exit(-1);
     }
   cout.precision(5);
   
   
  
  
   HumidityChannelInterface * Humiditys[MAXHUMIDITYCH];
   for ( int lc=0 ; lc < MAXHUMIDITYCH ; lc++)
     { Humiditys[lc] = new HumidityChannelLt(10+lc);
     } 
   TemperatureChannelInterface* Temperatures[MAXTEMPCH] ;
   for ( int lc=0 ; lc < MAXTEMPCH ; lc++)
     { Temperatures[lc] = new TemperatureChannelLt(10+lc);
     }  
   cout.precision(4);datout.precision(4);cout.width(8);datout.width(8);
     bool savetofile =false ;  	
   
      while(! HasToExit)
	{  
	  cout << "time " << time(NULL) - starttime << "[s] :" ;
	  datout << time(NULL) - starttime << ":" ;
	  for (int lc=0;lc < MAXTEMPCH ; lc++)
	    {
	      if (savetofile) {     cout << *Temperatures[lc]<<" : "; }
	      else 
		{    datout <<  *Temperatures[lc]<<" : ";
		}
	 }
      
     for (int lc=0;lc < MAXHUMIDITYCH ; lc++)
	    {
	      if (savetofile) {     cout << *Humiditys[lc]<<" : "; }
	      else 
		{    datout <<  *Humiditys[lc]<<" : ";
		}
	 }
     if(savetofile)  {cout << endl; } else{datout<< endl; }       
      
       sleep(20);
       savetofile  = !savetofile ;
       }
  
for ( int lc=0 ; lc < MAXHUMIDITYCH ; lc++)
     { delete Humiditys[lc];
     }  
for ( int lc=0 ; lc < MAXTEMPCH ; lc++)
     { delete Temperatures[lc];
     }  
   
   return 0 ; 
}  
