#include <qapplication.h>
#include <qsize.h>
#include "generalmainwindowui.hxx"
#include "coldboximpl.h"
#include "cmdlinedecode.h"
#include "ltparser.h"
#include "slowctrlconfig.h"
#include "coldbox.h"
#include <string>

using namespace std;

void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tColdBox  -ltconfig lttemp.xml " <<endl;
  cout <<"-h  this message "<<endl<<endl;
  std::exit(-1);
}

LtParser* ltparser=0;

int main( int argc, char* argv[] )
{
  
  string result;
  if( "found"==CmdLineDecode(argc,argv,"h",result,false)) {
     usage();
   }
  ltparser = new LtParser;
  if( "found"==CmdLineDecode(argc,argv,"ltconfig",result,true)){
    cout<< "use "<< result <<" as config " <<endl;
    ltparser->setParseFileName( result);
   }
  else {
    if (argc>1) {
      usage();
    }
  }
  if ( ltparser->parseFile()){
    return -1;;
  }



  QApplication app( argc, argv );
  GeneralMainWindowUi mw(0,"ColdBoxCtrl");
  app.setMainWidget( &mw);
  mw.setCaption( "ColdBoxCtrl" );
  ColdBoxImpl cbi( &mw);
  mw.resize(QSize(4,4)+cbi.size());    
  QRect df(cbi.frameGeometry());
  df.moveBy(1,1);
  cbi.setGeometry(df);


  ColdBox* fCb= new ColdBox( ltparser->getSlowCtrl(1)->getColdBoxId(0));
  cbi.setColdBox(fCb);
  mw.show();
  int ret = app.exec();
  
  delete fCb;
  delete ltparser;

  return ret;
}
