#include <cstdio>
#include <cstdlib>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
#include "ltparser.h" 
//#include "fecctrldevinterface.h"
#include "dcuchannellt.h"
//#include <adcchannel.h>
//#include <dacchannel.h>

#include "coldbox.h"
#include "temperaturechannellt.h"
#include "humiditychannellt.h"

pid_t fPid=0 ; 
bool HasToExit=false;

LtParser* ltparser; 

void  Ictrlc(int s)
{

 if (s == SIGCONT) {
 // printf("%d sigcont received\n ",getpid()); 
		     if( fPid !=0)
		       {  if (kill(fPid ,SIGCONT))
			  perror(" fail to send sigcont to child");
		     }
                     return ;
		    }
 // all other signals 
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  if( fPid !=0)
    if( kill(fPid ,SIGINT ))
       perror(" fail to send sigint to child");
   HasToExit=true;

}




int main(int argc, char *argv[], char *envp[])
{

   int exit_value=0 ; //assume everythink is o.k.
  
   signal(SIGINT,Ictrlc); // Arm interrupt handler
   signal(SIGCONT,Ictrlc); // Arm interrupt handler
   const time_t starttime = time(NULL);
   float targettemperature=-24;
  
   
   std::ofstream datout( "tmpctl.dat");
   if ( ! datout) 
     { cerr << "can not open scout.dat\n" ;
       exit(-1);
     } 
   if (argc >1)
     { targettemperature = (float) strtod(argv[1],NULL);
    }

    ltparser = new LtParser();
    char xmlfilename[100];
    ltparser->parseFile( 
      ltparser->getStandardConfigFile(xmlfilename,"Config/lttempctrl.xml")); 
    ColdBox TC(1);
    if(!TC.isInitialized()){
      cout << "cold box not intialized or found "<<endl;
      return -1;
    }
    //FecCtrlDevInterface=FecDev=ltparser->getFecCtrlDev(0);
    // bench position 0 is assumed 
   DcuChannelLt* thedcui2c = new DcuChannelLt(0);
   thedcui2c->lock();
   thedcui2c->setAddress(0x0);
   thedcui2c->unlock();
  
   sleep(1) ; // to give the server time to start 
   vector<TemperatureChannelInterface*>  Temperatures ;
   //Temperatures.push_back( new TemperatureChannelLt(10 ));
   Temperatures.push_back( new TemperatureChannelLt(11 ));
   Temperatures.push_back( new TemperatureChannelLt(12 ));
   Temperatures.push_back( new TemperatureChannelLt(13 ));
   Temperatures.push_back( new TemperatureChannelLt(14 ));
   Temperatures.push_back( new TemperatureChannelLt(15 ));
   Temperatures.push_back( new TemperatureChannelLt(17 ));
   Temperatures.push_back( new TemperatureChannelLt(18 ));
   //Temperatures.push_back( new TemperatureChannelLt(19 ));
   //Temperatures.push_back( new TemperatureChannelLt(20 ));
   //Temperatures.push_back( new TemperatureChannelLt(21 ));
   //Temperatures.push_back( new TemperatureChannelLt(22 ));
   //Temperatures.push_back( new TemperatureChannelLt(23 ));
   //Temperatures.push_back( new TemperatureChannelLt(24));
   Temperatures.push_back( new TemperatureChannelLt(1000 ));
   Temperatures.push_back( new TemperatureChannelLt(1001 ));
   vector<HumidityChannelInterface*>  Humiditys ;
   //Humiditys.push_back( new HumidityChannelLt(10 ));
   Humiditys.push_back( new HumidityChannelLt(11 ));
   Humiditys.push_back( new HumidityChannelLt(12 ));
   //Humiditys.push_back( new HumidityChannelLt(13 ));
   printf(" initialization passed  \n");

     int lc_wh=0;
     TC.setTargetTemperature(targettemperature);
     DT_DEBUG_LTC("start auto contrl");
     cout << "start auto contrl" <<endl;
     TC.startAutoCtrl() ;
     cout << "auto contrl started " <<endl;
     while ( ! HasToExit) 
       {  
	 cout << "time: " << time(NULL) - starttime <<"[s] ";
         cout << "box : "<<"\t"<< TC.getActualTemperature () <<" [C] target";
	 cout <<TC.getTargetTemperature()<<" [C]"<<endl;    
	 for (unsigned int lc=0;lc < Temperatures.size() ; lc++){
	   cout << Temperatures[lc]->getName()<<"\t";
	   cout  << *Temperatures[lc]   ;
	   cout <<"\t"<< Temperatures[lc]->getInputValue()<<" ";
	   cout <<endl;
	 }
	 for (unsigned int lc=0;lc < Humiditys.size() ; lc++){
          cout << Humiditys[lc]->getName()<<"\t";
	   cout  << *Humiditys[lc] <<endl  ;
	   
	 }
	thedcui2c->update();
	cout << "Dcu int " << thedcui2c->getDcuTempInt()<<" ";
	cout << "Dcu Si " << thedcui2c->getDcuTempSi()<<" ";
	cout << "Dcu Hyb " << thedcui2c->getDcuTempHyb();
	  cout <<endl;
       datout << time(NULL) - starttime << ":" ;
       for (unsigned int lc=0;lc < Temperatures.size()  ; lc++)
	 {         datout <<  *Temperatures[lc]<<" : ";
	 }
       thedcui2c->update();
       datout << thedcui2c->getDcuTempInt()<<":";
       datout << thedcui2c->getDcuTempSi()<<":";
       datout << thedcui2c->getDcuTempHyb()<<":";
       datout << "\n" ;
       sleep(1);
       lc_wh++;
       sleep(20);
       }

   cout << "clean up" << endl;
   delete thedcui2c;
   for (unsigned int lc=0;lc < Temperatures.size() ; lc++)
     { delete Temperatures[lc];}
   for (unsigned int lc=0;lc < Humiditys.size() ; lc++)
     { delete Humiditys[lc];}
   delete ltparser; 
   return exit_value ; 
}  
