#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
#include "ltparser.h" 

//#include <adcchannel.h>
//#include <dacchannel.h>

#include "coldbox.h"


pid_t fPid=0 ; 
bool HasToExit=false;

LtParser* ltparser; 

void  Ictrlc(int s)
{ if (s == SIGCONT)
  {  if( fPid !=0)
    {  if (kill(fPid ,SIGCONT))  perror(" fail to send sigcont to child");
    }
  return ;
  }
// all other signals 
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  if( fPid !=0)
    if( kill(fPid ,SIGINT ))
      perror(" fail to send sigint to child");
  HasToExit=true;
}


#define MAXTEMPCH 3

int main(int argc, char *argv[], char *envp[])
{  bool autoctrl=false;
  int tprobe=1;
   int exit_value=0 ; //assume everythink is o.k.
  
   signal(SIGINT,Ictrlc); // Arm interrupt handler
   signal(SIGCONT,Ictrlc); // Arm interrupt handler
   const time_t starttime = time(NULL);
   float targettemperature=-24;
   if (argc >2)
     {  tprobe = (int) strtod(argv[2],NULL);
    }
   if (argc >1)
     { targettemperature = (float) strtod(argv[1],NULL);
    }

   ltparser = new LtParser();
   if(ltparser->parseFile() )
   {DAQEXIT("error in lt configuration file look at error output");} 
      
   ColdBox*   TC= new ColdBox(tprobe);
   sleep(4) ; // to give the server time to start 
   printf(" initialization passed  \n");

   int lc_wh=0;
   int resultCtrl;
   TC->setTargetTemperature(targettemperature);
    if (!TC->startAutoCtrl()){ autoctrl=true;} 
   while ( ! HasToExit) 
     { if(! autoctrl)  // to the control call in the main loop
         { resultCtrl=TC->control();
	   if (  resultCtrl)    
	    { if (resultCtrl== -1) {   usleep(1000);  continue;// no new value 
	    } 
	    else 
	      { exit_value=resultCtrl ; break ;}
	    }
	 }
      cout <<lc_wh<< " time: " << time(NULL) - starttime <<"[s] " ;
       cout << TC->getActualTemperature() <<" {C} target:";
       cout << TC->getTargetTemperature() << endl;
       lc_wh++;
       sleep(1);
     }

   TC->stopAutoCtrl();
   cout << "clean up" << endl;
   delete TC;
   delete ltparser; 
   return exit_value ; 
}  
