#include <cstdlib>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "daqerrormsg.h"
#include "humiditychannellt.h"
#include "ltparser.h" 
#include "cmdlinedecode.h"
LtParser* ltparser;


bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}


void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tTestLtHumidiyt  -id 100  -ltconfig lttemp.xml " <<endl;
  cout <<"-id  nr  with nr humidiyt device id is required"<<endl;
  cout <<"-ltconfig  filename :  name of the configuration file  optional"<<endl;
  cout <<"-h  this message "<<endl<<endl;
  std::exit(-1);
}



int   main (int argc , char** argv ){ 
  int humidityprobe=10;
  HumidityChannelLt*  fT=0;
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  string result;
   string cmdresult;
   if( "found"==CmdLineDecode(argc,argv,"h",result,false)) {
     usage();
   }
   if( "found"==( cmdresult=CmdLineDecode(argc,argv,"id",result,true))){
     humidityprobe = (int)  strtod(result.c_str(),NULL);
   }
   else {     
     cout << "Humidity probe id ( deviceid) required " <<endl;
     cout << "\tcommand line error : "<<cmdresult<<endl;
     usage();
   }
   ltparser = new LtParser();
  if( "found"==CmdLineDecode(argc,argv,"ltconfig",result,true)){
    cout<< "use "<< result <<" as config " <<endl;
    ltparser->setParseFileName( result);
   }
  if(ltparser->parseFile( )) {
    DAQEXIT("error in lt configuration file look at error output");} 
  cout << "humdity probe " << humidityprobe << endl;
  
 fT= new HumidityChannelLt(humidityprobe);cout << endl;
 cout <<"humidity  probe " << fT->getName()<<" has id "<<fT->getId()<<endl;
 int i=0;
 while(!HasToExit) 
   { 
     
   //cout <<"S: "<<i<<" " ;cout<< *fT <<"  " << endl;
   float acthum = fT->getHumidity();
   cout << i <<" Humidity= "<< acthum << "%"
	<<" input "<< fT->getInputValue()<< endl;
      sleep(2); i++;
 }
   delete fT;
  
   delete ltparser;
    return 0;
  }
