#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
#include "ltparser.h" 

//#include <adcchannel.h>
//#include <dacchannel.h>

#include "tempctrl.h"
#include "temperaturechannellt.h"

pid_t fPid=0 ; 
bool HasToExit=false;

LtParser* ltparser; 

void  Ictrlc(int s)
{

 if (s == SIGCONT) {
 // printf("%d sigcont received\n ",getpid()); 
		     if( fPid !=0)
		       {  if (kill(fPid ,SIGCONT))
			  perror(" fail to send sigcont to child");
		     }
                     return ;
		    }
 // all other signals 
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  if( fPid !=0)
    if( kill(fPid ,SIGINT ))
       perror(" fail to send sigint to child");
   HasToExit=true;

}


#define MAXTEMPCH 3

int main(int argc, char *argv[], char *envp[])
{
  int tprobe=1;
   int exit_value=0 ; //assume everythink is o.k.
  
   signal(SIGINT,Ictrlc); // Arm interrupt handler
   signal(SIGCONT,Ictrlc); // Arm interrupt handler
   const time_t starttime = time(NULL);
   float targettemperature=-24;
   if (argc >2)
     {  tprobe = (int) strtod(argv[2],NULL);
    }
   
   std::ofstream datout( "tmpctl.dat");
   if ( ! datout) 
     { cerr << "can not open scout.dat\n" ;
       exit(-1);
     } 
   if (argc >1)
     { targettemperature = (float) strtod(argv[1],NULL);
    }

    ltparser = new LtParser();
   
  if(ltparser->parseFile( )) {DAQEXIT("error in lt configuration file look at error output");} 
  
  
   TempCtrl TC(tprobe);
    sleep(4) ; // to give the server time to start 
   TemperatureChannelInterface* Temperatures[MAXTEMPCH] ;
   Temperatures[0] = new TemperatureChannelLt(10 );
   Temperatures[1] = new TemperatureChannelLt( 11);
   Temperatures[2] = new TemperatureChannelLt(12);
   printf(" initialization passed  \n");

     int lc_wh=0;
     int resultCtrl;
     TC.setTargetTemperature(targettemperature);
    
     while ( ! HasToExit) 
       {  resultCtrl=TC.control();
       if ( resultCtrl)    
	 { if (resultCtrl== -1) {   usleep(1000);  continue;// no new value 
	 }
	 else 
	   { exit_value=resultCtrl ; break ;}
	 }
       // sleep(3);
       cout << "time: " << time(NULL) - starttime <<"[s] " ;
       //  cout << " Spill: " <<  TempAdc.getSpillNr();
       cout << "\n";
      
       TC.setTargetTemperature(targettemperature);
        {   for (int lc=0;lc < MAXTEMPCH ; lc++)
	  //Temperatures[lc]->printTempChannelInfo();
	  cout  << *Temperatures[lc] ;
		cout <<" "  ;
	 }
	  cout << "\n";
       datout << time(NULL) - starttime << ":" ;
       for (int lc=0;lc < MAXTEMPCH ; lc++)
	 {         datout <<  *Temperatures[lc];
			  datout <<" : ";
	 }
       datout << "\n" ;
       sleep(1);
       lc_wh++;
       }

   cout << "clean up" << endl;
 for (int lc=0;lc < MAXTEMPCH ; lc++)
	 { delete Temperatures[lc];}
       delete ltparser; 
   return exit_value ; 
}  
