#include <cstdlib>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "daqerrormsg.h"
#include "temperaturechannellt.h"
#include "ltparser.h"
#include "cmdlinedecode.h"
LtParser* ltparser;


bool HasToExit=false;
using namespace std;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}
void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tTestLtTemperature  -id 100  -ltconfig lttemp.xml " <<endl;
  cout <<"-id  nr  with nr temperature device id is required"<<endl;
  cout <<"-ltconfig  filename :  name of the configuration file  optional"<<endl;
  cout <<"-h  this message "<<endl<<endl;
  std::exit(-1);
}


int   main (int argc , char** argv ){ 
 int temperatureprobe=10;
 TemperatureChannelLt*  fT=0;
 signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
   string result;
   string cmdresult;
   if( "found"==CmdLineDecode(argc,argv,"h",result,false)) {
     usage();
   }
   if( "found"==( cmdresult=CmdLineDecode(argc,argv,"id",result,true))){
     temperatureprobe = (int)  strtod(result.c_str(),NULL);
   }
   else {     
     cout << "Temperature probe id ( deviceid) required " <<endl;
     cout << "\tcommand line error : "<<cmdresult<<endl;
     usage();
   }
   ltparser = new LtParser();
  if( "found"==CmdLineDecode(argc,argv,"ltconfig",result,true)){
    cout<< "use "<< result <<" as config " <<endl;
    ltparser->setParseFileName( result);
   }
  if(ltparser->parseFile( )) {
    DAQEXIT("error in lt configuration file look at error output");} 
  cout << "temperature probe " << temperatureprobe << endl;
 fT= new TemperatureChannelLt(temperatureprobe);cout << endl;
 cout <<"temperature probe " << fT->getName()<<" has id "<<fT->getId()<<endl;
 int i=0;
 while(!HasToExit) 
   {   //cout <<"S: "<<i<<" " ;cout<< *fT <<"  " << endl;
     // float basevalue;
   float acttemp= fT->getTemperature();
   cout << i <<" Temp= "<< acttemp << " C input value "<<fT->getInputValue() <<endl;
      sleep(2); i++;
 }
   delete fT;
  
   delete ltparser;
    return 0;
  }
