#ifndef __CURRENTCHANNEL
#define __CURRENTCHANNEL

#include "CalibrationValues.h"


#include <adcchannelinterface.h>
#include <currentchannelinterface.h>
/** \class CurrentChannel

    \brief current  channel class  def file
   \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 03 24 
      \version 1.1
     \date 2001 05 11
     \version 1.2 
     \date 2001 05 22
     
     The CurrentChannel 
     Interface for a electro meter readout by the ADC board
     or other I -> V conversion interface
     For the moment only electro meter -- ADC version is supported 
     
     For an example how to use it look in ScMonitor.cxx
   
    
 
*/
class CurrentChannel : public CurrentChannelInterface 

{ private:
   AdcChannelInterface* fAdcCh;
   float fActualAdcValue;
   

 public:
   /**  The constructor
        *AdcCh, is the adc channel to which the particulair current channe, is connected too 
	*c  the pointer to the calibration values that will be copied to the internal 
	       CalExchange <CurrentConvDef::CurrentCalValues structure 
	       ( inside    the CurrentConversion class) 
	*/ 
  CurrentChannel( AdcChannelInterface  *AdcCh, 
		  CalExchange <CurrentConvDef::CurrentCalValues>* c );

  /// return the current in [A]  based on actual ADC value 
  virtual float getCurrent() ;
  virtual float getInputValue(){return fActualAdcValue;} 

  virtual void info()
    { 
      fAdcCh->getAdcData(fActualAdcValue);
  
      printHCCValues( fActualAdcValue);
    }
 AdcChannelInterface* getAdcChannelPointer(){ return fAdcCh;}
};

#endif 
