#ifndef __CURRENTCHANNELDIM
#define __CURRENTCHANNELDIM

#include <dic.hxx>
#include "CalibrationValues.h"


#include "daqerrormsg.h"
#include "dimchannelnames.h"
#include "currentchannelinterface.h"
/** \class CurrentChannelDim

    \brief current  channel class  def file
   \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2002 10 14 
   
     
     The CurrentChannelDim
     is the implementation of the CurrentChannelInterface via dim
     
    
    
 
*/
class CurrentChannelDim  : public CurrentChannelInterface ,
			   public DimChannelNames,
			   public  DimClient
{ 
 private:
  bool fIsInitialized ; 
  DimInfo* fCurrentinfo;
  char fCmd[80];
  float fSent[256];
  float  fRecBuf[256];
  int fNsent;
  int fNreceived;
  float fActualCurrent;

 public:
   /**  The constructor
    *c  the pointer to the calibration values that will be copied 
        to the internal calibration values
	it should contain the name of the Dim server and the 
	boardnr and channelnr of the remote current  channel
	*/ 
  CurrentChannelDim ( CalExchange <CurrentConvDef::CurrentCalValues>* c );

  /// return the current in [A]  
  virtual float getCurrent() ;
  virtual float getInputValue();
  virtual bool isInitialized(){ return fIsInitialized;}   
  virtual ~CurrentChannelDim() {};
  virtual void info(){;}
   int wait();
  void infoHandler();
};

#endif 
