#ifndef __CURRENTCHANNELHVMOD
#define __CURRENTCHANNELHVNOD

#include "CalibrationValues.h"
#include <iostream>
#include <fstream>

#include <currentchannelinterface.h>
/**     
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 06 26
     \brief HV current  channel class 

     The CurrentChannelHvModoule 
     Maps the currrent readout of a HV module to the 
     currentchannel interface 
     remark there is no check if the hv device exist.
     The hv device has to be instantiate before this class
     can be instatitate.
   
    
   
*/

class HvChannelLt;
class HVChannelInterface;


class CurrentChannelHvMod  : public CurrentChannelInterface 
{ private:
  int fHvDeviceId;
  HvChannelLt* fHv;
  float fActualCurrent;
 public:
  /** the calibration class is there for compatiblity reasons 
      @param HvDeviceId the id of the HV channel of which te current should be measurred.
   */
  CurrentChannelHvMod(CalExchange <CurrentConvDef::CurrentCalValues>* c  );

  virtual ~CurrentChannelHvMod();
  virtual float getCurrent() ;
   
  virtual int   getId();  
  virtual float getInputValue(){return fActualCurrent;}
  virtual void info();
  HVChannelInterface* getHvChannelPointer();
};

#endif 
