#ifndef __CURRENTCHANNELINTERFACE
#define __CURRENTCHANNELINTERFACE

#include <iostream>
#include <fstream>
#include <CalibrationValues.h>

/** \brief current  channel interface class   def file
  
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 05 23 
   
     
    interface for application to get the hv bias current and
    other current measurements like lv current
    
      <h2> Usage </h2>
     For an example how to use it look in ScMonitor
   
    
 
*/
class CurrentChannelInterface  :  public CurrentConversion
{  public:
  CurrentChannelInterface(){};
  CurrentChannelInterface(CalExchange<CurrentConvDef::CurrentCalValues>* c ): CurrentConversion(*c){}
 
   virtual float getCurrent()=0; 
   /** return the raw input value like an adc input */
   virtual float getInputValue()=0;
   virtual void info()=0;
   virtual ~ CurrentChannelInterface(){};
};

std::ostream& operator<<(std::ostream& s, CurrentChannelInterface& TC  );


std::ofstream& operator<<(std::ofstream& s,  CurrentChannelInterface& TC  );


#endif 
