#ifndef __CURRENTCHANNELLT
#define __CURRENTCHANNELLT
#include  <unistd.h>
#include <iostream>
#include <fstream>
#include "currentchannelinterface.h"
#include "ltparser.h"


/** \brief (hv) current  channel for long term test
  
     
     The CurrentChannelLt provides the interface to a current 
     measurment device
     The device  connected to this object depends on the device ID 
     given in the lt.xml file
     The class takes care of   correct current channel and instanciate
     of lower level channels like adc channel if needed.
     
    
   
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 05 22 
   
 
*/

class CurrentChannelLt :  public CurrentChannelInterface  


{ private:
  
  
   CurrentChannelInterface * fT;
   int fType;

 private:

 public:
   /// constructor, the deviceID is used as key to connect the correct probe to this object
   CurrentChannelLt( int deviceID  ) ;
   virtual ~CurrentChannelLt();
   virtual float getInputValue(){ return fT->getInputValue();}
  virtual float getCurrent() 
    { return fT->getCurrent();} 
     

  virtual void info()
    { fT->info();
   }


};

#endif 
