#ifndef CURRENTCHANNELTCPIP_H
#define CURRENTCHANNELTCPIP_H
#include "currentchannelinterface.h"
/** \class CurrentChannelTcpip
    \author C.Delaere
    \date November 2002
    \version 1.0

    \brief Class used to access hv info via tcpip connection (vi viproxy)
    To be used in the dimsensserverovertcpip (the dimsensserver forwarding requests to tcpip)
*/
class CurrentChannelTCPIP : public CurrentChannelInterface
{
public:
  CurrentChannelTCPIP(ViProxy* prx, string identity,  CalExchange <CurrentConvDef::CurrentCalValues>* cal): CurrentChannelInterface(cal), proxy(prx), id(identity)
  {
    int b = cal->getBoardNr();
    int c = cal->getChannelNr();
    char board[5] = {0};
    char channel[5] = {0};
    sprintf(board,"%i",b);
    sprintf(channel,"%i",c);
    id = identity + " " + board + " " + channel;
  }
  virtual ~CurrentChannelTCPIP(){}
  virtual float getCurrent() { return float(proxy->getValue(id)); }
  virtual float getInputValue() { return 0.; }
  virtual void info() {}
private:
  ViProxy* proxy;
  string id;
};
#endif

