#ifndef HVCHANNELTCPIP_H
#define HVCHANNELTCPIP_H
#include "hvchannelinterface.h"
/** \class HvChannelTcpip
    \author C.Delaere
    \date October 2002
    \version 1.0

    \brief Class used to access hv info via tcpip connection (vi viproxy)
    To be used in the dimsensserverovertcpip (the dimsensserver forwarding requests to tcpip)
*/
class HVChannelTCPIP : public HVChannelInterface
{
public:
  HVChannelTCPIP(ViProxy* prx, string identity, int b,int c) : HVChannelInterface(b,c),
  							       proxy(prx),
							       id(identity)
  {
    char board[5] = {0};
    char channel[5] = {0};
    sprintf(board,"%i",b);
    sprintf(channel,"%i",c);
    bc = string(board) + " " + string(channel);
  }
  virtual ~HVChannelTCPIP(){}
  virtual float getHvVolt() { return float(proxy->getValue(id+"V "+bc)); }
  virtual float getHvCurrent() { return float(proxy->getValue(id+"I "+bc)); }
  virtual int   getHvStatus() {return 1;}
  virtual float getHvVoltLimit() {return 10000; }
  virtual float getHvSwVoltLimit() {return 10000; }
  virtual float getHvCurrentLimit() {return 10000; }
  virtual float getHvRampUp() {return 5;}
  virtual float getHvRampDown() {return 5;}
  virtual int   getV0() {return (int)getHvVolt(); }
  virtual int   setHvVolt(float newvalue) { proxy->setValue(id+"V "+bc,newvalue); return 1; }
  virtual int   setHvSwVoltLimit(float newvalue) {return 1; }
  virtual int   setHvVoltLimit(float newvalue) {return 1; }
  virtual int   setHvCurrentLimit(float newvalue) {return 1; }
  virtual int   setHvRampUp(float newvalue) {return 1; }
  virtual int   setHvRampDown(float newvalue) {return 1; }
  virtual int   wait() {return 1;}
private:
  ViProxy* proxy;
  string id;
  string bc;
};
#endif

