#include "currentchannelinterface.h"
#include "currentchannel.h"
#include "currentchanneldummy.h"
#include "currentchannellt.h"
#include "currentchanneldim.h"
#include "currentchannelhvmodule.h"
#include <adcchannel.h>
#include <adcchanneldummy.h> 
#include <adcchannelad4717.h>
#include "ltparser.h"
#include "daqerrormsg.h"

extern LtParser* ltparser; 
// for the moment as long I don't understand why I can not open the parser mechanism twice


CurrentChannelLt::CurrentChannelLt(int device) : CurrentChannelInterface()
{   
  if( device == CurrentConvDef::DUMMYDEVICEID) {
    fT= new CurrentChannelDummy ( );
  }
  else{ 
  CalExchange <CurrentConvDef::CurrentCalValues>* c =0;
   // LtParser* parser = new LtParser();
   //parser->parseFile( "lt.xml");
   fT=0;                        
  
       c = ltparser-> getCurrentCalibration(device);
     
          
   if ( c) 
     { DT_DEBUG_LTC(c->printIdValues( cout ));
      AdcChannelInterface* fADC; 
     fType= c->getType();
       switch (fType) { 
	 case  CurrentConvDef::DUMMY :{ 
	   CurrentConvDef::CurrentCalValues* cv=c->getCalValues();
	   fADC= new AdcChannelDummy(cv->CalAdcValue+10,2,
				     c->getBoardNr(),c->getChannelNr());
	   DT_DEBUG_LTC( "dummy channel board" << c->getBoardNr() <<
			 " channel" << c->getChannelNr()
			 << "adc ptr "<< fADC 
			 << "adc val "<< cv->CalAdcValue );
	   fT= new CurrentChannel( fADC , c );
	 }
	 break; 
	
	 case  CurrentConvDef::CURRENTSPEC : {
	     fT=new CurrentChannelDim(c);
	    //   if( !fT->isInitialized())
//  	       {   DAQEXIT("error in getting dim  channel for device "<< c->getId << endl) ;}
	 }   
	 break;

	   case  CurrentConvDef::AD4717:
	     fADC= new AdcChannelAd4717(c->getBoardNr(),c->getChannelNr());
	     DT_DEBUG_LTC( "adc channel board" << c->getBoardNr() <<" channel" << c->getChannelNr());
	       fT= new CurrentChannel( fADC , c );

	   break;  
	   case  CurrentConvDef::ADCELECTROMETER:
	   case  CurrentConvDef::ADC:
	     fADC= new AdcChannel(c->getBoardNr(),c->getChannelNr());
	     DT_DEBUG_LTC( "adc channel board" << c->getBoardNr() <<" channel" << c->getChannelNr());
	       fT= new CurrentChannel( fADC , c );

	   break;  
	   case  CurrentConvDef::HVMODULE:
	     fT= new CurrentChannelHvMod( c);
	     break;
	   default:   DAQEXIT("requested probe type"  << fType << "  not found") ;
	   break;
	 }
     
       // fT->info();
       DT_DEBUG_LTC( *fT); 
       DT_DEBUG_LTC( "pointer"<<fT <<"this pointer " << this ); 
     }
   else
     {  DAQEXIT("current device "<< device  << " not in configuration file "<<endl);
     }
    //delete parser;
     setCalibrationId(&fT->getCalibrationId());
  }
  }

CurrentChannelLt::~CurrentChannelLt()
{  switch (fType)
  { case  CurrentConvDef::DUMMY :  
    case  CurrentConvDef::ADCELECTROMETER:
    case  CurrentConvDef::ADC: 
    case  CurrentConvDef::AD4717:
                 {    CurrentChannel* fTC = (CurrentChannel*) fT; 
                     delete fTC->getAdcChannelPointer();
		 }   
    break;
    default: 
      break;
  }
 delete fT;

} 





