#include "hvchanneldummy.h"
#include "daqerrormsg.h"
#include <unistd.h>
#include <iostream>
using namespace std;

HvChannelDummy::HvChannelDummy(int board, int channel  ) : HVChannelInterface(board,channel)
{ fVolt=0;
      fCurrent=0;
      fVoltMax=0;
      fVoltSet=0;
      fVolt=0;
      fCurrentMax=0;
      fRamp=1;
      fDeviceId=board;
      fChannel=channel;fNewRequest=true; 
      start(); // have to called once it seems otherwise 
      // destructor problems ???
      usleep(10000);
     while (!finished()){
       DT_WARN("dummy hv channel doesn't leave hv setting thread  board" 
	       << getBoardId()<<" channel "<< getChannelId());
       usleep(10000);
     } 
}

float  HvChannelDummy::getHvCurrent( ) {
   DT_DEBUG_LTC( " board "   << getBoardId()<<" channel "<< getChannelId()
		 <<" current " << fCurrent);
   return fCurrent;
}
     

int  HvChannelDummy::setHvVolt(float newvalue){ 
  if (newvalue > fVoltMax) {return -2 ;}
  fVoltSet=newvalue;
  unsigned int count=0;
  while  (!fNewRequest && !finished()) {
    fNewRequest=true; usleep( 10000);
    if (!( (count++) % 1000)) { 
      DT_WARN("dummy hv channel doesn't hv leave setting thread  board" 
	      << getBoardId()<<" channel "<< getChannelId());
    }
  }
  start();
  return 0;
}

HvChannelDummy::~HvChannelDummy(){
  // make sure thread is not running 
  while (!finished()){
    DT_WARN("dummy hv channel doesn't leave hv setting thread  board" 
	      << getBoardId()<<" channel "<< getChannelId()
	    << "voltage:"<< fVolt );
    usleep(1000000);
    }
}



void HvChannelDummy::run(){
  fNewRequest=false;
  if( fVoltSet >= fVolt) {
    // rampup
    float ramp_10ms = fRamp/100;
    if (ramp_10ms  > 1 )  ramp_10ms=1;
    while (( fVolt < fVoltSet) &&  !fNewRequest){
      DT_DEBUG_LTC( " board"   << getBoardId()<<" channel "<< getChannelId()
		   <<" volt " << fVolt);
      fVolt = fVolt+ramp_10ms;
      fCurrent=fVolt/3000000;
      usleep( 10000);
    }
  }
  else {
    // rampdown 
    float ramp_10ms = fRampDown/100;
    if (ramp_10ms  > 1 && !fNewRequest )  ramp_10ms=1;
    while ( fVolt > fVoltSet ){
      fVolt = fVolt-ramp_10ms;
      DT_DEBUG_LTC( " board"   << getBoardId()<<" channel "<< getChannelId()
		   <<" volt " << fVolt);
      fCurrent=fVolt/3000000;
      usleep( 10000);
    } 
  }
  fNewRequest=true;
}


void HvChannelDummy::Info()
{
  cout << "dummychannel" << endl;
  cout << "device Id " << fDeviceId <<endl;
  cout << "channel"  <<  fChannel << endl;
}
