using namespace std;

#include <cstdlib>
#include <iostream>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "hvchannellt.h"
#include "currentchannellt.h"
#include  "adcchannelinterface.h"
#include "ltparser.h"
#include "daqerrormsg.h" 
LtParser* ltparser;


bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}

 

int   main (int argc , char** argv )
{ signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  int probe=1000;int hvprobe=-1;
   ltparser = new LtParser();
      char configfile[80];
      ltparser->getStandardConfigFile( configfile, "lt.xml");
  if(ltparser->parseFile(configfile )) 
    {DAQEXIT("error in lt configuration file look at error output");} 
 
  if (argc >1)
    { probe = (int) strtod(argv[1],NULL);
    }

  if(argc>2)
    { hvprobe= (int) strtod(argv[2],NULL); }
  HVChannelInterface* fHv=0;
  if (hvprobe >= 0) { 
    fHv = new HvChannelLt(hvprobe);
    cout<< "Hv probe:" << fHv<<endl;
    // if (fHv ==0){ DAQEXIT("hv " << hvprobe << " not found");}
  }

  CurrentChannelInterface   *fT= new CurrentChannelLt (probe);
 



  cout <<"current  probe " << fT->getName()<<" has id "<<fT->getId()<<endl;
  fT->info();
  int i=0;
  while(!HasToExit)  {  
    cout <<" "<<i<<" " ;cout<< *fT ;
    cout <<"Input value /ADC value   : "<< fT->getInputValue() <<" ";
    if(fHv)   {  
      float hv=0; fHv->justDoIt();  fHv->wait();
      fHv->lock(); hv= fHv->getHvVolt();
      fHv->unlock();
      cout <<"  HV:"<<hv;
    }
    cout<< endl;
    sleep(2); i++;
  }
  cout << " delete current channel " << endl;
  delete fT;
  if( fHv) delete fHv; 
  delete ltparser;
    
  return 0;
}
