#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include "hvchannellt.h"
#include "ltparser.h"
#include "benchposconnection.h"
#include <unistd.h>
#include "cmdlinedecode.h"
#include  <string>

LtParser* ltparser;


bool HasToExit=false;
using namespace std;

void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}

void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tTestLtHv -sethv=20   -ltconfig lttemp.xml " <<endl;
  cout <<"set the benchpos 0 (default) defined in lttemp.xml to 20 V"<<endl;
  cout <<"options:" <<endl;
  cout <<"\t-h  this message "<<endl;
  cout <<"\t-sethv :requested hv"<<endl;
  cout <<"\t-benchpos :the benchposition for which the hv should be set"<<endl;
  cout <<"\t-rampup :rampup speed (default = 5V/s)"<<endl;
  cout <<"\t-rampdown :rampdown speed (default = 5V/s)"<<endl;
  cout <<"\t-ltconfig :the configuration file (default is lt.xml)"<<endl;
  std::exit(-1);
}




int   main (int argc , char** argv )
{  
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  float requestvolt=57;
  int requestbenchpos =0;  
  float rampupspeed=5;
  float rampdownspeed=5;
  string cmdlresult;
  if( "found"== CmdLineDecode(argc,argv,"h",cmdlresult,false)){
     usage();
  }
  if( "found"==CmdLineDecode(argc,argv,"sethv",cmdlresult,true))
  { requestvolt=atoi(cmdlresult.c_str()); }
  if( "found"==CmdLineDecode(argc,argv,"rampup",cmdlresult,true))
  { rampupspeed=atoi(cmdlresult.c_str()); }
  if( "found"==CmdLineDecode(argc,argv,"rampdown",cmdlresult,true))
  { rampdownspeed=atoi(cmdlresult.c_str()); }
  if( "found"==CmdLineDecode(argc,argv,"benchpos",cmdlresult,true))
  { requestbenchpos=atoi(cmdlresult.c_str()); }

  ltparser = new LtParser(); 
  if( "found"== CmdLineDecode(argc,argv,"ltconfig",cmdlresult,true)){
    ltparser->setParseFileName( cmdlresult);
  }
  if(ltparser->parseFile()){
    cout<<"error in configuration file stop program"<<endl;
    delete ltparser;
    return -1 ;
  }
  //ltparser->parseFile( );
   //  BenchPosConnection* bp;
//     bp=ltparser->getBenchPosConnections(0);
//     bp->info();
   HvChannelLt 
     hv(ltparser->getBenchPosConnections(requestbenchpos)->getBiasDevice());
   hv.lock();
   cout << "entered lock" << endl;
   hv.setReadOnly(false);
   hv.setHvRampUp(rampupspeed);
   hv.setHvRampDown(rampdownspeed);
   hv.turnOn();
   hv.setHvVolt(0);
   hv.unlock();
   cout << "ramp setting done" << endl;
    sleep(3); 
   hv.Info();

   cout <<"limit= "<< hv.getHvVoltLimit()<< endl;
  hv.setHvSwVoltLimit(150);
  cout <<"limit= "<< hv.getHvVoltLimit()<< endl;
  sleep(1);
 
  cout << "request " << requestvolt << "V on channel " << endl;
  hv.lock();
  if ( -2 ==       hv.setHvVolt( requestvolt)) { cout << "voltage set failed "<< endl;}
  hv.unlock();
  hv.justDoIt();
  printf("wait %d \n",hv.wait());
  
  sleep(4);
  cout <<"voltage = "<< hv.getHvVolt() << endl;
  int lc=0;
  while ( ! HasToExit)
    {  lc++; 
       sleep(1);
       hv.justDoIt();
       hv.wait();
       hv.lock();
       cout <<"actual voltage = "<< hv.getHvVolt()<< " I: ";
       cout << hv.getHvCurrent() << endl;   
       hv.unlock();
       sleep(1);
      //   if (! ( lc % 8)) {
//  	  requestvolt=  lc%31;
//  	  cout << " request " << requestvolt << " V" << endl;
//  	  hv.lock(); hv.setHvVolt( requestvolt),hv.unlock(); hv.justDoIt(); hv.wait() ;} 


    }
  cout << " set output to 0 " << endl;
 hv.lock();
  hv.setHvVolt(0);
 hv.unlock();
hv.justDoIt();
  hv.wait();
    hv.justDoIt();
       hv.wait();
       hv.lock();
       cout <<"end voltage = "<< hv.getHvVolt() << endl;   
       hv.unlock();    


    return 0;
    delete ltparser;
  }
