#ifndef BASICCHPARSER
#define BASICCHPARSER
#include <unistd.h>
#include "i2cid.h"
#include "CalibrationValues.h"
#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
namespace  BasicChParser {
  
template < class T> void AdcChannelParser(DOM_Node &ei,CalExchange<T>*  CE )
{  
 
 DOM_NamedNodeMap attributes = ei.getAttributes();
 //int attrCount = attributes.getLength();
 DOM_Node e = attributes.getNamedItem("boardnr");
 int boardnr;
 sscanf(e.getNodeValue().transcode(),"%d",&boardnr);
  e = attributes.getNamedItem("channel");
 int channel;
 sscanf(e.getNodeValue().transcode(),"%d",&channel);
 CE->setBoardNr(boardnr);
 CE->setChannelNr(channel);

 char name[30]="adc channel";
 e = attributes.getNamedItem("shmname");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
  CE->setTDeviceControlName(name);
  e = attributes.getNamedItem("dimservername");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
   CE->setShmName(name);
  e = attributes.getNamedItem("mode");
  if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
  CE->setChannelMode(name);
 e = attributes.getNamedItem("connectiontype");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);}  //reuse of the name variable
 CE->setConnectionType(name);

}


template < class T> void I2cChannelParser(DOM_Node &ei,CalExchange<T>*  CE )
{  
 DOM_NamedNodeMap attributes = ei.getAttributes();
 //int attrCount = attributes.getLength();
 DOM_Node e = attributes.getNamedItem("devicenumber");
 int devnr;
 sscanf(e.getNodeValue().transcode(),"%d",&devnr);
 e = attributes.getNamedItem("subdevicenumber");
 int subdevnr;
 sscanf(e.getNodeValue().transcode(),"%d",&subdevnr);
 e = attributes.getNamedItem("i2caddress");
 int i2caddress;
 sscanf(e.getNodeValue().transcode(),"%d",&i2caddress);
 e = attributes.getNamedItem("devicechannel");
 int devchan;
 sscanf(e.getNodeValue().transcode(),"%d",&devchan);

 I2cId::i2cdevicetypes devtype=I2cId::INVALID;
 char name[30];
 e = attributes.getNamedItem("devicetype");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
 if( ! strcmp( "tsci2c",name)) {devtype= I2cId::TSCI2CCHANNEL;}
 if( ! strcmp( "pmci2c",name)) {devtype=  I2cId::PMCI2CCHANNEL;}
 if( devtype == I2cId::INVALID){ DT_WARN("Device type" << name << "not supported");}
 int boardnr=  calculateI2cBoardNr(i2caddress,devchan,subdevnr,devnr,devtype);
  e = attributes.getNamedItem("channel");
 int channel;
 sscanf(e.getNodeValue().transcode(),"%d",&channel);
 CE->setBoardNr(boardnr);
 CE->setChannelNr(channel);
 DT_DEBUG_LP("board: "<<boardnr<<" channel "<<channel);
 strcpy(name,"I2cadc channel");
 e = attributes.getNamedItem("shmname");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
  CE->setTDeviceControlName(name);
  e = attributes.getNamedItem("mode");
  if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
  CE->setChannelMode(name);
 e = attributes.getNamedItem("connectiontype");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);}  //reuse of the name variable
 CE->setConnectionType(name);

}



template < class T> void DummyChannelParser(DOM_Node &ei,CalExchange<T>*  CE )
{  
  // accept port of board and addres or channel (or nothing default 1,1
 DOM_NamedNodeMap attributes = ei.getAttributes();
 //int attrCount = attributes.getLength();
 DOM_Node e = attributes.getNamedItem("boardnr");
 int boardnr=1; //default
 if(! e.isNull() ) { sscanf(e.getNodeValue().transcode(),"%d",&boardnr); }
 e = attributes.getNamedItem("port");
 if(! e.isNull() ) { sscanf(e.getNodeValue().transcode(),"%d",&boardnr); }
  e = attributes.getNamedItem("channel");
  int channel=1; //default 
 if(! e.isNull() ){ sscanf(e.getNodeValue().transcode(),"%d",&channel);}
 
 CE->setBoardNr(boardnr);
 CE->setChannelNr(channel);
 const int namelength=80;
 char name[namelength];
 strcpy(name,"dummychannel");
 e = attributes.getNamedItem("shmname");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
 CE->setTDeviceControlName(name);
 e = attributes.getNamedItem("servername");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
 CE->setTDeviceControlName(name);
 strcpy(name, "shm/tcpip not defined");
 e = attributes.getNamedItem("tcpipaddress");    
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
 else {  
   e = attributes.getNamedItem("dimservername");
   if(! e.isNull() ) {  
     sscanf(e.getNodeValue().transcode(),"%s",name);
     // if the name is set to local make name host 
       if(!strcmp( "local",name)){
	 gethostname(name,namelength);
       }  
   }
 }
 CE->setShmName(name); 
 e = attributes.getNamedItem("mode");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
 CE->setChannelMode(name);
 
 e = attributes.getNamedItem("connectiontype");
 if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);}  //reuse of the name variable
 CE->setConnectionType(name);
 
}


template < class T> void SerialChannelParser(DOM_Node &ei,CalExchange<T>*  CE)
{
  DOM_NamedNodeMap attributes = ei.getAttributes();
  //int attrCount = attributes.getLength();  // why ?
  int port;
   DOM_Node e = attributes.getNamedItem("port");
    if(! e.isNull() ) 
      { sscanf(e.getNodeValue().transcode(),"%d",&port);
      }
    CE->setBoardNr(port);
    int address;
    e = attributes.getNamedItem("address");
    if(! e.isNull() ) 
      {  sscanf(e.getNodeValue().transcode(),"%d",&address);
        CE->setChannelNr(address);
      }
    else // accept also channel instead of address but not both 
      {   e = attributes.getNamedItem("channel");
          if(! e.isNull() )
	    {  address= atoi(  e.getNodeValue().transcode());
	       CE->setChannelNr(address);
	    }
      }  
    char name[50];
    e = attributes.getNamedItem("shmname");
    if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
    CE->setTDeviceControlName(name);
  
    e = attributes.getNamedItem("dimservername");
    if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
    CE->setShmName(name); 
    e = attributes.getNamedItem("mode");
    if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
    CE->setChannelMode(name);


    e = attributes.getNamedItem("connectiontype");
    if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);}  //reuse of the name variable
    CE->setConnectionType(name);
   
}

template < class T> void CaenNetChannelParser(DOM_Node &ei,CalExchange<T>*  CE)
{
  DOM_NamedNodeMap attributes = ei.getAttributes();
  //int attrCount = attributes.getLength();  // why ?
  int port;
   DOM_Node e = attributes.getNamedItem("cratenr");
    if(! e.isNull() ) 
      { sscanf(e.getNodeValue().transcode(),"%d",&port);
      }
    CE->setBoardNr(port);
    int channel=-1;
     // accept also channel instead of address but not both 
    e = attributes.getNamedItem("channel");
    if(! e.isNull() )      { 
      channel = atoi(  e.getNodeValue().transcode());
      CE->setChannelNr(channel);
    }
    e = attributes.getNamedItem("slot");
    if(! e.isNull() )      { 
      // in case a  boardnr is defined
      // this is only for SY527 fo the moment and the 20
      // is a fixed number. 
      channel +=(20* atoi(  e.getNodeValue().transcode()));
      CE->setChannelNr(channel);
    } 
   char name[50];
   e = attributes.getNamedItem("shmname");
   if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
   CE->setTDeviceControlName(name);
    e = attributes.getNamedItem("dimservername");
    if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);} 
    CE->setShmName(name);
   
   e = attributes.getNamedItem("connectiontype");
   if(! e.isNull() ) {sscanf(e.getNodeValue().transcode(),"%s",name);}  //reuse of the name variable
   CE->setConnectionType(name);
}

};


#endif 
