#ifndef BENCHPOSCONNECTIONPARSER
#define BENCHPOSCONNECTIONPARSER


#include "pmap.h"
#include "commonparser.h"
// needed for the replaceP function 
#include "benchposconnection.h"
class DOM_Node;

class BenchPositionParser : public CommonParser {
 public:
  BenchPositionParser(){}
  BenchPositionParser(DOM_Node &ei){parseNode(ei); }
  int parseNode(DOM_Node &ei);
  int getNumberBenchPositions()const { return  benchpos.size();}
/** returns the logical bench position number of the first module 
    registered
    this can be different from the bench position.
    the follow order in the xml file gives the number i,
    the device number in the lt.xml file is the real position number
*/
  
  BenchPosConnection* getRegisteredBenchPos(int i) ;
/** returns the bench position connection information for the
      benchposition i ( the device id )
      If the bench position is not defined an empty bench position
      connection information is returned.
*/

 BenchPosConnection* getBenchPosConnections(int i) ;

 void addBenchPosConnection(BenchPosConnection* p){
   int i=p->getId();
   benchpos.replaceP(i,p);
 }

 protected:
/// parser for the details of the connections to the I2C (FEC, CCU)
 int I2cConnectionParser(DOM_Node &ei,BenchPosConnection* a );

 int FedConnectionParser(DOM_Node &ei,BenchPosConnection* a );
 /// detail parser for each UTRI channel
 int UtriChannelParser(DOM_Node &ei,BenchPosConnection* a );
 protected:
 static  pmap<int,BenchPosConnection*> benchpos; 
};

#endif
