#ifndef CALEXCHANGE__
#define  CALEXCHANGE__
#include "idexchange.h"

/** /brief  class to get and set the calibratoin information from the system data base or file 
    this class contains the code to get and set the values needed for the differeent physic channels
   like  temperature channel, hv channel etc.
   The type T is assumed to be a structure that contains all sensor specific values.
   It is chosen to use a template class to avoid duplicating the code needed to fill in all necessary values 
   for the different sensors.
   For the standard information it make use of the IdExchange class
   
   \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2000 12 
  \version 2.0  spill of the IdExhcange class (previous members where implemented in this class)
     \date 2002 06 04    
*/



 template  <class T> class CalExchange : public IdExchange
{ 
 
 protected:
    T fCV ; //! < the specific  calibration values
    /*!< this should be take over by the class which inherits this function by assing a reference 
      and the class should not instanciate its own */
   
  

   public :
   
  CalExchange<T>( ) 
     {initCalexchange(-1);
     }
    CalExchange<T>(int Id ) 
     { initCalexchange(Id);
     }
 
    /// copy cal values @param a should have const but gives problems
 CalExchange <T>&   operator=( const  CalExchange <T>&  a  )
   
 { if( this != & a){ 
   this->setCalValues(&(a.getCalValues()));
   
   
   CalibrationId* plCI = new CalibrationId ;
      *plCI = a.getCalibrationId() ;
      this->setCalibrationId ( plCI);
      delete plCI;
 }
      return *this;
   }
   
        //    CalExchange<T> ( const CalExchange<T>& a) 
//	 { *this= a;
   //       } 
 /// returns the pointer to the calibration values
   T* getCalValues(){ return &fCV;}
   //! methode to copy the structure
  void setCalValues( const T* CV_in)
     { memcpy( &fCV , CV_in , sizeof (fCV));     }
  void clearCalValues ()
    { memset(&fCV ,0, sizeof(fCV));} 
   void putCalValues ( T* CV_out)
     { memcpy( CV_out , &fCV, sizeof (fCV));     }

private:
    void  initCalexchange(int Id )
      {fCId.fId = Id; 
       fCId.fChannel=Id;  //  for the moment   
       setTDeviceControlName("");
       setChannelMode("");
       setName("undefined");
       setConnectionType("");
       fCId.fBoardNr=-1;
       fCId.fType=-1;
       fCId.fDevice=-1;
       fCId.fModule=-1;    
       fCId.fSimulation=false;
      }

    
};

#endif 
