#ifndef __CHRONO
#define __CHORNO
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>

/**
   \class chrono
   \author W. Beaumont
   \date 20010516
   \version 0.2
   \brief to measure times during program running 

   This class is a simple method to check the time spend between two calls .
   It also use the class tv what is defined inside the class 
   way to use 

     Chrono C;
     // other code
     C.getDiff("this is the comment what apears in the output");
     // other code 
     C.getDiff("this is the comment what apears in the output");

   The getDiff funtion prints (with the printf statement) the time between the last call and the current call.

   Class is not fully tested. 

 */

class Chrono 
{
  class  tv 
    { public :
      long tv_usec;    long tv_sec;
      tv()
      { tv_usec=0;  tv_sec=0;    }

      tv(long sec , long usec)
	{ tv_sec=sec;  tv_usec=usec;    }

      tv(struct timeval tvi) 
      { tv_usec=tvi.tv_usec;     tv_sec= tvi.tv_sec;      }
    
      tv( const tv& tvi) 
      {  tv_usec=tvi.tv_usec;     tv_sec= tvi.tv_sec;     }
     
      tv operator -= (const tv& a)
      { tv_usec -= a.tv_usec;    
        if (tv_usec < 0)
	  { tv_sec--;
	  tv_usec+= 1000000; // + 1 sec
	  }
	tv_sec -= a.tv_sec;
	return *this ;
      }
      
      friend  tv   operator-(const tv& a, const tv& b)
	{ tv tmp(a);
	tmp -= b;
	return a;
	}

// doesn't work correct

      friend  tv    operator+(const tv& a,const tv&  b)
	{ tv c;
	c.tv_usec= a.tv_usec + b.tv_usec;
	c.tv_sec= a.tv_sec + b.tv_sec;
	return a;
	}
      
      friend bool    operator==(const tv& a,const tv&  b)
	{
	  if ( a.tv_sec ==  b.tv_sec) 
	    {  if ( a.tv_usec == b.tv_usec) 
	       return true;
	    }
	  return  false ;
	}

      friend bool    operator!=(const tv& a,const tv&  b)
	{
	   return  ! (a==b) ;
	}

      friend bool    operator<(const tv& a,const tv&  b)
	{
	  if ( a.tv_sec > b.tv_sec) 
	    { return false ;
	    }
	  if (a.tv_sec < b.tv_sec)
	    return true ;
	  // else seconds are the same
	  if ( a.tv_usec < b.tv_usec) 
	    return true;
	  return  false ;
	}

     friend bool    operator<=(const tv& a,const tv&  b)
     { if ( a == b) return true;
       return ( a < b);
     }

     friend bool    operator> (const tv& a,const tv&  b)
	{
	  if ( a == b) return false;
	  return ! ( a < b );
	}
  
      friend bool    operator>= (const tv& a,const tv&  b)
	{
	  if ( a == b) return true;
	  return ! ( a < b );
	}


      tv&   operator=(tv a)
      {
	tv_usec = a.tv_usec;
	tv_sec = a.tv_sec;
	return *this;
      }
      
      tv& operator=( struct timeval a)
      {
	tv_usec = a.tv_usec;
	tv_sec = a.tv_sec;
	return *this;
      }
    };


 private:
   struct timeval t;
  
   tv  fLast ; // last tine since call and update 
   struct timezone    fTimez;
   tv  fZero ; // startup time 



 public:
   
   Chrono()
     { 
       fTimez.tz_minuteswest= -60;
       fTimez.tz_dsttime=0;
       gettimeofday( &t, &fTimez);
       fZero=t; fLast=t;
     }

   void      output(char* comment,tv k)
     {  printf( "%s  Sec : %ld usec: %ld \n", comment, k.tv_sec,k.tv_usec);
     }

   void getDiff(char *addtext )
     {
           gettimeofday(&t, &fTimez);
     tv fsw(t) ; 
     fsw -=fLast;
     fLast=t;
     output (addtext, fsw);
     }
    void getDiffNoUpdate(char *addtext )
     {  gettimeofday(&t, &fTimez);
        tv fsw(t) ; 
        fsw -=fLast;
        output (addtext, fsw);
     }
   /*! brief: returns tru if there is more time then delay is past since the last call 
       if it is true the last time (fLast) is updated 
       if not nothing happens
   */
   
   bool PastTime(long secdelay, long usecdelay)
     { gettimeofday( &t, &fTimez);
        tv delay( secdelay , usecdelay);
        tv fsw(t) ; 
	fsw -=fLast;
	if ( fsw < delay )
	  return false;
	fLast= t;
	return true;
     }
    
      
};

#endif
