#ifndef __DACCHANNELTRHX_SENS
#define __DACCHANNELTRHX_SENS
#include  <unistd.h>
#include <iostream.h>
#include <fstream.h>
#include "TShare.h"
#include "TDeviceControl.h"
#include "CalibrationValues.h"
#include "trhxdescription.h"
//#include "trhx.h"
#include "dacchannelinterface.h"
/** \brief dac channel class for the trhx analogue outputs
     
     for setting  the output voltage  of the trhx DAC   
    
     \author W. Beaumont University Antwerpen 
     \version 0.1 
     \date 20011004 
*/

class DacChannelTrhx :  public DacChannelInterface  

{ private:
   
  ChannelDescription* fCd;
  pid_t fPid;
  TShare *fMemoryClient;
  TrhxDescription *fTrhx;
  TrhxDescription::dacbuffer* fDac; 
  
  bool fInitialized;
  int AttachTrhxDacChannel    (int serial_nr, int channelnr );
 public:
  /** \brief constructor 
      
      It attach itself to the trhx server
     
      @param TrhxBaseComPort  com port number to which the TRHX  base is connected.
      @param channel : the sensor channel number
  */
   DacChannelTrhx( int  TrhxBaseComPort ,int channel  ) ;
      /// returns the actual dac 
   virtual void setGain(int i) { ;} //<does nothing no gain to set for thr TRHX 
   
   virtual void setOutputVoltage(unsigned short v) ;
   virtual  int getGain() { return 1; } //<standard TRHX gain returns always 1 
   virtual  unsigned short getOutputVoltage();

  /// returns the pointer to the ThrxDescription none interface option
    TrhxDescription* getTrhxDescripion() { return fTrhx;} 
   
    bool isInitialized(){ return fInitialized;}

/** Share memory lock */
  virtual void  lock() {fMemoryClient->Lock();}
  /** Share memory unlock */
  virtual void  unlock() {fMemoryClient->Unlock();}
   
    virtual void release();
    virtual void justDoIt();
    virtual ~DacChannelTrhx();
};

#endif 
