#ifndef DIMCHANNELNAMES_H
#define DIMCHANNELNAMES_H
#include <string>
#include <cstdio>

class DimChannelNames
{ public:
  
  enum DIMSENSCMDS {GET_TEMP,SET_TARGET_TEMP,START_CONTROL,STOP_CONTROL,GET_STATUS,
		    GET_VOLT,GET_HVCURR,SET_VOLT,GET_CURRENT};
  enum DIMHVBUF { ACTVOLT=1, ACTCUR, SETHV };

    DimChannelNames( )  {  ; }
    void  setDimServerName(const char* name ){   fSSN=name;printf("init dimnames:%s , size:%d\n" ,
								fSSN.c_str() , fSSN.size());}
    bool DimServerNameNotValid(){ if ( fSSN.size()) return false; return true;}
    const char*  DimSensDevCmdName(int board) { std::string hlp = fSSN+"/DEV"+inttostring(board); 
                                                return hlp.c_str();}
    const char*  DimSensDevAckName(int board ){ std::string hlp= fSSN+"/DEV"+inttostring(board)+"/ACK" ; 
                                        return hlp.c_str();}
    const char*  BaseName(){ return fSSN.c_str();}

    const char*  DimTempChannelCmdName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/TEMP"+inttostring(ch) ; 
                                       return hlp.c_str();}
    const char*  DimTempChannelAckName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/TEMP"+inttostring(ch)+"/ACK" ; 
                                       return hlp.c_str();}
    const char*  DimHumidityChannelCmdName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/HUM"+inttostring(ch) ; 
                                       return hlp.c_str();}
    const char*  DimHumidityChannelAckName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/HUM"+inttostring(ch)+"/ACK" ; 
                                       return hlp.c_str();}
    const char*  DimTCtrlChannelCmdName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/TCTRL"+inttostring(ch) ; 
                                       return hlp.c_str();}
    const char*  DimTCtrlChannelAckName(int board ,int ch )
                {  std::string hlp= fSSN+"/DEV"+inttostring(board)+"/TCTRL"+inttostring(ch)+"/ACK" ; 
                                       return hlp.c_str();}


   const char*  DimCurrentChannelCmdName(int board ,int ch ) {  
     std::string hlp= fSSN+"/DEV"+inttostring(board)+"/CUR"+inttostring(ch) ; 
     return hlp.c_str();
   }
   const char*  DimCurrentChannelAckName(int board ,int ch ){  
     std::string hlp= fSSN+"/DEV"+inttostring(board)+"/CUR"+inttostring(ch)+"/ACK" ; 
     return hlp.c_str();
   }
   const char*  DimHvChannelAckName(int board ,int ch ){  
     std::string hlp= fSSN+"/DEV"+inttostring(board)+"/HV"+inttostring(ch)+"/ACK" ;
     return hlp.c_str();
   }
   const char*  DimHvChannelCmdName(int board ,int ch ) {  
     std::string hlp= fSSN+"/DEV"+inttostring(board)+"/HV"+inttostring(ch) ;
     return hlp.c_str();
   }

/*     const char* DimN470ChannelCmdName( int board, int ch) */
/*       { std::string hlp = fSSN+"/HV/"+A303_0x+intostring(board/10000)+"N470_"+inttostring(board%10000)+ */
/*  	 "/CHANNEL_"+inttostring(ch); */
/*       } */

   ~DimChannelNames( )  {   };
 private:
     std::string  fSSN; //< fSensServerName
     std::string  fDnsNode;
     
     std::string inttostring( int i) // only two width
       { char name[4];
         sprintf(name,"%02d",i);
	 std::string s=name;
	 return s;
       }
};


#endif
