#ifndef __DIOCHANNELDUMMY
#define  __DIOCHANNELDUMMY
#include "diochannelinterface.h"
#include "Dioctrl.h"

/** 
    \class Diochanneldummy
    \author W .Beaumont
    \date March 2002
    \version 0.1


    \brief Cio  implementation of DioChannelInterface

   

    <h2> Usage </h2>
    It implementsDioChannelInterface class and make the Daq transparent to 
    the user:
    <ul>
    <li> it connects to the Main TDeviceControl and request channel
    <li> it maps the Ddc Share memory corresponding part to a AdcDescription
    <li> it controls access to this AdcDescrition thru methods lockDataBuffer,
    unlockDataBuffer,getApvEventData and release.
    </ul>
    <pre>
    




*/

class DioChannelDummy : public DioChannelInterface
{ public:

private:
  int fLastStatus;
  int fBit ;
  pid_t fPid;
  bool fJustSet; 

public:
  /** Constructor
      @param number the adc device number determins which adc will be used.
      @param channel  wich channel of the adc will be used
       */   
  DioChannelDummy(char* dummy,long number, long channel,diomode mode );

  virtual ~DioChannelDummy();

  /** set the bit 
    @param i  if 0 bit is set to 0 else to 1 , 2 pulse 
    !!! locks also the buffer during requese 
  */
  virtual int  setBit(int i  );

  
  /** get the status of the bit , 1 or 0 
   */   
  virtual int getBit();
 virtual int getBit(int& i);
  /** Lock share memory access */
  virtual void  lock() {;}
  /** Unlock share memory access */
  virtual void  unlock() {;} 
  /** detach share memory access and release daq channel */
  virtual void  release();
  /** give the average ADC value for the channel 
      returns the number of samples used to calculate the avarage 
      @param adcvalue the average value of the ADC input 
  */
  
  virtual int wait();

  /** only for debug reasons */ 
  virtual void   info(std::ostream& sout);
   



};

#endif 
	

