#ifndef HUMIDITYPARSER
#define HUMIDITYPARSER

#include "pmap.h"
#include "commonparser.h"
#include "CalibrationValues.h"
class DOM_Node;


class HumidityParser : public CommonParser
{
 public:
  HumidityParser(){};
  ~HumidityParser(){;}
 int parseNode(DOM_Node &ei);
 CalExchange<HumidityConversionDef::HumidityCalValues>*
   getInfo(int device ){return humiditys.getP(device);}
   int getCards(){return humiditys.size();}
   void clear(){humiditys.clearpointermap();}
   void setDummy(int deviceid);
 private:
   void HumidityMirel1050parser(
     DOM_Node &ei,
     CalExchange<HumidityConversionDef::HumidityCalValues>*  CV
   );
   void HumidityTrhxparser(
     DOM_Node &ei,
     CalExchange<HumidityConversionDef::HumidityCalValues>*  CV
   );
   void HumiditySpecialparser(
     DOM_Node &ei,
     CalExchange<HumidityConversionDef::HumidityCalValues>*  CV
   );

    /// power channels that controls the peltier in the system
  static    
    pmap< int,CalExchange<HumidityConversionDef::HumidityCalValues>*>
    humiditys;
     
};

#endif 
