#ifndef STRUCTCONPARSER
#define STRUCTCONPARSER

#include "structconinfo.h"
#include "commonparser.h"
class DOM_Node;

class StructConParser : public CommonParser {
 public:
  StructConParser(){}
  ~StructConParser(){}
  
  void parseNode(DOM_Node& ei);
  void clear();
 
  int getFedChannel(int connr, int cirnr){
    StructConInfo::circuitinfo* ci=fSci.getCircuitInfo(connr,cirnr);
    if ( ci) { return ci->fFedChan;}
    else return -1;
  }

  int getFedSerialNr(int connr, int cirnr){
    StructConInfo::circuitinfo* ci=fSci.getCircuitInfo(connr,cirnr);
    if ( ci) { return ci->fFedSerialNr;}
    else return -1;
  }
  
  unsigned int getNrCon(){ return fSci.fConnectors.size();}
  static  StructConInfo* getStructConInfo(){ return &fSci;}
protected:
  void parseConnector(DOM_Node& ei );
  void parseCircuit(DOM_Node& ei ,pmap<int,StructConInfo::circuitinfo*>* ci);


 protected:
  static StructConInfo fSci;

};

#endif
