#ifndef __THRXBASE
#define __THRXBASE
#include  <unistd.h>
#include <iostream.h>
#include <fstream.h>
// #include "trhx.h"
/** \brief Thrx init class 
  
     
    Will intialize a Thrx base station.
    Each sensor will instanciate this class but the initialization is happen only once
    Uses the functions delivered with the Trhx system.

   
     \author W. Beaumont University Antwerpen 
     \version 0.1 
     \date 2001 08 31 
     
*/
#define MaxThrxComPort 2

class TrhxBase
{ private:
   static unsigned int  fIsInit[MaxThrxComPort];
   short unsigned int fTrhxVersion;
   short unsigned int fComPort;


 public:

  /** \brief constructor for initializing the Trhx base module
      the Thrx base should be connected to the com port 
      It is checked if the ThrxBase station connected to this port already exist. 
      If not it will be initialized.
      For the moment minimal static implementation. 
      @param ComPort  com port number to which the TRHX  base is connected.
    
  */
 TrhxBase( int ComPort  ) ;
  
    /// print some information about the  Trhx base station object only for debug reasons
   virtual void info()
    

     { 
       if( fIsInit[fComPort]) 
       { printf( "Connected to port %d, TRHX base station verion : %d\n",fComPort, fTrhxVersion );
       }
     else
       { printf ("THRX base station on com port %d seems not to be initialized\n",fComPort);
       }
    } 
   /// gives the value for  the  sens channel i
   float getSensValue( int i);
  /// destructor , exit the trhx if no io is  connected
  virtual ~TrhxBase( ) ;

};

#endif 
