#include "TDeviceControl.h"
#include "TShare.h"
#include "adcchanneldummy.h"
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
AdcChannelDummy::AdcChannelDummy(long adc_ser_nr, long channel_arg)
  : AdcChannelInterface(adc_ser_nr,channel_arg) {
  InitAdcChannelDummy(24560.38,256);
}

AdcChannelDummy::AdcChannelDummy(float level, int fluctuation,
				 long adc_ser_nr, long channel_arg)
  : AdcChannelInterface(adc_ser_nr,channel_arg) {
  InitAdcChannelDummy(level,fluctuation);
}


void AdcChannelDummy::InitAdcChannelDummy(float level, int fluctuation)
{ static char h[10]; 
 initstate( 3,h,10);srandom( 20);
  fSpill=0;
  fLevel=level;
  fRandomRange= fluctuation;
}

AdcChannelDummy::~AdcChannelDummy()
{;
  
}
void AdcChannelDummy::release()
{
  
}
int   AdcChannelDummy::variation()
{ static int  r;
   srandom( r);
    r= random();

 return r% fRandomRange;
} 


int AdcChannelDummy::getAdcData(float& mean )
{  
 
 mean = fLevel+(float)  variation();  
  return 1024 ;
}

int AdcChannelDummy::getAdcData(unsigned short *out_buf, int size_of_buf )
{
  
  // Check Size
  int Samples =1024;
 
  for (int isample=0;Samples;isample++)
    {
      
      out_buf[isample] = (unsigned int )(16*isample* (int)variation());
      fSpill++; 
    }
  return Samples;
}

unsigned short AdcChannelDummy::getAdcSample(int isample)
{  fSpill++; 
  return (unsigned short)(16*2345* (int)variation());
}

unsigned short AdcChannelDummy::getSampleFromBuffer(int i)
{  
  fSpill++;
  return (unsigned short) (16*2333 * (int)variation());
}



  void   AdcChannelDummy::info(std::ostream& sout)
{ // this is not written with effeciency in mind !!!
  sout << "Adc Channel info" ;
  sout << " Channel: "<< getChannelId(); 
  sout << " Actual spill :" << getSpillNumber() ;
  float mean;
  (void)getAdcData( mean);

  sout << " Actual value :" << mean; 
   sout << "sample 10 :" << getAdcSample(10);

}

int AdcChannelDummy::fSpill=0;
