#include "benchpositionparser.h"
#include "benchposconnection.h"
#include "daqerrormsg.h"
#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "diolineparser.h"
// this is as long there is no current , hv parrser class 
#include "ltparser.h"
#include <string>
using namespace std;
extern LtParser* ltparser; 

pmap<int,BenchPosConnection*> BenchPositionParser::benchpos; 

int  BenchPositionParser::parseNode(DOM_Node &ei){DOM_NamedNodeMap attributes = ei.getAttributes();
  int device=-1;
  DOM_Node e = attributes.getNamedItem("device");
  sscanf(e.getNodeValue().transcode(),"%d",&device  );
  BenchPosConnection* a= new  BenchPosConnection(device);
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull())
    { if (strcmp(n.getNodeName().transcode(),"TemperatureProbeNtc0")==0)
      {   a->setNTCDevice(ltparser->TemperatureParser(n),0);
       }
     if (strcmp(n.getNodeName().transcode(),"TemperatureProbeNtc1")==0)
      {   a->setNTCDevice(ltparser->TemperatureParser(n),1);
       }
     if (strcmp(n.getNodeName().transcode(),"Current125")==0)
      {   a->setLvCurrentDevice(ltparser->CurrentParser(n),0);
       }
      if (strcmp(n.getNodeName().transcode(),"Current250")==0)
      {   a->setLvCurrentDevice(ltparser->CurrentParser(n),1);
       }
      if(strcmp(n.getNodeName().transcode(),"BiasCurrentConnection")==0)
	{ a->setHvCurrentDevice(ltparser->CurrentParser(n));
	}
      if(strcmp(n.getNodeName().transcode(),"BiasHvConnection")==0)
	{ a->setBiasDevice(ltparser->HvParser(n));
	}
       if(strcmp(n.getNodeName().transcode(),"I2cConnection")==0)
	 { I2cConnectionParser(n,a);
	}
       if(strcmp(n.getNodeName().transcode(),"FedConnection")==0)
	 { FedConnectionParser(n,a);
	 }    
      if(strcmp(n.getNodeName().transcode(),"PowerSwitch")==0)
	 { DioLineParser dl;
	 a->setPowerSwitch(dl.parseNode(n));
	 
	 //a->setPowerSwitch(DioLineParser(n));
	 }   
       n = n.getNextSibling();        
    }
  
  benchpos.replaceP(device,a);
  return device;
}
int  BenchPositionParser::I2cConnectionParser(DOM_Node &ei,BenchPosConnection* a ){  
  int value; 
  bool sharedmem=false; 
  DOM_NamedNodeMap attributes = ei.getAttributes();
  DOM_Node e=attributes.getNamedItem("dimhost");
  string dimhost(e.getNodeValue().transcode());
  if( dimhost == "sharedmemory") { sharedmem=true;}
  if( dimhost == "local"){
    int len=80;
    char hname[80];
    gethostname(hname,len);
    string host(hname);
    dimhost=host;
  } 
  a->setDimHostName(dimhost);
  e= attributes.getNamedItem("fecboard");
  sscanf(e.getNodeValue().transcode(),"%d",&value  );
  a->setFecNr(value);
  e = attributes.getNamedItem("ccuaddress");
   sscanf(e.getNodeValue().transcode(),"%d",&value  );
   a->setCcuAddress(value);
   e = attributes.getNamedItem("ccuchannel");
   sscanf(e.getNodeValue().transcode(),"%d",&value  ); 
   a->setCcuChannel(value) ;
   e = attributes.getNamedItem("latencyoffset");
   sscanf(e.getNodeValue().transcode(),"%d",&value  );    
   a->setLatencyOffset((unsigned int)value);
   //set the defaults 
   if(sharedmem){
     a->setOptoType(BenchPosConnection::DUMMYI2C);
     a->setPllType(BenchPosConnection::PLL);
     a->setDcuType(BenchPosConnection::DCU2);
     a->setApvType(BenchPosConnection::APV25);
     a->setMuxType(BenchPosConnection::MUX25);
   }
   else {
     a->setOptoType(BenchPosConnection::DUMMYI2C);
     a->setPllType(BenchPosConnection::PLLDIM);
     a->setDcuType(BenchPosConnection::DCU2DIM);
     a->setApvType(BenchPosConnection::APV25DIM);
     a->setMuxType(BenchPosConnection::MUX25DIM);
   }
   { e = attributes.getNamedItem("optotype");
     if(!strcmp("opto",e.getNodeValue().transcode())){
       if( sharedmem){
	 a->setOptoType(BenchPosConnection::OPTO);
       }
       else{
	 a->setOptoType(BenchPosConnection::OPTODIM);
       }
     }
   }
   { e = attributes.getNamedItem("plltype");
     if(! e.isNull() ) {
       if(!strcmp("dummy",e.getNodeValue().transcode())){
	 a->setPllType(BenchPosConnection::DUMMYI2C);
       }
       if(!strcmp("plldim",e.getNodeValue().transcode())){
	 a->setPllType(BenchPosConnection::PLLDIM);
       }
     }  // else keep previous defined 
   }
   { e = attributes.getNamedItem("dcutype");
     if(! e.isNull() ) {
      if(!strcmp("dummy",e.getNodeValue().transcode())){
	a->setDcuType(BenchPosConnection::DUMMYI2C);
      }
      if(!strcmp("dcudim",e.getNodeValue().transcode())){
	a->setDcuType(BenchPosConnection::DCU2DIM);
      }
     }// else keep pervious defined 
   }
   a->setFecSimulation(false);
   e = attributes.getNamedItem("simulation");
    if(! e.isNull() )
     { if ('y' == e.getNodeValue().transcode()[0] || fSimulation  ) {  a->setFecSimulation(true);}
     }
   DOM_Node n =ei.getFirstChild();
   while (!n.isNull())
     {   n = n.getNextSibling();  }
   return 0;
}

int  BenchPositionParser::FedConnectionParser(DOM_Node &ei,BenchPosConnection* a )
{  DOM_Node n =ei.getFirstChild();
   while (!n.isNull())
     {  if(strcmp(n.getNodeName().transcode(),"UtriChannel")==0)
	{ UtriChannelParser(n,a);
	}
       n = n.getNextSibling();        
     }
   return 1;
}

int  BenchPositionParser::UtriChannelParser(DOM_Node &ei,BenchPosConnection* a )
{  int value;int utrichannel;
   DOM_NamedNodeMap attributes = ei.getAttributes();
   DOM_Node e = attributes.getNamedItem("utrichannel");
   sscanf(e.getNodeValue().transcode(),"%d",&utrichannel  );
   e = attributes.getNamedItem("fedserialnr");
   sscanf(e.getNodeValue().transcode(),"%d",&value );
   a->setFedNr(value, utrichannel);
   a->setFedSimulation(false,utrichannel);
   e = attributes.getNamedItem("simulation");
   if(! e.isNull() )
     { if ('y' == e.getNodeValue().transcode()[0] || fSimulation ) {  a->setFedSimulation(true,utrichannel);}
     }
   e = attributes.getNamedItem("type");
   if( strcmp(e.getNodeValue().transcode(),"sharedmem")==0){
     a->setFedType(BenchPosConnection::SHAREDMEM,utrichannel);
   }
   else { a->setFedType(BenchPosConnection::DIMDEV,utrichannel);}
   e = attributes.getNamedItem("muxcard");
   sscanf(e.getNodeValue().transcode(),"%d",&value );
   if (value != -1)  { 
     BenchPosConnection::MuxChId muxid;
     muxid.fMuxCard=value;
     e = attributes.getNamedItem("muxdevice");
     sscanf(e.getNodeValue().transcode(),"%d",&value );
     muxid.fMuxDevice=value;
     e = attributes.getNamedItem("muxchannel");
     sscanf(e.getNodeValue().transcode(),"%d",&value );
     muxid.fMuxChannel=value;
     a->setMuxId (muxid,utrichannel);
   }
   else     {   
     e = attributes.getNamedItem("fedchannel");
     sscanf(e.getNodeValue().transcode(),"%d",&value  );     
     a->setFedChannel(value, utrichannel);
   }
   return 0;
}

 
BenchPosConnection* BenchPositionParser::getBenchPosConnections(int i){
  BenchPosConnection* bpc=benchpos.getP(i);
  if ( !bpc){
    bpc= new BenchPosConnection (-1); //everything set  to -1 
    benchpos[i]=bpc;
  }
  return bpc;
}

BenchPosConnection* BenchPositionParser::getRegisteredBenchPos(int i){
  BenchPosConnection* bpc=0;
  if( (unsigned int)i > benchpos.size()){
     bpc= new BenchPosConnection (-1); //everything set  to -1 
     // where to add this ?
     // benchpos[i]=bpc;
  }
  else {
    pmap<int,BenchPosConnection*>::iterator bpi=benchpos.begin();
    for (int lc=0;lc < i;lc++,bpi++);// should be inside the map 
    bpc= bpi->second;
  }
  return bpc;
}
