#include <signal.h>
#include "daqerrormsg.h"
/** \brief dac channel Trhx code 
     
    
     \author W. Beaumont University Antwerpen 
     \version 1.0 
     \date 2001 10 01 
    
 
*/
#include "dacchanneltrhx.h"

static TDeviceControl* fControl =0;

DacChannelTrhx::DacChannelTrhx( int TrhxBaseComPort, int channel  ) 
                             :DacChannelInterface( TrhxBaseComPort,channel)
                         
{ fInitialized=false;
  // Attach to Main control share memory
  if (fControl== 0)
    fControl =new TDeviceControl("ControlePrincipal",TShare_OPEN);

  fPid = getpid();
  fCd = 0;
  if (AttachTrhxDacChannel(getBoardId(),getChannelId() ) <0)
    {
      printf("TrhxChannel >> Cannot getTRHX  dac channel %d from Trhx %d \n",
	      getBoardId(),getChannelId());
      if (fCd!=0)
        fControl->ReleaseChannel(fCd->fPidServer,fPid,fCd->fChannelNumber);
      return;
    }
  fInitialized=true;


   }


 void  DacChannelTrhx::setOutputVoltage(unsigned short inp ) 
{ 
 (*fDac)[getChannelId()]= (unsigned char) inp;
   
}
    
	
unsigned short DacChannelTrhx::getOutputVoltage()
{   unsigned char tmp =    (*fDac)[getChannelId()];
    return (unsigned short) tmp;
}


DacChannelTrhx::~DacChannelTrhx()
{   this->release();
}

void DacChannelTrhx::release()
{
 if (fInitialized && fCd!=0)
  {   fControl->ReleaseChannel(fCd->fPidServer,fPid,fCd->fChannelNumber);
  } 
}


int DacChannelTrhx::AttachTrhxDacChannel(int serial_nr, int channelnr )
{ fCd = fControl->RequestChannel(fPid,TRHXDAC,channelnr,serial_nr);
  if (fCd <= 0) return -1;
  kill(fCd->fPidServer,SIGCONT);
   DT_DEBUG_LTC("je signal " <<fCd->fPidServer);
  DT_DEBUG_LTC("Share Memory"<<fCd->fShareName<<" size " << fCd->fShareSize);
  fMemoryClient = new TShare(fCd->fShareName,TShare_OPEN,fCd->fShareSize);
  fTrhx = (TrhxDescription*) fMemoryClient->Attach();
  fDac =  fTrhx->getDacBuffer();
  
  return 0;
}



void DacChannelTrhx::justDoIt()
{
  if (fInitialized && fTrhx!=0 && fCd!=0)
  { 
    fTrhx->requestAction(getpid());
    kill(fCd->fPidServer,SIGCONT);
  }
}
