#include "TDeviceControl.h"
#include "TShare.h"

#include "daqerrormsg.h"
#include "diochanneltrhx.h"
static TDeviceControl* fControl =0;

//#ifndef DONE_DIO_ERROR
//#define DONE_DIO_ERROR DONE_DIO 
// patch as long the server part is not tested 
//endif 


DioChannelTrhx::DioChannelTrhx(char* TDeviceControlName, long adc_ser_nr, long channel_arg, diomode mode  ) 
                               : DioChannelInterface(adc_ser_nr,channel_arg) 
{
  fInitialized=false;
  //check channel possiblities
  if (! (   ( mode == DIO_IN  &&  channel_arg < 3  )  ||
	    ( mode== DIO_OUT  &&  channel_arg >7)
        )
    )
    {  fMode=DIO_INVALID ;
      DT_ERROR("Cannot get channel "<< channel_arg <<" for " << mode );
     return;
   }
  fMode=mode;
  // Attach to Main control share memory
  if (fControl== 0)
    fControl =new TDeviceControl(TDeviceControlName,TShare_OPEN);

  fPid = getpid();
  fCd = 0;
  if (AttachDIOChannel(getBoardId(),getChannelId())<0)
    {  DT_ERROR(" Cannot get channel "<< getChannelId() <<" from DIO "<<getBoardId());
      if (fCd!=0)
        fControl->ReleaseChannel(fCd->fPidServer,fPid,fCd->fChannelNumber);
      return;
    }
  fInitialized=true;
}

DioChannelTrhx::~DioChannelTrhx()
{
  //  printf("Destructeur  init %d  desc %d \n",fInitialized, fCd);
  this->release();
}
void DioChannelTrhx::release()
{
  if (fInitialized && fCd!=0)
 {    fControl->ReleaseChannel(fCd->fPidServer,fPid,fCd->fChannelNumber);
 fInitialized= false;
 }

}

int DioChannelTrhx::AttachDIOChannel(int serial_nr, int channelnr )
{

  fCd = fControl->RequestChannel(fPid,TRHXDIO,channelnr,serial_nr);
  if (fCd <= 0)
    { DT_DEBUG_LTC("no channel "<<channelnr<<"for board "<< serial_nr);
                 return -1;
    }
  kill(fCd->fPidServer,SIGCONT);
  DT_DEBUG_LTC("je signal " <<fCd->fPidServer);
  DT_DEBUG_LTC("Share Memory"<<fCd->fShareName<<" size " << fCd->fShareSize);
  fMemoryClient = new TShare(fCd->fShareName,TShare_OPEN,fCd->fShareSize);
  fDio= (TrhxDescription*) fMemoryClient->Attach();
  
  return 0;
}

int DioChannelTrhx::getBit()
{ int result;
  lock();
  (void)  fDio-> getDigInChannel( getChannelId(),result); 
  unlock();
 
  return result;
}


int DioChannelTrhx::getBit(int& status)
{  int result;
  lock();
  status= fDio-> getDigInChannel( getChannelId(),result); 
  unlock();
 
  return result;
}

int  DioChannelTrhx::setBit(int i )
{  lock();
 fDio->setDigOutChannel( getChannelId(),i);
    unlock();
  
    return 0;
   
}

/// trhx channels don't wait , takes to long so assume will be done

int DioChannelTrhx::wait(){return 0;}



//  void DioChannelTrhx::justDoIt()
//  {
//    if (fInitialized && fTrhx!=0 && fCd!=0)
//    { 
//      fTrhx->requestAction(getpid());
//      kill(fCd->fPidServer,SIGCONT);
//    }
//  }



void    DioChannelTrhx::info(std::ostream& sout)
{ // this is not written with effeciency in mind !!!
  sout << "Dio Trhx Channel info" ;
  sout << " Channel: "<< getChannelId(); 
  sout << " value  "  << getBit();
  sout << " last status (0 = ok) " <<   fLastStatus << std::endl;


}


