#include "diolineparser.h"
#include "daqerrormsg.h"
#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "basicchparser.h"
using namespace BasicChParser;
pmap< int, CalExchange<int>* >  DioLineParser::Dioline;

int  DioLineParser::parseNode(DOM_Node &ei)
{ DOM_NamedNodeMap attributes = ei.getAttributes();
  int device=Dioline.size();// dioline has no device nr ,device is there to find the dio line back
   bool simulation=false ;
   CalExchange <int>*
     a= new  CalExchange <int>(device);
   int* activelevel= a->getCalValues();
   *activelevel=1;
   DOM_Node e = attributes.getNamedItem("name");
   if(! e.isNull() )   { sscanf(e.getNodeValue().transcode(),"%s",a->getName());  }
   e = attributes.getNamedItem("simulation");
   if(! e.isNull() )   { 
     if ('y' == (e.getNodeValue().transcode())[0]) { simulation=true ;}  
   }
   e = attributes.getNamedItem("activelevel");
   if(! e.isNull() )   { 
     // activelevel is set to 0 ?
     if( ! atoi(e.getNodeValue().transcode())) *activelevel=0;
   }
    
   DOM_Node n =ei.getFirstChild();
   while (!n.isNull())
   {
     if (strcmp(n.getNodeName().transcode(),"DioChannel")==0)
     {  AdcChannelParser(n, a);
     a->setType(  DioChannelDef::CIODIO );
     }
     if (strcmp(n.getNodeName().transcode(),"DummyChannel")==0)
     {  DummyChannelParser(n, a);
     a->setType(   DioChannelDef::DUMMY);
     }
      if (strcmp(n.getNodeName().transcode(),"SerialChannel")==0)
     {  SerialChannelParser(n, a);
        a->setType( DioChannelDef::SERIAL);
     }
      if (strcmp(n.getNodeName().transcode(),"DioAd4717")==0)
     {  I2cChannelParser(n, a);
        a->setType( DioChannelDef::AD4717DIO);
     }
      if (strcmp(n.getNodeName().transcode(),"DioPcf8574")==0)
     {  I2cChannelParser(n, a);
        a->setType( DioChannelDef::PCF8574DIO);
     }
    if(simulation || fSimulation ) 
      { a->setType( DioChannelDef::DUMMY);}
     n = n.getNextSibling();        
   }
   DT_DEBUG_LP("dioline "<< device<<" found board "<<a->getBoardNr()<<" channel "<<a->getChannelNr()<<" type "
	       << a->getType());
 Dioline[device]=a;
 return device;
}


void DioLineParser::setDummy(int deviceid){
  CalExchange<int>* CV=  getInfo(deviceid);
  if(CV)   CV->setType( DioChannelDef::DUMMY);

}


CalExchange<int>*  DioLineParser::getInfo(int device ){
  if( device== DioChannelDef::DUMMYDEVICEID) {
    // create dummy dio line 
    if( ! Dioline.getP(device)){
      CalExchange <int>*a = new  CalExchange <int>(device);
      int* activelevel= a->getCalValues();
      *activelevel=1;
      a->setType( DioChannelDef::DUMMY);
      strcpy(a->getName(),"DummyDeviceId");
      Dioline[device]=a;
    }
  }
  return Dioline.getP(device);
}
