#include "diotypewrapper.h"
#include "diochannelcio.h"
#include "diochanneldummy.h"
#include "diochanneltrhx.h"
#include "diochannelad4717.h"
#include "diochannelpcf8574.h"
//#include "ltparser.h"
#include "daqerrormsg.h"
#include "CalibrationValues.h"

#include <string.h>



//  DioChannelInterface* getDioChannel(CalExchange<int>*  c  )
//  { DioTypeWrapper diowrap(c);
//   return  diowrap.getDioChannel();

//  } 

DioTypeWrapper::DioTypeWrapper(  CalExchange<int>*  c   ) 
{ DioChannelInterface::diomode mode =DioChannelInterface::DIO_INVALID;;
  fInitialized=false;  
  fT=0;                       
  if ( c)   {	
    DT_DEBUG_LTC(c->printIdValues(std::cout));
    if( ! strcmp(  c->getChannelMode(), "input")) { mode =  DioChannelInterface::DIO_IN;}
    else { 
      if ( !strcmp(  c->getChannelMode(), "output")) {  mode =  DioChannelInterface::DIO_OUT;}
      else {
	if ( !strcmp(  c->getChannelMode(), "inout")) {  mode =  DioChannelInterface::DIO_INOUT;}
	else { mode =DioChannelInterface::DIO_INVALID;}
      }
    }
      
    fType= c->getType();
	switch ( fType )
	  { case DioChannelDef::SERIAL:
	    {  DioChannelTrhx* fTChanneld  = 
	       new DioChannelTrhx( c->getTDeviceControlName( ) ,c->getBoardNr(),
				    c->getChannelNr(),mode);
	             if ( !( fInitialized=fTChanneld->isInitialized()) ) 
		       { delete fTChanneld ;  fT=0;}
		     else { fT=fTChanneld;}
	    }
	    break; 
	    case DioChannelDef::DUMMY :
	    {  DioChannelDummy* fTChanneld  = 
	       new DioChannelDummy( c->getTDeviceControlName( ) ,c->getBoardNr(),
				    c->getChannelNr(),mode);
	             if ( !( fInitialized=fTChanneld->isInitialized()) ) 
		       { delete fTChanneld ;  fT=0;}
		     else { fT=fTChanneld;}
	    }
	    break; 
	    case DioChannelDef::AD4717DIO   : 
	    {       DioChannelAd4717* fTChannel  = 
		   new DioChannelAd4717(c->getTDeviceControlName( ) ,c->getBoardNr(),
				     c->getChannelNr(),mode );
	              if ( !( fInitialized=fTChannel->isInitialized()) ) 
			{ delete fTChannel ;  fT=0;}
		      else { fT=fTChannel;}
	    }
	    break;
	    case DioChannelDef::PCF8574DIO   : 
	    {       DioChannelPcf8574* fTChannel  = 
		   new DioChannelPcf8574(c->getTDeviceControlName( ) ,c->getBoardNr(),
				     c->getChannelNr(),mode );
	              if ( !( fInitialized=fTChannel->isInitialized()) ) 
			{ delete fTChannel ;  fT=0;}
		      else { fT=fTChannel;}
	    }
	    break;

	    case DioChannelDef::CIODIO   : 
	    {       DioChannelCio* fTChannel  = 
		   new DioChannelCio(c->getTDeviceControlName( ) ,c->getBoardNr(),
				     c->getChannelNr(),mode );
	              if ( !( fInitialized=fTChannel->isInitialized()) ) 
			{ delete fTChannel ;  fT=0;}
		      else { fT=fTChannel;}
	    }
	    break;
	    default: fT=0;
	      DT_ERROR( "diochanel type " << fType << " not supported") ;
					
	    break;
	  }  
  }
  else
    {
      DAQEXIT( "requested Dio Type "<<   c->getType()<<  " board:" <<c->getBoardNr()<<" channel"<< c->getChannelNr());
    }
  if(!fInitialized || fT==0)
    { DAQEXIT( "requested Dio Type "<<   c->getType()<<  " board:" <<c->getBoardNr()<<" channel"<< c->getChannelNr() );
    }
   
    
  }

DioTypeWrapper::~ DioTypeWrapper()
{ ;
// nothing to do deleting of the channels should be done by the channel requester

} 





