#include "humidityparser.h"

#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "basicchparser.h"

using namespace BasicChParser;
void HumidityParser::HumidityMirel1050parser(DOM_Node &ei,CalExchange<HumidityConversionDef::HumidityCalValues>*  CV)
{ HumidityConversionDef::HumidityCalValues* HCV= CV->getCalValues();
  DOM_NamedNodeMap attributes = ei.getAttributes();

  DOM_Node e = attributes.getNamedItem("gain");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->Gain);
  e = attributes.getNamedItem("calhumidity");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalHumidity);
  e = attributes.getNamedItem("caladcvalue");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalAdcValue);
  e = attributes.getNamedItem("vrefgain");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->VRefGain);
  e = attributes.getNamedItem("offset");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->Offset);
 e = attributes.getNamedItem("calvoltage");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalVoltageRef);
  
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull())
   { if (strcmp(n.getNodeName().transcode(),"AdcChannel")==0)
       {AdcChannelParser(n, CV);}
      n = n.getNextSibling();        
   }
}

void HumidityParser::HumidityTrhxparser(DOM_Node &ei,CalExchange<HumidityConversionDef::HumidityCalValues>*  CV){  
   HumidityConversionDef::HumidityCalValues* HCV= CV->getCalValues();
   HCV->Offset=0;HCV->CalVoltageRef=5;
   DOM_NamedNodeMap attributes = ei.getAttributes();
   DOM_Node e = attributes.getNamedItem("gain");
   sscanf(e.getNodeValue().transcode(),"%f",&HCV->Gain);
   e = attributes.getNamedItem("calhumidity");
   sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalHumidity);
   e = attributes.getNamedItem("caladcvalue");
   sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalAdcValue);
   e = attributes.getNamedItem("vrefgain");
   sscanf(e.getNodeValue().transcode(),"%f",&HCV->VRefGain);
 
   DOM_Node n =ei.getFirstChild();
   while (!n.isNull())
     {
       if (strcmp(n.getNodeName().transcode(),"SerialChannel")==0)
	 { SerialChannelParser(n,CV);}
       n = n.getNextSibling();    
     }
}

void HumidityParser::HumiditySpecialparser(DOM_Node &ei,CalExchange<HumidityConversionDef::HumidityCalValues>*  CV){ 
  HumidityConversionDef::HumidityCalValues* HCV= CV->getCalValues();
  HCV->Offset=0;HCV->CalVoltageRef=5;
  DOM_NamedNodeMap attributes = ei.getAttributes();
  DOM_Node e = attributes.getNamedItem("gain");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->Gain);
  e = attributes.getNamedItem("calhumidity");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalHumidity);
  e = attributes.getNamedItem("caladcvalue");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalAdcValue);
  e = attributes.getNamedItem("vrefgain");
  sscanf(e.getNodeValue().transcode(),"%f",&HCV->VRefGain);
 
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull())
    { if (strcmp(n.getNodeName().transcode(),"DimChannel")==0)
      { DummyChannelParser(n,CV);}
      n = n.getNextSibling();    
    }
}

int HumidityParser::parseNode(DOM_Node &ei)
{ DOM_NamedNodeMap attributes = ei.getAttributes();
   bool simulation=false ;
  int device=-1;
  DOM_Node e = attributes.getNamedItem("device");
  sscanf(e.getNodeValue().transcode(),"%d",&device  );
  CalExchange <HumidityConversionDef::HumidityCalValues>*
    a= new  CalExchange <HumidityConversionDef::HumidityCalValues>(device);
  e = attributes.getNamedItem("name");
  if(! e.isNull() )   { sscanf(e.getNodeValue().transcode(),"%s",a->getName());  }
  e = attributes.getNamedItem("simulation");
  if(! e.isNull() )   { if ('y' == (e.getNodeValue().transcode())[0]) { simulation=true ;}  }
 
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull())
    { if (strcmp(n.getNodeName().transcode(),"HumidityMirel1050")==0)
      {    HumidityMirel1050parser(n, a);
           a->setType( HumidityConversionDef::HUMIRELADC);
      }
     if (strcmp(n.getNodeName().transcode(),"HumidityTrhx")==0)
      {    HumidityTrhxparser(n, a);
           a->setType( HumidityConversionDef::TRHXSENS);
      }
     if (strcmp(n.getNodeName().transcode(),"HumiditySpecial")==0)
      {    HumiditySpecialparser(n, a);
           a->setType( HumidityConversionDef::HUMSPECIAL);
      }
      n = n.getNextSibling();        
    }
  if(simulation || fSimulation) {  a->setType( HumidityConversionDef::DUMMY);}
  humiditys[device] = a;
  return device;
}


void HumidityParser::setDummy(int deviceid){
  CalExchange<HumidityConversionDef::HumidityCalValues>*  CV=
    getInfo(deviceid);
  if(CV)   CV->setType( HumidityConversionDef::DUMMY);
}
pmap< int,CalExchange<HumidityConversionDef::HumidityCalValues>*>
    HumidityParser::humiditys;
