#include "powerparser.h"
#include "diolineparser.h"

#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "basicchparser.h"



pmap<int,CalExchange<PowerConversionDef::PowerCalValues>*>
 PowerParser::powers;

using namespace BasicChParser;
void PowerParser::PeltierDacParser(DOM_Node &ei, 
				 CalExchange < PowerConversionDef:: PowerCalValues>*  CV)
{  
  PowerConversionDef:: PowerCalValues* HCV= CV->getCalValues();
 DOM_NamedNodeMap attributes = ei.getAttributes();
// int attrCount = attributes.getLength();

 DOM_Node e = attributes.getNamedItem("gain");
 sscanf(e.getNodeValue().transcode(),"%f",&HCV->Gain);
 e = attributes.getNamedItem("calpower");
 sscanf(e.getNodeValue().transcode(),"%f",&HCV->CalPower);
 e = attributes.getNamedItem("caldacvalue");
 sscanf(e.getNodeValue().transcode(),"%hu",&HCV->CalDacValue);

 e = attributes.getNamedItem("maxdac");
 sscanf(e.getNodeValue().transcode(),"%hu",&HCV->MaxDac);
 e = attributes.getNamedItem("positivevalue");
 if(! e.isNull() )   // can be for normal DACPELTIER
   {HCV->PosOutput=  atoi(  e.getNodeValue().transcode());}
 e = attributes.getNamedItem("negativevalue");
 if(! e.isNull() )   
   {HCV->NegOutput=  atoi(  e.getNodeValue().transcode());}
  
 DOM_Node n =ei.getFirstChild();
 while (!n.isNull())
   {
     if (strcmp(n.getNodeName().transcode(),"DacChannel")==0)
     {  AdcChannelParser(n, CV);// for the moment there 
                //is no difference between DAC and ADC parser 
        CV->setType(PowerConversionDef::DAC);
     }
      if (strcmp(n.getNodeName().transcode(),"SerialChannel")==0)
     {  SerialChannelParser(n, CV); 
        CV->setType(PowerConversionDef::SERIAL);
     }
      if (strcmp(n.getNodeName().transcode(),"DummyChannel")==0)
     {  DummyChannelParser(n, CV); 
        CV->setType(PowerConversionDef::DUMMY);
     }
      if (strcmp(n.getNodeName().transcode(),"DioLine")==0)  
	// only allowed for PeltierDacPol 
	{ DioLineParser dl;
	 HCV->DioChannelId= dl.parseNode(n);
         CV->setType(CV->getType()+PowerConversionDef::POL);
       }
      if (strcmp(n.getNodeName().transcode(),"CommonDioLine")==0)  
	// only allowed for PeltierDacPol 
       {DioLineParser dl;
	 HCV->DioChannelId= dl.parseNode(n);
         CV->setType(CV->getType()+PowerConversionDef::POLCOM);
       }
     n = n.getNextSibling();        
   }
}

int PowerParser::CoolingPowerParser(DOM_Node &ei)
{  bool simulation=false ;
   DOM_NamedNodeMap attributes = ei.getAttributes();
   int device=-1;
   DOM_Node e = attributes.getNamedItem("device");
   sscanf(e.getNodeValue().transcode(),"%d",&device  );
   CalExchange < PowerConversionDef:: PowerCalValues>* 
     a  =   new CalExchange < PowerConversionDef:: PowerCalValues>(device);
   e = attributes.getNamedItem("name");
   if(! e.isNull() )   
     { sscanf(e.getNodeValue().transcode(),"%s",a->getName()); }
   e = attributes.getNamedItem("simulation");
   if(! e.isNull() )   
     { if ('y' == (e.getNodeValue().transcode())[0]) { simulation=true ;}  }
   
   DOM_Node n =ei.getFirstChild();
   while (!n.isNull())
     { if (strcmp(n.getNodeName().transcode(),"PeltierDac")==0)
       {  PeltierDacParser(n, a); //type is set depending on the Dac  type 
       }
       if (strcmp(n.getNodeName().transcode(),"PeltierDacPol")==0)
       {  PeltierDacParser(n, a); //type is set depending on the Dac  type    
       }  
       n = n.getNextSibling(); 
     }  
   powers[device]=a;
   if(simulation || fSimulation ) {
     setDummy(device);
   }
   return device;
}

void PowerParser::setDummy(int deviceid){
 CalExchange<PowerConversionDef::PowerCalValues>* a=
   getInfo(deviceid);
 if(a) {
   if ( a->getType() >=  PowerConversionDef::POL){  
     if ( a->getType() >=  PowerConversionDef::POLCOM){
       a->setType(PowerConversionDef::POL+PowerConversionDef::DUMMY);
     }
     else {	   
       a->setType(PowerConversionDef::POL+PowerConversionDef::DUMMY);
     }
   }
   else{ a->setType( PowerConversionDef::DUMMY);
   } 
 }
}



