#include "structconparser.h"
#include <dom/DOM_Node.hpp>
#include <dom/DOM_NamedNodeMap.hpp>
#include "daqerrormsg.h"
#include "XercesExt.hpp"
using namespace std;
using namespace XercesExt;

void StructConParser::parseNode(DOM_Node &ei){
  //DOM_NamedNodeMap a = ei.getAttributes();
  // no attributes defined on this level
  DOM_Node n =ei.getFirstChild();  
  while (!n.isNull()) { 
    if( strcmp(n.getNodeName().transcode(),"ConnectorConnections")==0){
      parseConnector(n);
    }
    n = n.getNextSibling(); 
  } 

}

void StructConParser::parseConnector(DOM_Node &ei){
  DOM_NamedNodeMap a = ei.getAttributes();
  int connr;
  if( ! getItem(connr,"connectornr",a)){
    DT_WARN("required connector nr not found");
    return;
  }
  DT_DEBUG_LP("parse connector ");
  pmap<int,StructConInfo::circuitinfo*>* con=
    fSci.fConnectors.getP(connr);
  if(! con){ con =    new  pmap<int,StructConInfo::circuitinfo*>;
	      fSci.fConnectors[connr]=con;
  }  
  DOM_Node n =ei.getFirstChild();  
  while (!n.isNull()) { 
    if( strcmp(n.getNodeName().transcode(),"CircuitConnection")==0){
      parseCircuit(n,con);
    } 
    n = n.getNextSibling(); 
  } 

}

void StructConParser::parseCircuit(DOM_Node &ei,
				     pmap<int,StructConInfo::circuitinfo*>* ci){
  DOM_NamedNodeMap a = ei.getAttributes();
  int cirnr;
  if( ! getItem(cirnr,"circuitnr",a)){ 
    DT_WARN("Required circuit nr not found");
    return;
  }
  StructConInfo::circuitinfo* cir=    (*ci).getP(cirnr);
  if(! cir){ 
    (*ci)[cirnr]= new  StructConInfo::circuitinfo;
    cir=(*ci).getP(cirnr);
  }
  getItem(cir->fFedChan,"fedchannel",a,-1);
  getItem(cir->fFedSerialNr,"fedserialnr",a,-1);
  getItem(cir->fMuxDevice,"muxdevice",a,-1);
  getItem(cir->fMuxCard,"muxcard",a,-1);
  getItem(cir->fMuxChannel,"muxchannel",a,-1);
  DT_DEBUG_LP("circuit nr "<<cirnr<<" parsed");
}


void StructConParser::clear(){
  fSci.clear();
}

StructConInfo  StructConParser::fSci;
