#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include "diochannelcio.h"
#include "ltparser.h"

LtParser* ltparser;


bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}



int   main (int argc , char** argv )
{ 
 signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler

   ltparser = new LtParser();
      char configfile[80];
      ltparser->getStandardConfigFile( configfile, "Config/lt.xml");
  if(ltparser->parseFile(configfile )) {DAQEXIT("error in lt configuration file look at error output");} 

  int chnr=0;
  if (argc < 2)
    { chnr=0;
    }
  else
    { chnr= (int) strtol(argv[1],NULL, 0);
    }
  int diosetting=2;
  if (argc ==3 )
    { diosetting =( (int) strtol( argv[2],NULL,0)) % 2 ;
     
    }
  else 
    {  printf ( "Dio  will set to %d (if 2 it is alternating) \n", diosetting );
    } 
  CalExchange<int>*  c =ltparser->getDioLineInfo(chnr);
  if(!c) {DAQEXIT("not found");}
  cout << "channel "<<c->getChannelNr()<<" mode "<<c->getChannelMode()<< endl;
  DioChannelInterface* dc = ltparser->getDioChannel (c);
  
  int status=0;
  int lc=0;int bitset;
 while(!HasToExit) 
    { if( dc->getMode() == DioChannelInterface::DIO_OUT 
         || dc->getMode() == DioChannelInterface::DIO_INOUT   )
      { if (diosetting==2 )	{ bitset= lc%2 ;	}
        else {  bitset=diosetting;}
      
        status=dc->setBit(bitset);  
	//dc->justDoIt();
	
	//  dc->wait();
	cout<<lc << " set dio"<<chnr<<" to "<<bitset<<" with status " << status<<endl;	
      }
      else 
	{ if( dc->getMode() == DioChannelInterface::DIO_IN
         || dc->getMode() == DioChannelInterface::DIO_INOUT   )
	  {cout <<lc<<" dio chnr"<<chnr<<" is "<< dc->getBit(status) ;
	   cout <<"with status "<<status << endl;
	  }
	  else
	    { cout << "invalid channel"<<endl ;}
	}
      sleep(1);lc++;
    }
   delete dc;
  
   delete ltparser;
    return 0;
  }
