#ifndef _RecAnalyzer_H_
#define _RecAnalyzer_H_


/** 
\brief 
<p>     RecAnalyzer: Analyze data stored in Record,
        check for bad objects, produce badflags
               
     \author V.Zhukov  
     \version 1.2
     \date 2003/09
 
*/

class ModuleDescriptor;
class FlagsDescriptor;
class RecModule;
class QString;

class RecAnalyzer {

private:
int nchan;
RecModule* therecmodule;


 public:
RecAnalyzer(RecModule* r);
virtual  ~RecAnalyzer();

void AnalyzePed(const QString& s,ModuleDescriptor *  d);
void AnalyzeLight(const QString& s,ModuleDescriptor *  d);
void AnalyzeCal(const QString& s, ModuleDescriptor*  d);
void AnalyzeCalProf(const QString& s,ModuleDescriptor* d);
void AnalyzeBP(const QString& s, ModuleDescriptor* d);
void AnalyzeLed(const QString& s, ModuleDescriptor* d);
void AnalyzeLat(const QString& s, ModuleDescriptor* d);
void AnalyzeFb(const QString& s, ModuleDescriptor* d);
void AnalyzeConnectivity(const QString& s, ModuleDescriptor* d);
void AnalyzeAuxChip(const QString& s, ModuleDescriptor* d);
void AnalyzeIV(const QString& s, ModuleDescriptor* d);
void Analyze(FlagsDescriptor* f);

};
#endif
