#ifndef RecHeader_h_
#define RecHeader_h_

#include <TFile.h>
#include <TDirectory.h>
#include <string>
/** \brief Record Header for the Record
           


     \author V.Zhukov,UIA   
     \version 1.2 
     \date 2003/09
 
*/


class RecHeader{

 private:
 Int_t nrun;
 Int_t nev;
 Int_t nmodules;
 Int_t apvmodeall;
 Int_t indb;  
 Int_t valrec;

 char settings[40];
 Float_t ftime;
 char ctime[40];
 char foperator[80];
 char ftestcenter[80];
 Int_t dbversion;

 public:
RecHeader();
virtual ~RecHeader();
void Reset();
void Save(TDirectory* d);
//
 void setrun(Int_t n) {nrun=n;}
 void setvalrec(Int_t n) {valrec=n;}
 void setdbversion(Int_t n) {dbversion=n;}
 void setoperator(std::string  oper) { strcpy(foperator,oper.c_str()); }
 void setcenter(std::string  center) { strcpy(ftestcenter,center.c_str()); }
 void setev(Int_t n) {nev=n;}
 void setnmod(Int_t n) {nmodules=n;}
 void settime(Float_t f) {ftime=f;}
 void setctime(const char* s) {for(int i=0;i<40;i++) {ctime[i]=*s;s++;} }
 void setsettings(const char* s) {for(int i=0;i<40;i++) {settings[i]=*s;s++;} }
 void setapvmode(Int_t m) {apvmodeall=m;}
 void setindb(Int_t  m) {indb=m;}

//
 Int_t getrun() const {return nrun;}
 Int_t getvalrec() const {return valrec;}
 Int_t getdbversion() const {return dbversion;}
 const char * getoperator() { return foperator; }
 const char * getcenter() { return ftestcenter; }
 Int_t getnev() const {return nev;}
 Int_t getnmod() const {return nmodules;}
 Int_t getapvmod()  const {return apvmodeall;}
 Int_t getindb() const {return indb;}
 const char* getctime()   { return ctime;}
 Float_t gettime() const  {return ftime;}
 const  char*  getsettings()    { return settings;}

};

#endif
