#ifndef RecModSctrl_h_
#define RecModSctrl_h_

#include <vector>

#include <TObject.h>
#include <TVector.h>
#include <TGraph.h>
#include <TProfile.h>
#include <TH1.h>
#include <TFile.h>
#include <TDirectory.h>


/** 
\brief 
<p>     RecordModuleSlowControl for the Record
        Dinamicaly store data for the tested module
        
               
     \author V.Zhukov  
     \version 1.2
     \date 2003/09
*/



class RecModSctrl {
 private:

  Float_t temphybdcu1;// internal dcu  adc
  Float_t temphybdcu2; // external ntc by dcu  adc
  Float_t temphybdcu3; // sen ntc1 by dcu adc
  Float_t tempsenntsc1; // sen ntc1 by piggy board
  Float_t tempsenntsc2; // sen ntc2 by piggy board
  Float_t hvbias;
  Float_t ileakdcu;
  Float_t ileak;

  Float_t ihyb25;    //in mA
  Float_t ihyb125;
  Float_t vhyb25;    //in V
  Float_t vhyb125;

  Float_t vhyb25dcu;  //in adc
  Float_t vhyb125dcu;  // in adc

std::vector<float>  vvtimet;
std::vector<float>  vtemphybdcu1t;
std::vector<float>  vtemphybdcu2t;
std::vector<float>  vtemphybdcu3t;
std::vector<float>  vtempsen1t;
std::vector<float>  vtempsen2t;
std::vector<float>  vihyb125t;
std::vector<float>  vihyb25t;
std::vector<float>  vvtimeit;
std::vector<float>  vhvt;
std::vector<float>  vit;
 
 public:
RecModSctrl();
virtual ~RecModSctrl();

void Save(TDirectory* dir);
bool Read(TDirectory* dir);
void Reset();
void ResetXt();

 void settemphybdcu1(Float_t f) { temphybdcu1=f;}
 void settemphybdcu2(Float_t f) { temphybdcu2=f;}
 void settemphybdcu3(Float_t f) { temphybdcu3=f;}
 void settempsenntsc1(Float_t f) {tempsenntsc1=f;}
 void settempsenntsc2(Float_t f) {tempsenntsc2=f;}
 void sethvbias(Float_t f) {hvbias=f;} 
 void setileakdcu(Float_t f) {ileakdcu=f;} 
 void setitest(Float_t f) {ileak=f;} 
 void setileak(Float_t f) {ileak=f;} 
 void setihybi25(Float_t f) {ihyb25=f;}
 void setihybi125(Float_t f) {ihyb125=f;}
 void setvhyb125(Float_t f) {vhyb125=f;}
 void setvhyb25(Float_t f) {vhyb25=f;}
 void setvhyb125dcu(Float_t f) {vhyb125dcu=f;}
 void setvhyb25dcu(Float_t f) {vhyb25dcu=f;}


std::vector<float>*  vtimet()    {return &vvtimet;}
std::vector<float>*  temphybdcu1t() {return &vtemphybdcu1t;}
std::vector<float>*  temphybdcu2t() {return &vtemphybdcu2t;}
std::vector<float>*  temphybdcu3t() {return &vtemphybdcu3t;}
std::vector<float>*  ihyb125t() {return &vihyb125t;}
std::vector<float>*  ihyb25t() {return &vihyb25t;}
std::vector<float>* tempsen1t() {return &vtempsen1t;}
std::vector<float>* tempsen2t() {return &vtempsen2t;} 
std::vector<float>* vt() {return &vhvt;}
std::vector<float>* it() {return &vit;}
std::vector<float>*  vtimeit()    {return &vvtimeit;}


TGraph* TGtemphybdcu1t();
TGraph* TGtemphybdcu2t(); 
TGraph* TGtemphybdcu3t();
TGraph* TGtempsen1t();
TGraph* TGtempsen2t();
TGraph* TGvt();
TGraph* TGit();



Int_t AddMeast(Float_t t);
bool CheckHvchanges();


// 
 Float_t gettemphybdcu1() const {return temphybdcu1;}
 Float_t gettemphybdcu2() const {return temphybdcu2;}
 Float_t gettemphybdcu3() const {return temphybdcu3;}
 Float_t gettempsenntsc1() const {return tempsenntsc1;}
 Float_t gettempsenntsc2() const {return tempsenntsc2;}
 Float_t gethvbias() const {return hvbias;}
 Float_t getileakdcu() const {return ileakdcu;}
 Float_t getitest() const {return ileak;}
  Float_t getihyb25()  const {return ihyb25;}
  Float_t getihyb125()  const {return ihyb125;}
  Float_t getvhyb25()  const {return vhyb25;}
  Float_t getvhyb125()  const {return   vhyb125;}
  Float_t getvhyb25dcu()  const {return vhyb25dcu;}
  Float_t getvhyb125dcu()  const {return   vhyb125dcu;}



};
#endif
