#ifndef RecModule_h_
#define RecModule_h_

#include <string>
#include <TDirectory.h>

/** 
\brief 
<p>     RecordModule for the Record
        Dinamicaly store data for the tested module
        
               
     \author V.Zhukov  
     \version 1.2 
     \date 2003/09
*/

class ModuleDescriptor;
class FlagsDescriptor;
class QString;
class RecModHeader;
class RecModTest;
class RecModSctrl;
class RecAnalyzer;
class ModId;



class RecModule  {
 private:
void bookhist();
RecModHeader* themodheader;
RecModTest* themodtest;
RecModSctrl* themodsctrl;
RecAnalyzer* therecanal;
std::string gfilename;


 public:
RecModule(int nbench, ModId* id, int napvs);
RecModule(int nbench, int napvs);
virtual ~RecModule();
void Reset();
void ResetXt();
void Save(TDirectory* dir);
Int_t  AddMeast(Float_t t);
RecModHeader* getmodheader() {return themodheader;}
RecModTest*   getmodtest()   {return themodtest;}
RecModSctrl*  getmodsctrl()  {return themodsctrl;}
RecAnalyzer* getrecanalyzer() {return therecanal;}
std::string getModuleFilename(){ return gfilename;}
void setModuleFilename(std::string newfilename);

};

#endif
