#ifndef RecUtil_h_
#define RecUtil_h_

#include <TH1.h>
#include <TGraph.h>
#include <TVector.h>
#include <TDirectory.h>

#include <vector>
#include <map> 

/** 
\brief 
<p>     Convertion, write and other utilities for Record classes

                        
     \author V.Zhukov
     \version 2.0 
     \date 2003/02
 
*/

namespace RecUtil {

extern TVector totv(Int_t n); 
extern TVector totv(Float_t f);
extern TVector totv(unsigned int i);
extern TVector totv(const std::vector<int>& n);
extern TVector totv(const std::vector<float>& f);
extern TVector totv(std::vector<int>* n);
extern TVector totv(std::vector<float>* f);
extern TGraph* totg(const std::vector<float>& x,const std::vector<float>& y,const char* title);
extern TGraph* totg(std::vector<float>* x,std::vector<float>* y,const char* title);
extern TNamed  totn(const char* c);
extern TNamed  totn(Int_t n);

extern TVector totv(const std::map<int, int, std::less<int> >&  n);
extern void average(TH1F* h,const std::map<int, int, std::less<int> >&  n, float& av, float& s); 
extern std::vector<float> tvtovector(const TVector* v);
extern std::map<int, int, std::less<int> >  tvtomap(const TVector* v);
extern std::vector<float> tvtovector(TDirectory* d, const char* name);
extern std::map<int, int, std::less<int> > tvtomap(TDirectory* d, const char* name); 
extern Float_t tvtofloat(const TVector* v);
extern Int_t tvtoint(const TVector* v);
extern const char*  tntochar(const TNamed* c);

extern Float_t tvtofloat(TDirectory* d, const char* name);
extern Float_t tvtoint(TDirectory* d, const char* name);

extern void maskbadmap(std::map<int, int, std::less<int> >& m,int i,int flag);
extern const char* dirname(Int_t m);
extern  TH1F* toth(std::map<int, int, std::less<int> >& m,int c1,int c2,int n);
extern int findmapch(std::map<int, int, std::less<int> >&  m,int i);
extern  float  correctileak(float t,float i);
};
#endif
