#include "RecModSctrl.h"
#include "RecUtil.h"
#include "daqerrormsg.h"

using namespace std;
using namespace RecUtil;


RecModSctrl::RecModSctrl() {
temphybdcu1=100;temphybdcu2=100;temphybdcu3=100;tempsenntsc1=100; tempsenntsc2=100;
hvbias=0;ileakdcu=0;ileak=0;ihyb25=0;ihyb125=0;vhyb25=0;vhyb125=0;
vhyb25dcu=0;vhyb125dcu=0;
}

RecModSctrl::~RecModSctrl() {
  DT_DEBUG_DB(" destruct modheader ");
Reset();

}

void RecModSctrl::Reset() {
temphybdcu1=0;temphybdcu2=0;temphybdcu3=0;tempsenntsc1=0; tempsenntsc2=0;
hvbias=0;ileakdcu=0;ileak=0;ihyb25=0;ihyb125=0;vhyb25=0;vhyb125=0;
vhyb25dcu=0;vhyb125dcu=0;
ResetXt();
}

void RecModSctrl::Save(TDirectory* dir) {
 if(dir->cd("Environment")) {

  totv(vvtimet).Write("TVtimeit");
  totv(vit).Write("TVit");
  totv(vhvt).Write("TVhvt");
  totg(vvtimeit,vhvt,"TGvt")->Write("TGvt");
  totg(vvtimeit,vit,"TGit")->Write("TGit");
  totg(vvtimet,vtempsen1t,"TGtempsen1t")->Write("TGtempsen1t");
  totg(vvtimet,vtempsen2t,"TGtempsen2t")->Write("TGtempsen2t");
  totg(vvtimet,vtemphybdcu1t,"TGtemphybdcu1t")->Write("TGtemphybdcu1t");
  totg(vvtimet,vtemphybdcu2t,"TGtemphybdcu2t")->Write("TGtemphybdcu2t");
  totg(vvtimet,vtemphybdcu3t,"TGtemphybdcu3t")->Write("TGtemphybdcu3t");
  totg(vvtimet,vihyb125t,"TGihyb125t")->Write("TGihyb125t");
  totg(vvtimet,vihyb25t,"TGihyb25t")->Write("TGihyb25t");

  totv(temphybdcu1).Write("TVtemphybdcu1");
  totv(temphybdcu2).Write("TVtemphybdcu2");
  totv(temphybdcu3).Write("TVtemphybdcu3");
  totv(tempsenntsc1).Write("TVtempsenntsc1");
  totv(tempsenntsc2).Write("TVtempsenntsc2");
  totv(ihyb25).Write("TVihyb25");
  totv(ihyb125).Write("TVihyb125");
  totv(vhyb25).Write("TVvhyb25");
  totv(vhyb125).Write("TVvhyb125");
  totv(vhyb25dcu).Write("TVvhyb25Dcu");
  totv(vhyb125dcu).Write("TVvhyb125Dcu");
  totv(hvbias).Write("TVhvbias");
  totv(ileakdcu).Write("TVileakdcu");
  totv(ileak).Write("TVileak");
// ARC compatible
  totv(temphybdcu1).Write("TempHybDCU_I");
  totv(temphybdcu2).Write("TempHybNtc_F");
  totv(tempsenntsc1).Write("TempSenNtc1_F");
  totv(tempsenntsc2).Write("TempSenNtc2_F");
  totv(ihyb25).Write("Ihyb250_F");
  totv(ihyb125).Write("Ihyb125_F");
  totv(vhyb25).Write("Vhyb250_F");
  totv(vhyb125).Write("Vhyb125_F");
  totv(vhyb25dcu).Write("Vhyb250DCU_I");
  totv(vhyb125dcu).Write("Vhyb125DCU_I");
  totv(hvbias).Write("HVbias_F");
  totv(ileak).Write("Ileak_F");

 }

}

Int_t  RecModSctrl::AddMeast(Float_t t) {
      vvtimet.push_back(t);  
    vtemphybdcu1t.push_back(temphybdcu1);
    vtemphybdcu2t.push_back(temphybdcu2); 
    vtemphybdcu3t.push_back(temphybdcu3); 
    vihyb125t.push_back(ihyb125); 
    vihyb25t.push_back(ihyb25); 
    vtempsen1t.push_back(tempsenntsc1); 
    vtempsen2t.push_back(tempsenntsc2); 
//check if there are changes in hvbias, ileak)
  if(CheckHvchanges()) {
    vvtimeit.push_back(t);  
    vhvt.push_back(hvbias);
    vit.push_back(ileak);
  }
  return vvtimet.size();
}
/**/
void RecModSctrl::ResetXt() {
      vtemphybdcu1t.clear();
       vtemphybdcu2t.clear();
       vtemphybdcu3t.clear();
       vtempsen1t.clear();
       vtempsen2t.clear();
       vihyb125t.clear();
       vihyb25t.clear(); 
       vhvt.clear();
       vit.clear();
       vvtimet.clear();
       vvtimeit.clear();
}
/**/
bool RecModSctrl::CheckHvchanges() {
 float dv=2.; //2 volts
  float di=100.; // 100 nA
  int nu=100;  // each 100 update anyway
  int n= vvtimet.size();
  if(n<10) return true;

  if(!(n%nu)) return true; 
 
  if(fabs(vhvt[n-1]-hvbias)>dv) return true;
  if(fabs(vit[n-1]-ileak)>di) return true;

  return false;
}


TGraph* RecModSctrl::TGtemphybdcu1t() {
  Int_t ns=vvtimet.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimet[i];
    y[i]=vtemphybdcu1t[i];
  }
  return new TGraph(ns,x,y);
}

TGraph* RecModSctrl::TGtemphybdcu2t() {
  Int_t ns=vvtimet.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimet[i];
    y[i]=vtemphybdcu2t[i];
  }
  return new TGraph(ns,x,y);
}
TGraph* RecModSctrl::TGtemphybdcu3t(){
  Int_t ns=vvtimet.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimet[i];
    y[i]=vtemphybdcu3t[i];
  }
  return new TGraph(ns,x,y);

}
TGraph* RecModSctrl::TGtempsen1t(){
  Int_t ns=vvtimet.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimet[i];
    y[i]=vtempsen1t[i];
  }
  return new TGraph(ns,x,y);

}
TGraph* RecModSctrl::TGtempsen2t(){
  Int_t ns=vvtimet.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimet[i];
    y[i]=vtempsen2t[i];
  }
  return new TGraph(ns,x,y);

}
TGraph* RecModSctrl::TGvt(){
  Int_t ns=vvtimeit.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimeit[i];
    y[i]=vhvt[i];
  }
  return new TGraph(ns,x,y);

}
TGraph* RecModSctrl::TGit(){
  Int_t ns=vvtimeit.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vvtimeit[i];
    y[i]=vit[i];
  }
  return new TGraph(ns,x,y);
}

bool RecModSctrl::Read(TDirectory* dir) {
  DT_DEBUG_DB(" Read ModSctrl ");
 
settemphybdcu1(tvtofloat((TVector*)dir->Get("TVtemphybdcu1")));
settemphybdcu2(tvtofloat((TVector*)dir->Get("TVtemphybdcu2")));
settemphybdcu3(tvtofloat((TVector*)dir->Get("TVtemphybdcu3")));
settempsenntsc1(tvtofloat((TVector*)dir->Get("TVtempsenntsc1")));
settempsenntsc2(tvtofloat((TVector*)dir->Get("TVtempsenntsc2")));
sethvbias(tvtofloat((TVector*)dir->Get("TVhvbias")));
setileakdcu(tvtofloat((TVector*)dir->Get("TVileakdcu")));
setileak(tvtofloat((TVector*)dir->Get("TVileak")));
setihybi25(tvtofloat((TVector*)dir->Get("TVihyb25")));
setihybi125(tvtofloat((TVector*)dir->Get("TVihyb125")));
setvhyb125(tvtofloat((TVector*)dir->Get("TVvhyb125")));
setvhyb25(tvtofloat((TVector*)dir->Get("TVvhyb25")));
setvhyb125dcu(tvtofloat((TVector*)dir->Get("TVvhyb125Dcu")));
setvhyb25dcu(tvtofloat((TVector*)dir->Get("TVvhyb25Dcu")));
// vector 
vhvt=tvtovector((TVector*)dir->Get("TVhvt"));
vit=tvtovector((TVector*)dir->Get("TVit"));
vvtimeit=tvtovector((TVector*)dir->Get("TVtimeit"));

  return true;
}
