#include "RecModTest.h"
#include "RecUtil.h"
#include "daqerrormsg.h"

#ifndef NAPVCH
#define NAPVCH  128
#endif


using namespace std;
using namespace RecUtil;

RecModTest::RecModTest(int nb,int napv ) {
 napvs=napv;
 nbench=nb;
 cstat=new Stat();
 cstat->reset();
 hcalPApeak=0;
 hcalSbackpl=0;
 hcalSled=0;
 hcalA=0;
 hcalAlight=0;
 hcalSled=0;
 hpedestal=0;
 hnoise=0;
 hrawnoise=0;
 hcalPTrise=0;
 hcalPTfall=0;
 hcalAfb=0;

 pbp=0;
 pled=0;
 h2led=0;
 bookhistped(); // always book
 Reset();

}

RecModTest::~RecModTest() {
  DT_DEBUG_DB(" destruct modheader ");
  Reset();
  if(hpedestal) delete  hpedestal; hpedestal=0;
  if(hnoise) delete  hnoise; hnoise=0;
  if(hrawnoise) delete hrawnoise;  hrawnoise=0;
  if(hcalA) delete hcalA; hcalA=0;
  if(hcalPApeak) delete hcalPApeak;  hcalPApeak=0;
 if(hcalPTrise) delete hcalPTrise;  hcalPTrise=0;
 if(hcalPTfall) delete hcalPTfall;  hcalPTfall=0;
  if(hcalSbackpl) delete  hcalSbackpl;hcalSbackpl=0;
  if(hcalSled) delete  hcalSled; hcalSled=0;
  if(hcalAlight) delete  hcalAlight; hcalAlight=0;
   if(h2led) delete   h2led;  h2led=0;
 if(pbp) delete  pbp; pbp=0;
 if(pled) delete  pled; pled=0;
 for(int i=0;i<vCmn.size();i++) delete vCmn[i]; 
 vCmn.clear();
 for(int i=0;i<vPipe.size();i++) delete vPipe[i]; 
 vPipe.clear();
  for(int i=0;i<vCalProf.size();i++) delete vCalProf[i]; 
  vCalProf.clear();
 for(int i=0;i<vLat.size();i++) delete vLat[i]; 
  vLat.clear();

}
//
void RecModTest::bookhistped() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
 const float bs =0.1; // binshift 
sprintf(name,"pedestal_%.1d",nbench);
  hpedestal = new TH1F(name,"pedestal",ib,bs,max+bs); 
sprintf(name,"noise_%.1d",nbench);
  hnoise = new TH1F(name,"noise",ib,bs,max+bs);
sprintf(name,"rawnoise_%.1d",nbench);
  hrawnoise = new TH1F(name,"rawnoise",ib, bs,max+bs);
for (int i=0;i<napvs;i++) {  
      sprintf(name,"bench%.1dApvCmn_%.1d",nbench,i);
      sprintf(title,"Ch_%.1d_CMN",i);
      vCmn.push_back( new TH1F(name,title,100,-20.,20.));
    }
cstat->bped=true;
}
//
void RecModTest::bookhistcal() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
 const float bs =0.1; // binshift 
sprintf(name,"calA_%.1d",nbench);
hcalA = new TH1F(name,"calA",ib, bs,max+bs);
cstat->bcal=true;
}
//
void RecModTest::bookhistlight() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
 const float bs =0.1; // binshift 
sprintf(name,"calAlight_%.1d",nbench);
hcalAlight = new TH1F(name,"calAlight",ib, bs,max+bs);
cstat->blight=true;
}
//
void RecModTest::bookhistfb() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
 const float bs =0.1; // binshift 
sprintf(name,"calAfb_%.1d",nbench);
hcalAfb = new TH1F(name,"calAfb",ib, bs,max+bs);
cstat->bfb=true;
}


//
void RecModTest::bookhistcalprof() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
const float bs =0.1; // binshift 
sprintf(name,"calPApeak_%.1d",nbench);
  hcalPApeak = new TH1F(name,"calPApeak",ib, bs,max+bs);
 hcalPTrise = new TH1F(name,"calPTrise",ib, bs,max+bs);
 hcalPTfall = new TH1F(name,"calPTfall",ib, bs,max+bs);
for (int i=0;i<napvs;i++) {
      for (int j=0;j<NAPVCH;j++) {	
          sprintf(name,"bench%.1dApv%.1dChCal%.3d",nbench,i,j);
          sprintf(title,"Ch_%.1d_Strip_%.3dCalProf",i,j);
          vCalProf.push_back( new TH1F(name,title,104, bs,325.+bs));
        }	
    }
cstat->bcalprof=true;
}
//
void RecModTest::bookhistlat() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
const float bs =0.1; // binshift 
for (int i=0;i<napvs;i++) {

      sprintf(name,"bench%.1dpipe%.3d",nbench,i);
      sprintf(title,"Ch_%.3d_PipeAddr",i);
      vPipe.push_back(new TH1F(name,title,510, bs,510.+bs));

      for (int j=0;j<NAPVCH;j++) {	
         sprintf(name,"bench%.1dApv%.1dChLat%.3d",nbench,i,j);
          sprintf(title,"Ch_%.1d_Strip_%.3d_Lat",i,j);
          vLat.push_back( new TProfile(name,title,190,0.,190.,-20.,20.));
        }	
    }
cstat->blat=true;
cstat->bpipe=true;
}
//
void RecModTest::bookhistled() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
const float bs =0.1; // binshift 
sprintf(name,"led2D%.1d",nbench);
h2led  = new TH2F(name,"Led2D",ib,bs,max+bs ,100,-200,200);
sprintf(name,"hpledrun_%.1d",nbench);
pled = new TProfile(name,"called",ib,0.,max,-500.,500.);
sprintf(name,"calSled_%.1d",nbench);
hcalSled = new TH1F(name,"calSled",ib, bs,max+bs);
cstat->bled=true;
}
//
void RecModTest::bookhistbp() {
char name[80],title[80];
int  ib=napvs*NAPVCH;
float max=float(ib);
const float bs =0.1; // binshift 
sprintf(name,"hpbprun_%.1d",nbench);
pbp = new TProfile(name,"calbp",ib,0.,max,-500.,500.);
sprintf(name,"calSbackp_%.1d",nbench);
hcalSbackpl = new TH1F(name,"calSbackp",ib, bs,max+bs);
cstat->bbp=true;
}
//
void RecModTest::Reset() {
ResetPed();
ResetCalProf();
ResetLat();
ResetLed();
ResetCal();
ResetBp();
ResetIV();
ResetXt();
ResetLight();
ResetFb();
}

/**/
void RecModTest::ResetPed() {
 hpedestal->Reset();
  hnoise->Reset();
  hrawnoise->Reset();
  avgpedestal=0.;avgnoise=0.; avgrawnoise=0.;
  sgpedestal=0.; sgnoise=0.;sgrawnoise=0.; 
  mbadchped.clear();
 for(int i=0;i<vCmn.size();i++) vCmn[i]->Reset(); 


}
/**/
void RecModTest::ResetCalProf() {
  if(cstat->bcalprof) {
  if(hcalPApeak)  hcalPApeak->Reset();
  avgcalPApeak=0;sgcalPApeak=0;
  mbadchcalprof.clear();
  for(int i=0;i<vCalProf.size();i++) vCalProf[i]->Reset(); }  
}
/**/
void RecModTest::ResetLat() {
   mbadchlat.clear();
  if(cstat->blat) {
for(int i=0;i<vLat.size();i++) vLat[i]->Reset(); 
for(int i=0;i<vPipe.size();i++) vPipe[i]->Reset(); 

}
}
/**/
void RecModTest::ResetCal() {
  mbadchcal.clear();
  if(cstat->bcal) {
  if(hcalA) hcalA->Reset();
  avgcalA=0.;sgcalA=0.;
  }
}
/**/
void RecModTest::ResetLight() {
  mbadchlight.clear();
  if(cstat->blight) {
  if(hcalAlight) hcalAlight->Reset();
  avgcalAlight=0.;sgcalAlight=0.;
  }
}
/**/
void RecModTest::ResetFb() {
  mbadchfb.clear();
  if(cstat->bfb) {
  if(hcalAfb) hcalAfb->Reset();
  avgcalAfb=0.;sgcalAfb=0.;
  }
}

/**/
void RecModTest::ResetBp() {
  mbadchbp.clear();
  if(cstat->bbp) { 
    if(hcalSbackpl) hcalSbackpl->Reset();
    if(pbp) pbp->Reset();
  }
  avgcalBP=0.;sgcalBP=0.;
}
/**/
void RecModTest::ResetLed() {
  if(cstat->bled) {
  if(hcalSled) hcalSled->Reset();
  if(h2led) h2led->Reset(); }
  sgcalAled=0.; avgcalAled=0.;
}
/**/
void RecModTest::ResetIV() {
vivv.clear(); vivi.clear();
}
/**/
void RecModTest::ResetXt() {
      vavrmst.clear();
       vavcalat.clear();
       vvtimet.clear();
       vivv.clear();
       vivi.clear();
}
//
void RecModTest::Save(TDirectory* dir) {

char nam[32];
 if(cstat->bped) {
  const char* wd=dirname(apvmped); // select apvmode folder
  TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
  dm->cd();
 TDirectory* dped=dm->mkdir("Pedestal");
 TDirectory* dnoise=dm->mkdir("Noise");
 TDirectory* dcmn=dm->mkdir("CommonMode");
 DT_DEBUG_DB("  RecModTest: done create folders ");
// pedestal
 {
dped->cd();
 hpedestal->Write("Pedestal");
 totv(avgpedestal).Write("tMean_Pedestal_F");
 totv(sgpedestal).Write("tRMS_Pedestal_F");
 totv(vcons).Write("TVconnectivity");
TH1F* hbad=toth(mbadchped,32,64,NAPVCH);
 hbad->Write("Bad_Pedestal");
 DT_DEBUG_DB("  RecModTest: write ped ");
 }
//Noise
 {
dnoise->cd();
 hnoise->Write("CMSubtractedNoise");
 hrawnoise->Write("RawNoise");
 totv(avgnoise).Write("tMean_Noise_F");
 totv(avgrawnoise).Write("tMean_RawNoise_F");
 totv(sgnoise).Write("tRMS_Noise_F");
 totv(sgrawnoise).Write("tRMS_RawNoise_F");
 totv(mbadchped).Write("TIbadchped");
 TH1F* hbad=toth(mbadchped,2,16,NAPVCH);
 hbad->Write("Bad_CMSubtractedNoise");
 totg(vvtimet,vavrmst,"TGavrmst")->Write("TGavrmst");
 }
// cmn
dcmn->cd();
 for (int k=0;k<napvs;k++) {
        sprintf(nam,"THcmn_%d",k);
        hcmn(k)->Write(nam);   
    }
 DT_DEBUG_DB("  RecModTest: write cmn ");
 }
//calprof

  if(cstat->bcalprof) {
 const char* wd=dirname(apvmcalprof); // select apvmode folder
  TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
  TDirectory* dcalprof=dm->mkdir("PulseShape");
  dcalprof->cd();
   hcalPApeak->Write("PulseHeight");
   hcalPTrise->Write("RiseTime");
   totv(avgcalPApeak).Write("tMean_Height_F");
   totv(sgcalPApeak).Write("tRMS_Height_F");
   totv(avgcalPTrise).Write("tMean_RiseTime_F");
   totv(sgcalPTrise).Write("tRMS_RiseTime_F");
   totv(mbadchcalprof).Write("TIbadchcalprof");
   TH1F* hbad=toth(mbadchcalprof,2,4,NAPVCH);
   hbad->Write("Bad_PulseHeight");
   hbad=toth(mbadchcalprof,8,64,NAPVCH);
   hbad->Write("Bad_RiseTime");
  TDirectory* dprof=dcalprof->mkdir("Profiles");
  dprof->cd();
  for (int k=0;k<napvs;k++)
    {
      for (int j=0;j<NAPVCH;j++) {
      int l=k*NAPVCH+j;
     sprintf(nam,"TPcalprof_%.3d",l);
     hcalprof(l)->Write(nam);
      }
    }

  }

//pipeline
 if(cstat->blat) {
 const char* wd=dirname(apvmlat);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
  TDirectory* dpipe=dm->mkdir("Pipeline");
 dpipe->cd();
 for (int k=0;k<napvs;k++)
    {
       sprintf(nam,"THpipe_%.3d",k);
       hpipe(k)->Write(nam);
  for (int j=0;j<NAPVCH;j++) {
             int l=k*NAPVCH+j;
            sprintf(nam,"THlatency_%.3d",l);
	   hplatency(l)->Write(nam);
        }     
    }

  TH1F* hbad=toth(mbadchlat,2,4,NAPVCH);
   hbad->Write("Bad_Lat");
 }
//cal
 if(cstat->bcal) {
 const char* wd=dirname(apvmcal);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
TDirectory* dcal=dm->mkdir("Calibration");
 dcal->cd();
 hcalA->Write("CalAmp");
 totv(avgcalA).Write("tMean_CalAmp_F");
 totv(sgcalA).Write("tRMS_CalAmp_F");
 TH1F* hbad=toth(mbadchcal,2,4,NAPVCH);
   hbad->Write("Bad_CalAmp");
 totg(vvtimet,vavcalat,"TGavcalat")->Write("TGavcalat");
 }

//backplane
 if(cstat->bbp) {
 const char* wd=dirname(apvmbp);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
TDirectory* dbp=dm->mkdir("BackPlane");
 dbp->cd();
 hcalSbackpl->Write("BPlaneAmp");
 pbp->Write("TPbp");
 totv(avgcalBP).Write("tMean_BPlaneAmp_F");
 totv(sgcalBP).Write("tRMS_BPlaneAmp_F");
 TH1F* hbad=toth(mbadchbp,2,4,NAPVCH);
   hbad->Write("Bad_BPlaneAmp");
 }

//fb
 if(cstat->bfb) {
 const char* wd=dirname(apvmfb);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
TDirectory* dfb=dm->mkdir("ForwardBias");
 dfb->cd();
 hcalAfb->Write("FBiasAmp");
 totv(avgcalAfb).Write("tMean_FBiasAmp_F");
 totv(sgcalAfb).Write("tRMS_FBiasAmp_F");

TH1F* hbad=toth(mbadchfb,2,4,NAPVCH);
   hbad->Write("Bad_FBiasAmp");
 }
// light
 if(cstat->blight) {
 const char* wd=dirname(apvmlight);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
TDirectory* dlight=dm->mkdir("LightTest");
 dlight->cd();
 hcalAlight->Write("LightAmp");
 totv(avgcalAlight).Write("tMean_LightAmp_F");
 totv(sgcalAlight).Write("tRMS_LightAmp_F");
TH1F* hbad=toth(mbadchlight,2,4,NAPVCH);
   hbad->Write("Bad_LightAmp");
 }
//led
 if(cstat->bled) {
 const char* wd=dirname(apvmcal);
 TDirectory* dm;
  dm=(TDirectory*)dir->Get(wd);
TDirectory* dled=dm->mkdir("LedTest");
 dled->cd();
pled->Write("TPled");
h2led->Write("TH2led");
 hcalSled->Write("LedA");
 totv(avgcalAled).Write("tMean_Led_F");
 totv(sgcalAled).Write("tRMS_Led_F");

 }

//iv
 if(cstat->biv) {
  dir->cd("Summary");
 totv(vivv).Write("TVivv");
 totv(vivi).Write("TVivi");
 totg(vivv,vivi,"TGiv")->Write("TGiv");
  totv(itest1).Write("TVitest1");
  totv(itest2).Write("TVitest2");
  totv(itest2).Write("TVitest3");
  totv(vtest1).Write("TVvtest1");
  totv(vtest2).Write("TVvtest2");
  totv(vtest2).Write("TVvtest3");
}



}
/////////////
TH1F* RecModTest:: hcmn(int i) {
  if (i>vCmn.size()-1) {DT_WARN( "vCmn out of range  range");return 0;}
  else return vCmn[i];

}

TH1F*  RecModTest:: hcalprof(int i) { 
if(!cstat->bcalprof) bookhistcalprof();
 if (i>vCalProf.size()-1) {DT_WARN("vCalprof out of range");return 0;}
 else return  vCalProf[i];
}

TH1F* RecModTest:: hpipe(int i) {
if(!cstat->bpipe) bookhistlat();
 if (i>vPipe.size()-1) {DT_WARN( "vPipe out of range");return 0;} 
  else return vPipe[i];
}

TProfile*  RecModTest::hplatency(int i) { 
if(!cstat->blat) bookhistlat();
 if (i>vLat.size()-1) {DT_WARN("vLat out of range" );return 0;}
  else return vLat[i];
}

Int_t  RecModTest::AddMeast(Float_t t) {
  vvtimet.push_back(t); 
  vavrmst.push_back(avgnoise);
  vavcalat.push_back(avgcalA);
  return vvtimet.size();
}
/**/
Int_t  RecModTest::AddMeasIV(Float_t v, Float_t i) {
//  if(v==0) { vivv.clear(); vivi.clear(); } there is nog uarantee that v =0 (rest voltage of the device)
  vivv.push_back(v);
  vivi.push_back(i);
  return vivi.size();
}

/**/
TH2F* RecModTest::TH2calSled() {
if(!cstat->bled) bookhistled();
 return h2led;
}
TH1F*  RecModTest::THcalSled() {
if(!cstat->bled) bookhistled();
 return  hcalSled;
}
/**/
TProfile* RecModTest::TPled() {
if(!cstat->bled) bookhistled();
 return pled ;
}
//
TH1F* RecModTest::THcalPApeak() {
if(!cstat->bcalprof) bookhistcalprof();
 return hcalPApeak;
}
//
TH1F* RecModTest::THcalPTrise() {
if(!cstat->bcalprof) bookhistcalprof();
 return hcalPTrise;
}
//
TH1F* RecModTest::THcalPTfall() {
if(!cstat->bcalprof) bookhistcalprof();
 return hcalPTfall;
}

TH1F* RecModTest::THcalSbackpl() {
  if(!cstat->bbp) bookhistbp();
 return  hcalSbackpl;
}
/**/
TProfile* RecModTest::TPbp() {
  if(!cstat->bbp)  bookhistbp();
 return  pbp;
}
/**/
TH1F* RecModTest::THcalA() {
  if(!cstat->bcal) bookhistcal();
return hcalA;
} 
/**/
TH1F* RecModTest::THcalAlight() {
 if(!cstat->blight) bookhistlight();
return hcalAlight;
}
/**/
TH1F* RecModTest::THcalAfb() {
 if(!cstat->bfb) bookhistfb();
return hcalAfb;
}
/**/
TGraph* RecModTest::TGiv() {
  Int_t ns=vivv.size();
  Double_t  x[ns], y[ns];
  for(Int_t i=0; i<ns;i++) {
    x[i]=vivv[i];
    y[i]=vivi[i];
  }
  return new TGraph(ns,x,y);
}




/**/
void Stat::reset() {
bcalprof=false;
blat=false;
bpipe=false;
bled=false;
bbp=false;
bfb=false;
blight=false;
bcal=false;
bped=false;
biv=false;
}


