#include "RecModule.h"
#include "RecUtil.h"
#include "ModId.h"
#include "RecModHeader.h"
#include "RecModTest.h"
#include "RecModSctrl.h"
#include "RecAnalyzer.h"
#include  "ModuleDescriptor.h"
#include  "FlagsDescriptor.h"
#include <vector>
#include <map>
#include <TVector.h>
#include <TGraph.h>
#include <TProfile.h>
#include <TH1.h>
#include <TFile.h>
#include <qstring.h>
#include "daqerrormsg.h" 
#ifndef NAPVCH
#define NAPVCH  128
#endif

#ifndef NAPV
#define NAPV  6
#endif


using namespace RecUtil;
using namespace std;
RecModule::RecModule(int bench, ModId* id, int napv) {
  themodheader=new RecModHeader(bench, id, napv);
  themodtest=new RecModTest(bench, napv);
  themodsctrl=new RecModSctrl();
  therecanal=new RecAnalyzer(this);
}

RecModule::RecModule(int bench,  int napv) {
  themodheader=new RecModHeader(bench, napv);
  themodtest=new RecModTest(bench, napv);
  themodsctrl=new RecModSctrl();
  therecanal=new RecAnalyzer(this);
}


void RecModule::setModuleFilename(string gfile){
  gfilename=gfile;
}

/**/
RecModule::~RecModule() {
  DT_DEBUG_DB(" destruct mod ");
  delete themodheader;
  delete themodtest;
  delete themodsctrl;
  delete therecanal;
}
/**/
void RecModule::Reset() {
  themodheader->Reset();
  themodtest->Reset();
  themodsctrl->Reset();  
}
/**/
void RecModule::ResetXt() { 
  themodheader->ResetXt();
  themodtest->ResetXt();
  themodsctrl->ResetXt(); 
}
/**/
Int_t  RecModule::AddMeast(Float_t t) {

Int_t n= themodheader->AddMeast(t);
  themodtest->AddMeast(t);
  themodsctrl->AddMeast(t);
  return n;
}
//
void RecModule::Save(TDirectory* dir)
{
  TDirectory* dmod1=dir->mkdir("PeakInvOn");
  TDirectory* dmod2=dir->mkdir("PeakInvOff");
  TDirectory* dmod3=dir->mkdir("DecInvOn");
  TDirectory* dmod4=dir->mkdir("DecInvOff");
  TDirectory* dmod5=dir->mkdir("Summary");

  themodheader->Save(dir);
  themodsctrl->Save(dir);
  themodtest->Save(dir);
 }
