#ifndef _DbParser_h_
#define _DbParser_h_

#include <vector>
#include "DbActionDescriptor.h"
#include "RecordReader.h"
#include <qdom.h>
#include <qfile.h>
#include <qstring.h>


/** \brief Database Parser
           reads template Db file and populate it
           with data from root file
           The correspondance is defined by lookup map 

              
     \author V.Zhukov,UIA   
     \version 2.0 
     \date 2002 06/2002
 
*/

class DbParser {

public:

DbParser(const char*  filename);
~DbParser();

void populate(RecordReader* r);

DbActionDescriptor* getCompositeActionDescriptor() {return  compositeactiondescriptor;}
std::vector<DbActionDescriptor*> getBasicActionDescriptors() {return basicactiondescriptor;} 
bool getTree(const QString filename);
void getBasicAction(const QDomElement &a);
void getCompositAction( const QDomElement &a);
void setAttribute(QDomElement &a);
void write(const QString filename);
void write();

private:

void fillresults(); 

QString templatename;

QDomDocument domTree;
std::vector<DbActionDescriptor*> basicactiondescriptor;
DbActionDescriptor* compositeactiondescriptor;

RecordReader*  therecreader;
int ncomp;
};
#endif
