#ifndef _RecordReader_h_
#define _RecordReader_h_

#include <TFile.h> 
#include <qstring.h>
#include "daqerrormsg.h"

/** \brief Reads localDb for the central Db XML files.

    RecordReader reads LocalDb root file
    provided by Record and extract information
    needed for the central DB 
              
     \author V.Zhukov,UIA   
     \version 2.1 
     \date  02/2003
 
*/

class DbLUT;
class DbForm;

class RecordReader {

  public:

RecordReader();
~RecordReader();

bool     Read(const  char* file, std::vector<int> s);
QString  Find(const QString& attr);
bool     setRecord(int i);
QString  modId() {return themodid;}

 private: 
QString find( DbForm& s);
QString findfolder(const char* c, DbForm& s);
TFile* rootfile; 
DbLUT* thedblut;

std::vector<int> theselrec;
 int theRec;
 QString  themodid;
};
#endif
