#include "DbLUT.h"
#include "daqerrormsg.h"

using namespace std;

DbLUT::DbLUT() {
  initmap(); 
  DT_DEBUG_LTAPPL("init DbLut");
}
/**/
DbLUT::~DbLUT() {
  thelut.clear();
}
/**/
/* the format parameter of the DbForm makes only sense for the 
   historgram type the others are not (yet) implemented
*/
void DbLUT::initmap()
{

  thelut["tool_id"]=DbForm("0");  // can be activated
  thelut["status"]=DbForm("0");
  thelut["MODULBASIC_val"]=DbForm("TLval");
  thelut["HYBRIDBASIC_val"]=DbForm("0");
  thelut["id"]=DbForm("TImodid");
  thelut["TComment"]=DbForm("0");
  thelut["StatusApv"]=DbForm("TIstatApv");
  thelut["StatusPLL"]=DbForm("TIstatPll");
  thelut["StatusMUX"]=DbForm("TIstatMux");
  thelut["StatusDCU"]=DbForm("TIstatDcu");
  thelut["StatusSensors"]=DbForm("TIstatSensor");
  thelut["StatusHybrid"]=DbForm("TIstatHybrid");

    thelut["Settings"]=DbForm("TNsettings");
    thelut["apvMode"]=DbForm("TIapvmode");

    thelut["ModuleType"]=DbForm("TNmodtype");
    thelut["operator"]=DbForm("TNoperator");

    thelut["Tdate"]=DbForm("TNstime");
    thelut["TempSetup"]=DbForm("TVtempbox");
    thelut["HumSetup"]=DbForm("TVhumbox");
    thelut["TempExt"]=DbForm("TVtempext");
    thelut["HumExt"]=DbForm("TVhumext");
  
    thelut["TempHybDcu"]=DbForm("TVtemphybdcu1");
    thelut["TempHybNtsc"]=DbForm("TVtemphybdcu2");
    thelut["TempSenNtsc1"]=DbForm("TVtempsenntsc1");
    thelut["TempSenNtsc2"]=DbForm("TVtempsenntsc2");
    thelut["TempSenNtsc1Dcu"]=DbForm("TVtemphybdcu3");

    thelut["IleakDcu"]=DbForm("TVileakdcu");
    thelut["Ihyb25"]=DbForm("TVihyb25");
    thelut["Ihyb125"]=DbForm("TVihyb125");
    thelut["Vhyb25"]=DbForm("TVvhyb25");
    thelut["Vhyb125"]=DbForm("TVvhyb125");
    thelut["Vhyb25Dcu"]=DbForm("TVvhyb25Dcu");
    thelut["Vhyb125Dcu"]=DbForm("TVvhyb125Dcu");  
    thelut["HVbias"]=DbForm("TVhvbias");
    thelut["Ileak"]=DbForm("TVileak");
    thelut["Itest1"]=DbForm("TVitest1");
    thelut["Itest2"]=DbForm("TVitest2");

    thelut["NBadChan"]=DbForm("TInbadch");
    thelut["BadChanList"]=DbForm("TIbadchlist");

    thelut["apvModePed"]=DbForm("TIapvmped");
    thelut["apvModeCal"]=DbForm("TIapvmcal");
    thelut["apvModeCalP"]=DbForm("TIapvmcalprof");
    thelut["apvModeBP"]=DbForm("TIapvmbp");
    thelut["apvModeLight"]=DbForm("TIapvmlight");

    thelut["pedestal"]=DbForm("Pedestal",10);
    thelut["noise"]=DbForm("CMSubtractedNoise",100);
    thelut["rawnoise"]=DbForm("RawNoise",100);
    thelut["calA"]=DbForm("CalAmp",10);
    thelut["calApeak"]=DbForm("PulseHeight",10);
    thelut["calAlight"]=DbForm("LightAmp",10);
    thelut["calBP"]=DbForm("BPlaneAmp",10);
    thelut["calFB"]=DbForm("FBiasAmp",10);

 
    thelut["avgpedestal"]=DbForm("tMean_Pedestal_F");
    thelut["avgnoise"]=DbForm("tMean_Noise_F",1," %5.3f");
    thelut["avgrawnoise"]=DbForm("tMean_RawNoise_F",1," %5.3f");
    thelut["sgpedestal"]=DbForm("tRMS_Pedestal_F",1," %5.3f"); 
    thelut["sgnoise"]=DbForm("tRMS_Noise_F",1," %5.3f"); 
    thelut["sgrawnoise"]=DbForm("tRMS_RawNoise_F",1," %5.3f");
  
    thelut["avgcalA"]=DbForm("tMean_CalAMp_F");
    thelut["avgcalAlight"]=DbForm("tMean_LightAmp_F");
    thelut["avgcalApeak"]=DbForm("tMean_Height_F");
    thelut["avgcalBP"]=DbForm("tMean_BPlaneAmp_F");
    thelut["avgcalAled"]=DbForm("TVavgcalAled");
    thelut["avgcalFB"]=DbForm("tMean_FBiasAmp_F");

    thelut["sgcalA"]=DbForm("tRMS_CalAmp_F");
    thelut["sgcalAlight"]=DbForm("tRMS_LightAmp_F");
    thelut["sgcalpApeak"]=DbForm("tRMS_Height_F");
    thelut["sgcalBP"]=DbForm("tRMS_BPlaneAmp_F");
    thelut["sgcalAled"]=DbForm("TVsgcalAled");
    thelut["sgcalFB"]=DbForm("tRMS_FBiasAmp_F");  

    thelut["chflagpeakinvon"]=DbForm("TIbadchpinvon");
    thelut["chflagpeakinvoff"]=DbForm("TIbadchpinvoff");
    thelut["chflagdecinvon"]=DbForm("TIbadchdinvon");
    thelut["chflagdecinvoff"]=DbForm("TIbadchdinvoff");
    thelut["chflag"]=DbForm("TIbadch");

    thelut["voltageIV"]=DbForm("TVivv");
    thelut["currentIV"]=DbForm("TVivi");
    thelut["timeIt"]=DbForm("TVtimeit");
    thelut["currentIt"]=DbForm("TVit");   
}
/**/
DbForm DbLUT::find(const QString& s) {
  if(thelut.find(s)!=thelut.end()) { 
    DT_DEBUG_LTAPPL(" found "<<s<<" return "<<thelut[s].getName()); 
    return thelut[s];
  }
  else {
    DT_DEBUG_LTAPPL(" not found "<<s);  return DbForm("0");
  }
}
