#include "ReadUtil.h"
#include <cstring>
/**/

int  ReadUtil::to_int(float f){
  if( f >0) return (int) (f +.5);
  else return (int) (f-.5);
}


QString ReadUtil::Root2Str(TH1F* h,DbForm dbl) { 
  if(!h) return "0";
  float m=dbl.getM();
  QString out;
   QString s;
   char f[10]=" %4d";
  
   if(! dbl.getForm().isEmpty()) {
     strncpy(f,dbl.getForm().latin1(),10);     
   }
   if( f[-1+strlen(f)] == 'd'){
     for(int i=1;i<=h->GetNbinsX();i++) {
       s.sprintf(f, to_int(m*h->GetBinContent(i)));
       out=out.append(s); 
     }
   }
   else{
     // assume float 
     for(int i=1;i<=h->GetNbinsX();i++) {
       s.sprintf(f, m*h->GetBinContent(i));
       out=out.append(s); 
     }
   }
   return out;
}
//
QString ReadUtil::Root2Str(TProfile* pl,DbForm dbl) {
  if(!pl) return 0;
  float m=dbl.getM();
    QString out;
    QString s;
  for(int i=0;i<pl->GetNbinsX();i++) {
    s.sprintf(" %5.1f %5.1f",pl->GetBinCenter(i),m*pl->GetBinContent(i)); 
    out=out.append(s); 
  }
  return out;
   }
//
QString ReadUtil::Root2Str(TGraph* g,DbForm dbl) { 
    if(!g) return "0"; 
    float m=dbl.getM();
    QString out;
    QString s;
    double* x;
    double* y;
    int n=g->GetN();
    int is=0;
    if(n>4000) is=n-4000;
     x=g->GetX();y=g->GetY();
    for(int i=is;i<n;i++) {
      s.sprintf(" %5.1f %5.1f",x[i],m*y[i]);
      out=out.append(s);
    }
    return out;
  }
//
QString ReadUtil::Root2Str(TVector* v,DbForm dbl) {
  QString out;
  QString s;
  int n=v->GetNoElements();
  if(n>=1) {
    float m=dbl.getM();
    char f[10]=" %5.1f";
    if(! dbl.getForm().isEmpty()) {
      strncpy(f,dbl.getForm().latin1(),10);     
    }
    int is=0;
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      float x=(*v)(i);
      // CHECK has this to be multiplied ?
      s.sprintf(f,m*x);
      out=out.append(s);
    }
  }
  return out;
}
//
QString ReadUtil::Root2Str(TNamed* n,DbForm dbl) {
     return n->GetName();
}
//
QString ReadUtil::Root2Str(TVectorD* v,DbForm dbl) {
  QString out;
  QString s;
  int n=v->GetNoElements();
  if(n>=1) {
    float m=dbl.getM();
    int is=0;
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      float x=(*v)(i);
      // CHECK has this to be multiplied ?
      s.sprintf(" %5.1f",m*x);
      out=out.append(s);
    }
  }
  return out;
}
//
QString ReadUtil::Root2StrI(TVector* v,DbForm dbl) {
     QString out;
     QString s;
     int n=v->GetNoElements();
     if(n>=1) {
    int is=0;
     float m=dbl.getM();
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      int x=int((*v)(i));
        // CHECK has this to be multiplied ?
      s.sprintf(" %4d",m*x);
      out=out.append(s);
       }
     }
    return out;
   }
//
QString ReadUtil::Root2StrL(TVector* v,DbForm dbl) {
     QString out;
     QString s;
     int n=v->GetNoElements();
     if(n>=1) {
    int is=0;
    float m=dbl.getM();
    if(n>4000) is=n-4000;
    for(int i=is;i<n;i++) {
      int x=int((*v)(i));
      // CHECK has this to be multiplied ?
      s.sprintf(":%4d:",m*x);
      out=out.append(s);
       }
     }
    return out;
   }
