#include "DbParser.h"
#include "DbLUT.h"
#include "ReadUtil.h"
#include "daqerrormsg.h"
#include "DbForm.h"

//#include <qfile.h>
#include <vector>


using namespace std;
using namespace ReadUtil;

RecordReader::RecordReader()
{
 themodid="0";
 thedblut=new DbLUT();
 theRec=0;
 DT_DEBUG_LTAPPL(" created recordreader ");
 cout<<"created recordreader "<<endl;
}
/**/
RecordReader::~RecordReader() {
  delete thedblut;
}
/**/
bool RecordReader::Read(const char* f, vector<int> s) {
 DT_DEBUG_LTAPPL(" read "<<f);
 cout<<" read "<<f<<endl;
   theselrec=s;
   DT_DEBUG_LTAPPL(" size "<<s.size());
   if(s.size()==0) { DT_WARN(" no record selected "); return false;} 
   DT_DEBUG_LTAPPL(" select "<<s[0]);
   DT_DEBUG_LTAPPL(" try to open "<<f);
    rootfile=new TFile(f,"READ");
    if(rootfile->IsOpen()) { DT_DEBUG_LTAPPL(" opened "<<f); }
   DT_DEBUG_LTAPPL(" open file  "<<f);
   cout<<" open file  "<<f<<endl;
   QString fs=f;
   QString ffs=fs.section('_',-1);
   themodid=ffs.section('.',0,0);
   DT_DEBUG_LTAPPL("Module Id root file : "<<themodid);
   cout<<" Module Id root file : "<<themodid<<endl;
 return true;
}
/**/
QString RecordReader::Find(const QString& ss) {
  DbForm s=thedblut->find(ss);
  DT_DEBUG_LTAPPL(" try to find  "<<ss<<" in record "<<theRec);
  //cout<<" try to find  "<<ss<<" in record "<<theRec<<endl;
  if( s.getName() == "0") return "-0";
   char dir[50];
   QString sout;
  sprintf(dir,"Record%d",theRec);
   DT_DEBUG_LTAPPL(" search  dir "<<dir);
   if(!rootfile->cd(dir)) { DT_DEBUG_DB(" not found dir "<<dir);  return "0";}

    sout=findfolder("Header",s);
    if(sout!="0") return sout;
    sout=findfolder("Environment",s);
   if(sout!="0") return sout;
    sout=findfolder("Summary",s);
   if(sout!="0") return sout;
// first look  on peakinvon(should exist always), and store it
// preliminary version, will bne modified for final action tables 
    sout= findfolder("PeakInvOff/Pedestal",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/Noise",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/PulseShape",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/ForwardBias",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/LightTest",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/BackPlane",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/Calibration",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/Pipeline",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOff/LedTest",s);if(sout!="0") return sout;


    sout= findfolder("PeakInvOn/Pedestal",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/Noise",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/PulseShape",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/ForwardBias",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/LightTest",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/BackPlane",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/Calibration",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/Pipeline",s);if(sout!="0") return sout;
    sout= findfolder("PeakInvOn/LedTest",s);if(sout!="0") return sout; 



     sout=  findfolder("DecInvOn/Pedestal",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/Noise",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/PulseShape",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/ForwardBias",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/LightTest",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/BackPlane",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/Calibration",s);if(sout!="0") return sout;      sout=  findfolder("DecInvOn/Pipeline",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOn/LedTest",s);if(sout!="0") return sout; 

     sout=  findfolder("DecInvOff/Pedestal",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/Noise",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/PulseShape",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/ForwardBias",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/LightTest",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/BackPlane",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/Calibration",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/Pipeline",s);if(sout!="0") return sout; 
     sout=  findfolder("DecInvOff/LedTest",s);if(sout!="0") return sout; 

  return "0";
}
/**/
QString RecordReader::findfolder(const char* c,DbForm& s) {
   char dir[50];
   QString sout;
    sprintf(dir,"Record%d/%s",theRec,c);
   DT_DEBUG_LTAPPL(" change to dir "<<dir);
   //cout<<" change to dir "<<dir<<endl;
    if(!rootfile->cd(dir))  { DT_DEBUG_DB(" no  directory found ");  return "0";}
   DT_DEBUG_LTAPPL("  search "<<dir);
   sout=find(s); if(sout!="0") {
     DT_DEBUG_LTAPPL(" found "<<s.getName()<<" "<<sout);
     return sout;
   }
   return "0";

}

/**/
QString RecordReader::find( DbForm& dlf)  {
  QString s=dlf.getName(); 
 DT_DEBUG_LTAPPL(" try to find "<<s);
 //cout<<" try to find "<<s<<endl; 
   if(s.contains("TV", TRUE)>0) {  
     if((TVector*)gDirectory->Get(s)!=0)  return Root2Str((TVector*)gDirectory->Get(s),dlf);}
  if(s.contains("_F", TRUE)>0) {  
     if((TVector*)gDirectory->Get(s)!=0)  return Root2Str((TVector*)gDirectory->Get(s),dlf);}
  if(s.contains("TI", TRUE)>0) {  
     if((TVector*)gDirectory->Get(s)!=0)  return Root2StrI((TVector*)gDirectory->Get(s),dlf);}
 if(s.contains("_I", TRUE)>0) {  
     if((TVector*)gDirectory->Get(s)!=0)  return Root2StrI((TVector*)gDirectory->Get(s),dlf);}
  if(s.contains("TL", TRUE)>0) {  
     if((TVector*)gDirectory->Get(s)!=0)  return Root2StrL((TVector*)gDirectory->Get(s),dlf);}
   if(s.contains("TH", TRUE)>0) {
     if((TH1F*)gDirectory->Get(s)!=0)  return  Root2Str((TH1F*)gDirectory->Get(s),dlf); }
   if(s.contains("TN", TRUE)>0) {
     if((TNamed*)gDirectory->Get(s)!=0)  return  Root2Str((TNamed*)gDirectory->Get(s),dlf); }
   if(s.contains("TG", TRUE )>0) {
     if((TGraph*)gDirectory->Get(s)!=0)  return  Root2Str((TGraph*)gDirectory->Get(s),dlf); }
   if(s.contains("TP", TRUE)>0) {
     if((TProfile *)gDirectory->Get(s)!=0)  return  Root2Str((TProfile*)gDirectory->Get(s),dlf); }
// else
   TH1F* h=(TH1F*)gDirectory->Get(s);
   if(h!=0){
     QString sout=Root2Str(h,dlf); return sout;
   }
 
   DT_DEBUG_LTAPPL("=====not found "<<s);
   return "0";
}
/**/
bool  RecordReader::setRecord(int i) {
  int lastrec=theselrec.size()-1;
  DT_DEBUG_LTAPPL(" set Record "<<i);
  if(i==-1&&theselrec.size()>0) {theRec=theselrec[lastrec];
  DT_DEBUG_LTAPPL(" theRec= "<<theRec);
  return true;}
  
  if(i>=theselrec.size()&&theselrec.size()>0) {theRec=theselrec[lastrec];  return false;}

  theRec=theselrec[i]; return true;

  if(rootfile->IsOpen()) {
    char* recorddir;
    sprintf(recorddir,"Record%d",theRec);
    if(rootfile->cd(recorddir)) return true;
    else return false;
  } else return false;
}
