#ifndef MEASURECHANNEL_H
#define MEASURECHANNEL_H
#include <qcolor.h>
#include "pmap.h"
#include <qstring.h>
#include <vector>
class QComboBox; 
class  QLineEdit;
class QLCDNumber;
class  QPushButton;
class QTextBrowser;
class QLabel;
class MeasureChannel {
 public:
  MeasureChannel(QLabel* label, QComboBox*  Lb,  
		 QLineEdit*  physref,QLineEdit* physunit,
		 QLineEdit*  anaref , QPushButton* meas, 
		  QLCDNumber* result,QLineEdit* refvalue,QTextBrowser*  results);
 
  ~MeasureChannel();
  void addMeasureLine( QString name , float  physref, QString unit,
		       float analogue_value, int adc_ref_value);
  void storeMeasurement();
  void Measure( QPushButton* target, QLCDNumber* targetresult );
  void updateLine();
  struct mresults {
    float  fAnValue;
    float fResult;
    float fPhysRef; 
  };
  std::vector<mresults> getResultValues();
  private :
    struct  MeasInfo{ 
      float  fAnValue;
      float fResult;
      float fResultRef;
      float fPhysRef;
      QString fPhysUnit;
      bool fValid;
      QColor fColor;
    } ;

  pmap<QString , MeasInfo*> fLines;
  QString fChName;
  QComboBox* fName;
  QLineEdit* fPhysRef;
  QLineEdit* fPhysUnit;
  QLineEdit* fAnRef;
  QPushButton* fMeasure;
  QLCDNumber* fResult;
  QLineEdit* fRefValue;
  QTextBrowser* fMR; //Measure Results 
  QLabel* fLabel;
};

#endif
