#ifndef MODULEINFO
#define MODULEINFO

#include "ModId.h"
#include "dom/DOM_Node.hpp"
#include "positioninfo.h" 


class ModuleInfoParser;
class OptoHybridInfo;
class ModuleInfoDisplayExch;

class ModuleInfo: public ModId {
  friend class ModuleInfoParser;
  friend class ModuleMenuImpl;
  friend class ModuleInfoDisplayExch;
 public: 
  // needs a PositionInfo by ref !! 
  ModuleInfo(PositionInfo* pi){ 
    fDNMod=0;
    fModPi=pi;
    fHvConnector=-1;fHvCircuitNr=1; fSiTConnector=-1;fSiTCircuitNr=-1;
    
  }
  ~ModuleInfo(){};
  //int geModtFollownr(){return fModPi->getFollownr();}
  //int getRing(){return fModPi->fRing;}
  //int getRingPos(){ return fModPi->fRingPos;}
  int getDelayOffset25ns(){return fDelayOffset25ns;}
  int getDelayOffsetFine(){return fDelayOffsetFine;}
  DOM_Node* getModDomNode(){return &fDNMod;}
  /// shouldn't be necessary only for debugging 
 protected: 
  /** the dom node in the DomTree pointing to this module
   */
  DOM_Node fDNMod;
  PositionInfo* fModPi;
  int fHvConnector;
  int fHvCircuitNr;
  int fSiTConnector;
  int fSiTCircuitNr; 
  int fDelayOffset25ns;
  int fDelayOffsetFine;
  int fDelayCorrection;
  
};

#endif
