#ifndef MDOULEINFODISPLAYEXCH
#define MODULEINFODISPLAYEXCH
#include <string>
#include <vector>
#include <map>

class QLineEdit;
class QSpinBox;
class QCheckBox;
class QLCDNumber;
class ModuleInfo;
class QLabel;
/**
   \class ModuleInfoDisplayExch
   \brief Handles the writer and reading form the module menuinfo display
   it assumes fixed names for the fields used for the module info
   \authors: W. Beaumot ,UA
   \date 20030726
   \version 1.0
 
 */
class ModuleMenuImpl;

class ModuleInfoDisplayExch{
  // as long there are poblems with the moc generation 
  friend class ModuleMenuImpl;
 typedef struct {
   QLabel* benchpos;
    QLineEdit* modid;
    QLineEdit* modtype;
    QSpinBox* apvnrs;
    QLineEdit* dcunr;
    QCheckBox* checkdcu;
   QLCDNumber* ring;
   QLCDNumber* ringpos;
   QSpinBox* delay25ns;
   QSpinBox* finedelay;
  } structmodinfodisplay;
 public:
  ModuleInfoDisplayExch( );
  ~ModuleInfoDisplayExch();
  /** return the mod information
  */
  ModuleInfo*  getModIdInfo  (  );
 
 protected:
 
  /** reads the module info from the user interface and store it
      into the theModInfo for all benchpositions
      @return the number of modules with a valid Id 
  */
 
  void setOperator( QLineEdit* oper){ OpName=oper;} 
  void setTestCenter( QLineEdit* centr){ CenterName=centr;} 


  /** enable  the modules fields for bench pos
      if bool is true else it disable the fields
   */
  void enableModuleField(bool enable);

  void enableTestCenterField(bool enable);
  void enableOperatorField(bool enable);

   void addModuleDisplayInfo( 
     QLabel* benchnr,
    QLineEdit* modidin,  
    QLineEdit* modtypein, QSpinBox* apvnrsin,
    QLineEdit* dcunrin,  QCheckBox* checkdcuin,
     QLCDNumber* ring, QLCDNumber* ringpos,
     QSpinBox* delay25ns ,QSpinBox* finedelay
   ); 

  void   setModuleInfo();
  
  /** updates the display of the module information
      according the information in mi
      @param moduleid  ModId information for updating the display
  */
  void writeModuleInfo(ModuleInfo* mi);
 
 
 // the following vectors are created to have index access
  // perhaps qt has someting for it but is not checked
  // the index is the bench position

  ModuleInfo* fModInfo;
  structmodinfodisplay fDs; // DisplayStructure

   QLineEdit* OpName;
   QLineEdit* CenterName;
  // first number is the bench position 

};
#endif 
