#ifndef MODULEWIDGET_H
#define MODULEWIDGET_H

#include <qvariant.h>
#include <qwidget.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QColor;
class QPainter;
class QPaintEvent;
class ModuleMenuImpl;
class QPushButton;
class QPopupMenu;
class QAction;
class OptoModInfo;
class ModuleWidget : public QWidget
{ 
    Q_OBJECT

      public slots:
      
      // void moduleSelected();
    void menuFocus(int menustatus);
    
 public:
    enum ModuleState{NOTINITIALIZED,INITIALIZED};
    ModuleWidget(OptoModInfo* mi, QWidget* parent = 0, 
		 const char* name = 0, WFlags fl = 0 );
    ~ModuleWidget();
    
    // QLabel* PixmapLabel2;
 public:
    void setWedgeShape(bool ws);
    void paintRectFrame( QPainter * p=0);
    void simplePaint();
    void paintEvent(QPaintEvent *);
    ModuleMenuImpl* fMM;
 protected:
    virtual void mousePressEvent ( QMouseEvent * e ); 
    virtual void mouseDoubleClickEvent ( QMouseEvent * e );
    int fModnr;

 private:
    OptoModInfo* fMi;
    void removeModuleMenu();
    QPushButton* PushButton1;
    QColor fModColor;
    ModuleState fmodule_state;
    QWidget* fParent;
    bool fSelected;
    bool fMenuFocus;
    void drawFocusRect();
    QPopupMenu* leftBMenu;
    QAction* propAction;
    QAction* actAction;
    /// the wedge parameter 
    int fWedge; 

    private slots:
      void createModuleMenu();
    void createActionDialog();

};
#endif // MODULEWIDGET_H
