#ifndef NORMI2CDUMMY_H
#define NORMI2CDUMMY_H

#include <iostream>
#include "normi2c.h"
/**
   \class NormI2cDummy
   \author W. Beaumont
   \date March 2003
   \version 1.0

   \brief NormI2cDummy is an debugging implementation of the NormI2c
   \version 1.1
   Add multi bytes read and write
 */
class  NormI2cDummy : public NormI2c 
{
public:
  unsigned char retval;
  NormI2cDummy(int device ){std::cout << "device " << device <<std::endl;}
  /** Write mode
      @param addr I2c address 
      @param val  Value to write 
  */
  virtual int SingleByteWrite(unsigned char addr,unsigned char val){ 
    int a=addr;int v =val;
    std::cout <<"Norm Single Write address "<<a<<" val " << v <<std::endl;
    return 0;
  }
  /** Read mode
      @param addr I2c address 
      @param val  Read value 
  */
  virtual int SingleByteRead(unsigned char addr,unsigned char &val){
    int a=addr;
    val=retval;
    std::cout <<"Norm Single Read address "<<a<<" val " <<retval <<std::endl;
    retval++;
    return 0;
  }
  /** Write mode
      @param addr I2c address 
      @param Buffer to write
      @param len len in bytes
  */
  virtual int MultiByteWrite(unsigned char addr, char* buf, int len){
    int a=addr;
    std::cout << "Mulit  Write address "<<a<<" lenght= "<<len<<" values " ;
    for( int lc=0;lc< len;lc++){
      std::cout<< buf[lc]<<" ";
    }
    std::cout <<std::endl;
    return 0;
  }

  /** Read mode
      @param addr I2c address 
      @param Buffer to read
      @param len len in bytes

  */
  virtual int MultiByteRead(unsigned char addr,char* buf,int len){
    int a=addr;
    std::cout << "Mulit Read address "<<a<<" lenght= "<<len<<" values " ;
    for( int lc=0;lc< len;lc++){ 
      buf[lc]=retval++;
      std::cout<< buf[lc]<<" ";
    }
    std::cout <<std::endl;
    return 0;
  }
  
  
};


#endif


