#ifndef OPTOHYBRIDINFO
#define OPTOHYBRIDINFO
#include "positioninfo.h" 
#include <map>
#include <string>
//class DOM_Node;

class OptoHybInfo {
  friend class OptoHybMenuImpl;
  friend class OptoHybInfoParser;
 public:
  struct laserinfo {
    std::string fFiberId;
    int fConnectorNr;
    int fCircuitNr;
    int fBias;
    int fGain;
    unsigned int fLaserNr;
  };


  OptoHybInfo(PositionInfo* pi )  {fHybPos=pi;}
  ~OptoHybInfo(){}
  
  std::string getOptoHybId(){ return fOptoHybId;}
  std::string getOptoHybType(){return fOptoHybType;}
  int getNrLasers(){ return fLi.size();}
  int getConnectorNr(unsigned int laser){ 
    if( fLi.find(laser) != fLi.end()) {
      return fLi[laser].fConnectorNr;
    }
    else { return -1;}
  }
  int getCircuitNr(unsigned int laser){ 
    if( fLi.find(laser) != fLi.end()) {
      return fLi[laser].fCircuitNr;
    }
    else { return -1;}
  }
  int getGain(unsigned int laser){ 
    if( fLi.find(laser) != fLi.end()) {
      return fLi[laser].fGain;
    }
    else { return -1;}
  }
  int getBias(unsigned int laser){ 
    if( fLi.find(laser) != fLi.end()) {
      return fLi[laser].fBias;
    }
    else { return -1;}
  }


 protected:
  int fFollowNr;
  int fNrLasers;
  std::string fOptoHybId;
  std::string fOptoHybType;
  PositionInfo* fHybPos;
  std::map<unsigned int,laserinfo> fLi;
  //  DOM_Node fDNMod;
};


#endif
