#ifndef OPTOHYBWIDGET_H
#define OPTOHYBWIDGET_H

#include <qvariant.h>
#include <qwidget.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QColor;
class QPainter;
class QPaintEvent;
class OptoHybMenuImpl;
class QPushButton;
class QPopupMenu;
class QAction;
class OptoModInfo;
class OptoHybWidget : public QWidget
{ 
    Q_OBJECT

      public slots:
      
      // void moduleSelected();
    void menuFocus(int menustatus);
    
 public:
    enum OptoHybState{NOTINITIALIZED,INITIALIZED};
    OptoHybWidget(OptoModInfo* mi, QWidget* parent = 0, 
		  const char* name = 0, WFlags fl = 0 );
    ~OptoHybWidget();
    
    // QLabel* PixmapLabel2;
 public:
   
    void paintRectFrame( QPainter * p=0);
    void simplePaint();
    void paintEvent(QPaintEvent *);
    OptoHybMenuImpl* fHM;
 protected:
    virtual void mousePressEvent ( QMouseEvent * e ); 
    virtual void mouseDoubleClickEvent ( QMouseEvent * e );
    int fHybNr;

 private:
    OptoModInfo* fMi;
    void removeOptoHybMenu();
//    QPushButton* PushButton1;
    QColor fHybColor;
    OptoHybState fOptoHybState;
    QWidget* fParent;
    bool fSelected;
    bool fMenuFocus;
    void drawFocusRect();
    QPopupMenu* leftBMenu;
    QAction* propAction;
    QAction* actAction;

    private slots:
      void createOptoHybMenu();
    void createActionDialog();

};
#endif 
