#ifndef STRUCTUREIMPL
#define STRUCTUREIMPL

#include "structureui.hxx"
#include "substructtypes.h"
#include <vector>
class StructureImplInterface;
class PetalWidgetImpl;
class RodWidgetImpl;
class StructureInfo;
class OptoModInfo;
class ModId;

class QTabWidget;

class StructureImpl: public StructureUi {
  
  Q_OBJECT;
  
 public:
  StructureImpl(QWidget* parent= 0 , const char* name= 0 , WFlags fl= 0 );
  StructureImpl(lttest::substructtypes st ,
		QWidget* parent= 0 , const char* name= 0 , WFlags fl= 0 );
  ~StructureImpl();
  public slots:
    // normal the id should be scanned and the 
    // correct file should be automatically read 
    virtual void structSelection(const QString&);
  virtual void  selectStructFile();
 int initModuleInfo();
 ModId*  getModIdInfoOrderNr(int lc);
 OptoModInfo* getModIdInfo(int lc);
 std::vector<ModId*>* getModIdInfo();

 QTabWidget* TWStructure;
    QWidget* FrontView;
    QWidget* BackView;
    QWidget* FrontStereo;
    QWidget* BackStereo;


 protected:
  PetalWidgetImpl* fPw[4];
  RodWidgetImpl* fRw[4];
  QWidget* fQw[4];
  void createPetalView( );
  void addModules();
  void createRodView( );
  bool structSelection(lttest::substructtypes st);
  bool fInitialized;
  StructureInfo* fSi;
 private:
  // this is temporarly so this will fail for more than one sturcture
  static std::vector<ModId*> fModVector;
};

#endif 
