#ifndef STRUCTUREINFO
#define STRUCTUREINFO
#include <string>
#include "pmap.h"
// include is here needed to access the delete functions of OptoModInfo
#include "ccuinfo.h"
#include "optomodinfo.h" 
#include "ccuinfo.h" 
class StructureInfo {
  friend class StructureParser;
 public:
  StructureInfo(){ }
  ~StructureInfo(){
    modules.clearpointermap( );
    fCcus.clearpointermap( );
  }

  std::string getStructureId(){ return fId;}
  std::string getStructureType(){ return fType;}
  // get the ccuadddr
  int getCcuAddr( int ccunr){
    if( fCcus.find(ccunr) == fCcus.end()) { return -1;}
    else { return fCcus[ccunr]->getCcuAddr() ;}
  }
  // get the full CCU information
  CcuInfo* getCcuInfo( int ccunr) {
    if( fCcus.find(ccunr) == fCcus.end()) { return 0;}
    else { return fCcus[ccunr] ;}
  }
   
  pmap <int, OptoModInfo*>* getOptoModInfo() {
    return &modules;
  }
  int getNrCcus(){ return fCcus.size();} 
  int getNrOptoMods(){ return modules.size();}
  OptoModInfo*  getOptoModInfo(int i){ return modules.getP(i);}
  protected :
/// fills the information of the Ccu's into the module info
  void setOptoModCcuAddr(){
    for(pmap <int, OptoModInfo*>::const_iterator iter=modules.begin();
	iter != modules.end(); iter++) {
      int ccuaddr=getCcuAddr(iter->second->getCcuNr());
      iter->second->setCcuAddr(ccuaddr);
    }
  }
    std::string fId;
  std::string fType;
  pmap<int,CcuInfo*> fCcus;
  pmap <int, OptoModInfo*> modules; 
};

#endif
