#ifndef STRUCTUREPARSER
#define STRUCTUREPARSER
#include "pmap.h"
#include <string>
class DOM_Node;

class StructureInfo;

/** \class StructureParser parse the information of each structure 
    definition in the ltduts.dtd compatible xml file into the 
    StructureInfo. 
    For the moment no setNode method. 

    \Author  W.Beaumont Univeristy Antwerpen
    \date 20030809
    \version 1.0
*/
class CcuInfo;

class StructureParser {
 public:
  StructureParser();
  StructureParser(DOM_Node &ei);
  ~StructureParser(){}
  static StructureInfo* getStructureInfo(const std::string type);
  static int getNrStructInfos(){ return fStructInfos.size();}
  static StructureInfo* getFirstStructInfo(){ 
    if( fStructInfos.begin() != fStructInfos.end()){
      return fStructInfos.begin()->second;
    }
    else return 0;
  }
  private :
  static  pmap<std::string,StructureInfo*> fStructInfos;
  int  parseNode(DOM_Node &ei);
  int  CcuParser(CcuInfo* s, DOM_Node &ei);
};

#endif
