#include "ad4717calc.h"
#include "ad4717getter.h"
#include <limits.h>
#include <iostream> 
using namespace std;

Ad4717Calc:: Ad4717Calc(NormI2c *ni2c,unsigned char addr ) {
  fAd=new Ad4717Getter();
  fAd->setNormI2c(ni2c);
  fAddress=addr;


}

Ad4717Calc:: ~Ad4717Calc(){
  delete fAd;
}


int Ad4717Calc::PowerOn(bool poweron){
  int err=-1;
  if( poweron) {err= fAd->SetOtiPolarity(  fAddress, Ad4717Getter::OTI_LOW);}
  else {err=fAd->SetOtiPolarity(  fAddress, Ad4717Getter::OTI_HIGH);}
  return err;
}

int  Ad4717Calc::getChannelValue( unsigned char  chan, int nracq, 
		      float &value,unsigned short  &min, unsigned short  &max,float &sig){
  unsigned short  mx=0;
  unsigned int mn= USHRT_MAX;
  unsigned short result;
  unsigned int tot=0;
  int err=-1;
  for (int lc=0;lc<nracq;lc++){
    err=fAd->readAdc(fAddress,chan,result);
    cout << result<< " min " << mn;;
    if(err <0) break;
    if(result >mx ) { mx=result;}
    if(result <mn) {mn=result;}
    tot+= (unsigned int)result;
    cout <<" tot "<< tot <<" ";
  }
  cout << endl;
  if(err >= 0){
    max=mx; min=mn;
    value = (float)tot / nracq;
    cout <<"value "<< value <<endl;
  }
  return err;
}

int  Ad4717Calc::getTemperature( unsigned char  chan, int nracq, 
		      float &value,float  &min, float   &max,float &sig){

  float mx=0;
  float mn=2000;
  float result;
  float tot=0;
  int err=-1;
  for (int lc=0;lc<nracq;lc++){
    err=fAd->getTemperature(fAddress,result);
    if(err <0 ) break;
    if(result >mx ) { mx=result;}
    if(result <mn) {mn=result;}
    tot+= result;
  }
  if(err >=0 ){
    max=mx; min=mn;
    value = tot / nracq;
  }
  return err;
}


