#include "dcuinfoparser.h"
#include "dom/DOMString.hpp"
#include "dom/DOM_Node.hpp"
#include <dom/DOM_NamedNodeMap.hpp>
#include <dom/DOM_Document.hpp>
#include <dom/DOM_DOMException.hpp>
#include "iostream"
#include "dcuinfo.h"
#include "XercesExt.hpp"
#include "daqerrormsg.h"
using namespace std;
using namespace XercesExt;

int DcuInfoParser::parseNode(DcuInfo* du,DOM_Node &ei){
  DOM_NamedNodeMap a = ei.getAttributes();
  getItem(du->fTempRefValue,"tempoffset",a);
  getItem(du->fRefTemp,"reftemperature",a);
  getItem(du->fAdcGain,"adcgain",a);
  getItem(du->fDcuId,"dcu id",a);
  return (int) du->fDcuId;
}



void  DcuInfoParser::setNode(DcuInfo* du,
				DOM_Node &ei){
  DT_DEBUG_LP("fill");
  setItem(du->fTempRefValue,"tempoffset",ei);
  setItem(du->fRefTemp,"reftemperature",ei);
  setItem(du->fAdcGain,"adcgain",ei);
  setItem(du->fDcuId,"dcuid",ei);
  DT_DEBUG_LP("filled")
}
   

void DcuInfoParser::createNode( DcuInfo* du,
				DOM_Node &ei){
  DOM_Node n;
  DT_DEBUG_LP("created dcu element ");
  try {
   n = ei.getOwnerDocument().createElement("DcuInfo");
  }
  catch(const DOM_DOMException& e)    {
    DT_ERROR( DOMString(e.msg).transcode() );
    return ;
  }
  if( n.isNull()) { DT_ERROR("no node created"); return;}
  setNode(du,n);
  DT_DEBUG_LP("dcu");
  try{
    ei.appendChild(n);
  }
   catch(const DOM_DOMException& e)    {
    DT_ERROR( DOMString(e.msg).transcode() );
    return ;
  }
  DT_DEBUG_LP("dcu filled and added");
}
