#include "qcombobox.h"
#include "qlcdnumber.h"
#include "qlineedit.h"
#include "qpushbutton.h"
#include "qtextbrowser.h"
#include "qlabel.h"
#include <iostream>
using namespace std;

#include "measurechannel.h"


MeasureChannel::MeasureChannel(QLabel* label, QComboBox*  Lb, 
			       QLineEdit*  physref,QLineEdit* physunit,
			       QLineEdit*  anaref ,  QPushButton* meas, 
			       QLCDNumber* result,QLineEdit* refvalue,QTextBrowser* outtext)
{ fChName=label->text();fPhysRef=physref;fLabel=label;fPhysUnit=physunit;
  fName=Lb;fAnRef=anaref;fMeasure=meas;fResult=result;fRefValue=refvalue;
  fMR=outtext;
  fLabel->setPaletteForegroundColor(QColor(0,0,0));
}

MeasureChannel::~MeasureChannel(){
    fName->clear();
 fLines.clearpointermap();
  
}

void MeasureChannel::addMeasureLine(  
  QString name ,float  physref, QString unit, 
  float analogue_value, int adc_ref_value)
{
  MeasInfo* mi= fLines.getP(name) ;
  if (!mi) { mi=new MeasInfo; fLines[name]=mi;
  }
  fName->setMaxCount(fLines.size());
  mi->fAnValue=analogue_value;
  mi->fResult=-1;
  mi->fResultRef=(float)adc_ref_value;
  mi->fValid=false;
  mi->fColor=QColor(120,100,10);
  fName->insertItem(name);
  //mi->fIndex = fName->findItem(name);
  mi->fPhysRef=physref;
  mi->fPhysUnit=unit;
  int lines= fLines.size();if(lines>6) lines=6;
  fName->setSizeLimit(lines);
  updateLine();
}


void MeasureChannel::updateLine(){
  QString name= fName->currentText();
  MeasInfo* mi= fLines.getP(name) ;
  if(!mi) { return; }
  fAnRef->setText(QString::number((double)mi->fAnValue,'g',4));
  fRefValue->setText(QString::number((double)mi->fResultRef,'g',4));
  fPhysRef->setText(QString::number((double)mi->fPhysRef,'g',4));
  fPhysUnit->setText( mi->fPhysUnit);
  fResult->display( (int) mi->fResult);
  QPalette pal= fMeasure->palette();
  QColorGroup  cg=pal.active();
  cg.setColor(QColorGroup::Button,mi->fColor);
  pal.setActive(cg);
  fMeasure->setPalette(pal);
}


void MeasureChannel::storeMeasurement(){
  fMR->clear();
  fMR->setText(fChName);
  fMR->append("ActName\tPhysRef\tAValue\tAdcValue ");
  for (pmap<QString , MeasInfo*>::const_iterator  p=fLines.begin();p!=fLines.end();p++){
    MeasInfo* mi=p->second;
    if (mi->fValid) {
    fMR->append(p->first +"\t"+QString::number((double)mi->fPhysRef)
		+mi->fPhysUnit
		+"\t"+ QString::number((double)mi->fAnValue)+"\t"
		+QString::number((double)mi->fResult));	 
    }
    else {
      fMR->append(p->first +" no valid measurement made");
    }

    
  }
  

}

void MeasureChannel::Measure( QPushButton* target,  QLCDNumber* targetresult){
  
  QString name= fName->currentText();
  cout<< name << " is actual" <<endl;
  MeasInfo* mi= fLines.getP(name) ;
  if(!mi) { cout <<"meas  not found"<<endl;  return; }
  target->animateClick();
  cout<<"button toggled " << endl;
  mi->fAnValue=fAnRef->text().toFloat();
  mi->fResult=targetresult->value();
  QPalette pal= target->palette();
  QColorGroup cg=pal.active();
  mi->fColor=cg.color(QColorGroup::Button);
  if( mi->fColor != QColor(255,0,0)){ mi->fValid=true;}
  updateLine();
  bool allvalid=true;;
  for (pmap<QString , MeasInfo*>::const_iterator  p=fLines.begin();p!=fLines.end();p++){
    allvalid = allvalid && ( p->second->fValid);
  }
  if(allvalid) { fLabel->setPaletteForegroundColor(QColor(0,255,0));}
}


vector< MeasureChannel::mresults> MeasureChannel::getResultValues(){
  mresults mr;
  vector<mresults> lv;
  for (pmap<QString , MeasInfo*>::const_iterator  p=fLines.begin();p!=fLines.end();p++)
    {
      if( p->second->fValid){
	mr.fResult=p->second->fResult;
	mr.fPhysRef=p->second->fPhysRef;
	mr.fAnValue=p->second->fAnValue;
	lv.push_back(mr);
	
      }
    }
  return lv;
}
 
