#include "ltparser.h"
#include "benchposconnection.h"
#include "modinfotobenchpos.h"
#include "optomodinfo.h"
#include "structconparser.h"
#include "structureinfo.h" 
#include <iostream>
using namespace std;
using namespace lttest;
extern LtParser* ltparser; 

BenchPosConnection lttest::modInfoToBenchPos(OptoModInfo* mi){
  int benchnr=mi->getFollowNr();
  BenchPosConnection b(benchnr);
  BenchPosConnection* bc= &b;
  StructConInfo* si=StructConParser::getStructConInfo();
  bc->setCcuAddress( mi->getCcuAddr() );
  bc->setCcuChannel(mi->getCcuCh());
  bc->setFecNr(0);
  CalExchange <int>* c=ltparser->getFedProcessCtrlInfo(0);
  //int feddevice  = c->getId();
  bool fedsim =c->getSimulationState();
  c=ltparser->getFecCtrlDevInfo(0);
  int fecdevice = c->getId();
  bool fecsim =c->getSimulationState();
  for (int lc=0;lc < mi->getNrLasers();lc++){
    int connector= mi->getConnectorNr(lc);
    int circuit =mi->getCircuitNr(lc);
    StructConInfo::circuitinfo* ci=si->getCircuitInfo(connector,circuit);
    if (! ci) {
      cout << "cir "<<circuit <<" con " << connector<< " not found"<<endl;
      continue;
    }
    // switch for 2/ 3 channel 
    int chnr=lc;
    if(lc == 1 && mi->getNrLasers() == 2) {chnr++;}
    bc->setFedNr(ci->fFedSerialNr,chnr);
    bc->setFedType(BenchPosConnection::DIMDEV,chnr);
    bc->setFedChannel(  ci->fFedChan,chnr);
    bc->setFedSimulation (fedsim,chnr);
    BenchPosConnection::MuxChId muxid;
    muxid.fMuxDevice=ci->fMuxDevice;
    muxid.fMuxChannel=ci->fMuxChannel;
    muxid.fMuxCard=ci->fMuxCard;
    bc->setMuxId (muxid,chnr);
  }
  bc-> setLatencyOffset((unsigned short) 
			(mi->getDelayOffset25ns()*25 +mi->getDelayOffsetFine()));
  bc->setFecNr(fecdevice);
  bc->setFecSimulation (fecsim);
  bc->setOptoType(BenchPosConnection::OPTODIM) ;
  bc->setPllType(BenchPosConnection::PLLDIM);
  // this value has to be understand
  bc->setLatencyOffset(0); 
  bc->setDcuType(BenchPosConnection::DCU2DIM);
  bc->setMuxType(BenchPosConnection::MUX25DIM); 
  bc->setApvType(BenchPosConnection::APV25DIM) ;
  bc->setDimHostName(c->getShmName());
  bc->setNTCDevice(TempConverDef::DUMMYDEVICEID, 0);
  bc->setNTCDevice(TempConverDef::DUMMYDEVICEID, 1);
  bc->setHvCurrentDevice(CurrentConvDef::DUMMYDEVICEID );
  bc->setBiasDevice(HvConversionDef::DUMMYDEVICEID); 
  bc->setLvCurrentDevice(CurrentConvDef::DUMMYDEVICEID,0);
  bc->setLvCurrentDevice(CurrentConvDef::DUMMYDEVICEID,1);
  bc->setPowerSwitch (DioChannelDef::DUMMYDEVICEID);
  return b;
}


