
#include <moduleinfodisplayexch.h>


#include <qstring.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <qlcdnumber.h>
#include <moduleinfo.h>
#include <qlabel.h>


using namespace std;
ModuleInfoDisplayExch::ModuleInfoDisplayExch( ){
  OpName=0;  
  CenterName=0;
 
}

ModuleInfoDisplayExch::~ModuleInfoDisplayExch(){

}

void ModuleInfoDisplayExch::enableTestCenterField(bool enable){
 CenterName->setEnabled(enable);
}
void ModuleInfoDisplayExch::enableOperatorField(bool enable){
  OpName->setEnabled(enable);
}


void ModuleInfoDisplayExch::enableModuleField(bool enable){
  fDs.modid->setEnabled(enable);
    fDs.apvnrs->setEnabled(enable);
    fDs.modtype->setEnabled(enable);
    fDs.dcunr->setEnabled(enable);
    fDs.checkdcu->setEnabled(enable);
    fDs.delay25ns->setEnabled(enable);
    fDs.finedelay->setEnabled(enable);
}



void ModuleInfoDisplayExch::addModuleDisplayInfo(
   QLabel* benchpos,QLineEdit* modidin,
  QLineEdit* modtypein,QSpinBox* apvnrsin,
  QLineEdit* dcunrin,QCheckBox* checkdcuin,
   QLCDNumber* ring, QLCDNumber* ringpos,
   QSpinBox* delay25ns ,QSpinBox* finedelay
){ 
  fDs.modid= modidin;modidin->setEnabled(false);
  fDs.modtype= modtypein; modtypein->setEnabled(false);  
  fDs.apvnrs=apvnrsin;apvnrsin->setEnabled(false);
  fDs.dcunr=dcunrin; dcunrin->setEnabled(false);
  fDs.checkdcu=checkdcuin;checkdcuin->setEnabled(false);
  fDs.ring=ring;fDs.ringpos=ringpos;
  fDs.benchpos=benchpos;
  fDs.delay25ns=delay25ns;
  fDs.finedelay=finedelay;
}

 


ModuleInfo*  ModuleInfoDisplayExch::getModIdInfo  ()
{  return fModInfo;
}



void    ModuleInfoDisplayExch::setModuleInfo(  ) {  
  if(!fModInfo) return;
  if ( OpName!= 0){
    fModInfo->fOperator=OpName->text().latin1();
  }
  if ( CenterName!= 0){
    fModInfo->fcenter= CenterName->text().latin1();
  }
  fModInfo->fModId=fDs.modid->text().latin1();
  fModInfo->fNrApv=fDs.apvnrs->value();
  fModInfo->fType=fDs.modtype->text().latin1();
  fModInfo->fDcuId=fDs.dcunr->text().toUInt();
  fModInfo->fCheckDcu=fDs.checkdcu->isChecked();
  fModInfo->fDelayOffset25ns=fDs.delay25ns->value();
  fModInfo->fDelayOffsetFine=fDs.finedelay->value();
   
}

void ModuleInfoDisplayExch::writeModuleInfo(ModuleInfo* mi){
  fModInfo=mi;
  fDs.modid->setText(mi->getModId().c_str());
  string str=(string)mi->getModuleType();
  fDs.modtype->setText(str.c_str());
  fDs.dcunr->setText(QString::number(mi->getDcuId()));
  fDs.apvnrs->setValue(mi->getNrApvs());
  fDs.checkdcu->setChecked(mi->checkDcuId());
  if( mi->fModPi){
    fDs.ring->display(mi->fModPi->getRing());
    fDs.ringpos->display(mi->fModPi->getRingPos());
  }
  fDs.benchpos->setText(QString::number(mi->getBenchPosition()));
  fDs.delay25ns->setValue(mi->fDelayOffset25ns);
  fDs.finedelay->setValue(mi->fDelayOffsetFine);
}



