#include "moduleinfoparser.h"
#include "dom/DOMString.hpp"
#include "dom/DOM_Node.hpp"
#include <dom/DOM_NamedNodeMap.hpp>
#include <dom/DOM_Document.hpp>
#include <iostream>
#include "moduleinfo.h"
#include "XercesExt.hpp"
#include "dcuinfoparser.h"
#include "daqerrormsg.h"
using namespace std;
using namespace XercesExt;


int ModuleInfoParser::parseNode(ModuleInfo* mi,DOM_Node &ei){
  mi->fDNMod=ei;
  DOM_NamedNodeMap a = ei.getAttributes();
  if(getItem(mi->fNrApv,"nrapv",a)){
    DT_DEBUG_LP( "apvnr "<< mi->fNrApv);
  }
  else { DT_DEBUG_LP( "apv not defined " )}
  getItem(mi->fModId,"moduleid",a);
  getItem(mi->fType,"type",a);
  getItem(mi->fCheckDcu,"checkdcu",a);
  getItem(mi->fHvConnector,"hvconnectornr",a);
  getItem(mi->fHvCircuitNr,"hvciruitnr",a);
  getItem(mi->fDelayOffset25ns,"delayoffset25ns",a);
  getItem(mi->fDelayOffsetFine,"finedelayoffset",a); 
  mi->fDcuId=0;
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull()) {
    if (strcmp(n.getNodeName().transcode(),"DcuInfo")==0){
      DcuInfoParser dp(mi,n);
    }
    n = n.getNextSibling();
  }
  getItem(mi->fDcuId,"dcuid",a);
  return mi->fBenchPos;
}



void  ModuleInfoParser::setNode(ModuleInfo* mi,
				DOM_Node &ei){
  DT_DEBUG_LP("set module info node");
  setItem(mi->fModId,"moduleid",ei);
  setItem(mi->fType,"type",ei);
  setItem(mi->fCheckDcu,"checkdcu",ei);
  setItem(mi->fDelayOffset25ns,"delayoffset25ns",ei);
  setItem(mi->fDelayOffsetFine,"finedelayoffset",ei);
  DOM_Node n =ei.getFirstChild();
  bool dcunode=false ;
  while (!n.isNull()) {
    if( strcmp(n.getNodeName().transcode(),"DcuInfo")==0){
       DT_DEBUG_LP("set dcu info ");
      DcuInfoParser::setNode(mi,n);
      dcunode=true;
    }
  }
  if (!dcunode) {
    DcuInfoParser dp;
    DT_DEBUG_LP("create  dcu info ");
   dp.createNode(mi,ei);
  }
      
}
   
