#include <qspinbox.h>
#include <qlineedit.h>
#include <string>
#include <qlcdnumber.h>
#include <qlabel.h>
#include "optohybmenuimpl.h"
#include "optohybinfo.h"
#include "optomodinfo.h"
#include "structureparser.h"
using namespace std;
const bool enable=true;

OptoHybMenuImpl::OptoHybMenuImpl(OptoModInfo* mi, QWidget* parent , const char* name , WFlags fl ):OptoHybMenuUi(parent , name, fl){
   setFocusPolicy(QWidget::ClickFocus );
  
 fHi=mi;
 if(fHi){
   // fill the array 
   fLi[0].fFiberId= LEFiberId_1;fLi[0].fConnectorNr=SBConnectorNr_1;
   fLi[0].fCircuitNr=SBCircuitNr_1; fLi[0].fCalValue=SBLaserCal_1;
   fLi[1].fFiberId= LEFiberId_2;fLi[1].fConnectorNr=SBConnectorNr_2;
   fLi[1].fCircuitNr=SBCircuitNr_2; fLi[1].fCalValue=SBLaserCal_2;
   fLi[2].fFiberId= LEFiberId_3;fLi[2].fConnectorNr=SBConnectorNr_3;
   fLi[2].fCircuitNr=SBCircuitNr_3; fLi[2].fCalValue=SBLaserCal_3;
   

   writeOptoHybInfo(fHi);
   LEOptoHybType->setEnabled(true);
   LEOptoHybId->setEnabled(true);

  QString qs("OptoHyb Properties Ring ");
  QString qs2;
  if (fHi->fHybPos){
    qs2=qs2.setNum(fHi->fHybPos->getRing()); 
  }
  else {qs2="unknown";}
  qs+=qs2;
  qs+=" Position ";
  if (fHi->fHybPos){
    qs2=qs2.setNum(fHi->fHybPos->getRingPos()); 
  }
  else {qs2="unknown";}
  qs+=qs2;
  setCaption(qs);
  if(fHi->fNrLasers < 3){
    SBLaserCal_3->hide();
    SBCircuitNr_3->hide();
    SBConnectorNr_3->hide();
    LEFiberId_3->hide();
  }
 }
}

void OptoHybMenuImpl::focusOutEvent(QFocusEvent* qevent){
  qWarning("q out event " );
  QWidget::focusOutEvent(qevent);
  emit focusStatus(OUTFOCUS);
}

void OptoHybMenuImpl::focusInEvent(QFocusEvent* qevent){
  qWarning("q in  event " );
  QWidget::focusOutEvent(qevent);
  emit focusStatus(INFOCUS);
}

void OptoHybMenuImpl::closeEvent ( QCloseEvent * e ){
  emit  focusStatus(CLOSSED);
}

void OptoHybMenuImpl::UpdateOptoHybInfo(){
  if(!fHi) return;
  fHi->fOptoHybId=LEOptoHybId->text().latin1();
  fHi->fNrLasers=SBNrLasers->value();
  fHi->fOptoHybType=LEOptoHybType->text().latin1();
  for (int lc=0;lc<2;lc++){
    if( fHi->fLi.find(lc) != fHi->fLi.end()) {
      fHi->fLi[lc].fConnectorNr=fLi[lc].fConnectorNr->value() ;
      fHi->fLi[lc].fCircuitNr=fLi[lc].fCircuitNr->value() ;
      fHi->fLi[lc].fBias=fLi[lc].fCalValue->value() ;
    }
  }
}

OptoHybMenuImpl::~OptoHybMenuImpl(){
 //   for (unsigned int lc=0;lc<3;lc++){
//      fLi[0].fFiberId=0;fLi[0].fConnectorNr=0;
//      fLi[0].fCircuitNr=0; fLi[0].fCalValue=0;
//    }

  qWarning("menu destroyed");
  //emit  focusStatus(CLOSSED);
}



void OptoHybMenuImpl::writeOptoHybInfo(OptoHybInfo* mi){
  fHi=mi;
  LEOptoHybId->setText(mi->getOptoHybId().c_str());
  string str=(string)mi->getOptoHybType();
  LEOptoHybType->setText(str.c_str());
   
  for(int lc=0;lc<3;lc++){
    if( fHi->fLi.find(lc) != fHi->fLi.end()) {
      fLi[lc].fFiberId->setText(QString(fHi->fLi[lc].fFiberId.c_str()));
      fLi[lc].fConnectorNr->setValue(fHi->fLi[lc].fConnectorNr);
      fLi[lc].fCircuitNr->setValue(fHi->fLi[lc].fCircuitNr);
      fLi[lc].fCalValue->setValue(fHi->fLi[lc].fBias);
    }
  }
  if(fHi->fHybPos){
    LCDRing->display(fHi->fHybPos->getRing());
    LCDRingPos->display(fHi->fHybPos->getRingPos());
  }

  TLOptoBenchP->setText(QString::number(fHi->fHybPos->getFollowNr()));
}
