#include "optomodinfoparser.h"
#include "dom/DOMString.hpp"
#include "dom/DOM_Node.hpp"
#include <dom/DOM_NamedNodeMap.hpp>
#include <dom/DOM_Document.hpp>
#include "iostream"
#include "optomodinfo.h"
#include "DOMTreeWriter.hpp"
#include "XercesExt.hpp"
#include "moduleinfoparser.h"
#include "optohybinfoparser.h"
#include "daqerrormsg.h"
#include "centerinfo.h"
#include "dutsparser.h"
using namespace std;
using namespace XercesExt;

int OptoModInfoParser::parseNode(DOM_Node &ei){
  OptoModInfo* mi=new OptoModInfo();
  int follownr= parseNode(mi,ei);
  fMi=mi;
  return follownr;
}




int OptoModInfoParser::parseNode(OptoModInfo* mi,DOM_Node &ei){
 
  int follownr; 
  DOM_NamedNodeMap a = ei.getAttributes();
  mi->fDN=ei;
  getItem(follownr,"follownr",a);
  mi->fFollownr=follownr;
  DT_DEBUG_LP("follow nr "<<follownr);
  mi->fBenchPos=follownr;;
  getItem(mi->fRingPos,"ringpos",a);
  getItem(mi->fRing,"ring",a);
  getItem(mi->fStereo,"stereomodule",a);
  getItem(mi->fFront,"frontmodule",a);
  getItem(mi->fCcuCh,"ccuch",a);
  getItem(mi->fCcuNr,"ccunr",a);
  fCenterInfo=DutsParser::getCenterInfo();
  if( fCenterInfo) {
    mi->fOperator=fCenterInfo->getOperator();
    mi->fcenter=fCenterInfo->getCenter();
  }
  //if( fStructureInfo) {
  //  mi->fCcuAddr= fStructInfo->getCcuAddr(mi->fCcuNr);
  //}
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull()) {
    DT_DEBUG_LP( n.getNodeName().transcode());
    if (strcmp(n.getNodeName().transcode(),"ModuleInfo")==0){
      DT_DEBUG_LP("Will parse Module");
      ModuleInfoParser mp(mi,n);
    }
    if (strcmp(n.getNodeName().transcode(),"OptoHybridInfo")==0){
      OptoHybInfoParser ohp(mi,n);
    }
    n = n.getNextSibling();    
  }  
  return follownr;
}


//  bool  OptoModInfoParser::setNode(int i,bool subnodes){
//    bool found = false;
//    OptoModInfo* mi= modules.getP(i);
//    if (mi) {
//      cout<<"set node "<< mi->fFollownr<<" " <<i << " "<< mi->fRing << endl;
//      if(mi->getDomNode()){
//        setNode(mi,*mi->getDomNode());
 
void OptoModInfoParser::setSubNodes(OptoModInfo* mi,DOM_Node &ei){
  DOM_Node n =ei.getFirstChild();
  // order is fixed so need to do the while in this way ?
  while (!n.isNull()) {	  
    if(strcmp(n.getNodeName().transcode(),"OptoHybridInfo")==0) {
      DT_DEBUG_LP("optomod set opto hyb info ");
      OptoHybInfoParser ohp;
      ohp.setNode(mi,n);
    }
    if (strcmp(n.getNodeName().transcode(),"ModuleInfo")==0) {
      DT_DEBUG_LP("optomod set module info ");
      ModuleInfoParser mp;
      mp.setNode(mi,n);
    }
    DT_DEBUG_LP("opto mod next node ");
    n = n.getNextSibling();    
  }  
}
void  OptoModInfoParser::setNode(OptoModInfo* mi,bool subnodes){    
  setNode(mi,*(mi->getDomNode()),subnodes);
}

void  OptoModInfoParser::setNode(OptoModInfo* mi,
				DOM_Node &ei,bool subnodes){
  // follownr will not be changed !!
  if(!setItem(mi->fRingPos,"ringpos",ei)){
    DT_DEBUG_LP( "ring pos was not defined");
  }
  else { DT_DEBUG_LP("ringpos was already defined" );}
  setItem(mi->fRing,"ring",ei);
  mi->fOperator="noneoper";
  setItem(mi->fOperator,"operator",ei);
  setItem(mi->fcenter,"center",ei);
  setItem(mi->fCcuCh,"ccunrr",ei);
  setItem(mi->fCcuNr,"ccuch",ei);
  setItem(mi->fStereo,"stereomodule",ei);
  setItem(mi->fFront,"frontmodule",ei);
  DOM_NamedNodeMap a = ei.getAttributes();
  DOM_Node e=a.getNamedItem("stereomodule");
  DT_DEBUG_LP(" stereo module value= " << e.getNodeValue().transcode());
  if(subnodes) setSubNodes(mi,ei);
}
   
 
//pmap <int, OptoModInfo*> OptoModInfoParser::modules; 

