#include <qsize.h>
#include <qrect.h>
#include "optomodwidget.h"
#include "optohybwidget.h"
#include "modulewidget.h"
#include "optomodinfo.h"

OptoModWidget::OptoModWidget(OptoModInfo* mi, QWidget* parent,  
			     const char* name, WFlags fl )
  : QWidget( parent, name, fl ) {
  qDebug("create mod widget");
  fModnr=mi->getFollowNr();
  fParent=parent;
  //  QPixmap image0( ( const char** ) image0_data );
    if ( !name )
	setName( "ModuleWidget" );
    resize(100, 70 );
    setBackgroundOrigin( QWidget::ParentOrigin );
    setCaption( trUtf8( "OptoModWidget" ) );
    
    fMod=new ModuleWidget(mi,this);
    fMod->resize(50,50);
    fOH=new OptoHybWidget(mi,this);
    fOH->resize(35,15);
    QSize modsize= fMod->size();
    QSize ohsize= fOH->size();
    int dim = modsize.width()>ohsize.width()?
      modsize.width():ohsize.width();
    dim=dim+2;
    modsize.setWidth(dim);
    int height =modsize.height();
    modsize.setHeight(2+height+ohsize.height());
    resize(modsize);
    QRect df2;
    df2=(fMod->frameGeometry());
    df2.moveBy(1,1);
    fMod->setGeometry(df2);
    df2=fOH->frameGeometry();
    //calculate the center
    dim= (dim-ohsize.width())/2;
    df2.moveBy(dim,height+1);
    fOH->setGeometry(df2);
}

void OptoModWidget::setWedgeShape(bool wedge){
  if (fMod){ fMod->setWedgeShape(wedge);}
}

OptoModWidget::~OptoModWidget(){}
