#include "structureparser.h"
#include "dom/DOM_Node.hpp"
#include <dom/DOM_NamedNodeMap.hpp>
#include <dom/DOM_Document.hpp>
#include "optomodinfoparser.h"
#include "XercesExt.hpp"
#include "structureinfo.h"
//#include "daqerrormsg.h"
#include "dcuinfoparser.h" 
using namespace std;
using namespace XercesExt;

#define DT_DEBUG_LP(x);
#define DT_WARN(x);

StructureParser::StructureParser(){
  DT_DEBUG_LP("no parse constructor ");
}

StructureParser::StructureParser(DOM_Node &ei){
    DT_DEBUG_LP("go to parse ");
    parseNode(ei);}


int  StructureParser::parseNode(DOM_Node &ei){
  StructureInfo*  structinfo = new StructureInfo();
  DOM_NamedNodeMap a = ei.getAttributes();
  //int attrCount = attributes.getLength();  // why ?
  getItem(structinfo->fId,"strucureid",a);
  if( getItem(structinfo->fType,"structuretype",a)) {
    DT_DEBUG_LP("struct type  "<<structinfo->fType);
  }
  else { DT_DEBUG_LP("default struct type used ");}
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull()) {
    if(strcmp(n.getNodeName().transcode(),"CCU") == 0) {
      CcuInfo* ci=new CcuInfo;
      int follownr=CcuParser(ci, n);
      // if dcu info already exist remove it (removes also the dcu;s 
      if( structinfo->getCcuInfo(follownr)) { structinfo->fCcus.eraseP(follownr);}
      structinfo->fCcus[follownr]=ci;
    }
    if (strcmp(n.getNodeName().transcode(),"Position")==0){ 
      DT_DEBUG_LP("parse optomode");
      OptoModInfoParser mp(n);
      structinfo->modules.replaceP(mp.getFollowNr(),mp.getOptoModInfo());
     
    }
    n = n.getNextSibling();    
  }  
  structinfo-> setOptoModCcuAddr();
  if( fStructInfos.getP(structinfo->fType) ){
    DT_WARN("for the moment a type can only be defined once");
  }
  else{ 
    fStructInfos[structinfo->fType]=structinfo;
    DT_DEBUG_LP("Struture of type "<<  
		fStructInfos[structinfo->fType]->getStructureType());
  }  
  return 0 ;
}

int  StructureParser::CcuParser(CcuInfo* s, DOM_Node &ei){
  DOM_NamedNodeMap a = ei.getAttributes();
  int ccunr;
  getItem(ccunr,"follownr",a);
  // overwrite eventual existing CCU address 
  getItem(s->fAddress,"address",a);    
  DOM_Node n =ei.getFirstChild();
  while (!n.isNull()) {
    if(strcmp(n.getNodeName().transcode(),"DcuInfo") == 0) {
      DcuInfo* du=new DcuInfo;
      DcuInfoParser dp(du,n);
      s->dcus.push_back(du);
    }
    n = n.getNextSibling();    
  }
  return ccunr;
}

//void  StructureParser::clear(){

//}

//statics:

StructureInfo* StructureParser::getStructureInfo(const std::string type){
    return fStructInfos.getP(type);
  }

pmap<string,StructureInfo*> StructureParser::fStructInfos;
