#include "dutsparser.h"
#include "ltparser.h"
#include "daqerrormsg.h"
#include <fstream>
#include <iostream>
#include "structureinfo.h"
#include "structureparser.h"
#include "optomodinfoparser.h"
#include "DOMTreeWriter.hpp"
#include "cmdlinedecode.h"
#include "modinfotobenchpos.h"
#include "benchposconnection.h"

LtParser* ltparser; 
using namespace std; 
using namespace lttest;
void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout << "testmodtobenchinfo -ltconfig ltpetal.xml" <<endl;
  cout <<"options:" <<endl;
  cout <<"\t-h  this message "<<endl;
  cout <<"\t-ltconfig :the configuration file (default is ltpetal.xml)"<<endl;
  std::exit(-1);
}

int main( int argc, char* argv[] )
{
  //DaqToolsErrorMessage tem(DT_DEBUG_ALL); // show all messages
  string cmdlresult;
  if( "found"== CmdLineDecode(argc,argv,"h",cmdlresult,false)){
     usage();
  }
  ltparser= new LtParser();
  if( "found" != CmdLineDecode(argc,argv,"ltconfig",cmdlresult,true)){  
    cmdlresult="ltpetal.xml";
  }
  ltparser->setParseFileName( cmdlresult);
  if(ltparser->parseFile()){
    cout<<"error in configuration file stop program"<<endl;
    delete ltparser;
    return -1 ;
  }


 
  DutsParser dutparser;
  // calls the module parser that stores the parsed info in a static 
  if(dutparser.parseFile( )) { 
    cout << "parse error see above "<< endl;
    return -1;
  }
  int nrmodules=20; // should come for petal parser 
  // update the parser document before writing
  StructureInfo* si= StructureParser::getStructureInfo("Petal");
  for (int i=0;i<nrmodules;i++){
    OptoModInfo* mi=si->getOptoModInfo(i);
    if( mi){
      BenchPosConnection bp(modInfoToBenchPos(mi));
      bp.info();

      OptoModInfoParser::setNode(mi);
    }    
  }

 //string resultfilename="resultfile";
  //ofstream rf(resultfilename.c_str());
  //if(! rf){ cerr<< "can not open "<<resultfilename <<endl;}
  //DOMTreeWriter(dutparser.getDocument(),cout);

  dutparser.clear();
  ltparser->clear();
  delete ltparser; ltparser=0;
  return 0;
}
