#ifndef DaqSettingImpl
#define DaqSettingImpl
#include "DaqSettingsUi.hxx"
#include "qthread.h" 

class DaqCtrl;
class QString;

class DaqSettingsImpl : public DaqSettingsUi, public QThread
{
  Q_OBJECT
 
 public:
  DaqSettingsImpl( QWidget* parent ,  const char* name , WFlags fl=0  );
  ~DaqSettingsImpl();
  void setDaqCtrl( DaqCtrl* daqctrl ); 
  /** updates the values from the DaqCtrl
  */
  void writeDaqSettingsDisplay( );
  public slots:
    virtual void ApplyTscSettings();
    virtual void FedThresholdFinding();
    virtual void SetFedClkDelay();
    /** activates the fed monitor spy */
    virtual void FedMon(bool switchon);
    virtual void setScopeMode(bool value);
    /** request a new spill of nrevents */
    virtual void newSpill();
  signals :
    /* is send when apply tsc settings is called */
    void DaqSettingsChanged( QString );
  
  private :
   virtual  void run();
    DaqCtrl* fDaqCtrl;
  bool  fMonRunning;
  int fLastReadEvent;
  bool fScopeMode;
};


#endif
