#ifndef MDOULEINFODISPLAY
#define MODULEINFODISPLAY
#include <string>
#include <vector>
#include <map>
//#include <qmainwindow.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <ModId.h>


/**
   \class ModuleInfoDisplay
   \brief Handles the writer and reading form the module info display
   it assumes fixed names for the fields used for the module info
   \authors: W. Beaumot ,UA
   \date 20021124
   \version 1.0
 
 */

class ModuleInfoDisplay{
 typedef struct {
    QLineEdit* modid;
    QLineEdit* modtype;
    QSpinBox* apvnrs;
    QLineEdit* dcunr;
    QCheckBox* checkdcu;
  } structmodinfodisplay;
 public:
  ModuleInfoDisplay( );
  ~ModuleInfoDisplay();
  /** return the mod information of the module inside the vector
      take care order is not the benchposition but the nr on which the module
      info is registered (so the index in fModInfo) 
      @return the pointer to the module info 
  */
  ModId*  getModIdInfo  ( int order );
   
  /** @return the pointer to the module info vector 
   */
  std::vector<ModId*> *getModIdInfo(){ return &fModInfo;}
  std::vector<ModId*> *getNotValidMod(){return &fNotValidModInfo;}

 protected:
  /// clears the theModInfo Vector 
  void clearModuleInfo(); 
  /** reads the module info from the user interface and store it
      into the theModInfo for all benchpositions
      @return the number of modules with a valid Id 
  */
 
  void setOpperator( QLineEdit* oper){ OpName=oper;} 
  void setTestCenter( QLineEdit* centr){ CenterName=centr;} 


  /** enable  the modules fields for bench pos
      if bool is true else it disable the fields
   */
  void enableModuleField(int benchpos,bool enable);

  void enableTestCenterField(bool enable);
  void enableOperatorField(bool enable);

  void addModuleDisplayInfo(int benchpos ,
    QLineEdit* modidin,  
    QLineEdit* modtypein, QSpinBox* apvnrsin,
    QLineEdit* dcunrin,  QCheckBox* checkdcuin); 

  int  setModuleInfo();
  /** reads the module info from the user interface for the module
      at benchposition. 
      @param benchposition the bench position 
      @returns true the pointer to the new ModId  else returns 0 
  */
  ModId*  setModuleInfo(int benchposition);
  /** updates the display of the module information
      according the information in mi
      @param moduleid  ModId information for updating the display
  */
  void writeModuleInfo(ModId mi);
 
 
 // the following vectors are created to have index access
  // perhaps qt has someting for it but is not checked
  // the index is the bench position

  std::vector<ModId*> fModInfo;
  std::vector<ModId*> fNotValidModInfo;
  std::vector<ModId*>::const_iterator fModInfoPtr;

   QLineEdit* OpName;
   QLineEdit* CenterName;
  // first number is the bench position 
  std::map<int,structmodinfodisplay*> fM;
  std::map<int,structmodinfodisplay*>::const_iterator pfM; 
  /** the number of bench positions is set in the
      is set in the fill_modinfoVectors
  */

int fFields;

};
#endif 
