#ifndef MODULEINFODISPLAYINFO
#define MODULEINFODISPLAYINFO
#include "ModuleInfoDisplay.h"
#include "ModuleInfoDisplayUi.hxx"

class LtParser;
//class MonitorImpl;

class ModuleInfoDisplayImpl : public ModuleInfoDisplay ,  public ModuleInfoDisplayUi
{
 public:
  ModuleInfoDisplayImpl(LtParser* ltparser, 
			QWidget* parent ,  const char* name , WFlags fl=0  );

    ~ModuleInfoDisplayImpl();

 
  
  /** clears the information in the module info display and set the values to the 
      values read from the lt.xml file
  */
  void resetModuleInfo();

  /** reintialize the module info 
   @return the number of defined bench positions 
  */ 
  int  initModuleInfo();
  /** set all fields to the edit enable mode 
   */
  void setEditEnable( bool editenable ) ;
 /** set the bench position entries defined in the lt.xml file to edit enable
   */
  void setActiveBenchEntries();
 private:
  LtParser* fLtParser; 

/**\brief Fills  the vector with pointers to the GUI module id information
     For each bench position there is a GUI with the module information.
     This function creates a vector that points to this group so it can
     be ussed as an array. The vector is implemented in the 
     ModuleInfoDisplay class. 
   */
  void fill_modinfoVectors();


};


#endif
