#include "HybridSettingsImpl.h"
#include "Monitorimpl.h"
#include "ModuleDescriptor.h"
#include "ModuleTestSetup.h"
#include "TestProcedure.h"
#include "TestStatus.h"
#include "DaqCtrl.h"
#include "daqerrormsg.h"
// done by Monitorimpl.h:
//include <qstring.h>
//include <qpushbutton.h>

HybridSettingsImpl::HybridSettingsImpl(Monitorimpl*  monitorimpl,    QWidget* parent ,
					      const char* name , 
					      WFlags fl  ):
 HybridSettingsUi( parent,  name )
{
  fMi=monitorimpl;
  thetestsetup=0;
#ifndef  LTDEBUG1 
  GBOptoSettings->hide();
#endif
}

HybridSettingsImpl::~HybridSettingsImpl()
{

}



void HybridSettingsImpl::writeI2cSettingsDisplay( I2cDescriptor* curi2c){

 SBAddress->setValue(curi2c->fAddress);
  SBMode->setValue(curi2c->fMode);
  SBLatApv->setValue(curi2c->fLatency);
  SBLatPll->setValue(curi2c->fLatencypll);
  SBCdrv->setValue(curi2c->fCdrv);
  SBCsel->setValue(curi2c->fCdrv);
  SBIcal->setValue(curi2c->fIcal);
  SBIsha->setValue(curi2c->fIsha);
  SBVfs->setValue(curi2c->fVfs);
  SBVpsp->setValue(curi2c->fVpsp);
  SBVfp->setValue(curi2c->fVfp);
  SBImuxin->setValue(curi2c->fImuxin);
  SBMuxgain->setValue(curi2c->fMuxgain);
  SBMuxRes->setValue(curi2c->fResistormux);
}

 
/*
 * slot from settings menu
 * init the pll and set the delays 
*/
void HybridSettingsImpl::InitPll(){

  if(fMi->initDone() && thetestsetup ) {
    I2cDescriptor* curi2c=thetestsetup->getTestProcedure()->getCurrentI2c(); 
    curi2c->fInitpll= 2  ;  // 2 = init pll 
    curi2c->fLatencypll=SBLatPll->text().toInt();   
    DT_NOTE(" pll init ");
    thetestsetup->getTestProcedure()->setPll(curi2c);
    curi2c->fInitpll= 0  ;
  }
  return;
}

void HybridSettingsImpl::HardReset(){
 if(fMi->initDone() && thetestsetup ) {
   thetestsetup->getDaqCtrl()->hardReset();
   DT_NOTE(" Monitor: FEC hardreset");
   InitPll();
 }
  return;
}


/*
 * slot from settings menu
 * set i2c settings from settings menu to the objects 
*/
void HybridSettingsImpl::ApplyI2C() {
  if(fMi->initDone() && thetestsetup ) {
    I2cDescriptor* curi2c= thetestsetup->getTestProcedure()->getCurrentI2c();
    curi2c->fInitpll= false ;     
    curi2c->fAddress=SBAddress->text().toInt();
    curi2c->fMode=SBMode->text().toInt();
    curi2c->fLatency=SBLatApv->text().toInt();
    curi2c->fLatencypll=SBLatPll->text().toInt();
    curi2c->fCdrv=SBCdrv->text().toInt();
    curi2c->fCsel=SBCsel->text().toInt();
    curi2c->fIcal=SBIcal->text().toInt();
    curi2c->fIsha=SBIsha->text().toInt();
    curi2c ->fVfs=SBVfs->text().toInt();
    curi2c->fVfp=SBVfp->text().toInt();
    curi2c->fVpsp=SBVpsp->text().toInt();
    curi2c->fImuxin=SBImuxin->text().toInt();
    curi2c->fMuxgain=SBMuxgain->text().toInt();
    curi2c->fResistormux=SBMuxRes->text().toInt();
    thetestsetup->getTestProcedure()->SetI2c(curi2c); 
    QString s;
    s.sprintf(" Time:%d Applyed I2C setting",thetestsetup->getCTime() );
    fMi->StatusBox->insertItem(s);
    fMi->StatusBox->ensureCurrentVisible ();
  }
}

void HybridSettingsImpl::ApplyOpto() {
  thetestsetup->getTestProcedure()->setLld(SBLldGain->text().toInt(),
					   SBLldBias->text().toInt());

}
