
#include <ModuleInfoDisplay.h>
using namespace std;
ModuleInfoDisplay::ModuleInfoDisplay( ){
  OpName=0;  
  CenterName=0;
}

ModuleInfoDisplay::~ModuleInfoDisplay(){
  clearModuleInfo();
  for(pfM=fM.begin();pfM!=fM.end();pfM++){
    delete pfM->second;
  }
}

void ModuleInfoDisplay::enableTestCenterField(bool enable){
 CenterName->setEnabled(enable);
}
void ModuleInfoDisplay::enableOperatorField(bool enable){
  OpName->setEnabled(enable);
}


void ModuleInfoDisplay::enableModuleField(int benchpos,bool enable){
  if( (pfM = fM.find(benchpos)) != fM.end()){
    pfM->second->modid->setEnabled(enable);
    pfM->second->apvnrs->setEnabled(enable);
    pfM->second->modtype->setEnabled(enable);
    //pfM->second->dcunr->setEnabled(enable);
    //pfM->second->checkdcu->setEnabled(enable);
  }

}

void ModuleInfoDisplay::addModuleDisplayInfo( int benchpos, 
  QLineEdit* modidin,
  QLineEdit* modtypein,QSpinBox* apvnrsin,
  QLineEdit* dcunrin,QCheckBox* checkdcuin){
  structmodinfodisplay* s=  new structmodinfodisplay();
  s->modid=  modidin;modidin->setEnabled(false);
  s->modtype= modtypein; modtypein->setEnabled(false);  
  s->apvnrs=apvnrsin;apvnrsin->setEnabled(false);
  s->dcunr=dcunrin; dcunrin->setEnabled(false);
  s->checkdcu=checkdcuin;checkdcuin->setEnabled(false);
  fM[benchpos]= s;  
}

void ModuleInfoDisplay::clearModuleInfo( ){
 if (fModInfo.size()){
    for ( fModInfoPtr= fModInfo.begin(); fModInfoPtr==fModInfo.end();
	  fModInfoPtr++){
      if( (*fModInfoPtr)){ delete (*fModInfoPtr);}
    }
    fModInfo.clear();
 }
 
 for ( unsigned int lc=0;lc <fNotValidModInfo.size();lc++){
   delete fNotValidModInfo[lc];
   fNotValidModInfo.clear();
 } 
}

 


int  ModuleInfoDisplay::setModuleInfo(  ){
  clearModuleInfo();
  int nrMod=0;ModId* MId;
  for (int i=0; i< fFields;i++){
    MId=setModuleInfo(i);
    if(MId ){
      fModInfo.push_back(MId); 
      nrMod++;
    }
  }
  return nrMod;
}
ModId*  ModuleInfoDisplay::getModIdInfo  ( int order )
{ ModId* retval=0;
 if( (unsigned int)order < fModInfo.size()){
   retval=fModInfo[order];
 }
 return retval;
}



ModId*   ModuleInfoDisplay::setModuleInfo(int bench  ){
  //bool modvalid=false;
  QString qs("noname"),tc("noname");
  if ( OpName!= 0){
    qs= OpName->text().latin1();
  }
 if ( CenterName!= 0){
    tc= CenterName->text().latin1();
  }
  ModId* MId=0;
  //const char* center0="TestCenter";
  if((pfM=fM.find(bench))== fM.end()) { return MId;} 
  structmodinfodisplay* s=pfM->second;
  if(! s->modid->isEnabled()) { return MId;}
  MId=  new ModId(s->modid->text().latin1(),s->apvnrs->value(),
			 s->modtype->text().latin1(),bench,
		    s->dcunr->text().toUInt(),
		    s->checkdcu->isChecked(),qs,tc);
    if( ! MId->ValidId()) {fNotValidModInfo.push_back(MId); MId=0; }   
  return MId;
}

void ModuleInfoDisplay::writeModuleInfo(ModId mi){
  int bench= mi.getBenchPosition();
  if((pfM=fM.find(bench))== fM.end()) { return;}
  structmodinfodisplay* s=pfM->second;
  s->modid->setText(mi.getModId().c_str());
  string str=(string)mi.getModuleType();
  s->modtype->setText(str.c_str());
  s->dcunr->setText(QString::number(mi.getDcuId()));
  s->apvnrs->setValue(mi.getNrApvs());
  s->checkdcu->setChecked(mi.checkDcuId());
}



