#include "daqerrormsg.h"
#include "ModuleInfoDisplayImpl.h"
#include "benchposconnection.h"
#include "ltparser.h"


ModuleInfoDisplayImpl:: ModuleInfoDisplayImpl(LtParser* ltparser, 
					      QWidget* parent ,
					      const char* name , 
					      WFlags fl  ):
  ModuleInfoDisplayUi( parent,  name )

{ fLtParser=ltparser;
  fFields=0; // nr of position in the interface
  fill_modinfoVectors();
  setActiveBenchEntries();
   setOpperator(Opperator);
   setTestCenter(Center);
}

int  ModuleInfoDisplayImpl::initModuleInfo(){
  return setModuleInfo();
}

void ModuleInfoDisplayImpl::resetModuleInfo(){
  clearModuleInfo();
  setActiveBenchEntries();
}


void  ModuleInfoDisplayImpl::setEditEnable( bool enable ) {
  for(int  lc=0;lc< fFields;lc++) {enableModuleField(lc,enable);} 
  enableTestCenterField(enable);
  enableOperatorField(enable);
}


void ModuleInfoDisplayImpl::setActiveBenchEntries(){
for (int lc=0 ; lc < fLtParser->getNumberBenchPositions();lc++){
   BenchPosConnection* bc = fLtParser->getRegisteredBenchPos(lc);
     // int benchid= ltparser->getBenchPosConnections(lc)->getId();
   int benchid= bc->getId();
   DT_NOTE("bench id " << benchid << " nr of benches " <<fLtParser->getNumberBenchPositions());
   enableModuleField(benchid,true);
 }

}


ModuleInfoDisplayImpl::~ModuleInfoDisplayImpl()
{
  clearModuleInfo();
}


void ModuleInfoDisplayImpl::fill_modinfoVectors(){
// bench position logical starts with 0 
// in user numbering with 1 
  addModuleDisplayInfo(0,modid1,modtype1,modnrapv1,dcunr1,checkdcu1);
  addModuleDisplayInfo(1,modid2,modtype2,modnrapv2,dcunr2,checkdcu2);
  addModuleDisplayInfo(2,modid3,modtype3,modnrapv3,dcunr3,checkdcu3);
  addModuleDisplayInfo(3,modid4,modtype4,modnrapv4,dcunr4,checkdcu4);
  addModuleDisplayInfo(4,modid5,modtype5,modnrapv5,dcunr5,checkdcu5);
  addModuleDisplayInfo(5,modid6,modtype6,modnrapv6,dcunr6,checkdcu6);
  addModuleDisplayInfo(6,modid7,modtype7,modnrapv7,dcunr7,checkdcu7);
  addModuleDisplayInfo(7,modid8,modtype8,modnrapv8,dcunr8,checkdcu8);
  addModuleDisplayInfo(8,modid9,modtype9,modnrapv9,dcunr9,checkdcu9);
  addModuleDisplayInfo(9,modid10,modtype10,modnrapv10,dcunr10,checkdcu10);  
  fFields=10;
}
