#include <qapplication.h>
#include "ModuleInfoGen.h"
#include "ModuleInfoDisplayImpl.h"
#include "cmdlinedecode.h"
#ifdef SUBSTRIMPL
#include "structureimpl.h"      
#endif

#include <string>
using namespace std;
using namespace lttest;
ModuleInfoGen::ModuleInfoGen(LtParser *lt,QWidget* parent ,const char* name ){
  string structtype="Coldbox"; 

  CmdLineDecode(qApp->argc(),qApp->argv(),"struct",
			       structtype,true);
  fVM=0;
  fST=strtosubstruct(structtype);
  
  switch (fST){
    case COLDBOX : {
      fMdi=new ModuleInfoDisplayImpl(lt,parent,"init");
    }
    break;
    case PETAL:
    case ROD :  {
#ifdef SUBSTRIMPL
      fSi=new StructureImpl(parent,"init");      
#endif
    }
    break;
    default : {
    }
    break;
  }
      
}

ModuleInfoGen::~ModuleInfoGen(){
  // deleting of the widgets done by qt 
}


void ModuleInfoGen::resetModuleInfo(){
  switch (fST){
    case COLDBOX : {
      fMdi->resetModuleInfo();
    }
    break;
    case PETAL : {
      
    }
    break;
    case ROD : {
      
    }
    break;
    default : {
    }
    break;
  }

    
}

void ModuleInfoGen::setActiveBenchEntries(){
  switch (fST){
    case COLDBOX : {
     fMdi->setActiveBenchEntries();
    }
    break;
    case PETAL : {
      
    }
    break;
    case ROD : {
      
    }
    break;
    default : {
    }
    break;
  }
}

int ModuleInfoGen::initModuleInfo(){
  int nrmod=0;
  switch (fST){
    case COLDBOX : {
     nrmod= fMdi->initModuleInfo();
    }
    break;
    case PETAL : 
    case ROD : {
#ifdef SUBSTRIMPL
     return  fSi->initModuleInfo();     
#endif    

    }
    break;
    default : {
    }
    break;
  }
  return nrmod;
}
 
ModId*  ModuleInfoGen::getModIdInfo(int lc){
  ModId* mi=0;
  switch (fST){
    case COLDBOX : {
      mi= fMdi->getModIdInfo(lc);
    }
    break;
    case PETAL :
    case ROD : {
#ifdef SUBSTRIMPL
      mi=fSi->getModIdInfoOrderNr(lc);     
#endif  
    }
    break;
   
    default : {
    }
    break;
  }
  return mi;
}

std::vector<ModId*>*  ModuleInfoGen::getNotValidMod(){
switch (fST){
    case COLDBOX : {
     return  fMdi->getNotValidMod();
    }
    break;
    case PETAL : {
      return  fVM;
    }
    break;
    case ROD : {
      return  fVM;
    }
    break;
    default : {
      return  fVM;
    }
    break;
  }
  
}

std::vector<ModId*>* ModuleInfoGen::getModIdInfo(){
  std::vector<ModId*>* res=fVM;
  switch (fST){
    case COLDBOX : {
      res=fMdi->getModIdInfo();
    }
    break;
    case PETAL : 
    case ROD : {
#ifdef SUBSTRIMPL
      res= fSi->getModIdInfo();     
#endif  
    }
    break;
    default : {
      res= fVM;
    }
    break;
  }
  
  return res;
}

void ModuleInfoGen::setEditEnable(bool b){
  switch (fST){
    case COLDBOX : {
      fMdi->setEditEnable(b);
    }
    break;
    case PETAL : {
      
    }
    break;
    case ROD : {
      
    }
    break;
    default : {
    }
    break;
  }
}

//  switch (fST){
//      case COLDBOX : {
     
//      }
//      break;
//      case PETAL : {
      
//      }
//      break;
//      case ROD : {
      
//      }
//      break;
//      default : {
//      }
//      break;
//    }
