#include "RunSettingsImpl.h"
#include "Monitorimpl.h"
#include "ModuleDescriptor.h"
#include "setparser.h"
#include "ModuleTestSetup.h"
#include "Module.h"
#include "TestProcedure.h"

using namespace std; 

RunSettingsImpl::RunSettingsImpl(Monitorimpl* monitorimpl,  QWidget* parent ,
					      const char* name , 
					      WFlags fl  ):
  RunSettingsUi( parent,  name )
{
  fMi=monitorimpl;
  thetestsetup=0;
}

RunSettingsImpl::~RunSettingsImpl()
{

}



void RunSettingsImpl::writeRunSettingsDisplay( SetParser* sets){
  SBVend->setValue((int)sets->getSensorDescriptor("default")->vendiv);
  SBNpiv->setValue(sets->getSensorDescriptor("default")->npointsiv);  
  SBNped->setValue(sets->getPedRunDescriptor("default")->nped);
  SBNpedraw->setValue(sets->getPedRunDescriptor("default")->npedraw);
  SBTbad->setValue((int)sets->getPedRunDescriptor("default")->tbad); 
  SBLatStart->setValue(sets->getCalProfRunDescriptor("default")->latstart);
  SBLatEnd->setValue(sets->getCalProfRunDescriptor("default")->latend); 
  SBNscan->setValue(sets->getCalProfRunDescriptor("default")->nevpoint); 
  SBDtslow->setValue(sets->getProcedureDescriptor("default")->dtslowctrl);
  SBAlgo->setValue(sets->getPedRunDescriptor("default")->modped);  
}




 /*
 * slot from settings menu
 * set run settings from settings menu to the objects
 */
void RunSettingsImpl::ApplyRunSet() {

  if(fMi->initDone() && thetestsetup)  {
 
 thetestsetup->getTestProcedure()->setDt(SBDtslow->text().toInt());

  SetParser* sets=thetestsetup->getSetParser();
  sets->getSensorDescriptor("default")->vendiv=SBVend->text().toFloat();
  sets->getSensorDescriptor("default")->npointsiv=SBNpiv->text().toInt();
  sets->getPedRunDescriptor("default")->nped=SBNped->text().toInt();
  sets->getPedRunDescriptor("default")->npedraw=SBNpedraw->text().toInt();
  sets->getPedRunDescriptor("default")->tbad=SBTbad->text().toFloat();
  sets->getCalProfRunDescriptor("default")->latstart=SBLatStart->text().toInt();
  sets->getCalProfRunDescriptor("deconv")->latstart=SBLatStart->text().toInt();
  sets->getLatRunDescriptor("default")->latstart=SBLatStart->text().toInt();
  sets->getLatRunDescriptor("default")->latend=SBLatEnd->text().toInt();
  sets->getLatRunDescriptor("deconv")->latstart=SBLatStart->text().toInt();
  sets->getLatRunDescriptor("deconv")->latend=SBLatEnd->text().toInt();
  sets->getCalRunDescriptor("default")->lat=SBLatStart->text().toInt();
  sets->getCalRunDescriptor("deconv")->lat=SBLatStart->text().toInt();
  sets->getBPlaneRunDescriptor("default")->lat=SBLatStart->text().toInt();
  sets->getBPlaneRunDescriptor("deconv")->lat=SBLatStart->text().toInt();
  sets->getPedRunDescriptor("default")->lat=SBLatStart->text().toInt();
  sets->getPedRunDescriptor("default")->modped=SBAlgo->text().toInt();
  sets->getCalProfRunDescriptor("default")->latend=SBLatEnd->text().toInt(); 
  sets->getCalProfRunDescriptor("default")->nevpoint=SBNscan->text().toInt(); 
  sets->getCalProfRunDescriptor("deconv")->latend=SBLatEnd->text().toInt(); 
  sets->getCalProfRunDescriptor("deconv")->nevpoint=SBNscan->text().toInt(); 
  sets->getCalRunDescriptor("default")->nevpoint=SBNscan->text().toInt();
  sets->getCalRunDescriptor("deconv")->nevpoint=SBNscan->text().toInt();
  sets->getBPlaneRunDescriptor("default")->nevpoint=SBNscan->text().toInt();
  sets->getBPlaneRunDescriptor("deconv")->nevpoint=SBNscan->text().toInt();
  sets->getLatRunDescriptor("default")->nevpoint=SBNscan->text().toInt();
  sets->getLatRunDescriptor("deconv")->nevpoint=SBNscan->text().toInt();
  sets->getLedRunDescriptor("default")->nevpoint=SBNscan->text().toInt();
  // this has to be a methode of the ModuleTestSetup
  std::vector<Module*> themodules=thetestsetup->getModules();
 for(std::vector<Module*>::iterator imod=themodules.begin();imod!=themodules.end();imod++)
  (*imod)->Settings(sets);

 QString s;
 s.sprintf(" Time:%d Applyed Run settings ",thetestsetup->getCTime());
 fMi->StatusBox->insertItem(s);
 fMi->StatusBox->ensureCurrentVisible ();
  }
 }
