#include "muxctrlimpl.h"
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlcdnumber.h>
#include "MuxCtrl.h"
MuxCtrlImpl::MuxCtrlImpl( QWidget* parent ,  const char* name , WFlags fl  ):
  MuxCtrlUi( parent,  name ){

  fMuxCtrl=0;

}

MuxCtrlImpl::~MuxCtrlImpl(){}

void MuxCtrlImpl::setMuxCtrl( MuxCtrl* muxctrl,bool standalone ){
  if(muxctrl){
    fMuxCtrl=muxctrl;
    //PBActiveCh->setEnabled(true);
    //SBSetChannel->setEnabled(true);
    PBGetGroupNr->setEnabled(true);
    SBSetGroupNr->setEnabled(true);
    PBNextGroup->setEnabled(true);
    SBMuxDev->setValue(fMuxCtrl->getNrMuxCtrlDev()-1);
    SBSetDevGroupNr->setEnabled(true);
    if(standalone) {
      SBRegisterGroup->setEnabled(true);
      PBAcceptGroupNr->setEnabled(true);
    }
    else {
      SBRegisterGroup->hide();
      PBAcceptGroupNr->hide();
    }
  }
}

void MuxCtrlImpl::registerGroupNr(){
  fMuxCtrl->registerGroup((int)SBRegisterGroup->value());
}

void  MuxCtrlImpl::writeMuxCtrlDisplay( ){
  getActiveGroup() ;
}

void  MuxCtrlImpl::getActiveGroup(){
  int actgroup=fMuxCtrl->getActiveGroup();
  LCDActGroup->display(actgroup);
  
}

void MuxCtrlImpl::setNextGroup(){
  int actgroup=-2;
  if( !fMuxCtrl->lastGroupNotReached()){ 
    actgroup=fMuxCtrl->getFirstGroup();
  }
  else {
    actgroup=fMuxCtrl->getNextActiveGroup();
  }
  getActiveGroup();
}

void MuxCtrlImpl::setGroupNr(int i){
  if(fMuxCtrl->setActiveGroup(i)){
    getActiveGroup();
     SBSetGroupNr->setPaletteBackgroundColor( QColor( 0, 255,0 ) );
  }
  else{
    SBSetGroupNr->setPaletteBackgroundColor( QColor( 255, 0, 0 ));
  }
}

void MuxCtrlImpl::setDevGroupNr(int i){
  if(fMuxCtrl->setActiveDevGroup(i)){
     SBSetDevGroupNr->setPaletteBackgroundColor(QColor(0,255,0));
  }
  else{
    SBSetDevGroupNr->setPaletteBackgroundColor(QColor(255,0,0));
  }
}

void MuxCtrlImpl::setChannelNr(int){
  qDebug("setChannelNr Not Implemented ");

}

void MuxCtrlImpl::getActiveChannel(){
qDebug("setChannelNr Not Implemented ");

}
