#include "tempctrlimpl.h"
#include <qspinbox.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include "tempctrlinterface.h"
TempCtrlImpl::TempCtrlImpl(QWidget* parent , const char* name , WFlags fl ):
  TempCtrlUi(parent){
  fTci=0;
  SBTempSet->setEnabled(false);
  CbUpdate->setEnabled(false);
  CbControl->setEnabled(false);
  CbUpdate->setEnabled(false);
}


void TempCtrlImpl::setTempCtrl( TempCtrlInterface* cbp) {
  fTci=cbp;
  SBTempSet->setEnabled(true);
  CbUpdate->setEnabled(true);
  CbControl->setEnabled(true);
  CbUpdate->setEnabled(true);
}

void TempCtrlImpl::CbCtrlPressed(){
 
    fTci->control();
}

void TempCtrlImpl::setPower(int i){
   fTci->setPower( i);
}

void TempCtrlImpl::CbSetTemp(){
  fTci->setTargetTemperature(SBTempSet->value());
}

void TempCtrlImpl::CbUpdatePressed(){
  LCDTemp->display(fTci->getActualTemperature());
  LCDWaterTemp->display(fTci->getWaterTemperature());
  LCDHotSideTemp->display(fTci->getHotSideTemperature());
  LCDPower->display(fTci->getActualPower());
  SBTempSet->setValue((int) fTci->getTargetTemperature());
  LECtrlStatus->setText(QString(fTci->ctrlStatusString().c_str()));
}



