#include "DaqSettingsImpl.h"
#include "daqerrormsg.h" 
#include <qapplication.h>
#include "ltparser.h"
#include "setparser.h"
#include "DaqCtrl.h"

#include "iostream"

using namespace std;
LtParser *ltparser=0;

/** \brief      
      main programm
         
     \author W. Beaumont
     \version 1.0 
     \date 20030715
*/

int main(int argc, char **argv)
{  
  //init parser
  ltparser=new LtParser();
  string ltfile;
  if( argc > 1) { 
    ltfile=argv[1];
    ltparser->setParseFileName(ltfile);
  }
  DT_DEBUG_LTAPPL("Procedure: parse "<< ltfile.c_str());
  ltparser->parseFile();
  SetParser* sp =new SetParser();
  char filename[80];
  sp->parseFile(ltparser->getStandardConfigFile(filename,"settings.xml"));
  DaqCtrl* dc =new DaqCtrl(sp);
  // create Qt application
  QApplication a( argc, argv );
  // create main GUI
  DaqSettingsImpl* guiappl=new DaqSettingsImpl(0,"DaqCtrlTest");
  guiappl->setDaqCtrl(dc);
  a.setMainWidget(guiappl);
  guiappl->show();
  // run qt application
  int result=a.exec();
  delete guiappl;
  delete dc;
  delete sp;
  delete ltparser;
  return result;
}
