#ifndef MODID__
#define MODID__

#include <string>
#include "dcuinfo.h"
/** \class ModID
    \brief holds the information of a module like nr apv's type etc.
    
    \authors: W.Beaumont 
    \date 20021111
    \version 0.1
     \authors: W.Beaumont 
    \date 20030725
    \version 1.1  
    make members protected instead of private so they can be filled afterwards.
*/



class ModId : public DcuInfo {
  
 public:

typedef std::string  ModType;

  /** constructor
      @param modid a string what is the mod id nr. 
      @param nrapv the number of apv's at the module 4 or 6
      @param mod type the type of the module has to
        be a string of the type 1.1.1.1
      @param dcuid the dcu id 
      @param checkdcu for pre production 
       if this is false the dcu number will not read out 
      @param  posnr  the bench position nr
      @param opreator a string that will be filled into the data base
  */
  ModId(const char* modid, 
	int nrapv, const char* modtype,int posnr, 
	unsigned int dcuid , 
	bool checkdcu ,
	const char* oper,const char* center );
  ModId();
  /** return true if it is a valid module Id 
     child classes have to take care of setting this correctly!
   */
  bool ValidId(){return fValidId;} 
  std::string getModId(){return fModId;}
  int getBenchPosition(){return fBenchPos;}
  bool checkDcuId(){return fCheckDcu;}
  int getNrApvs(){return fNrApv;}
  std::string getModuleType(){ return fType;}
  std::string getOperator() { return fOperator; }
  std::string getTestCenter() { return fcenter; }
 
 protected:
  std::string   fModId;
  std::string fOperator;
  std::string fcenter;
  ModType fType;
  int fNrApv;
  int fBenchPos;
  bool fCheckDcu; 
  bool fValidId;
   /** routine to check a valid module Id
       also sets the fValidId member  
    */
   bool isValid();
};


#endif
