#ifndef _ModuleDescriptor_h_
#define _ModuleDescriptor_h_

//#include "fedprocessctrlinterface.h" 

/** \file ModuleDescrtiptor.h
    \brief    Descriptor structures define seetings
               of APV tests.
              
     \author V.Zhukov ,UIA 
     \version 2.2 
     \date 09/2003
 
*/

class ModuleDescriptor {
 public:
ModuleDescriptor() {;}
};
    
class I2cDescriptor: public ModuleDescriptor {
public:
  short fStatus;
  short fAddress;
  short fMode;
  short fLatency;
  short fMuxgain;
  short fIpre;
  short fIpcasc;
  short fIpsf;
  short fIsha;
  short fIssf;
  short fIpsp;
  short fImuxin;
  short fIcal;
  short fVfp;
  short fVfs;
  short fVpsp;
  short fCdrv;
  short fCsel;    
  short fAddressmux;
  short fResistormux;
  short fInitpll;  
  short fAddresspll;
  short fLatencypll;
};


class PedRunDescriptor: public ModuleDescriptor {
public:
  int nped;
  int npedraw;
  int modped;
  float tskip;
  float tbad;
  float rmsmax;
  float rmsmin;
  int pedmax;
  int pedmin;
  float pskip;
  int modcmn;
  int nstrcmn;
  int ncmniter;
  int lat;

 float rmsmin1;
 float rmsmin2;
 float rmsmin3;
 float rmsmax2;
 float rmsmax3;
 float rmsmax4;

};

class CalProfRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int latstart;
  int latend;
  int calamp;
  float tbad; 
  int timeskip;
  int drvskip;
  bool pedestalskip;
  
  float calPAmin1;
  float calPAmax1;

  float calTPmin1;
  float calTPmin2;
  float calTPmin3;
  float calTPmax2;
  float calTPmax3;
  float calTPmax4;


};

class CalRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int lat;
  int calamp;
  float tbad; 

  float calAmin1;
  float calAmax1;

};

class LightRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int lat;
  int calamp;
  float tbad; 
  float alight;

  float  calLightmin1;
  float  calLightmax1;

};

class FbRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int lat;
  int calamp;
  float tbad; 
  float vfb;

  float  calFbmin1;
  float  calFbmax1;

};


class BPlaneRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int lat;
  int tsclat;
  int calamp;
  float tbad; 

 float calBpmin1;
 float calBpmax1;

};

class LedRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int lat;
  int calamp;
  int group;
  float tbad; 

  //reserved  for laser control movement 
  int startX;
  int startY;
  int stopX;
  int stopY;
};

class LatRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoint;
  int latstart;
  int latend;
  float tbad;

};

class AuxChipRunDescriptor: public ModuleDescriptor  {
public:
  int nevpoints;
};


class SensorDescriptor: public ModuleDescriptor {
public:
  float vmax;
  float hvrumpup;
  float hvrumpdwn;
  float imax;
  float imaxhw;
  float vstartiv;
  float vendiv;
  int npointsiv;
  int dtvset;
  int dtiv;
  int dimax;
  int npointsi;
  float dv;
  float vtest1;
  float vtest2;
  float vtest3;
  float imax1;
  float imax2;
  float imax3;



};
class ConnectivityRunDescriptor: public ModuleDescriptor {
public:
  int   nevpoints;
  float noisedifference;
  float currentdifference;
  float lowtestvoltage;
  float hightestvoltage;
  short apvaddr[7];
  short fMode;/// apv mode for the tests 
  short fVfp;///test level 
  short displacement;///displacement in ADC counts 

};


 
#endif
