#ifndef XERCESEXT_1
#define XERCESEXT_1 

#include "stringtools.h"
class DOM_NamedNodeMap;
class DOMString;
class DOM_Node;
namespace XercesExt {

 
template <typename T> 
bool getItem( T& s,const char * itemname,
	      DOM_NamedNodeMap& attributes,const T& alt){
  bool found= getItem( s,itemname,attributes);
  if (!found) { s=alt;}
  return found;
}

  bool getItem( std::string& s,const char * itemname,
		DOM_NamedNodeMap& attributes);
  bool getItem(  char* c,const char * itemname,
		 DOM_NamedNodeMap& attributes);

  bool getItem( int& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem( unsigned short& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem( short& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem( unsigned int& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem( long& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem(bool& i,const char * itemname,
	       DOM_NamedNodeMap& attributes);


  bool getItem( float& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  bool getItem( double& i,const char * itemname,
		DOM_NamedNodeMap& attributes);

  /** set the item of a node
      @param i the interger value that should be set 
      @param attribute  the DOM node map where the item should be set
      @param itemname the item name 
      @param create if the item has to be created if it doesn't exist
      @param ow  should the item overwritten if exist 
      @param create always create the item always (not tested )
      @param format the format what should be used not in use
      @return true if the item already exist.
  */
template<typename  T> bool  setItem(
  const T value ,
  const char * itemname, DOM_Node& ei,
  bool create=true, bool ow=true,
  bool createalways=false,
  const char* format=0)
{
  bool found =false;
  bool setnewvalue=false; 
  DOM_NamedNodeMap a = ei.getAttributes();
  DOM_Node e = a.getNamedItem(itemname);
  if(!e.isNull()) {found=true;}
  if(!e.isNull()  && ow){ setnewvalue=true; }
  if(e.isNull() && create || createalways){
    e=ei.getOwnerDocument().createAttribute(itemname);
    a.setNamedItem(e);
    setnewvalue=true ;
  }
  if(setnewvalue) {
    DOMString ds;
    //std::string s="\"";
    std::string strvalue=BasicTypeToStr(value);
    //s+=strvalue;
    //s+="\"";
    ds=strvalue.c_str();
    //cout <<"domstring "<<ds<<endl;
    e.setNodeValue (ds);
  }
  return found;
}



};



#endif 
