#ifndef _AuxChipRun_H
#define _AuxChipRun_H

#include <vector>
#include "TestBase.h"

/**  
\brief Hydrid chips generic test (APV,PLL,DCU,MUX)

    \author W. Beaumont  UA
     \version 0.2 
     \date 09/2003
 
*/ 
class Module; 
class HybridI2C;
class DaqCtrl;
class RecModule;

class AuxChipRunDescriptor;  

class AuxChipRun: public TestBase  { 

  enum runstatus{AUXSTART,AUXINIT,AUXI2C,AUXMUX,DCUCHECK,AUXDONE};

public:
AuxChipRun(Module* m);
~AuxChipRun();

void InitTest(SetParser* s);
virtual bool Update(int nev);
void FillRecord();
void Abort() {done=true;}
bool isDone()  {return done;}


private:
/** scans the i2c addresses 
    @return true  in case of error 
*/
 bool scanI2c();
 bool muxRangeCheck();
 bool dcuCheck();
HybridI2C* thei2c;
Analysis theapvanals;
Feds thefeds;
RecModule* therec;
AuxChipRunDescriptor*  sets;
vector <unsigned int> erraddr;
 Module* themodule;

int Nev;
int Ncalev;
int Napvs;
short prevmode;
bool done;
float Tbad;
 DaqCtrl* thedaqctrl;
 runstatus runstat; 
};

#endif 




