#ifndef _BPlaneRun_H
#define _BPlaneRun_H

#include <vector>
#include <valarray>
#include <iostream.h>
#include <stdio.h>
#include <TH1.h>
#include <TProfile.h>
#include "TestBase.h"

/**  
\brief Back plane Pulsing Run for the TestProcedure

 <p>
          Calculate cal(i)-ped(i)  for each channel and fill histo.
           Uses TSC pulser as a calibration signal delivered to the 
          sensors biasing line.         
          Uses already created in Module  objects; feds, analysis,record, i2c
          InitTest-define settings, 
          Update-acquires data and stops at the end
          FillRecord-fill results into Record 


     \author V.Zhukov,UIA   
     \version 2.2 
     \date 09/2003
 
*/
class Module;
class HybridI2C;
class RecModule;
class BPlaneRunDescriptor;  

class BPlaneRun: public TestBase  { 

public:
BPlaneRun(Module* m);
~BPlaneRun();

void InitTest(SetParser* s);
virtual bool Update(int nev);
void FillRecord();
void Abort() {done=true;}
bool isDone()  {return done;}


private:

HybridI2C* thei2c;
Analysis theapvanals;
Feds thefeds;
RecModule* therec;
BPlaneRunDescriptor*  bpsets;

int Nev;
int Ncalev;
int Napvs;
short prevmode;
bool done;
float Tbad;

};

#endif 




