#ifndef _CalRun_H
#define _CalRun_H

#include <vector>
#include <valarray>
#include <iostream.h>
#include <stdio.h>


#include <TH1.h>
#include "TestBase.h"


/** \brief Calibration Run for TestProcedure

     \author V.Zhukov,UIA   
     \version 2.0 
     \date 2003/02
 
*/

class Module;
class HybridI2C;
class RecModule;
class CalRunDescriptor;


class CalRun : public TestBase  { 

public:
CalRun(Module* m);
~CalRun();

void InitTest(SetParser* s);
bool Update(int nev);
void FillRecord();
void Abort() {done=true;}
bool isDone()  {return done;}

private:
HybridI2C* thei2c;
Analysis theapvanals;
Feds thefeds;
RecModule* therec;
CalRunDescriptor* calsets;

int Nev;
int Ncalev;
int Ntot;
int Napvs;
short prevmode;
short drv;
bool done;
float Tbad;
double fCorr[NAPV*NAPVCH][1000];
};

#endif 




