#ifndef CONNECTIVITYRUN_H
#define CONNECTIVITYRUN_H
//
#include "TestBase.h"
#include "HybridI2C.h"
#include "ModuleHv.h"
#include "ApvReadoutCtrl.h"
#include <vector>

/**  
  \connections test procedures


   \class ConnectivityRun
   \authors: V.Hovhannisyan,UIA,V.Z.
   \date 02/2003
   \version 2.1

*/
class Module;
class RecModule;
class ConnectivityRunDescriptor;

class ConnectivityRun : public TestBase {

 public:

ConnectivityRun(Module* m);
~ConnectivityRun();
  void InitTest(SetParser* s); 
  bool Update(int nevinspill);
  void FillRecord();
  void Abort() { done=true; }
  bool isDone() { return done; }

 private:

std::vector<double> pedestalStatus(int nevinspill);
void setModeAddress(short mode,short addr,short vpsp);
bool hvConnectionTest(int nevinspill);
std::vector<bool>  apvConnectionsTest(int nevinspill);

  int nmod,napv,nped;
  short prevmode;
  short apvtestmode;
  short apv_com_addr;
  short* apvaddr;
  std::vector<bool> result0;
  bool done;
  ModuleHv* hv;
  RecModule* recmod;
  HybridI2C* di2c;
  Feds thefeds;
  Analysis theapvanals;
  SetParser* setp;
  ApvReadoutCtrl* apvctrl;
  ConnectivityRunDescriptor* consets;
};

#endif






 
 
