#ifndef DAQCTRL__
#define DAQCTRL__
#include "MuxCtrl.h"
#include "ApvReadoutCtrl.h"
#include "interlock.h"
#include "LightCtrl.h"
#include "FBCtrl.h"

/** \class  DaqCtrl 
    \author W.Beaumont,
    \date Oct  2002
    \version 1.0

    \brief gloabal control function readout process controll
    is an class that combines the control of the devices that influence the 
    readout it inherits the control from 
    - apvreadoutctrl : enabeling triggers ,
                       sending resets , enabling cal sequence
                       fed :  check for new spill (blocking the buffer)
                       enabling / disabling  external calibration 
    - muxctrl : sets the active karlsruhe mux channel and report on it
    - 
    This class is written special for the module test application
    
    This class is not " stable" in this sense that the interfaces can be changed if this
    is required for the module test application. 
    The FEC control is not implemented so 
    
*/


class DaqCtrl: public ApvReadoutCtrl ,public MuxCtrl,public InterLock, public LightCtrl, public FBCtrl {
/** constructor 
 */
 public:
  DaqCtrl(SetParser* thesettings):ApvReadoutCtrl(thesettings,0,0){}
  ~DaqCtrl(){}
};


#endif 
