#ifndef FBCTRL__
#define FBCTRL__
#include "pmap.h"



/** \class  FBCtrl 
    \author W.Beaumont,
    \date Feb   2002
    \version 1.0

    \brief Forward bias ctrl for ModuleTest


    This class provides the interface of the setting of the Forward bias 
    control. To set the light intensity.
    The FBCtrl instatiates a number of forward ctrlcards depending 
    on the xml file (if the forward  control is not defined in 
    the xml file a dummy card is created
    The version 1.0 only supports the io ctrl 
    Each card is indentified by an ID obtaind by its 
    "coodinates"  (device it is connected to, sub device etc. 
    
*/

class  FBCardInterface;


class FBCtrl {

 private:

  /// the list of the information about the devices
  //vector < MuxExchange*> thedev ;
  /// the list of connected mux devices
  pmap <int , FBCardInterface*> fFBCard;
  
 public:

  FBCtrl();
  ~FBCtrl();
  /** set the light level to level for all led cars.
      returns the level returned by the LAST card (for the moment)
  */
  float setCurrentLevel(float level);
  /** set the light level to level for the card with ledcardid
   */
  float setCurrentLevel(float level,int fbcardid);
   /** set the light level to level for the card with ledcardid
       for the given channel
   */
  float setCurrentLevel(float level,int fbcardid, int channel);

};
#endif 
