#ifndef FEDCTRL
#define FEDCTRL
#include "pmap.h"

class LtParser;
class FedProcessCtrlInterface;
/** class to contol more then one FED. 
    This class takes care that the commands for the 
    "normal FedProcess objects are executed for all defined FED's
    This version is just for one FED to test compatiblity with the APVCTRL 
*/ 


class FedCtrl {
 public:
  class  FedCtrlInfo{
    friend class FedCtrl;
  public:
    FedCtrlInfo(FedProcessCtrlInterface* fpc){
      fFedpc=fpc;
      thresholdlow=0;
      thresholdhigh=0;
      feddelay=0;     
    }
    ~FedCtrlInfo();
    
  protected:
    FedProcessCtrlInterface* fFedpc;
    int thresholdlow;
    int thresholdhigh;
    int feddelay;     
  };

 public:
  FedCtrl( LtParser* ltparser);
  ~FedCtrl();
  bool clearFed(int fednr=-1) ;
  bool stopFedDaqLoop(int fednr=-1);
  void setSpillSize(int spillsize);
  void NextSpill(int fednr=-1);
  int getNumberOfEvents(int fednr=-1); 
  /** check for the new spill status 
      @param fednr all feds if fednr=-1 only for the fed given
      @param skip not in use for the moment 
      @return the and of all fed new spill status
  */
  bool NewSpill(int fednr=-1,int skip=-1);
  bool isInitialized (){return fInitialized;}
  /** sets the threshold for the feds 
      only for the last  fed the low and high are returned
      @param fednr all feds if fednr=-1 only for the fed given
      @return the and of all fed adjust threshold status
  */  
  void getThreshold(int & low, int& high,int fednr);

 bool  AdjustThresholds(int & low, int& high,int fednr=-1);
 /** sets the threshold for the feds 
     @param fednr all feds if fednr=-1 only for the fed given
     @return the and of all  adjust threshold status 
  */  
 bool  AdjustThresholds(int fednr=-1);
 /** set the fed sample time (delay) for the feds 
     @delay ,only the last  fed sample time is returned
     @param fednr all feds if fednr=-1 only for the fed given
     @return the and of all  adjust threshold status 
  */ 
 bool  TuneFedSampleTime(int & delay,int fednr=-1);
 /** set the fed in scope mode if mode > 0  */
 void setScopeMode(int mode,int fednr=-1);
 FedProcessCtrlInterface* getFedProcessCtrl(int fednr);
 private:
  bool fInitialized;
  pmap<int, FedCtrlInfo*> ffeds;
  pmap<int, FedCtrlInfo*>::const_iterator fi;
};

#endif
