#ifndef _IVRun_H
#define _IVRun_H


#include <vector>
#include <valarray>
#include <iostream.h>
#include <stdio.h>
#include <qdatetime.h> 
#include "TestBase.h"


/** 
\brief IVrun  for the TestProcedure

<p>
          Measures the  IV curve and fill into record
          Default settings in the settings.xml can be modified from settings menu.    
          Uses already created in Module  objects; moduleHv, Record 
          InitTest-define settings, 
          Update-acquires data and stops at the end
          FillRecord-fill results into Record 


     \author V.Zhukov,UIA   
     \version 2.1
     \date 02/2003
 
*/
class Module;
class RecModule;
class ModuleHv;
class SensorDescriptor;

class IVRun: public TestBase {

 public:
IVRun(Module* m);
~IVRun();


void InitTest(SetParser* s);
bool Update(int n);
void FillRecord();
void Abort() {done=true;}
bool isDone()  {return done;}

 private:
RecModule* therec;
ModuleHv* themodhv;
SensorDescriptor* sets;

 QDateTime  stime;
 int Np;
 int Npoints;
 int dt;
 float dv;
 float vend;
 float vmax;
 float imax;
 float Hv;
 float prevHv;
 bool done;

 void checkvtest();

};

#endif
