#ifndef _LedRun_H
#define _LedRun_H

#include <vector>
#include <valarray>
#include <iostream.h>
#include <stdio.h>

#include <TH1.h>
#include "TestBase.h"



/**
 \brief Led Run for the TestProcedure
<p>
          Calculate sig(i)-ped(i) for each channel and fill histo.
          Latency is defined in settings file or menu.
          By default reset is off.
          Uses already created in Module  objects; feds, analysis,record, i2c
          InitTest-define settings, 
          Update-acquires data and stops at the end
          FillRecord-fill results into Record 


     \author V.Zhukov,UIA   
     \version 2.0 
     \date 2003/02
 
*/
class Module;
class HybridI2C;
class RecModule;
class LedRunDescriptor;


class LedRun : public TestBase { 

public:
LedRun(Module* m );
~LedRun();


void InitTest(SetParser* s);
bool Update(int nev);
void FillRecord();
void Abort() { done=true;}
bool isDone()  {return done;}

private:

HybridI2C* thei2c;
Analysis theapvanals;
Feds thefeds;
RecModule* therec;
LedRunDescriptor* ledsets;
int Ncalev;
int Nev;
int Napvs;
short prevmode;
bool done;
};

#endif 




