#ifndef  _ModulHv_H
#define  _ModulHv_H

#include <iostream.h>


/** 
\brief   Module at bench position bench  HV control
  
     \author V.Zhukov,UIA  
     \version 2.0 
     \date 02/2003

*/

class RecModule;
class HvChannelLt;
class CurrentChannelLt;
class SetParser;

class ModuleHv {

public:
ModuleHv(int bench, RecModule* r);
~ModuleHv();

public:
bool  ChangeHV(float v,bool block=true);
float getCurrent(bool update = true );
void Settings(SetParser* sp);
HvChannelLt* getHvChannel() {return thehvch;}
CurrentChannelLt* getCurrentChannel() {return thecurch;} 
/** get the hv of the channel 
    @param update     if update is true th physical channel is requested     
    if update is false the last readout is returned. true by default. 
    `@return the voltage in volts (float)
*/
float   getVbias(bool update = true );
    
float   getSetVbias()  const {return theSetHv;}
float   getItest(float v);
/** checks if the hv  is reached  (taken in account the tolerance 
    @param waitforcheck if true the check is done theWait later (set by sensordescription)
 */
 bool  HvReached(bool waitforcheck=true);
  
private:

HvChannelLt* thehvch;
CurrentChannelLt* thecurch;
RecModule* therec;
SetParser* thesettings;
  //
  float theCurrent;
//! last readout hv 
  float theHv; 
  float theSetHv; 
  float theItest;
  int theBench;
  int theWait; 

  
};
#endif  // _MODULEHV

