#ifndef _PedestalRun_H
#define _PedestalRun_H

#include <vector>
#include <valarray>
#include  <TH1.h>

#include "TestBase.h"

/**
 \brief Pedestal Run for the TestProcedure.

<p>
          Calculates pedestal, rawnoise, noise, cmn, flag bad channels
          Default without reset, can be enabled  from settings menu
          Uses already created in Module  objects; feds, analysis,record, i2c
          InitTest-define settings, 
          Update-acquires data and stops at the end
          FillRecord-fill results into Record 
           
           
     \author V.Zhukov,UIA   
     \version 2.1
     \date 02/2003
 
*/
class Module;
class HybridI2C;
class RecModule;
class PedRunDescriptor;

class PedestalRun: public TestBase  { 

public:
PedestalRun(Module* m);
~PedestalRun();

void InitTest(SetParser* s);
bool Update(int nev);
void FillRecord();
void Abort() {done=true;}
bool isDone()  {return done;}


private:

HybridI2C* thei2c;
Analysis theapvanals;
Feds thefeds;
RecModule* therec;
PedRunDescriptor* ps;

int Napvs;
int Nev;
short prevmode;
int Npedrun;
bool done;


};

#endif 




