#ifndef _TestBase_H
#define _TestBase_H

#include <vector>
#include "LtDefs.h"

/** \brief Base test abstract interface for all tests


     \author V.Zhukov,UIA   
     \version 1.0 
     \date 2002 1/04
 
*/
class SetParser;
class Record;
class FedChannelLt;
class Spill_Analysis;


class TestBase { 
  protected :
    int    theTestResult;

public:
TestBase(){  theTestResult=0;}
virtual ~TestBase();
typedef std::vector<FedChannelLt*>  Feds;
typedef std::vector<Spill_Analysis*> Analysis; 

virtual int getTestResult(){return theTestResult;}
virtual void InitTest(SetParser* s)=0;
virtual bool Update(int n)=0;
virtual void FillRecord()=0;
virtual void Abort()=0;
virtual bool isDone()=0;
/** loads the data from the FED shared memory into the individual 
    analisys classes  
    @param f  the vector of fedchannels (apv's ) 
    @param a the vector of Analyisis classes 
    @param n the number of events to transfer 
*/
virtual void loadSpill(Feds f, Analysis  a, int n);


};

#endif 
