#ifndef _TestStatus_H
#define _TestStatus_H


#include <qstring.h>
#include <map>


/**  
  \brief   Status of the Module tests


   \class TestStatus
   \authors: V.Zhukov,UIA
   \date 25/05//2002
   \version 2.0

*/



class TestStatus {
 public:
TestStatus();
~TestStatus();


bool Find(const QString& s);
bool isRunning();
bool allDone();
bool isRunning(const QString& s);
bool isDone(const QString& s);
bool isAbort(const QString& s);
bool isAbort();
bool SetRun(const QString& s); 
bool SetAbort(const QString& s); 
bool Abort();
bool SetDone(const QString& s); 
bool SetDone(); 
bool getHasRun(const QString& s);
void Reset();
void Reset(const QString& s);
int  Ntest() {return theNtests;}
QString currentTest() {if(isRunning()) return currentrun;
                        else return "None";}

bool SetPause();
bool ResetPause() {bpause=false;return true;}
bool ResetScenario() {bscenario=false;bpause=false;bsaction=false;return true;}
bool SetScenario();
bool pauseOn() {return bpause;}
bool scenarioOn() {return bscenario;}
bool SetAction();
bool ResetAction() {bsaction=false; return true;}
bool actionOn() {return bsaction;}
bool apvctrlOn() {return bsetapvctrl;} 
bool SetApvctrl() { if(bsetapvctrl=true)  return false;
                     else {bsetapvctrl=true; return true;} } 
bool ResetApvctrl() {  if(bsetapvctrl==false) return false;
                        else { bsetapvctrl=false; return true;}  } 

bool isInit() {return binit;}
bool setInit() {binit=true;return true;}

 int getErrorStatus(const QString& s);
 bool  setErrorStatus(const QString& s, int i);

struct State {
   bool done;
   bool running;
   bool abort;
  bool hasrun;
  int errorstatus;
 };

private:
 std::map<const QString, State*> status;
 State* sinit;

 int  theNtests;
 QString currentrun;


bool bsaction;
bool bscenario;
bool bpause;
bool bsaveresult; 
bool bsetapvctrl;
bool binit;
};

#endif
