#include "AuxChipRun.h"
#include "Module.h"
#include "HybridI2C.h"
#include "ModuleDescriptor.h"
#include "RecModule.h"
#include "RecModHeader.h"
#include "RecAnalyzer.h"
#include "RecModTest.h"
#include "Spill_Analysis.h"
#include "setparser.h"
#include "daqerrormsg.h"
#include "apv25i2cchannellt.h"
#include "dcuchannellt.h"
using namespace std;


AuxChipRun::AuxChipRun(Module* m) {
 thefeds=m->feds();
 themodule=m;
 theapvanals=m->apvanalysis();
 thei2c=m->hybridi2c();
// version problem have to be checked 
// therec=m->getrecmod();
 thedaqctrl=m->getDaqCtrl();
  Napvs=m->getNrApvs();
 DT_DEBUG_LTAPPL("AuxChipRun ");
 runstat=AUXSTART;
}
/**/
AuxChipRun::~AuxChipRun() {
}
/**/
void AuxChipRun::InitTest(SetParser* s) {
  prevmode= thei2c->GetMode();
   sets=0; 
 
   //  sets=s->getAuxChipRunDescriptor("default");
  done=false;
  runstat=AUXINIT;
}


bool AuxChipRun::Update(int nevinspill) {
  bool errstat=false ;
  if(done) {thei2c->SetMode(prevmode); return true;}
  switch(runstat) {
    case AUXSTART : {
      // something went wrong exit with error flag
      done=true;
      return  false ;
    }
    break;
    case AUXINIT: { 
      runstat =AUXI2C;
     
    }
     // no break can start with AUXI2C 
    case AUXI2C : { 
      if( scanI2c()){ done =true ;  errstat=true ;}
      else { 
	runstat = AUXMUX; 
	// take the change to abort the run 
	errstat=false;
      }
    }
    break;
    if( muxRangeCheck()){ done =true ;  errstat=true ;}
    else { 
      runstat = DCUCHECK; 
      // take the change to abort the run 
     errstat=false;
    }
    break;
    if( dcuCheck()){ done =true ;  errstat=true ;}
    else { 
      runstat = AUXDONE; 
      // take the change to abort the run 
     errstat=false;
    }
    break;
    case  AUXDONE :

      // nothing to do leave switch statement to finialize the run 
      break;
    default: 
      // should never come to here 
      done=true; errstat=true  ;
  }
  
  if(done)   { thei2c->SetMode(prevmode); }
  return !errstat; // should return true if o.k. 

}
/**/
void AuxChipRun::FillRecord() {
  thei2c->SetMode(prevmode);
 
  // therec->getrecanalyzer()->AnalyzeAuxChip(thei2c->CheckMode(prevmode),sets); 
}



bool AuxChipRun::scanI2c(){
  Apv25I2cChannelLt* apvi2c=thei2c->apvi2c();
  // should comee from desrcriptor 
  unsigned int dcuaddr=0;unsigned int apvaddr=32,muxaddr=67,plladdr=68;
  unsigned int apvprc=63;
  erraddr.clear();
  unsigned int addr;
  int waitres; bool errresp;
  for( addr=0 ; addr < 128;addr++) {
    apvi2c->lock();
    apvi2c->setMode(0); 
    apvi2c->setAddress(addr);
    //apvi2c->update();
    apvi2c->unlock(); 
    apvi2c->justDoIt();
    waitres=apvi2c->wait();
    //cout << "addr "<< addr<<" waitres "<<waitres<<"nr errors" << erraddr.size()<<endl;
    if( (dcuaddr <= addr) && (addr < dcuaddr+8) ) {
      if(  (errresp =(bool) waitres) ){
	erraddr.push_back(addr);
      }
      continue;
    }
    if ( apvprc==addr || 
	 ((apvaddr <= addr)  && (addr < apvaddr+6)) 
    ){
      if( (addr == apvaddr+2 || addr == apvaddr+3 ) 
	  &&  Napvs==4
      ) {    
	errresp= ! waitres  ;
      }
      else { errresp= (bool) waitres;}	    
      if(errresp) { erraddr.push_back(addr);}
      continue;
    }
    if( addr == muxaddr) {
      if( (errresp= (bool) waitres) ){
	erraddr.push_back(addr);
      }
      continue;
    }
    if(( plladdr <= addr) && (addr< plladdr+4)) {
      if( (errresp= (bool) waitres) ){
	erraddr.push_back(addr);
      }
      continue;
    }
    if( (errresp =! waitres) ){
      erraddr.push_back(addr);
    }       
  }

// provisonal debug code :
  if( erraddr.size() ){
    for ( addr=0; addr<erraddr.size();addr++) {
      cout <<"error on i2c address " << erraddr[addr] <<endl;
    }
  }
  
  thei2c->SetI2C(thei2c->lasti2c());

    return (bool) erraddr.size() ;
  
}


bool AuxChipRun::muxRangeCheck(){
  int muxresval= thei2c->lasti2c()->fResistormux;
  // has to come from auxdes
  int rmux[2];
  rmux[0]= 255;
  rmux[1] = 193;


  int lowth[2],highth[2];
  I2cDescriptor i2cset(*(thei2c->lasti2c()));
  for( unsigned int lc=0;lc<2;lc++) {
    i2cset.fResistormux=rmux[lc];
    thei2c->setMux(&i2cset);
    thedaqctrl->AdjustFedThresholds( lowth[lc], highth[lc]);
    lowth[lc]=highth[lc]-lowth[lc];
  }
  int diff = lowth[1]-lowth[0];
  cout << "diff1: "<< lowth[0]<<" diff2:"<<lowth[1]<<" diff in thershold = "<< diff;
  
  i2cset.fResistormux= muxresval;
  thei2c->setMux(&i2cset);
  
  return  (diff <  10);
  
}


bool AuxChipRun::dcuCheck(){
  bool dcuidcheck=true;
  if(dcuidcheck) {
    unsigned int  dcuid=thei2c->dcui2c()->getDcuHardId();
    return !( themodule->getDcuId() == dcuid) ;
  }
  return false;

}
