#include "BPlaneRun.h"
#include "Module.h"
#include  "HybridI2C.h"
#include  "ModuleDescriptor.h"
#include "RecModule.h"
#include "RecModHeader.h"
#include "RecAnalyzer.h"
#include "RecModTest.h"
#include "Spill_Analysis.h"
#include "setparser.h"
#include "daqerrormsg.h"

using namespace std;


BPlaneRun::BPlaneRun(Module* m) {
 thefeds=m->feds();
 theapvanals=m->apvanalysis();
 thei2c=m->hybridi2c();
 therec=m->getrecmod();
 Napvs=thefeds.size();

 DT_DEBUG_LTAPPL(" created bplanerun ");
}
/**/
BPlaneRun::~BPlaneRun() {
}
/**/
void BPlaneRun::InitTest(SetParser* s) {
  prevmode= thei2c->GetMode();
   bpsets=0; 
  if (thei2c->CheckDecMode(prevmode))
    {   bpsets=s->getBPlaneRunDescriptor("deconv");}
  else
    {   bpsets=s->getBPlaneRunDescriptor("peak");}
  Ncalev=bpsets->nevpoint;
  Ncalev=bpsets->nevpoint;
  Tbad=bpsets->tbad;
  thei2c->UnsetCalMode(prevmode);
   int cm=int( thei2c->GetMode());
   therec->getmodtest()->setapvmbp(cm);
  thei2c->SetLatency(bpsets->lat);
  Nev=0;
 done=false;
 therec->getmodtest()->ResetBp();
}
/*
 */

bool BPlaneRun::Update(int nevinspill) {

  if(done) {thei2c->SetMode(prevmode); return true;}
  loadSpill(thefeds,theapvanals, nevinspill);
  int nbadev=0;
  for(int iev =0; iev < nevinspill; iev++)  {
    Nev++;  
      DT_DEBUG_LTAPPL(" BPlane Update  Nev "<<Nev);
    if(Nev>=Ncalev || Nev>999) { DT_DEBUG_LTAPPL(" too many events"); continue;}
     for (int ich=0;ich<Napvs;ich++) {        
              theapvanals[ich]->loadEvent(iev);          
              if (theapvanals[ich]->FindFrame()) {
                
                  theapvanals[ich]->SubtractPed();
         
                      valarray<double> sig=*(theapvanals[ich]->getSignal()); 
    
                 for (int is=0;is<NAPVCH;is++)
                    {
		      //   cout<<" "<<is<<" "<<ich*NAPVCH+is<<" "<<sig[is]<<endl;
                   therec->getmodtest()->TPbp()->Fill(ich*NAPVCH+is,sig[is]);
                    }                                    
	      }  else {DT_WARN("BPlane:Update Cannot find frame ");nbadev++;}
            }
        } 
  if(Nev>= Ncalev) { 
      DT_DEBUG_LTAPPL("BPlaneRun is done");
	    thei2c->SetMode(prevmode); done=true; return true; 
  }    
	  return true;
}
/**/
void BPlaneRun::FillRecord() {
  thei2c->SetMode(prevmode);
 DT_DEBUG_LTAPPL("BPlaneRun fillrecord ");
  TProfile* pbp=therec->getmodtest()->TPbp();
  TH1D* proj=pbp->ProjectionX();
  therec->getmodtest()->setTHcalSbackpl((TH1F*) proj); 
  therec->getrecanalyzer()->AnalyzeBP(thei2c->CheckMode(prevmode),bpsets); 
}


