#include "ltparser.h"
#include "FBCtrl.h" 
#include "fbcardinterface.h"
#include "fbcarddummy.h"
#include  "daqerrormsg.h"
#include "i2cid.h"
extern LtParser* ltparser;  


FBCtrl::FBCtrl( )   {
  int fbnr =  ltparser->getNrFBCards();
  /*  FBcard id should come from lt parser for the moment only one 
      with device nr 0 filles in by lt.dtd , 
  */
  if (fbnr !=0) {
   // for the moment only on card with device 0 is supported 
    fFBCard[0]=ltparser->getFBCard(0); // this creates the device
    if (fFBCard[0] == 0) {
      DAQEXIT(" led card wrongly defined ");
    }
  }
  else { 
    fFBCard[0]= new FBCardDummy();
    DT_WARN("No Forward bais  Device defined");  
  }
}

float FBCtrl::setCurrentLevel(float level){
  float retlevel;
  for (pmap <int , FBCardInterface*>::const_iterator pt=fFBCard.begin();
       pt!= fFBCard.end(); pt++){
    retlevel=pt->second->setCurrentLevel(level);
  }
  return retlevel;
}
float FBCtrl::setCurrentLevel(float level,int fbcardid){
  float retlevel;
  if( fFBCard.find(fbcardid) != fFBCard.end()){
    retlevel=fFBCard[fbcardid]->setCurrentLevel(level);
  }
  return retlevel;
}
float FBCtrl::setCurrentLevel(float level,int fbcardid, int channel){
   float retlevel;
  if( fFBCard.find(fbcardid) != fFBCard.end()){
     retlevel=fFBCard[fbcardid]->setCurrentLevel(level,channel);
  }
  return retlevel;
}
FBCtrl::~FBCtrl(){
  fFBCard.clearpointermap();
 
}
