#include "HybridI2C.h"
#include "daqerrormsg.h"
#include "apv25i2cchannellt.h"
#include "plli2cchannellt.h"
#include "muxi2cchannellt.h"
#include "dcuchannellt.h"
#include "optoi2cchannellt.h"
#include "ModuleDescriptor.h"

HybridI2C::HybridI2C(int bench,DaqCtrl* ctrl) { 
  thedaqctrl=ctrl;
  thei2cset=0;
  fBench=bench;
  fBench=0;
  fNrapverr=0;
  fNrmuxerr=0;
  fNrdcuerr=0;
  fNrpllerr=0;
  fNrllderr=0;
DT_DEBUG_LTAPPL("start i2c attach");
theapvi2c = new Apv25I2cChannelLt(bench);
 if (!theapvi2c->isInitialized()){ DT_WARN(" apvi2c  channel is not init");
 }
 theapvi2c->setReadOnly(false);
 DT_DEBUG_LTAPPL("APVi2c attaced");
 theplli2c = new PllI2cChannelLt(bench);
 if (!theplli2c->isInitialized()) DT_WARN(" plli2c channel is not init");
 DT_DEBUG_LTAPPL("plli2c attaced");
 fLatencyOffset=theplli2c->getLatencyOffset();
 theplli2c->setReadOnly(false);
themuxi2c = new MuxI2cChannelLt(bench);
 if (!themuxi2c->isInitialized())  DT_WARN(" themuxi2ci2c channel is not init");
 DT_DEBUG_LTAPPL("muxi2c attaced");
thedcui2c = new DcuChannelLt(bench);
 if (!thedcui2c->isInitialized()) 
   {DT_WARN(" thedcui2ci2c channel is not init");}
 else { thedcui2c->setAddress(0x0);}
 DT_DEBUG_LTAPPL("dcu attaced");
 theopto = new OptoI2cChannelLt(bench);
 if (!theopto->isInitialized()) 
   {DT_WARN(" opto i2c channel is not init");}
 else { 
   if(theopto){
     DT_DEBUG_LTAPPL("setting opto info");
     theopto->lock();
     theopto->setAddress(96);
     theopto->setOptoGain(0,2);
     theopto->setOptoGain(1,2);
     theopto->setOptoGain(2,2);
     theopto->setOptoBias(0,20);
     theopto->setOptoBias(1,20);
     theopto->setOptoBias(2,20);
     theopto->justDoIt();
     theopto->unlock();  
     int i2cerr=0;
     if( (i2cerr=theopto->wait()) <0) {
       DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
     }
   }
 }

 theapvi2c->setLoadAll(false);
}

/**/
HybridI2C::~HybridI2C() {
  if (theapvi2c!=0) { theapvi2c->release(); delete theapvi2c;  theapvi2c=0;}      
  if (theplli2c!=0) {theplli2c->release();delete theplli2c;  theplli2c=0; }
  if (themuxi2c!=0) {themuxi2c->release();delete themuxi2c;  themuxi2c=0;}
  if (thedcui2c!=0) {thedcui2c->release();delete thedcui2c;  thedcui2c=0; } 
  if (theopto != 0) {theopto->release();delete theopto;  theopto=0; } 

}
/**/
int  HybridI2C::setLld(int gain, int bias, int channel){
  int startch=0;
  int endch=2;
  if( channel > -1) { startch=channel; endch=startch;}
   theopto->lock();
   theopto->setAddress(96);
   for (int lc=startch;lc<=endch;lc++){
     // take care of the <= 
     theopto->setOptoGain(lc,gain);
     theopto->setOptoBias(lc,bias);
   }
   theopto->justDoIt();
   theopto->unlock();  
   int i2cerr=0;
   if( (i2cerr=theopto->wait()) <0) {
     DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
     fNrllderr++;
   }
   // no compare checking for the moment have to be added 
   return i2cerr;
}



/**/
int  HybridI2C::setPll(I2cDescriptor* i2cset){
 // PLLI2C
  int err=0;
  if (theplli2c==0) {DT_WARN("PLL i2c set problem") return -2 ;}
  if(thei2cset==0) {thei2cset=i2cset;}
  theplli2c->lock();
  if( 0x4 & i2cset->fInitpll) {
    // to be sure something is registerd added 2 september
    i2cset->fInitpll |= 0x2;
    theplli2c->setAddress(i2cset->fAddresspll);
    theplli2c->setLatency(128);
    theplli2c->setClock(1);
    theplli2c->setInit(i2cset->fInitpll);
    theplli2c->justDoIt();
    theplli2c->unlock();
    int i2cerr=0;
    if( (i2cerr= theplli2c->wait()) <0) {
      fNrpllerr++;
      DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
      err=-1;
    }
    theplli2c->lock();
    thedaqctrl->hardReset();
    i2cset->fInitpll |= 0x2; // always init pll after reset
    i2cset->fInitpll ^=0x4;  // remove reset pll bit 
  }
  theplli2c->setInit(i2cset->fInitpll);
  theplli2c->setAddress(i2cset->fAddresspll);
  unsigned short latency = (fLatencyOffset+i2cset->fLatencypll) % 25 ;
  // .55 gives the best result. 13 => 13.58 ns  14 => 13.58 ns 
  latency = ( unsigned short)((double(latency+.55) ) / 1.04); 
  unsigned short clockdelay =0xF &(  i2cset->fLatencypll / 25) ;
  latency = (latency)<12?latency:latency-12+16;
  DT_DEBUG_LTAPPL("addr:"<<i2cset->fAddresspll 
		  <<"pllcoarse "<<clockdelay<<" fine "<<latency+128);
  theplli2c->setLatency(latency+128);
  theplli2c->setClock( clockdelay ); 
  theplli2c->justDoIt();
  theplli2c->unlock();
  int i2cerr=0;
  if( (i2cerr= theplli2c->wait()) <0) {
    fNrpllerr++;
    DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
    err=-1;
  }
  else {
    // don't set the values back if error 
    //i2cset->fInitpll=0; // no init by default only explecit
  // can not be done here because only first module will be initialized. 
  // correct the local setting  
    thei2cset->fAddresspll=i2cset->fAddresspll;
    thei2cset->fLatencypll=i2cset->fLatencypll ;
  }
    usleep(1);
  DT_DEBUG_LTAPPL("pll set done with error status "<<err);
  return err;
}
int  HybridI2C::setMux(I2cDescriptor* i2cset){
  int err=0;
  DT_DEBUG_LTAPPL("mux settings "<< themuxi2c);
  if (themuxi2c==0){DT_WARN("MUX i2c set problem") return -2 ;}
  if(thei2cset==0) {thei2cset=i2cset;}
  themuxi2c->lock();
  themuxi2c->setAddress(i2cset->fAddressmux);
  themuxi2c->setResistor(i2cset->fResistormux);
  themuxi2c->justDoIt();
  themuxi2c->unlock(); 
  int i2cerr=0;
  if( (i2cerr=themuxi2c->wait()) <0) {
    fNrmuxerr++;
    DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
    err=-1;
  } 
  else {   
    thei2cset->fAddressmux=i2cset->fAddressmux;
    thei2cset->fResistormux=i2cset->fResistormux;
  }
  usleep(1);
  DT_DEBUG_LTAPPL("mux set done with error status "<<err);
  return err;
}

int HybridI2C::setApv(I2cDescriptor* i2cset){
  int err=0;
  if (theapvi2c==0){DT_WARN("APV i2c set problem") return -2 ;}
  if(thei2cset==0) {thei2cset=i2cset;}
  theapvi2c->lock();
  theapvi2c->setAddress(i2cset->fAddress);
  theapvi2c->setMode(i2cset->fMode);
  theapvi2c->setLatency(i2cset->fLatency); 
  theapvi2c->setMuxgain(i2cset->fMuxgain);
  theapvi2c->setIpre(i2cset->fIpre);
  theapvi2c->setIpcasc(i2cset->fIpcasc);
  theapvi2c->setIpsf(i2cset->fIpsf);
  theapvi2c->setIsha(i2cset->fIsha);
  theapvi2c->setIssf(i2cset->fIssf);
  theapvi2c->setIpsp(i2cset->fIpsp);
  theapvi2c->setImuxin(i2cset->fImuxin);
  theapvi2c->setIcal(i2cset->fIcal);
  theapvi2c->setVfp(i2cset->fVfp);
  theapvi2c->setVfs(i2cset->fVfs);
  theapvi2c->setVpsp(i2cset->fVpsp);
  theapvi2c->setCdrv(i2cset->fCdrv);
  theapvi2c->setCsel(i2cset->fCsel);    
  theapvi2c->justDoIt();
  theapvi2c->unlock(); 
  int i2cerr=0;
  if( (i2cerr=theapvi2c->wait()) <0) {
    fNrapverr++;
    DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
    err=-1;
  }
  else{ 
    // no check for a correct return check (for the moment ) !!
    thei2cset->fAddress=i2cset->fAddress;
    thei2cset->fMode=i2cset->fMode;
    thei2cset->fLatency=i2cset->fLatency; 
    thei2cset->fMuxgain=i2cset->fMuxgain;
    thei2cset->fIpre=i2cset->fIpre;
    thei2cset->fIpcasc=i2cset->fIpcasc;
    thei2cset->fIpsf=i2cset->fIpsf;
    thei2cset->fIsha=i2cset->fIsha;
    thei2cset->fIssf=i2cset->fIssf;
    thei2cset->fIpsp=i2cset->fIpsp;
    thei2cset->fImuxin=i2cset->fImuxin;
    thei2cset->fIcal=i2cset->fIcal;
    thei2cset->fVfp=i2cset->fVfp;
    thei2cset->fVfs=i2cset->fVfs;
    thei2cset->fVpsp=i2cset->fVpsp;
    thei2cset->fCdrv=i2cset->fCdrv;
    thei2cset->fCsel=i2cset->fCsel;
  }
  DT_DEBUG_LTAPPL("apv set done with error status "<<err);
  usleep(1);
  return err;
}



int  HybridI2C::SetI2C(I2cDescriptor* i2cset)
{
  DT_DEBUG_LTAPPL(" HybridI2C: setI2c mode  "<<i2cset->fMode);
  thei2cset=i2cset; 
  int err=0;
  if( (err=setPll(i2cset)) < 0) {return err;}
  if( (err=setMux(i2cset)) < 0) {return err;}
  if( (err=setApv(i2cset)) < 0) {return err;}
 DT_DEBUG_LTAPPL("apvreset ");  
 thedaqctrl->sendApvReset();
 return err;

}
/**/
int  HybridI2C::SetLatency(int lat) {
  DT_DEBUG_LTAPPL(" HybridI2c: setLat "<<lat);
              theapvi2c->lock();
              theapvi2c->setLatency(lat);
              theapvi2c->setLoadAll(false);          
              theapvi2c->justDoIt();
              theapvi2c->unlock(); 
              int i2cerr=0;
	      if( (i2cerr=theapvi2c->wait()) <0) {
		fNrapverr++;
		DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
	      }
	      thedaqctrl->sendApvReset();
	      if(!i2cerr) {
		
		thei2cset->fLatency=lat;
		theapvi2c->lock();
		lat=theapvi2c->getLatency();
		theapvi2c->unlock(); 
		usleep(1);
		if(lat != thei2cset->fLatency){
		  DT_ERROR("set latency to "<<thei2cset->fLatency 
			   << " get latency "<<lat);	
		  fNrapverr++; // in case of an i2c err this is count twice !!
		  thei2cset->fLatency=lat;
		}
	      }	      
	      return lat;
}
/**/
void HybridI2C::SetSkew(short sel) {
           unsigned char del = ~((1<<sel) & 0xFF);
 DT_DEBUG_LTAPPL(" HybridI2c: change Skew "<<sel);
              theapvi2c->lock();
              theapvi2c->setCsel(del);
              theapvi2c->setLoadAll(false);          
              theapvi2c->justDoIt();
              theapvi2c->unlock(); 
	      int i2cerr=0;
	      if( (i2cerr=theapvi2c->wait()) <0) {
		DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
		fNrapverr++;
	      }
	      thedaqctrl->sendApvReset();
	      if(!i2cerr) {
		thei2cset->fCsel=del;
	      }
	      usleep(1);
}
/**/
void HybridI2C::SetDrv(short drv) {
           unsigned char chan = ~((1<<drv) & 0xFF);
 DT_DEBUG_LTAPPL(" HybridI2c: change Drv "<<drv);
              theapvi2c->lock();
              theapvi2c->setCdrv(chan);
              theapvi2c->setLoadAll(false);          
              theapvi2c->justDoIt();
              theapvi2c->unlock(); 
	      int i2cerr=0;
	      if( (i2cerr=theapvi2c->wait()) <0) {
		fNrapverr++;
		DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
	      }
	      thedaqctrl->sendApvReset();
	      if(!i2cerr) {
		thei2cset->fCdrv=chan;
	      }
	      usleep(1);
}
/**/


short HybridI2C::SetMode(short m) {
DT_DEBUG_LTAPPL(" HybridI2c: setMode "<<m);
 theapvi2c->lock();
 theapvi2c->setMode(m); 
 theapvi2c->justDoIt(); 
 theapvi2c->unlock(); 
 int i2cerr=0;
 if( (i2cerr=theapvi2c->wait()) <0) {
   fNrapverr++;
   DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
 } 
 thedaqctrl->sendApvReset();
 if(!i2cerr){
   thei2cset->fMode=m;
   theapvi2c->lock();
   m=theapvi2c->getMode();
   theapvi2c->unlock(); 
   usleep(1);
   if(m != thei2cset->fMode){ 
     fNrapverr++;
     DT_ERROR("set mode to "<<thei2cset->fMode << " get mode "<<m);
     thei2cset->fMode=m;
   }
 }
 return m;
}
/**/
void HybridI2C::SetCalAmp(int a) {
  DT_DEBUG_LTAPPL(" HybridI2C: setCalAmp  "<<a);
 theapvi2c->lock();
 theapvi2c->setIcal(a);
 theapvi2c->justDoIt(); 
 theapvi2c->unlock(); 
 int i2cerr=0;
 if( (i2cerr=theapvi2c->wait()) <0) {
   fNrapverr++;
   DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
 } 
 usleep(1);
 thedaqctrl->sendApvReset();
 thei2cset->fIcal=a;
}
/**/
void HybridI2C::ChangeCal(int lat, short sel, short drv) {
  unsigned char chan = ~((1<<drv) & 0xFF);
  unsigned char del = ~((1<<sel) & 0xFF);
  unsigned char latency=lat;
 theapvi2c->lock();
 theapvi2c->setCsel(del);
 theapvi2c->setCdrv(chan);
 theapvi2c->setLatency(lat);
 theapvi2c->justDoIt(); 
 theapvi2c->unlock();
 int i2cerr=0;
 if( (i2cerr=theapvi2c->wait()) <0) {
   fNrapverr++;
   DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
 } 
 thedaqctrl->sendApvReset();
 thei2cset->fLatency=lat;
 thei2cset->fCdrv=chan;
 thei2cset->fCsel=del;
 theapvi2c->lock();
 chan=theapvi2c->getCdrv();
 del=theapvi2c->getCsel();
 latency=theapvi2c->getLatency();
 theapvi2c->unlock(); 
 usleep(1);
 if((short) latency != thei2cset->fLatency){
   fNrapverr++;
   DT_ERROR("set latency to "<<thei2cset->fLatency << "is "<<latency);
 }
 if((short)chan != thei2cset->fCdrv){
   fNrapverr++;
   DT_ERROR("set drv  to "<<thei2cset->fCdrv << " is "<<(int)chan);
 }
 if((short) del != thei2cset->fCsel){
   fNrapverr++;
   DT_ERROR("set delay  to "<<thei2cset->fCsel << " is "<<(int)del);
 }

}
/**/
short HybridI2C::GetMode() {
 theapvi2c->lock();
 theapvi2c->setReadOnly(true);
 theapvi2c->justDoIt(); 
 theapvi2c->unlock(); 
 int i2cerr=0;
 if( (i2cerr=theapvi2c->wait()) <0) {
   fNrapverr++;
   DT_WARN("Benchnr "<<fBench<<" i2c com error "<< i2cerr); 
 }
 theapvi2c->lock();
 theapvi2c->setReadOnly(false);
 short mode=theapvi2c->getMode();
 theapvi2c->unlock(); 
 usleep(1);
 return mode;
}
/**/
void HybridI2C::SetCalMode(short mode) {
  short m=mode;
   DT_DEBUG_LTAPPL(" HybridI2c : setCalmode "<<mode);
  if(!CheckCalMode(mode))    {
    DT_DEBUG_LTAPPL("HybridI2C  calibration is off put it on"); mode^=0x04;m=SetMode(mode);
  }
  else DT_DEBUG_LTAPPL("HybridI2C  calibration is on already");
  if(CheckDecMode(m)) DT_DEBUG_LTAPPL(" HybridI2C: decmode ");
  if(CheckInvMode(m)) DT_DEBUG_LTAPPL(" HybridI2C: invmode ");
  //return m==mode;
}

/**/
void HybridI2C::UnsetCalMode(short mode) {
  DT_DEBUG_LTAPPL(" HybridI2c : UnsetCalmode "<<mode);
     if(CheckCalMode(mode)) 
       {DT_DEBUG_LTAPPL("HybridI2C  calibration is on put it off"); mode|=0x04; SetMode(mode);} 
    else DT_DEBUG_LTAPPL("HybridI2C  calibration is off already");
}

/**/
bool HybridI2C::CheckCalMode(short mode) {
 DT_DEBUG_LTAPPL(" HybridI2c : checkCalmode "<<mode);
if(mode&0x04) return false;
else return true;
}
/**/
bool HybridI2C::CheckDecMode(short mode) {
if(mode&0x08) return false;
else return true;
}
/**/
bool HybridI2C::CheckInvMode(short mode) {
if(mode&0x20) return true;
else return false;
}

QString  HybridI2C::CheckMode(short mode) {
   QString s;
    if(CheckDecMode(mode)) {
     if(CheckInvMode(mode))
       s="dinvon";
     else 
       s="dinvoff";
       } else {
        if(CheckInvMode(mode))
        s="pinvon";
         else 
         s="pinvoff";  
       }
    DT_DEBUG_LTAPPL(" HybridI2c : mode"<<mode<<" is "<<s);
    return s;
}
