#include "IVRun.h" 
#include "Module.h"
#include "daqerrormsg.h"
#include "ModuleHv.h"
#include "RecModule.h"
#include "RecAnalyzer.h"
#include "RecModTest.h"
#include "RecModHeader.h"
#include "setparser.h"
#include "ModuleDescriptor.h"

IVRun::IVRun(Module* m) {
  themodhv=m->modulehv();
  therec=m->getrecmod();
  done=false;
}
/*
 */
IVRun::~IVRun()
{
}
/**/

void IVRun::InitTest(SetParser* s) {
  sets=s->getSensorDescriptor("default");
  Npoints=sets->npointsiv;
  vend=sets->vendiv;
  float vstart=sets->vstartiv;
  dv=(vend-vstart)/Npoints;
  dt=sets->dtiv;
  vmax=sets->vmax;
  imax=sets->imax;
  prevHv=themodhv->getVbias();
  Hv=vstart;
  if(!themodhv->ChangeHV(Hv)){
    DT_WARN("IVRun: can't set voltages"<<Hv);
  }
  Np=0;
  done=false;
  therec->getmodtest()->ResetIV();
  stime=QDateTime::currentDateTime();
}
/**/
bool IVRun::Update(int n) {
  if(done) return false;  
  if(stime.secsTo(QDateTime::currentDateTime())<dt) return true;

  float v=themodhv->getVbias();
  float i=themodhv->getCurrent();
  if(v>=vmax || i>=imax)  {
    checkvtest();
    if(i>imax)  { int statSensor=therec->getmodheader()->getstatSensor();
    statSensor|=128;
    }
    themodhv->ChangeHV(prevHv);
    done=true;   return false;}
  if(v>vend ||  Np>Npoints) {
    checkvtest();
    themodhv->ChangeHV(prevHv);
    done=true; return true;
  }
  therec->getmodtest()->AddMeasIV(v,i);
  Hv+=dv;
  Np++;
  if(!themodhv->ChangeHV(Hv)) {
    DT_WARN("IVRun: can't set required  voltages"<<Hv);
    int statSensor=therec->getmodheader()->getstatSensor();
    statSensor|=256;
    return false;
  }
  
  stime=QDateTime::currentDateTime();
  return true;
}
/**/
void IVRun::checkvtest() {
themodhv->ChangeHV(sets->vtest1);
 therec->getmodtest()->setitest1(themodhv->getCurrent());
 therec->getmodtest()->setvtest1(themodhv->getVbias());

themodhv->ChangeHV(sets->vtest2);
 therec->getmodtest()->setitest2(themodhv->getCurrent());
 therec->getmodtest()->setvtest2(themodhv->getVbias());

themodhv->ChangeHV(sets->vtest3);
 therec->getmodtest()->setitest3(themodhv->getCurrent());
 therec->getmodtest()->setvtest3(themodhv->getVbias());
}


/**/
void IVRun::FillRecord() {
therec->getrecanalyzer()->AnalyzeIV("",sets);
}
