#include "LedRun.h"
#include "Module.h"
#include "daqerrormsg.h"
#include  "HybridI2C.h"
#include  "ModuleDescriptor.h"
#include "RecModule.h"
#include "RecModHeader.h"
#include "RecModTest.h"
#include "RecAnalyzer.h"
#include "Spill_Analysis.h"
#include "setparser.h"
using namespace std;

LedRun::LedRun(Module* m)  {
 thefeds=m->feds();
 theapvanals=m->apvanalysis();
 thei2c=m->hybridi2c();
 therec=m->getrecmod();
  Napvs=thefeds.size();
 DT_DEBUG_LTAPPL(" created calprofrun ");
}
/**/
LedRun::~LedRun() {
}
/**/
void LedRun::InitTest(SetParser* s) {
  ledsets=s->getLedRunDescriptor("default");
  Ncalev=ledsets->nevpoint;
  prevmode=thei2c->GetMode();
  thei2c->UnsetCalMode(prevmode);
  Nev=0;
  done=false;
  therec->getmodtest()->ResetLed();
}
/*
 */
bool LedRun::Update(int nevinspill) {
  if(done) {thei2c->SetMode(prevmode); return true;}
  loadSpill(thefeds,theapvanals, nevinspill);
  int nbadev=0;
  for(int iev =0; iev < nevinspill; iev++)  {
    Nev++;   
    if(Nev>=Ncalev || Nev>999) { DT_WARN(" too many events"); continue;}
    for (int ich=0;ich<Napvs;ich++) {        
      theapvanals[ich]->loadEvent(iev);          
      if (theapvanals[ich]->FindFrame()) {    
	theapvanals[ich]->SubtractPed();               
	valarray<double> sig=*(theapvanals[ich]->getSignal());     
	for (int is=0;is<NAPVCH;is++)  {
		      //   cout<<" "<<is<<" "<<ich*NAPVCH+is<<" "<<sig[is]<<endl;
	  therec->getmodtest()->TH2calSled()->Fill(ich*NAPVCH+is,sig[is]);
          therec->getmodtest()->TPled()->Fill(ich*NAPVCH+is,sig[is]);
	}                            
      }  else {DT_WARN("CalProfRun:Update Cannot find frame ");nbadev++;}
    }       
  }
  if(nbadev>=nevinspill) return false;
  if(Nev>= Ncalev) {   
    DT_DEBUG_LTAPPL("LedRun is done");
    thei2c->SetMode(prevmode); done=true; return true;
  }  
  return true;
}
/**/
void LedRun::FillRecord() {
  thei2c->SetMode(prevmode);
  DT_DEBUG_LTAPPL("LedRun fillrecord ");
  TProfile* pled=therec->getmodtest()->TPled();
  TH1D* proj=pled->ProjectionX();
therec->getmodtest()->setTHcalSled((TH1F*) proj); 
therec->getrecanalyzer()->AnalyzeLight(thei2c->CheckMode(prevmode),ledsets);

}


