#include "ltparser.h"
#include "LightCtrl.h" 
#include "ledcardinterface.h"
#include "ledcarddummy.h"
#include  "daqerrormsg.h"

extern LtParser* ltparser;  

//~~ typedef  vector <MuxExchange*>::const_iterator MDI;

LightCtrl::LightCtrl( )   {
  int lednr =  ltparser->getNrLedCards();
  /*  Ledcard id should come from lt parser for the moment only one 
      with device nr 0 filles in by lt.dtd , 
  */
  if (lednr !=0) {
   // for the moment only on card with device 0 is supported 
    fLedCard[0]=ltparser->getLedCard(0); // this creates the device
    if (fLedCard[0] == 0) {
      DAQEXIT(" led card wrongly defined ");
    }
  }
  else { 
    fLedCard[0]= new LedCardDummy();
    DT_WARN("No Led Device defined");  
  }
}

float LightCtrl::setLightLevel(float level){
  float retlevel;
  for (pmap <int , LedCardInterface*>::const_iterator pt=fLedCard.begin();
       pt!= fLedCard.end(); pt++){
    retlevel=pt->second->setLightLevel(level);
  }
  return retlevel;
}
float LightCtrl::setLightLevel(float level,int ledcardid){
  float retlevel;
  if( fLedCard.find(ledcardid) != fLedCard.end()){
    retlevel=fLedCard[ledcardid]->setLightLevel(level);
  }
  return retlevel;
}
float LightCtrl::setLightLevel(float level,int ledcardid, int channel){
   float retlevel;
  if( fLedCard.find(ledcardid) != fLedCard.end()){
     retlevel=fLedCard[ledcardid]->setLightLevel(level,channel);
  }
  return retlevel;
}
LightCtrl::~LightCtrl(){
  fLedCard.clearpointermap();
 
}
