#include "daqerrormsg.h"
#include "ltparser.h"
#include "MuxCtrl.h" 
#include "normi2ctsc.h"
#include "muxdevdummy.h"
#include "muxdevinterface.h"
#include "muxchannelinterface.h"
#include "muxexchange.h"
#include "muxdevwrapper.h"
#include "i2cid.h"
//#include "muxchannelkarls.h"
using namespace std;
extern LtParser* ltparser;  

//~~ typedef  vector <MuxExchange*>::const_iterator MDI;

MuxCtrl::MuxCtrl( )   {
  fActPointer=theRegisterGroups.begin();
  fRealMuxCtrl=false;
  int muxnr =  ltparser->getNrMuxDevices();
  /*  mux id should come from lt parser for the moment only one 
      with device nr 0 filles in by lt.dtd , not changed by lt.xml
      only one mux type KARLS and dummy is supproted 
  */
  if( muxnr == 0) {
    //instantiate dummy mux with 3 cards 
    fMuxDev[0]=new MuxDevDummy();
    DT_DEBUG_MUX("Dummy mux  initialized");
   
  }
  else{
    fMuxDev[0]=lttest::getMuxDev(0,ltparser); // this creates the device !
    if(fMuxDev[0] == 0) {
      DT_WARN("Mux device not initialized");
    }
    else{
      DT_DEBUG_MUX("Mux dev initialized");
      fRealMuxCtrl=true;
    }
  }
}

void MuxCtrl::registerGroup(int groupnr){
  if ( theRegisterGroups.find(groupnr) ==  theRegisterGroups.end()){
    theRegisterGroups[groupnr]=1; 
  }
  else {
    theRegisterGroups[groupnr]++;
  }
  DT_DEBUG_MUX(" register group "<< groupnr 
       << " times registered "<<theRegisterGroups[groupnr]);
}

void MuxCtrl::unregisterGroup(int groupnr){
  if ( theRegisterGroups.find(groupnr) ==  theRegisterGroups.end()){
    DT_WARN("tried to unregister not used muxgroup "<< groupnr);
  }
  else {
    theRegisterGroups[groupnr]--;
    if( theRegisterGroups[groupnr]==0 ){
      theRegisterGroups.erase( groupnr); 
    }
  }
}

int MuxCtrl::getFirstGroup(){
  if( theRegisterGroups.size()==0) {return -4;}
  fActPointer=theRegisterGroups.begin();
  if (fActPointer == theRegisterGroups.end()){return -4;}
  else {  setActiveDevGroup(fActPointer->first);
     return fActPointer->first;}
}

int MuxCtrl::getNextActiveGroup(){
  if( theRegisterGroups.size()==0){ return -4;}
    fActPointer++;
    if(fActPointer == theRegisterGroups.end())
      {
      //no correct check was done before 
      return -4;
    }
    DT_DEBUG_LTAPPL("actroup is now "<< fActPointer->first);
    setActiveDevGroup(fActPointer->first);
    return fActPointer->first;
}
 


bool MuxCtrl::lastGroupNotReached(){
  map<int,int>::const_iterator pt=theRegisterGroups.end();
  if(theRegisterGroups.size()>0){   
    pt--; //point to the last group
    return  (fActPointer != pt) ;
  }
  else {
   // if it comes to here something is wrong in the 
    //procedure. There should be groups defined if there modules even if
    // it is only groupnr -1
    DT_ERROR("not mux group defined check configuration");
    return false ; 
  }
}

bool  MuxCtrl::setActiveGroup( int groupnr){
  map<int,int>::const_iterator 
    pt=theRegisterGroups.find(groupnr);

  if(pt == theRegisterGroups.end()){
    return false;
  }
  else {
    fActPointer=pt;
    setActiveDevGroup(pt->first);
    return true;
  }
}



bool  MuxCtrl::setActiveDevGroup( int groupnr){
  bool seterror=false;
  for (  pmap <int , MuxDevInterface*>::const_iterator lc= fMuxDev.begin();
	lc != fMuxDev.end();lc++) {
    seterror |=  (lc->second)->setGroupNr( groupnr);
  }
  return !seterror;
}

   
MuxCtrl::~MuxCtrl(){
  fMuxDev.clearpointermap();
 
}
