using namespace std;
#include "Spill_Analysis.h"
#include "fedchannellt.h"
#include "fedchannel.h"
#include "daqerrormsg.h"


Spill_Analysis:: Spill_Analysis(int i) : Apv_Analysis(i) 
{
  fFrameThreshold=240;
  fFrameMaximumAddress=0xff;
  DT_DEBUG_LTAPPL(" create APVanal");
}

Spill_Analysis:: ~Spill_Analysis() {
}



int  Spill_Analysis::FindCellAddress()
{
  // Determine the 8-bit address of the memory cell in the pipeline
  // and decode the Gray code.
  // This,here, works only in Header finding mode !!N.M

  int raw_addr=0, decoded_addr;
  int Threshold=220;
  int error_bit=0;

  static const int gray[256] = {
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /*   0 -   9 */
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /*  10 -  19 */
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /*  20 -  29 */
     499,  499,   31,   30,   28,   29,   24,   25,   27,   26, /*  30 -  39 */
      16,   17,   19,   18,   23,   22,   20,   21,    0,    1, /*  40 -  49 */
       3,    2,    7,    6,    4,    5,   15,   14,   12,   13, /*  50 -  59 */
       8,    9,   11,   10,   95,   94,   92,   93,   88,   89, /*  60 -  69 */
      91,   90,   80,   81,   83,   82,   87,   86,   84,   85, /*  70 -  79 */
      64,   65,   67,   66,   71,   70,   68,   69,   79,   78, /*  80 -  89 */
      76,   77,   72,   73,   75,   74,   32,   33,   35,   34, /*  90 -  99 */
      39,   38,   36,   37,   47,   46,   44,   45,   40,   41, /* 100 - 109 */
      43,   42,   63,   62,   60,   61,   56,   57,   59,   58, /* 110 - 119 */
      48,   49,   51,   50,   55,   54,   52,   53,  499,  499, /* 120 - 129 */
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /* 130 - 139 */
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /* 140 - 149 */
     499,  499,  499,  499,  499,  499,  499,  499,  499,  499, /* 150 - 159 */
     160,  161,  163,  162,  167,  166,  164,  165,  175,  174, /* 160 - 169 */
     172,  173,  168,  169,  171,  170,  191,  190,  188,  189, /* 170 - 179 */
     184,  185,  187,  186,  176,  177,  179,  178,  183,  182, /* 180 - 189 */
     180,  181,   96,   97,   99,   98,  103,  102,  100,  101, /* 190 - 199 */
     111,  110,  108,  109,  104,  105,  107,  106,  127,  126, /* 200 - 209 */
     124,  125,  120,  121,  123,  122,  112,  113,  115,  114, /* 210 - 219 */
     119,  118,  116,  117,  159,  158,  156,  157,  152,  153, /* 220 - 229 */
     155,  154,  144,  145,  147,  146,  151,  150,  148,  149, /* 230 - 239 */
     128,  129,  131,  130,  135,  134,  132,  133,  143,  142, /* 240 - 249 */
     140,  141,  136,  137,  139,  138                           /* 250 - 255 */
  };


 
  bool scope = 
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_DOUBLE)||
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_FIRST_SAMPLE)||
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_SECOND_SAMPLE)||
    (fFedChannel->getProcessMode() == FedChannelInterface::SCOPE_MUX)||
    (fFedChannel->getProcessMode() == FedChannelInterface::SCOPE_DOWN_SAMPLE);
    if (!scope) {
      int pas;
      int head=0;
      if (fFedChannel->getSkip() == 2) {
	if(fRaw[0]  > Threshold) head++;
	if(fRaw[1]  > Threshold) head++;
	if(fRaw[2]  > Threshold) head++;
	if(head!=3)   DT_WARN(" headsize "<<head); 
	if (fRaw[3]  > Threshold) raw_addr += 128;
	if (fRaw[4]  > Threshold) raw_addr += 64;
	if (fRaw[5]  > Threshold) raw_addr += 32;
	if (fRaw[6]  > Threshold) raw_addr += 16;
	if (fRaw[7]  > Threshold) raw_addr += 8;
	if (fRaw[8]  > Threshold) raw_addr += 4;
	if (fRaw[9]  > Threshold) raw_addr += 2;
	if (fRaw[10] > Threshold) raw_addr += 1;
	  // check if the error bit is low 
	if (fRaw[11] < Threshold) error_bit = 1;
      }
    }  
    decoded_addr=gray[raw_addr];
    if ( error_bit !=0) { 
        decoded_addr=decoded_addr+200;
        DT_WARN("  the error bit is low "<< getId());
    }
    if( decoded_addr == 499)
	 { decoded_addr-=10; 
	 DT_WARN(" illegal address in the pipeline "<<getId()<<" "<<raw_addr);
}
 //     if(decoded_addr>200||error_bit !=0) {  
//         cout<<" pipeaddress "<<decoded_addr<<" threshold "<<Threshold<<endl;
//          for(int i=0;i<12;i++) cout<<" "<<fRaw[i];  cout<<endl; 
         //}
       return decoded_addr;
}

bool Spill_Analysis::FindFrame() {  
  int is,ifirst;
  bool found = false;    
  bool scope = 
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_DOUBLE)||
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_FIRST_SAMPLE)||
    (fFedChannel->getProcessMode()==FedChannelInterface::SCOPE_SECOND_SAMPLE)||
    (fFedChannel->getProcessMode() == FedChannelInterface::SCOPE_MUX)||
    (fFedChannel->getProcessMode() == FedChannelInterface::SCOPE_DOWN_SAMPLE);
  if (scope && fFedChannel->getSkip() == 2) {
      // Look for 4 consecutives "strips" lower by fFrameThreshold from the base line
      // (no APV error)
    for (is=0;is<512-4;is++) {
          if (fRaw[(is+1)]-fRaw[is] <fFrameThreshold) continue;
          if (fRaw[(is+2)]-fRaw[is] <fFrameThreshold) continue;
          if (fRaw[(is+3)]-fRaw[is] <fFrameThreshold) continue;
          if (fRaw[(is+4)]-fRaw[is] <fFrameThreshold) continue;
          break;
        }
    ifirst = is;
      // Ask for a pipeline address between 0 & 160

    if (ifirst<384 && ifirst>0) {
          // Find address
          unsigned char addr=0;

          if (fRaw[ifirst+5]-fRaw[ifirst]  > fFrameThreshold) addr += 128;
          if (fRaw[ifirst+6]-fRaw[ifirst]  > fFrameThreshold) addr += 64;
          if (fRaw[ifirst+7]-fRaw[ifirst]  > fFrameThreshold) addr += 32;
          if (fRaw[ifirst+8]-fRaw[ifirst]  > fFrameThreshold) addr += 16;
          if (fRaw[ifirst+9]-fRaw[ifirst]  > fFrameThreshold) addr += 8;
          if (fRaw[ifirst+10]-fRaw[ifirst] > fFrameThreshold) addr += 4;
          if (fRaw[ifirst+11]-fRaw[ifirst] > fFrameThreshold) addr += 2;
          if (fRaw[ifirst+12]-fRaw[ifirst] > fFrameThreshold) addr += 1;

          //          printf("I first = %d  %d\n",ifirst,addr);
          if (addr  == 0 || addr>fFrameMaximumAddress) {found = false;return found;}
          // Store the reordered 128 strips
          ifirst+=13;
          for (is=0;is<128;is++)
            {
              int l = 32*(is%4) + 8*(int)(is/4) -31*(int)(is/16);
#ifdef NOFRAMEREORDER
              l =is;
#endif
              theData[l] =float( fRaw[ifirst+is]);
            }
          found = true;
    }
  }
  else     // Header finding  !!
    if (!scope) {
      int pas;
      if (fFedChannel->getSkip() == 1) {
	ifirst = 24;
	pas =2;
      } else {
	ifirst = 12;
	pas = 1;
      }
      
      for (is=0;is<128;is++) {
	int l = 32*(is%4) + 8*(int)(is/4) -31*(int)(is/16);
#ifdef NOFRAMEREORDER
	l =is;
#endif
	theData[l] =float( fRaw[ifirst+is*pas]);
      }
      found = true;
    }
  return found;
}
//
void  Spill_Analysis::getEventData(int iev, FedChannelLt* f)
  { fFedChannel=f;f->getApvEventData(iev,&fSpillBuffer[iev][0],2048);}
//
int  Spill_Analysis::loadEvent(int iev)
  {memcpy(fRaw,&fSpillBuffer[iev][0],1024*sizeof(unsigned short)); return 1024;} 
