#include "TestStatus.h"
#include "daqerrormsg.h"
using namespace std;

TestStatus::TestStatus() {
 
  sinit=new State();
  sinit->done=false;
  sinit->running=false;
  sinit->abort=false;
  sinit->errorstatus=0;
  sinit->hasrun=false;
 status.clear();

  status["PedRun"]=sinit;
  status["CalProfRun"]=new State(*sinit);//use sinit to initialize 
  status["CalRun"]=new State(*sinit); 
  status["BPlaneRun"]=new State(*sinit); 
  status["LatRun"]=new State(*sinit);
  status["LightRun"]=new State(*sinit);
  status["LedRun"]=new State(*sinit);
  status["IVRun"]=new State(*sinit);
  status["ConnectivityRun"]=new State(*sinit);
  status["AuxChipRun"]=new State(*sinit);
  theNtests=status.size();
  DT_DEBUG_LTAPPL(" Ntest "<<theNtests);
 for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++) 
      DT_DEBUG_LTAPPL(" test "<<i->first);


  currentrun="None";

  bsaveresult=false; 
  bscenario=false;
  bpause=false;
  bsaction=false;
  bsetapvctrl=false;
  binit=false;
  DT_NOTE(" TesStatus is constructed "); 
}
/**/
TestStatus::~TestStatus() {
  for(map<const QString, State*>::iterator i=status.begin();
      i!=status.end();i++){
    delete i->second;
  }
  status.clear();
}
/**/
bool TestStatus::Find(const QString& s) {
  if(status.find(s)!=status.end() ) return true;
  else return false;
}
/**/
bool  TestStatus::getHasRun(const QString& s){
  if(status.find(s)==status.end() ) return false;
  else  return status[s]->hasrun ;
}

int  TestStatus::getErrorStatus(const QString& s){
  if(status.find(s)==status.end() ) {    return -100;  }
  return status[s]->errorstatus ;
}

bool  TestStatus::setErrorStatus(const QString& s, int i){
  if(status.find(s)==status.end() ) return false;
  status[s]->errorstatus=i;
  return true ;
}


bool TestStatus::SetRun(const QString& s) {
  if(status.find(s)!=status.end())  {
    if(status[s]->running) return false;
    else   {status[s]->running=true; 
          status[s]->done=false; 
           status[s]->abort=false;
	   status[s]->hasrun=true;
           currentrun=s;
           return true;}
  } else return false;
}
/**/
bool TestStatus::SetAbort(const QString& s) {
  if(status.find(s)!=status.end())  {
    if(status[s]->running) {status[s]->running=false;status[s]->done=false;status[s]->abort=true; return true;}
    else   {status[s]->done=true; status[s]->abort=true; return true;}
  } else return false;
}
/**/
bool TestStatus::isRunning(const QString& s) {
  if(status.find(s)!=status.end())  {
    if(status[s]->running)   return true;
    else   return false;
  } else return false;
}
/**/
bool TestStatus::isDone(const QString& s) {
  if(status.find(s)!=status.end())  {
    if(status[s]->done)   return true;
    else   return false;
  } else return false;
}
/**/

void TestStatus::Reset(const QString& s) {
  if(status.find(s)!=status.end())  status[s]=sinit;
}
/**/
void TestStatus::Reset() {
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
  i->second=sinit;
}
/**/
bool TestStatus::allDone() {
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
    if(!(i->second->done)) return false;
  return true;
}
/**/
bool TestStatus::isRunning() {
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
        if(i->second->running) return true;
  return false;
}
/**/
bool TestStatus::isAbort() {
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
        if(i->second->abort) return true;
  return false;
}
/**/
bool TestStatus::Abort() {
   bsaction=false;
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
     {i->second->running=false; i->second->abort=true; i->second->done=false; }
  return true;
}
/**/
bool TestStatus::SetDone() {
  bsaction=false;
  for(map<const QString, State*>::iterator i=status.begin();i!=status.end();i++)
    if(i->second->running)  { i->second->running=false; i->second->done=true; }
  return true;
}
/**/
bool TestStatus::SetPause() {
              if(bpause)  return false;
               else {bpause=true; return true;}
}
/**/
bool TestStatus::SetScenario() {
              if(bscenario)  return false;
               else {bscenario=true; return true;}
}
/**/
bool TestStatus::SetAction() {
              if(bsaction)  return false;
               else {bsaction=true; return true;}
}
