//omon_client.C
//-------------------------------------------------------------
//Root CINT TCP/IP client for Si CMS hybrid module test data.
//The test data is stored in the Root memory and easily can be
//accessed by using the Root's native browser. The data may be
//further processed by any custom root macro.This macro must be
//started each time when an update is needed.
//04-04-02 Author V. Hovhannisyan UIA
//15-05-02 Modified by V.(using TFile database structures)
//14-06-02 Modified by V.(data and database structure changes)
//10-07-02 Modified by V.(using separate file for each update)
//18-07-02 Buggs corrected by V. (directories, file mode)
//23-07-02 Upgraded by V. (buttons).
//--------------------------------------------------------------
//
void omon_client(int dn,const char* ip)
{
//
  char str0[32];
  TFile* tf;
//
  cout << endl;
  cout << "Client: waiting for response..." << endl;
  char str[32];
  TSocket *s;
  int maxcnt=5000;
  int cnt=0;
  do
    {
      s=new TSocket(ip,9010);
      s->Recv(str,32);
      cnt++;
    } 
  while (strcmp(str,"OnlineMonitor")!=0 && cnt<=maxcnt);
  if (cnt>maxcnt)
    {
      cout << endl;
      cout << "No response" << endl;
      return;
    }
//
  TInetAddress sr;
  cout<< "Connection established to server:" ;
  sr=s->GetInetAddress();
  sr.Print();
  cout << endl;
//
  TMessage *msg=new TMessage();
//
 s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
 TVector nmod=(TVector)msg->ReadObject(msg->GetClass());
 int nnmod=nmod(0);
 cout << "Number of modules " << nnmod << endl;
 cout << endl;
// 
 for(int i=0;i<nnmod;i++)
  {
    sprintf(str0,"Update_%d_Module_%d.root",dn,i);
    tf=new TFile(str0,"RECREATE","UIA, Antwerpen");
    tf->cd();
    tf->mkdir("Header");
    tf->cd("Header");
//
    TVector TVnmod=nmod;
    nmod.Write("TVnmod");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVev");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVmod");
      s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVrun");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtime");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVapvmode");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TNamed)msg->ReadObject(msg->GetClass()).Write("TNsettings");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT)
      (TNamed)msg->ReadObject(msg->GetClass()).Write("TNstime");
    cout  << str0  <<  " / Header received" << endl;
//
    tf->cd();
    tf->mkdir("Setup");
    tf->cd("Setup");
// 
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtemptag");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempcold");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempbox");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempwarm"); 
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempext");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVhumext");
//
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVhumbox");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVtemps");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TVector)msg->ReadObject(msg->GetClass()).Write("TVhums");
// 
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtemptagt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempcoldt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempwarmt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempboxt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempextt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGhumboxt");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGhumextt");
    cout << str0 << " / Setup received" << endl;
//
    tf->cd();
    TDirectory* dmod=tf->mkdir("Module");
    dmod->cd();
//
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVmodid");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       TVector vv=(TVector)msg->ReadObject(msg->GetClass());
     vv.Write("TVnapvs");
     int napvs=vv(0);
     cout << str0 << " / Number of APVs " << napvs << endl; 
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVnbench");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVnbadch");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVnapverrors");
// 
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector )msg->ReadObject(msg->GetClass()).Write("TVtemphybdcu1");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVtemphybdcu2");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempsenntsc1");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVtempsenntsc2");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVhvbias");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVtileakdcu");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVitest");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVihyb25");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVihyb125");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVvhyb25");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TVector)msg->ReadObject(msg->GetClass()).Write("TVvhyb125");
//
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGavrms(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGavcala(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGnbadcht(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtemphybdcu1(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtemphybdcu2(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtemphybdcu3(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGihyb125(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGihyb25(t)");
//
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGv(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGi(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempsen1(t)");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGtempsen2(t)");
//
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TGraph *)msg->ReadObject(msg->GetClass())->Write("TGivi(TVivv)");
//
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THpedestal");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THnoise");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THrawnoise");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THchflag");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THcala");
    s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THcalPApeak");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THcalSbackpl");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("THcalSled");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
       (TH1F *)msg->ReadObject(msg->GetClass())->Write("TPbp");
     s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
      (TH1F *)msg->ReadObject(msg->GetClass())->Write("TPled");
//
     TDirectory* dcmn=dmod->mkdir("cmn");
     TDirectory* dpip=dmod->mkdir("pipe");
     TDirectory* dcal=dmod->mkdir("calprof");
     TDirectory* dlat=dmod->mkdir("latency");
     for (int k=0;k<napvs;k++)
	{
	  dcmn->cd();
	  sprintf(str,"THcmn[%d]",k);
	  s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
	    (TH1F *)msg->ReadObject(msg->GetClass())->Write(str);
	  dpip->cd();
	  sprintf(str,"THpipe[%d]",k);
	  s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
	    (TH1F *)msg->ReadObject(msg->GetClass())->Write(str);
	  for (int j=0;j<128;j++)
	    {
	      int l=napvs*k+j;
	      dcal->cd();
	      sprintf(str,"THcalprof[%d]",l);
	      s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
		(TProfile *)msg->ReadObject(msg->GetClass())->Write(str); 
	      dlat->cd();
	      sprintf(str,"TPlatency[%d]",l);
	      s->Recv(msg);if (msg->What()==kMESS_OBJECT) 
		(TH1F *)msg->ReadObject(msg->GetClass())->Write(str);
	    }
	}      
     cout << str0 << " / Module received" << endl;
     tf->Close();
     delete tf;
    }
  s->Recv(msg);if (msg->What()==kMESS_STRING) msg->ReadString(str,32);
  cout << str << endl;
  s->Close();
  delete msg; 
  delete s;
}
//end of macro ----------------------------------------------------


