#include "Monitorimpl.h"
#include "daqerrormsg.h" 
#include <qapplication.h>
#include "cmdlinedecode.h"
#include "ltparser.h"
using namespace std;
LtParser *ltparser;

/** \brief      
      main programm
         
     \author V.Zhukov,UIA  
     \version 1.0 
     \date 20/11/2001  
*/

//int daq_tools_printing_level=0;

void usage (){
  cout <<endl<<" usage example : "<<endl;
  cout <<"\tmainMonitor  -ltconfig lttemp.xml " <<endl;
  cout <<"options:"<<endl;
  cout <<"\t-ltconfig :the configuration file (default is lt.xml)"<<endl;  
  cout <<"\t-settings:the settings file file (default is settings.xml)"<<endl;  
  cout <<"\t-expmode : expert mode extra control windows ";
  cout <<"but these are not documented";
  cout <<"-h  this message "<<endl<<endl;
  cout <<" forbidden :  -struct don't use it" <<endl;
  cout << "other options will be ignored" <<endl;
  cout <<endl;  std::exit(-1);
}



int main(int argc, char **argv)
{  
//init parser
   ltparser=new LtParser();
   string cmdresult;
   string cmderr;
   if( "found"== CmdLineDecode(argc,argv,"h",cmdresult,false)){
     usage();
   }
   
   if( "found"== CmdLineDecode(argc,argv,"struct",cmdresult,true)){
     // cout<< "use "<< result <<" as config " <<endl;
     if( cmdresult=="Petal" || cmdresult=="Rod") {
       ltparser->setParseFileName("ltpetal.xml");
     }
   }
   if( "found"== CmdLineDecode(argc,argv,"ltconfig",cmdresult,true)){
     // cout<< "use "<< result <<" as config " <<endl;
    ltparser->setParseFileName( cmdresult);
   }
 

   DT_DEBUG_LTAPPL("Procedure: parse "<< cmdresult.c_str());
   

// create Qt application
  QApplication a( argc, argv );
// create main GUI
 Monitorimpl* monitor=new Monitorimpl("../data/LtSetup",&a,0,"Test");
 a.setMainWidget(monitor);
 monitor->show();
// run qt application
 int result=a.exec();
// quit
 delete monitor;
 return result;
  }
