#include <cstdlib>
#include <cstring>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>
#include "ltparser.h"
#include "diochannelinterface.h"
#include "benchposconnection.h"
#include <iostream>

using namespace std;
LtParser* ltparser; 

int main(int argc, char *argv[], char *envp[]){
  char * arg2=0;
  
  bool on=false;
  int theBench=0;
  if( argc >1 ) { 
    arg2= argv[1]; 
    if ( !strcmp( arg2, "on") ){ on =true;}
  }
  bool all=true;
  if (argc >2) {  
    all = false;
    theBench  = atoi(argv[2]);
  }
  
  ltparser = new LtParser();
  ltparser->parseFile( );
    
  for (int lc=0 ; lc < ltparser->getNumberBenchPositions();lc++){
    BenchPosConnection* bc = ltparser->getRegisteredBenchPos(lc);
    // int benchid= ltparser->getBenchPosConnections(lc)->getId();
    int benchid= bc->getId();
    cout << benchid << " "<< ltparser->getNumberBenchPositions()<<endl;
    if(!all && benchid != theBench){ continue;}
    
    DioChannelInterface* thepowerswitch = ltparser->getDioChannel(
      ltparser->getBenchPosConnections(benchid)->getPowerSwitch());
    if( on)   {  
      thepowerswitch->setBit(0);
      cout << "power on for bench pos " << benchid<<endl;
    }
    else {  
      thepowerswitch->setBit(1);
      cout << "power off  for bench pos " <<benchid<<endl;
    }
      delete thepowerswitch ;
  }
  
  delete ltparser;
  return 0;
}
