
#include <cstdlib>
#include <sys/types.h>
#include <signal.h>

#include "HybridI2C.h"
#include "ltparser.h"
#include "ApvReadoutCtrl.h"
#include "setparser.h"
#include <vector>
#include <string>
#include <iostream>
using namespace std;
LtParser *ltparser;


bool HasToExit=false;
void  Ictrlc(int s)
{


  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;

}





int main( int argc, char **argv )
{
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  //init parser
 ltparser=new LtParser();
 char* envir=getenv("DAQHOME");
 string ltfile(envir);
 if( argc > 1) { ltfile=ltfile+"/Config/"+argv[1];}
 else {   ltfile=ltfile+"/Config/lt.xml";}
 DT_DEBUG_LTAPPL("Procedure: parse "<< ltfile.c_str());
 if(ltparser->parseFile(ltfile.c_str())) {
   DAQEXIT("error in lt configuration file look at error output above");
 }
 vector<int> benchpos;
 int poscnt=2;
 if(argc <= poscnt) {  benchpos.push_back(0);}
 else {
   while (argc > poscnt) {
     benchpos.push_back( atoi(argv[poscnt]));
     poscnt++;
   }
 }
 SetParser* settings=new SetParser();
 string setf(envir);
 setf=setf+"/Config/settings.xml";
 cout <<"set file" << setf<<endl;
 settings->parseFile(setf.c_str());
 I2cDescriptor* i2cset= settings->getI2cDescriptor("default");
 if(! i2cset) {return -1;}
 cout << i2cset->fAddressmux<< endl;
 ApvReadoutCtrl* apvctrl=new ApvReadoutCtrl(settings,0,0);
 vector<HybridI2C*> hi2c;
 for( vector<int>::const_iterator hyb=benchpos.begin();
      hyb != benchpos.end();hyb++){
   hi2c.push_back(new HybridI2C(*hyb,apvctrl));
 }
 int merr=0,aerr=0,perr=0;
 unsigned count=0;
 int merrcnt=0,perrcnt=0,aerrcnt=0;
 while(! HasToExit){
   cout<<count++<<endl;
   int samemax=count%4;
   for(int i=0;i<hi2c.size();i++){
     for (int lc=0;lc<samemax;lc++){
       merr=(hi2c[i])->setMux(i2cset);
       perr=hi2c[i]->setPll(i2cset);
       aerr=hi2c[i]->setApv(i2cset);
       if(perr <0 ) {perrcnt++;}
       if(merr <0 ) {merrcnt++;}
       if(aerr< 0) {aerrcnt++;}
       cout<<i<<" mux"<<merr<<" pll ";
       cout<<perr<<" apv "<<aerr <<endl;
     }
   }
   if(!(count%73)) {sleep(100);}
 }
 cout<<" mux"<<merr<<" pll "<<perrcnt<<" apv "<<aerrcnt <<endl;
 for(int i=0;i<hi2c.size();i++) {
   delete hi2c[i];
 }
 delete apvctrl;
 delete settings;
 
}

 
