#include <cstdlib>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
using namespace std;
#include <iostream>
#include "daqerrormsg.h"
#include "ApvReadoutCtrl.h"
#include "ltparser.h"
#include "setparser.h"
LtParser* ltparser;


bool HasToExit=false;
void Ictrlc(int s){
  if (s == SIGCONT) return;
  printf("SIGINT:I: %d  got signal %d \n",getpid(),s);
  HasToExit=true;
}

  
int   main (int argc , char** argv ){
  signal(SIGINT,Ictrlc); // Arm interrupt handler
  signal(SIGCONT,Ictrlc); // Arm interrupt handler
  ltparser = new LtParser();
  char configfile[80];

  
  string ltfile;
  if( argc > 1) { 
    ltparser->setParseFileName(argv[1]);  
  }
  DT_DEBUG_LTAPPL("Procedure: parse "<< ltparser->getParseFileName());
  if(ltparser->parseFile()) {
    DAQEXIT("error in lt configuration file " << ltparser->getParseFileName()
	    <<" look at error output above");
  } 
  SetParser* thesettings = new SetParser();
  sleep(1);
  char setfile[100];
  ltparser->getStandardConfigFile(setfile,"settings.xml");
  thesettings->parseFile(setfile);
  ApvReadoutCtrl*  daqctrl=new ApvReadoutCtrl(thesettings,0,0);
  daqctrl->AdjustFedThresholds();
  daqctrl->AdjustFedThresholds(); // only once for the moment
 while(!HasToExit)    {  
   cout<<"start Daq"<<endl;
   daqctrl->startDaqTest(); 
   sleep(1);
   cout<<"events start" <<daqctrl->getNrEvents() ;
   cout<< " should be " ;
   cout << 0; // daqctrl->getSpillSize ()+4
   cout <<endl;
   int totevents=daqctrl->getNrEvents() ; 
   int totshouldbe= 0; //daqctrl->getSpillSize ()+4; //shoud be 5 ?
   // why it is 0 ?
   for (int i=0 ; i<100;i++){
     daqctrl->NextSpill(); 
     usleep(100000);
     cout<<i<<" events start" <<daqctrl->getNrEvents() ;
     totevents+=daqctrl->getNrEvents() ;    
     cout<< " should be " <<  daqctrl->getSpillSize ()+5;
     totshouldbe+= daqctrl->getSpillSize ()+5;
     cout<<" total evens  " << totevents ;
     cout << " tot should be " <<totshouldbe;
     cout<<endl;     
     if(HasToExit) { break;}
   }
   daqctrl->stopDaqTest();
   sleep(1);
 }
 
 delete daqctrl;
 delete thesettings;
 delete ltparser;
 return 0;
}
